<p align="center">
<img src="docs/source/RAFFLE_logo_no_background.png" width="250"/>
</p>

[![GPLv3 workflow](https://img.shields.io/badge/License-GPLv3-yellow.svg)](https://www.gnu.org/licenses/gpl-3.0.en.html "View GPLv3 license")
[![Latest Release](https://img.shields.io/github/v/release/ExeQuantCode/RAFFLE?sort=semver)](https://github.com/ExeQuantCode/RAFFLE/releases "View on GitHub")
[![Methods Paper](https://img.shields.io/badge/Paper-Phys_Rev_B-blue.svg)](https://link.aps.org/doi/10.1103/PhysRevLett.132.066201)
[![Code Paper](https://img.shields.io/badge/Paper-arXiv-red.svg)](https://doi.org/10.48550/arXiv.2504.02528)
[![Documentation Status](https://readthedocs.org/projects/raffle-fortran/badge/?version=latest)](https://raffle-fortran.readthedocs.io/en/latest/?badge=latest "RAFFLE ReadTheDocs")
[![FPM](https://img.shields.io/badge/fpm-0.11.0-purple)](https://github.com/fortran-lang/fpm "View Fortran Package Manager")
[![CMAKE](https://img.shields.io/badge/cmake-3.27.7-red)](https://github.com/Kitware/CMake/releases/tag/v3.27.7 "View cmake")
[![GCC compatibility](https://img.shields.io/badge/gcc-14.2.0-green)](https://gcc.gnu.org/gcc-14/ "View GCC")
[![Coverage](https://img.shields.io/endpoint?url=https://gist.githubusercontent.com/nedtaylor/48f14ebb5636b54d3813e4b4494903eb/raw/raffle_coverage_main.json)](https://ExeQuantCode.github.io/RAFFLE/ "View coverage report")


# RAFFLE

by Ned Thaddeus Taylor, Joe Pitfield, and Steven Paul Hepplestone

RAFFLE (pseudoRandom Approach For Finding Local Energetic minima) is a package for structural prediction applied to material interfaces.
RAFFLE interfaces with the [Atomic Simulation Environment (ASE)](https://gitlab.com/ase/ase).

RAFFLE is both a Fortran and a Python library, with the option of a Fortran executable.
The code heavily relies on features of Fortran 2018 and above, so there is no backwards compatibility with Fortran95.

## Documentation

Tutorials and documentation are provided on the [docs](http://raffle-fortran.readthedocs.io/) website.
The methodology is detailed in the [Phys Rev B paper](https://link.aps.org/doi/10.1103/PhysRevLett.132.066201).
The paper detailing the software package is currently avaialble on [arXiv](https://doi.org/10.48550/arXiv.2504.02528) with plans for peer-reviewed publication.

Refer to the [API Documentation section](#api-documentation) later in this document to see how to access the API-specific documentation.



## Requirements

- Fortran compiler supporting Fortran 2018 standard or later
- fpm or CMake (fpm works only for Fortran installation)

Python-specific installation:

- Python 3.11 or later (might work on earlier, have not tested)
- NumPy.f2py
- f90wrap
- cython
- scikit-build-core
- meson
- make or ninja
- CMake
- ASE

The library bas been developed and tested using the following Fortran compilers:
- gfortran -- gcc 11.4.0
- gfortran -- gcc 13.2.0
- gfortran -- gcc 14.1.0
- gfortran -- gcc 14.2.0

The library is known to not currently work with the intel Fortran compilers.

## Installation

For the Python library, the easiest method of installation is to install it directly from pip:

```
pip install raffle
```

Once this is done, RAFFLE is ready to be used.

Alternatively, to download development versions or, if, for some reason, the pip method does not work, then RAFFLE can be installed from the source.
To do so, the source must be obtained from the git repository.
Use the following commands to get started:
```
 git clone https://github.com/ExeQuantCode/raffle.git
 cd raffle
```

Depending on what language will be used in, installation will vary from this point.

### Python

For Python, the easiest installation is through pip:
```
pip install .
```

Another option is installing it through cmake, which involves:
```
mkdir build
cd build
cmake ..
make install
```

Then, the path to the install directory (`${HOME}/.local/raffle`) needs to be added to the include path. NOTE: this method requires that the user manually installs the `ase`, `numpy` and `f90wrap` modules for Python.

### Fortran

For Fortran, either fpm or cmake are required.

#### fpm

fpm installation is as follows:

```
fpm build --profile release
```

This will install both the Fortran library and the Fortran application for RAFFLE.
The library can then be called from other fpm-built Fortran programs through normal means (usually referencing the location of RAFFLE in the program's own `fpm.toml` file).
The application can be run using **(NOTE: The application is not a priority for development, so is less likely to work)**:
```
fpm run
```

The library can be tested to ensure compilation was successful **(NOTE: Unit tests currently only provide minimal code coverage)**:
```
fpm test --profile release
```

#### cmake

cmake installation is as follows:
```
mkdir build
cd build
cmake [-DBUILD_PYTHON=Off] ..
make install
```
The optional filed (dentoted with `[...]`) can be used to turn off installation of the Python library.
This will build the library in the build/ directory. All library files will then be found in:
```
${HOME}/.local/raffle
```
Inside this directory, the following files will be generated:
```
include/raffle.mod
lib/libraffle.a
```

To check whether RAFFLE has installed correctly and that the compilation works as expected, the following command can be run:
```
ctest
```
This runs the unit tests (found in the `test` directory) to ensure procedures output as expected.

### MacOS

Issues can arise with the built-in C and Fortran compilers when installing on MacOS, particularly for Python installation.
It is recommended to manually install new versions (such as via [Homebrew](https://brew.sh)) and setting the `CC` and `FC` environment variables (i.e. defining the default compilers for the respective language).
We have found the following to work:

```
brew install gcc
brew install gfortran
export CC=$(brew --prefix gfortran)
export FC=$(brew --prefix gcc)
```

Now follow the instructions for the [Python](#python) build methods.


## Examples

After the library has been installed, a set of example programs can be found in the `example` directory (note, the `test` directory is for unit tests to ensure each procedure in the library produces expected outputs after compilation, they are not really needed to be looked at by potential users).

The `example/fortran_exe` example uses a shell script to run the Fortran installed application.
It uses a user-editable input file `param.in` in the same directory to change values of the RAFFLE generator and provided database.

The `example/python_pkg` directory contains a set of subdirectories `MATERIAL_learn` that show how RAFFLE can be called using Python to implement it into existing structure search workflows.
These examples are the recommended ones to run.
To successfully run them, follow the above installation instructions for Python, then go to the `example/python_pkg` directory and run one of the scripts.


API documentation
-----------------

API documentation can be generated using FORD (Fortran Documenter).
To do so, follow the installation guide on the [FORD website](https://forddocs.readthedocs.io/en/stable/) to ensure FORD is installed.
Once FORD is installed, run the following command in the root directory of the git repository:

```
  ford ford.md
```

Contributing
------------

Please note that this project adheres to the [Contributing Guide](CONTRIBUTING.md).
If you want to contribute to this project, please first read through the guide.
If you have any questions, bug reports, or feature requests, please either discuss then in [issues](https://github.com/ExeQuantCode/raffle/issues).


License
-------
This work is licensed under a [GPL v3 license]([https://opensource.org/license/mit/](https://www.gnu.org/licenses/gpl-3.0.en.html)).

Code Coverage
-------------

Automated reporting on unit test code coverage in the README is achieved through utilising the [cmake-modules](https://github.com/rpavlik/cmake-modules) and [dynamic-badges-action](https://github.com/Schneegans/dynamic-badges-action?tab=readme-ov-file) projects.


## References

If you use this code, please cite our papers:
```text
@article{Pitfield2024PredictingPhaseStability,
  title = {Predicting Phase Stability at Interfaces},
  author = {Pitfield, J. and Taylor, N. T. and Hepplestone, S. P.},
  journal = {Phys. Rev. Lett.},
  volume = {132},
  issue = {6},
  pages = {066201},
  numpages = {8},
  year = {2024},
  month = {Feb},
  publisher = {American Physical Society},
  doi = {10.1103/PhysRevLett.132.066201},
  url = {https://link.aps.org/doi/10.1103/PhysRevLett.132.066201}
}

@article{Taylor2025RAFFLEActiveLearning,
  title = {RAFFLE: Active learning accelerated interface structure prediction},
  author = {Taylor,  Ned Thaddeus and Pitfield,  Joe and Davies,  Francis Huw and Hepplestone,  Steven Paul},
  year = {2025},
  eprint={2504.02528},
  archivePrefix={arXiv},
  primaryClass={cond-mat.mtrl-sci},
  doi = {10.48550/ARXIV.2504.02528},
  url = {https://arxiv.org/abs/2504.02528},
  publisher = {arXiv},
}
```

# Python Package Example

This directory contains example Python files demonstrating how to use the raffle package.

## Directory Structure

```
python_pkg/
├── <SYSTEM>          # Example with dataset containing global minimum from which to learn RAFFLE descriptors
    └── run.py        # Script to test placement methods
└── <SYSTEM_learn>    # Example with no prior database, i.e. RAFFLE starts with no prior knowledge
    ├── DRAFFLE       # Directory containing example RAFFLE learning script
        ├── learn.py  # Script to run RSS generating and learning
        └── pca.ipynb # Notebook to plot principal component analysis of RAFFLE results
    └── DRSS          # Directory containing example random structure search script using AGOX
        ├── rss.py    # Script to run RSS
        └── pca.ipynb # Notebook to plot principal component analysis of RSS results
```

## File Descriptions

- `run.py`: Example script highlighting placement method capabilities
- `learn.py`: Example script highlighting learning capabilties of RAFFLE
- `pca.ipynb`: Notebook to generate principal component analysis of generated structures

## Execution Order

To run a RAFFLE example and analyse the results, the following order must be performed.
1. Move to the desired `SYSTEM_learn/DRAFFLE` directory and create a directory to work in:
   ```bash
   cd SYSTEM_learn
   mkdir DOutput
   cd DOutput
   ```

2. Run the `learn.py` script:
   ```bash
   python ../learn.py
   ```

3. Go to parent directory and open the notebook `pca.ipynb`, run all the cells.

NOTE: for the `C_learn/DRSS/` example, the `pca.ipynb` notebook expects that the `C_learn/DRAFFLE/` example script and notebook have been fully run first.
This is because it attempts to use the PCA fit to the RAFFLE results to transform its data.
Doing so enables the two techniques to be properly compared.

The `[un]rlxd_structures_seed0.traj` files are provided (as are the `energies_[un]rlxd+seed0.txt`) as the key outputs from the `learn.py` runs.
For the `rss.py` scripts, the `[un]rlxd_structures_seed0.traj` files are provided.
Whilst other output files are generated during the RAFFLE runs, these are optional files with mostly redundant data.

## Prerequisites

- Python 3.11 or higher
- raffle package installed (`pip install .`)
- `ase` for handling atomic structure data
- `CHGNet`, `MACE-0`, `VASP`, or some other `ase`-compatible calculator

program test_misc_maths
  use raffle__io_utils, only: test_error_handling
  use raffle__misc_maths
  use raffle__constants, only: real32
  implicit none

  logical :: success = .true.

  test_error_handling = .true.


  call test_lnsum(success)
  call test_triangular_number(success)
  call test_set_difference(success)


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_misc_maths passed all tests'
  else
     write(0,*) 'test_misc_maths failed one or more tests'
     stop 1
  end if

contains

  subroutine test_lnsum(success)
    implicit none
    logical, intent(inout) :: success
    integer :: n
    real(real32) :: result

    n = 5
    result = lnsum(n)
    call assert( &
         abs( &
              result - &
              ( &
                   log(1.0_real32) + &
                   log(2.0_real32) + &
                   log(3.0_real32) + &
                   log(4.0_real32) + &
                   log(5.0_real32) &
              ) &
         ) .lt. 1.E-6_real32, &
         'lnsum failed', &
         success &
    )
  end subroutine test_lnsum

  subroutine test_triangular_number(success)
    implicit none
    logical, intent(inout) :: success
    integer :: n, result

    n = 5
    result = triangular_number(n)
    call assert( &
         result .eq. 15, &
         'Triangular number failed', &
         success &
    )
  end subroutine test_triangular_number

  subroutine test_set_difference(success)
    implicit none
    logical, intent(inout) :: success
    real(real32), dimension(3) :: a, b, result, expected
    real(real32), dimension(4) :: c

    a = [1.0_real32, 2.0_real32, 3.0_real32]
    b = [1.0_real32, 1.0_real32, 1.0_real32]
    expected = [0.0_real32, 1.0_real32, 2.0_real32]
    result = set_difference(a, b)

    call assert( &
         all( abs(result - expected) .lt. 1.E-6_real32 ), &
         'Set difference failed', &
         success &
    )

    b = [0.0_real32, 1.0_real32, 4.0_real32]
    expected = [1.0_real32, 1.0_real32, 0.0_real32]
    result = set_difference(a, b, set_min_zero=.true.)

    call assert( &
         all( abs(result - expected) .lt. 1.E-6_real32 ), &
         'Set difference min zero failed', &
         success &
    )

    c = [1.0_real32, 2.0_real32, 3.0_real32, 4.0_real32]
    write(*,*) "Testing set_difference error handling"
    result = set_difference(a, c)
    write(*,*) "Handled error: set difference of arrays of different lengths"


  end subroutine test_set_difference

!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_misc_maths

module raffle__geom_utils
  !! Module to contain all geometry-manipulation related procedures
  !!
  !! This module contains procedures that are used to manipulate the geometry
  !! of the system. The geometry type used is defined in the geom_rw module.
  use raffle__constants, only: pi,real32
  use raffle__geom_rw, only: basis_type
  use raffle__misc_linalg, only: modu, get_angle
  implicit none


  private

  public :: basis_merge


contains

!###############################################################################
  function basis_merge(basis1,basis2,length,map1,map2) result(output)
    !! Merge two supplied bases
    !!
    !! Merge two bases assuming that the lattice is the same
    implicit none

    ! Arguments
    type(basis_type) :: output
    !! Output merged basis.
    class(basis_type), intent(in) :: basis1, basis2
    !! Input bases to merge.
    integer, intent(in), optional :: length
    !! Number of dimensions for atomic positions (default 3).
    integer, allocatable, dimension(:,:,:), optional, intent(inout) :: map1,map2
    !! Maps for atoms in the two bases.

    ! Local variables
    integer :: i, j, k, itmp, dim
    !! Loop counters.
    logical :: lmap
    !! Boolean for map presence.
    integer, allocatable, dimension(:) :: match
    !! Array to match species.
    integer, allocatable, dimension(:,:,:) :: new_map
    !! New map for merged basis.



    !---------------------------------------------------------------------------
    ! set up number of species
    !---------------------------------------------------------------------------
    dim=3
    if(present(length)) dim=length

    allocate(match(basis2%nspec))
    match=0
    output%nspec=basis1%nspec
    do i = 1, basis2%nspec
       if(.not.any(basis2%spec(i)%name.eq.basis1%spec(:)%name))then
          output%nspec=output%nspec+1
       end if
    end do
    allocate(output%spec(output%nspec))
    output%spec(:basis1%nspec)%num=basis1%spec(:)%num
    output%spec(:basis1%nspec)%name=basis1%spec(:)%name


    write(output%sysname,'(A,"+",A)') &
         trim(basis1%sysname),trim(basis2%sysname)
    k=basis1%nspec
    spec1check: do i = 1, basis2%nspec
       do j = 1, basis1%nspec
          if(basis2%spec(i)%name.eq.basis1%spec(j)%name)then
             output%spec(j)%num=output%spec(j)%num+basis2%spec(i)%num
             match(i)=j
             cycle spec1check
          end if
       end do
       k=k+1
       match(i)=k
       output%spec(k)%num=basis2%spec(i)%num
       output%spec(k)%name=basis2%spec(i)%name
    end do spec1check


    !---------------------------------------------------------------------------
    ! if map is present, sets up new map
    !---------------------------------------------------------------------------
    lmap = .false.
    if_map: if(present(map1).and.present(map2))then
       if(all(map1.eq.-1)) exit if_map
       lmap = .true.
       allocate(new_map(&
            output%nspec,&
            maxval(output%spec(:)%num,dim=1),2))
       new_map = 0
    end if if_map


    !---------------------------------------------------------------------------
    ! set up atoms in merged basis
    !---------------------------------------------------------------------------
    do i = 1, basis1%nspec
       allocate(output%spec(i)%atom(output%spec(i)%num,dim))
       output%spec(i)%atom(:,:)=0._real32
       output%spec(i)%atom(1:basis1%spec(i)%num,:3)=basis1%spec(i)%atom(:,:3)
       if(lmap) new_map(i,:basis1%spec(i)%num,:)=map1(i,:basis1%spec(i)%num,:)
    end do
    do i = 1, basis2%nspec
       if(match(i).gt.basis1%nspec)then
          allocate(output%spec(match(i))%atom(output%spec(match(i))%num,dim))
          output%spec(match(i))%atom(:,:)=0._real32
          output%spec(match(i))%atom(:,:3)=basis2%spec(i)%atom(:,:3)
          if(lmap) new_map(match(i),:basis2%spec(i)%num,:) = &
               map2(i,:basis2%spec(i)%num,:)
       else
          itmp=basis1%spec(match(i))%num
          output%spec(match(i))%atom(itmp+1:basis2%spec(i)%num+itmp,:3) = &
               basis2%spec(i)%atom(:,:3)   
          if(lmap) new_map(match(i),itmp+1:basis2%spec(i)%num+itmp,:) = &
               map2(i,:basis2%spec(i)%num,:)      
       end if
    end do
    output%natom=sum(output%spec(:)%num)


    if(lmap) call move_alloc(new_map,map1)

    return
  end function basis_merge
!###############################################################################

end module raffle__geom_utils

module raffle
  use raffle__constants, only: real32
  use raffle__io_utils, only: raffle__version__
  use raffle__generator, only: raffle_generator_type
  use raffle__distribs_container, only: distribs_container_type
  implicit none


  private
  public :: real32
  public :: distribs_container_type
  public :: raffle_generator_type


end module raffle

!!!#############################################################################
module raffle__tools_infile
  !! This module contains a collection of tools for reading input files.
  !!
  !! Code written by Ned Thaddeus Taylor and Francis Huw Davies
  !! Code part of the ARTEMIS group (Hepplestone research group).
  !! Think Hepplestone, think HRG.
  !! Original distribution: https://github.com/ExeQuantCode/ARTEMIS
  !! This module is distributed under the CC-BY-3.0 license.
  !! License: http://creativecommons.org/licenses/by/3.0/
  !! This module has been copied and modified with permission from the
  !! original authors.
  use raffle__constants, only: real32
  use raffle__misc, only: grep,icount

  implicit none


  private
  public :: getline, rm_comments
  public :: assign_val, assign_vec

  
  interface assign_val
     procedure assignI, assignR, assignS, assignL
  end interface assign_val

  interface assign_vec
     procedure assignIvec, assignRvec
  end interface assign_vec



contains

!###############################################################################
  function val(buffer)
    !! Return the section of buffer that occurs after an "=".
    implicit none

    ! Arguments
    character(*), intent(in) :: buffer
    !! The input buffer.

    ! Local variables
    character(100) :: val
    !! The output value.

    val = trim( adjustl( buffer((scan(buffer,"=",back=.false.)+1):) ) )

  end function val
!###############################################################################


!###############################################################################
  subroutine getline(unit, pattern, buffer)
    !! Get the line from a grep and assign it to buffer.
    implicit none

    ! Arguments
    integer, intent(in) :: unit
    !! The unit to read from.
    character(*), intent(in) :: pattern
    !! The pattern to grep for.
    character(*), intent(out) :: buffer
    !! The buffer to assign the line to.
    
    ! Local variables
    integer :: iostat
    !! input output status

    call grep(unit,pattern)
    backspace(unit)
    read(unit,'(A)',iostat=iostat) buffer
    
  end subroutine getline
!###############################################################################


!###############################################################################
  subroutine assignI(buffer, variable, found, keyword)
    !! Assign an integer to a variable.
    implicit none

    ! Arguments
    integer, intent(inout) :: found
    !! The number of variables found. External counter
    character(*), intent(inout) :: buffer
    !! The buffer to read from.
    integer, intent(out) :: variable
    !! The variable to assign to.
    character(*), optional, intent(in) :: keyword
    !! The keyword to search for.

    character(1024) :: buffer2

    if(present(keyword))then
       buffer = buffer(index(buffer,keyword):)
    end if
    if(scan("=",buffer).ne.0) buffer2 = val(buffer)
    if(trim(adjustl(buffer2)).ne.'') then
       found = found + 1
       read(buffer2,*) variable
    end if
  end subroutine assignI
!###############################################################################


!###############################################################################
  subroutine assignIvec(buffer, variable, found, keyword)
    !! Assign an arbitrary length vector of integers to a variable.
    implicit none

    ! Arguments
    integer, intent(inout) :: found
    !! The number of variables found. External counter
    character(*), intent(inout) :: buffer
    !! The buffer to read from.
    integer, dimension(:) :: variable
    !! The variable to assign to.
    character(*), optional, intent(in) :: keyword
    !! The keyword to search for.

    ! Local variables
    integer :: i
    !! Loop counter
    character(1024) :: buffer2
    !! Temporary buffer


    if(present(keyword))then
       buffer = buffer(index(buffer,keyword):)
    end if
    if(scan("=",buffer).ne.0) buffer2 = val(buffer)
    if(trim(adjustl(buffer2)).ne.'') then
       found = found + 1
       if(icount(buffer2).eq.1.and.&
            icount(buffer2).ne.size(variable))then
          read(buffer2,*) variable(1)
          variable = variable(1)
       else
          read(buffer2,*) ( variable(i), i = 1, size(variable) )
       end if
    end if
  end subroutine assignIvec
!###############################################################################


!###############################################################################
  subroutine assignR(buffer, variable, found, keyword)
    !! Assign a float value to a variable.
    implicit none

    ! Arguments
    integer, intent(inout) :: found
    !! The number of variables found. External counter
    character(*), intent(inout) :: buffer
    !! The buffer to read from.
    real(real32), intent(out) :: variable
    !! The variable to assign to.
    character(*), optional, intent(in) :: keyword
    !! The keyword to search for.

    ! Local variables
    character(1024) :: buffer2
    !! Temporary buffer

    if(present(keyword))then
       buffer = buffer(index(buffer,keyword):)
    end if
    if(scan("=",buffer).ne.0) buffer2 = val(buffer)
    if(trim(adjustl(buffer2)).ne.'') then
       found = found + 1
       read(buffer2,*) variable
    end if
  end subroutine assignR
!###############################################################################


!###############################################################################
  subroutine assignRvec(buffer, variable, found, keyword)
    !! Assign an arbitrary length float vector to a variable.
    implicit none

    ! Arguments
    integer, intent(inout) :: found
    !! The number of variables found. External counter
    character(*), intent(inout) :: buffer
    !! The buffer to read from.
    real(real32), dimension(:), intent(out) :: variable
    !! The variable to assign to.
    character(*), optional, intent(in) :: keyword
    !! The keyword to search for.

    ! Local variables
    integer :: i
    !! Loop counter
    character(1024) :: buffer2
    !! Temporary buffer

    if(present(keyword))then
       buffer = buffer(index(buffer,keyword):)
    end if
    if(scan("=",buffer).ne.0) buffer2=val(buffer)
    if(trim(adjustl(buffer2)).ne.'') then
       found = found + 1
       if(icount(buffer2).eq.1.and.&
            icount(buffer2).ne.size(variable))then
          read(buffer2,*) variable(1)
          variable = variable(1)
       else
          read(buffer2,*) (variable(i),i=1,size(variable))
       end if
    end if
  end subroutine assignRvec
!###############################################################################


!###############################################################################
  subroutine assignS(buffer, variable, found, keyword)
    !! Assign a string to a variable.
    implicit none

    ! Arguments
    integer, intent(inout) :: found
    !! The number of variables found. External counter
    character(*), intent(inout) :: buffer
    !! The buffer to read from.
    character(*), intent(out) :: variable
    !! The variable to assign to.
    character(*), optional, intent(in) :: keyword
    !! The keyword to search for.

    ! Local variables
    character(1024) :: buffer2
    !! Temporary buffer

    if(present(keyword))then
       buffer = buffer(index(buffer,keyword):)
    end if
    if(scan("=",buffer).ne.0) buffer2 = val(buffer)
    if(trim(adjustl(buffer2)).ne.'') then
       found = found + 1
       read(buffer2,'(A)') variable
    end if
  end subroutine assignS
!###############################################################################


!###############################################################################
  subroutine assignL(buffer, variable, found, keyword)
    !! Assign a logical to a variable.
    !!
    !! This subroutine will assign a logical value to a variable. The
    !! logical can take the form of a string or an integer. The following
    !! are all valid logical values:
    !! T, F, t, f, 1, 0
    implicit none

    ! Arguments
    integer, intent(inout) :: found
    !! The number of variables found. External counter
    character(*), intent(inout) :: buffer
    !! The buffer to read from.
    logical, intent(out) :: variable
    !! The variable to assign to.
    character(*), optional, intent(in) :: keyword
    !! The keyword to search for.

    ! Local variables
    character(1024) :: buffer2
    !! Buffer to read from

    if(present(keyword))then
       buffer=buffer(index(buffer,keyword):)
    end if
    if(scan("=",buffer).ne.0) buffer2 = val(buffer)
    if(trim(adjustl(buffer2)).ne.'') then
       found=found+1
       if(index(buffer2,"T").ne.0.or.&
            index(buffer2,"t").ne.0.or.&
            index(buffer2,"1").ne.0) then
          variable = .TRUE.
       end if
       if(index(buffer2,"F").ne.0.or.&
            index(buffer2,"f").ne.0.or.&
            index(buffer2,"0").ne.0) then
          variable = .FALSE.
       end if
    end if
  end subroutine assignL
!###############################################################################


!###############################################################################
  subroutine rm_comments(buffer, iline)
    !! Remove comments from a buffer.
    implicit none

    ! Arguments
    character(*), intent(inout) :: buffer
    !! Buffer to remove comments from.
    integer, optional, intent(in) :: iline
    !! Line number.

    ! Local variables
    integer :: lbracket,rbracket
    !! Bracketing variables
    integer :: iline_
    !! Line number

    iline_ = 0
    if(present(iline)) iline_ = iline

    if(scan(buffer,'!').ne.0) buffer = buffer(:(scan(buffer,'!')-1))
    if(scan(buffer,'#').ne.0) buffer = buffer(:(scan(buffer,'#')-1))
    do while(scan(buffer,'(').ne.0.or.scan(buffer,')').ne.0)
       lbracket = scan( buffer, '(', back=.true. )
       rbracket = scan( buffer(lbracket:), ')' )
       if( lbracket .eq. 0 .or. rbracket .eq. 0 )then
          write(6,'(A,I0)') &
               ' NOTE: a bracketing error was encountered on line ',iline_
          buffer = ""
          return
       end if
       rbracket = rbracket + lbracket - 1
       buffer = buffer(:(lbracket-1)) // buffer((rbracket+1):)
    end do

  end subroutine rm_comments
!###############################################################################

end module raffle__tools_infile

module raffle__viability
  !! Module to determine the viability of a set of gridpoints
  !!
  !! This module contains procedures to determine the viability of a set of
  !! points and update the viability based on new atoms being added to the cell.
#ifdef _OPENMP
  use omp_lib
#endif
  use raffle__constants, only: real32
  use raffle__misc_linalg, only: inverse_3x3
  use raffle__geom_extd, only: extended_basis_type
  use raffle__dist_calcs, only: &
       get_min_dist_between_point_and_atom, get_min_dist
  use raffle__evaluator, only: evaluate_point
  use raffle__distribs_container, only: distribs_container_type
  implicit none


  private

  public :: get_gridpoints_and_viability, update_gridpoints_and_viability


contains

!###############################################################################
  function get_gridpoints_and_viability(distribs_container, grid, bounds, &
       basis, &
       species_index_list, &
       radius_list, grid_offset) result(points)
    !! Return a list of viable gridpoints and their viability for each species.
    !!
    !! This function returns the viability of all viable gridpoints.
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    type(extended_basis_type), intent(in) :: basis
    !! Structure to add atom to.
    integer, dimension(3), intent(in) :: grid
    !! Number of gridpoints in each direction.
    real(real32), dimension(2,3), intent(in) :: bounds
    !! Bounds of the unit cell.
    real(real32), dimension(:), intent(in) :: radius_list
    !! List of radii for each pair of elements.
    integer, dimension(:), intent(in) :: species_index_list
    !! List of species indices to add atoms to.
    real(real32), dimension(3), intent(in) :: grid_offset
    !! Offset for gridpoints.
    real(real32), dimension(:,:), allocatable :: points
    !! List of gridpoints.

    ! Local variables
    integer :: i, j, k, l, is, ia
    !! Loop indices.
    integer :: num_points
    !! Number of gridpoints.
    real(real32) :: min_radius
    !! Minimum radius.
    real(real32), dimension(3) :: grid_scale, offset
    !! Grid scale and offset.
    real(real32), dimension(3) :: point
    !! Gridpoint.
    integer, dimension(3) :: idx_lw, idx_up, idx, extent, atom_idx
    !! Gridpoint indices.
    integer, dimension(3) :: grid_wo_bounds
    !! Grid size of cell without bounds.
    integer, dimension(:,:), allocatable :: idx_list
    !! Temporary list of gridpoints.
    real(real32), dimension(3,3) :: grid_matrix
    !! Grid conversion matrix.
    logical, dimension(product(grid)) :: viable
    !! Temporary list of boolean values for gridpoints.


    !---------------------------------------------------------------------------
    ! get the minimum radius for the gridpoints
    !---------------------------------------------------------------------------
    min_radius = minval(radius_list) * distribs_container%radius_distance_tol(1)
    grid_scale = ( bounds(2,:) - bounds(1,:) ) / real(grid, real32)
    grid_wo_bounds = nint( real(grid, real32) / ( bounds(2,:) - bounds(1,:) ) )


    !---------------------------------------------------------------------------
    ! get the grid offset in the unit cell
    ! i.e. the grid must perfectly intersect the
    !      grid_offset fractional coordinate
    !---------------------------------------------------------------------------
    offset = ( grid_offset - bounds(1,:) ) / grid_scale
    offset = offset - nint(offset)
    offset = bounds(1,:) + offset * grid_scale


    !---------------------------------------------------------------------------
    ! get the extent of a sphere in terms of the grid
    !---------------------------------------------------------------------------
    grid_matrix = transpose(inverse_3x3(basis%lat))
    extent = ceiling( [ &
         sum( abs( grid_matrix(1,:) ) ), &
         sum( abs( grid_matrix(2,:) ) ), &
         sum( abs( grid_matrix(3,:) ) ) &
    ] * min_radius * real(grid, real32) )

    ! precompute sphere stencil
    num_points = 0
    allocate(idx_list(1:3, product( extent * 2 + [ 1, 1, 1] )))
    do i = -extent(1), extent(1), 1
       do j = -extent(2), extent(2), 1
          do k = -extent(3), extent(3), 1
             point = matmul( [ i, j, k ] / real(grid,real32), basis%lat)
             if ( norm2(point) .lt. min_radius ) then
                num_points = num_points + 1
                idx_list(:, num_points) = [ i, j, k]
             end if
          end do
       end do
    end do

    !---------------------------------------------------------------------------
    ! apply stencil to exclude gridpoints too close to atoms
    !---------------------------------------------------------------------------
    viable = .true.
!$omp parallel do default(shared) private(i,is,ia,l,atom_idx,idx)
    do is = 1, basis%nspec
       atom_loop: do ia = 1, basis%spec(is)%num
          if(.not. basis%spec(is)%atom_mask(ia)) cycle atom_loop

          ! get the atom position in terms of the grid indices
          atom_idx = &
               nint( ( basis%spec(is)%atom(ia,1:3) - offset ) / grid_scale )

          ! if any one of the indicies is always outside of the grid, skip
          idx_lw = atom_idx - extent
          idx_lw = modulo( idx, grid_wo_bounds )
          idx_up = atom_idx + extent
          idx_up = modulo( idx, grid_wo_bounds )
          do i = 1, 3
             if( &
                  idx_lw(i) .gt. grid(i) .and. idx_up(i) .lt. grid(i) &
             ) cycle atom_loop
          end do

!$omp parallel do default(shared) private(i,idx)
          do i = 1, num_points
             idx = idx_list(:,i) + atom_idx
             idx = modulo( idx, grid_wo_bounds )
             if( any( idx .ge. grid ) ) cycle
             viable( &
                  idx(3) * grid(2) * grid(1) + &
                  idx(2) * grid(1) + &
                  idx(1) + 1 &
             ) = .false.
          end do
!$omp end parallel do
       end do atom_loop
    end do
!$omp end parallel do

    !---------------------------------------------------------------------------
    ! get the viable gridpoints in the unit cell
    !---------------------------------------------------------------------------
    num_points = count(viable)
    allocate( points( 4 + basis%nspec, num_points) )
    j = 0
    do i = 1, size(viable)
       if(.not. viable(i)) cycle
       j = j + 1
       idx(1) = mod( i - 1, grid(1) )
       idx(2) = mod( ( i - 1 ) / grid(1), grid(2) )
       idx(3) = ( i - 1 ) / ( grid(1) * grid(2) )
       points(1:3,j) = offset + grid_scale * real(idx, real32)
    end do


    !---------------------------------------------------------------------------
    ! run evaluate_point for a set of points in the unit cell
    !---------------------------------------------------------------------------
!$omp parallel do default(shared) private(i,is)
    do i = 1, num_points
       do concurrent ( is = 1 : size(species_index_list,1) )
          points(4,i) = &
               norm2( get_min_dist(basis, [ points(1:3,i) ], .false. ) )
          points(4+is,i) = &
               evaluate_point( distribs_container, &
                    points(1:3,i), species_index_list(is), basis, radius_list &
               )
       end do
    end do
!$omp end parallel do

  end function get_gridpoints_and_viability
!###############################################################################


!###############################################################################
  subroutine update_gridpoints_and_viability( &
       points, distribs_container, basis, &
       species_index_list, &
       atom, radius_list &
  )
    !! Update the list of viable gridpoints and their viability for each
    !! species.
    !!
    !! This subroutine updates the viability of all viable gridpoints.
    implicit none

    ! Arguments
    real(real32), dimension(:,:), allocatable, intent(inout) :: points
    !! List of gridpoints.
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    type(extended_basis_type), intent(in) :: basis
    !! Structure to add atom to.
    integer, dimension(2), intent(in) :: atom
    !! Index of atom to add.
    real(real32), dimension(:), intent(in) :: radius_list
    !! List of radii for each pair of elements.
    integer, dimension(:), intent(in) :: species_index_list
    !! List of species indices to add atoms to.

    ! Local variables
    integer :: i, is
    !! Loop indices.
    integer :: num_points
    !! Number of gridpoints.
    integer :: num_species
    !! Number of species.
    real(real32) :: min_radius
    !! Minimum radius.
    real(real32) :: distance
    !! Distance between atom and gridpoint.
    integer, dimension(:), allocatable :: idx
    !! List of indices of viable gridpoints.
    logical, dimension(size(points,dim=2)) :: viable
    !! Temporary list of gridpoints.
    real(real32), dimension(3) :: diff
    !! Difference between atom and gridpoint (direct coorindates).
    real(real32), dimension(3) :: atom_pos
    !! Position of atom in direct coordinates.
    real(real32), dimension(:,:), allocatable :: points_tmp
    !! Temporary list of gridpoints.


    !---------------------------------------------------------------------------
    ! run evaluate_point for a set of points in the unit cell
    !---------------------------------------------------------------------------
    if(.not.allocated(points)) return
    num_points = size(points,dim=2)
    viable = .true.
    min_radius = max( &
         distribs_container%cutoff_min(1), &
         minval(radius_list) * distribs_container%radius_distance_tol(1) &
    )
    atom_pos = basis%spec(atom(1))%atom(atom(2),1:3)
    num_species = size(species_index_list,1)
!$omp parallel do default(shared) private(i,is,diff,distance)
    do i = 1, num_points
       diff = atom_pos - points(1:3,i)
       diff = diff - anint(diff)
       distance = norm2( matmul( diff, basis%lat ) )
       if( distance .lt. min_radius )then
          viable(i) = .false.
       else
          if( distance .le. distribs_container%cutoff_max(1) )then
             do concurrent( is = 1 : num_species )
                points(4+is,i) = &
                     evaluate_point( distribs_container, &
                          points(1:3,i), species_index_list(is), basis, &
                          radius_list &
                     )
             end do
          end if
          points(4,i) = min( points(4,i), distance )
       end if
    end do
!$omp end parallel do

    num_points = count(viable)
    if(num_points.lt.1)then
       deallocate(points)
       return
    end if

    idx = pack([(i, i = 1, size(viable))], viable)
    points_tmp = points(:, idx)
    call move_alloc(points_tmp, points)

  end subroutine update_gridpoints_and_viability
!###############################################################################

end module raffle__viability

program test_distribs_container
  use raffle__io_utils, only: test_error_handling
  use raffle__distribs_container, only: &
       distribs_container_type
  use raffle__constants, only: real32, pi
  use raffle__geom_rw, only: basis_type
  implicit none

  logical :: success = .true.
  type(basis_type) :: basis_diamond, basis_graphite, basis_mgo

  test_error_handling = .true.

  ! diamond cell
  basis_diamond%nspec = 1
  basis_diamond%natom = 8
  allocate(basis_diamond%spec(basis_diamond%nspec))
  basis_diamond%spec(1)%num = 8
  basis_diamond%spec(1)%name = 'C'
  allocate(basis_diamond%spec(1)%atom(basis_diamond%spec(1)%num, 3))
  basis_diamond%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  basis_diamond%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  basis_diamond%spec(1)%atom(3, :3) = [0.5, 0.0, 0.5]
  basis_diamond%spec(1)%atom(4, :3) = [0.0, 0.5, 0.5]
  basis_diamond%spec(1)%atom(5, :3) = [0.25, 0.25, 0.25]
  basis_diamond%spec(1)%atom(6, :3) = [0.75, 0.75, 0.25]
  basis_diamond%spec(1)%atom(7, :3) = [0.75, 0.25, 0.75]
  basis_diamond%spec(1)%atom(8, :3) = [0.25, 0.75, 0.75]

  basis_diamond%lat(1,:) = [3.5607451090903233, 0.0, 0.0]
  basis_diamond%lat(2,:) = [0.0, 3.5607451090903233, 0.0]
  basis_diamond%lat(3,:) = [0.0, 0.0, 3.5607451090903233]
  basis_diamond%energy = -72.213492

  ! graphite cell
  basis_graphite%nspec = 1
  basis_graphite%natom = 4
  allocate(basis_graphite%spec(basis_graphite%nspec))
  basis_graphite%spec(1)%num = 4
  basis_graphite%spec(1)%name = 'C'
  allocate(basis_graphite%spec(1)%atom(basis_graphite%spec(1)%num, 3))
  basis_graphite%spec(1)%atom(1, :3) = [0.0, 0.0, 0.25]
  basis_graphite%spec(1)%atom(2, :3) = [0.0, 0.0, 0.75]
  basis_graphite%spec(1)%atom(3, :3) = [1.0/3.0, 2.0/3.0, 0.25]
  basis_graphite%spec(1)%atom(4, :3) = [2.0/3.0, 1.0/3.0, 0.75]

  basis_graphite%lat(1,:) = [1.2336456308015413, -2.1367369110836267, 0.0]
  basis_graphite%lat(2,:) = [1.2336456308015413,  2.1367369110836267, 0.0]
  basis_graphite%lat(3,:) = [0.0, 0.0, 7.8030730000000004]
  basis_graphite%energy = -36.86795585

  ! diamond cell
  basis_mgo%nspec = 2
  basis_mgo%natom = 8
  allocate(basis_mgo%spec(basis_mgo%nspec))
  basis_mgo%spec(1)%num = 4
  basis_mgo%spec(1)%name = 'Mg'
  allocate(basis_mgo%spec(1)%atom(basis_mgo%spec(1)%num, 3))
  basis_mgo%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  basis_mgo%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  basis_mgo%spec(1)%atom(3, :3) = [0.5, 0.0, 0.5]
  basis_mgo%spec(1)%atom(4, :3) = [0.0, 0.5, 0.5]
  basis_mgo%spec(2)%num = 4
  basis_mgo%spec(2)%name = 'O'
  allocate(basis_mgo%spec(2)%atom(basis_mgo%spec(2)%num, 3))
  basis_mgo%spec(2)%atom(1, :3) = [0.5, 0.0, 0.0]
  basis_mgo%spec(2)%atom(2, :3) = [0.0, 0.5, 0.0]
  basis_mgo%spec(2)%atom(3, :3) = [0.0, 0.0, 0.5]
  basis_mgo%spec(2)%atom(4, :3) = [0.5, 0.5, 0.5]

  basis_mgo%lat(1,:) = [4.19, 0.0, 0.0]
  basis_mgo%lat(2,:) = [0.0, 4.19, 0.0]
  basis_mgo%lat(3,:) = [0.0, 0.0, 4.19]
  basis_mgo%energy = -20.0

  call test_init_distribs_container(success)
  call test_set_width(success)
  call test_set_sigma(success)
  call test_set_cutoff_min(success)
  call test_set_cutoff_max(success)
  call test_set_radius_distance_tol(success)
  call test_create([basis_graphite], success)
  call test_update([basis_graphite, basis_diamond], success)

  call test_create([basis_diamond, basis_mgo], success)
  call test_update([basis_diamond, basis_mgo], success)
  !  call test_write_read(success)
  !  call test_write_2body(success)
  !  call test_write_3body(success)
  !  call test_write_4body(success)
  call test_add(basis_diamond, success)
  call test_get_element_energies(basis_diamond, success)
  call test_get_element_energies_staticmem(basis_diamond, success)
  call test_set_bond_radii(basis_diamond, success)
  call test_get_bin(success)

  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_distribs_container passed all tests'
  else
     write(0,*) 'test_distribs_container failed one or more tests'
     stop 1
  end if

contains

  subroutine test_init_distribs_container(success)
    implicit none
    logical, intent(inout) :: success

    integer :: i
    class(distribs_container_type), allocatable :: distribs_container
    character(len=10) :: test_name

    integer, dimension(3) :: nbins
    real(real32), dimension(3) :: width, sigma, cutoff_min, cutoff_max

    ! Test case 1: Default initialisation
    distribs_container = distribs_container_type()
    nbins = [-1, -1, -1]
    width = [0.025_real32, pi/64._real32, pi/64._real32]
    sigma = [0.1_real32, 0.1_real32, 0.1_real32]
    cutoff_min = [0.5_real32, 0._real32, 0._real32]
    cutoff_max = [6._real32, pi, pi]
    test_name = "Default"

    do i = 1, 2
       call assert( &
            all( distribs_container%nbins .eq. nbins ), &
            trim(test_name)//" nbins initialisation failed", &
            success &
       )
       call assert( &
            all( abs( distribs_container%width - width ) .lt. 1.E-6_real32 ), &
            trim(test_name)//" width initialisation failed", &
            success &
       )
       call assert( &
            all( abs( distribs_container%sigma - sigma ) .lt. 1.E-6_real32 ), &
            trim(test_name)//" sigma initialisation failed", &
            success &
       )
       call assert( &
            all( abs( distribs_container%cutoff_min - cutoff_min ) .lt. &
                 1.E-6_real32 &
            ), &
            trim(test_name)//" cutoff_min initialisation failed", &
            success &
       )
       call assert( &
            all( abs( distribs_container%cutoff_max - cutoff_max ) .lt. &
                 1.E-6_real32 &
            ), &
            trim(test_name)//" cutoff_max initialisation failed", &
            success &
       )

       if(i.eq.2) exit
       ! Test case 2: Custom initialisation
       nbins = [10, 20, 30]
       width = [0.05_real32, 0.1_real32, 0.15_real32]
       sigma = [0.2_real32, 0.3_real32, 0.4_real32]
       cutoff_min = [1.0_real32, 2.0_real32, 3.0_real32]
       cutoff_max = [5.0_real32, 6.0_real32, 7.0_real32]
       distribs_container = distribs_container_type( &
            nbins=nbins,  &
            width=width,  &
            sigma=sigma,  &
            cutoff_min=cutoff_min,  &
            cutoff_max=cutoff_max &
       )
       test_name = "Custom"
    end do

    write(*,*) "Testing distribs_container_type initialisation error handling"
    cutoff_min = [6.0_real32, 6.0_real32, 6.0_real32]
    cutoff_max = [1.0_real32, 1.0_real32, 1.0_real32]
    distribs_container = distribs_container_type( &
         cutoff_min=cutoff_min,  &
         cutoff_max=cutoff_max &
    )
    write(*,*) "Handled error: cutoff_min > cutoff_max"
  
  end subroutine test_init_distribs_container

  subroutine test_set_width(success)
    implicit none
    logical, intent(inout) :: success

    type(distribs_container_type) :: distribs_container
    real(real32), dimension(3) :: width

    ! Initialise test data
    width = [0.05_real32, 0.1_real32, 0.15_real32]

    ! Call the subroutine to set the width
    call distribs_container%set_width(width)

    ! Check if the width was set correctly
    call assert( &
         all( abs( distribs_container%width - width ) .lt. 1.E-6_real32 ), &
         "Width was not set correctly", &
         success &
    )

  end subroutine test_set_width

  subroutine test_set_sigma(success)
    implicit none
    logical, intent(inout) :: success

    type(distribs_container_type) :: distribs_container
    real(real32), dimension(3) :: sigma

    ! Initialise test data
    sigma = [0.05_real32, 0.1_real32, 0.15_real32]

    ! Call the subroutine to set the width
    call distribs_container%set_sigma(sigma)

    ! Check if the width was set correctly
    call assert( &
         all( abs( distribs_container%sigma - sigma ) .lt. 1.E-6_real32 ), &
         "Sigma was not set correctly", &
         success &
    )

  end subroutine test_set_sigma

  subroutine test_set_cutoff_min(success)
    implicit none
    logical, intent(inout) :: success

    type(distribs_container_type) :: distribs_container
    real(real32), dimension(3) :: cutoff_min

    ! Initialise test data
    cutoff_min = [0.5_real32, 0.5_real32, 0.5_real32]

    ! Call the subroutine to set the cutoff_min
    call distribs_container%set_cutoff_min(cutoff_min)

    ! Check if the cutoff_min was set correctly
    call assert( &
         all( abs( distribs_container%cutoff_min - cutoff_min ) .lt. &
              1.E-6_real32 &
         ), &
         "Cutoff_min was not set correctly", &
         success &
    )

  end subroutine test_set_cutoff_min

  subroutine test_set_cutoff_max(success)
    implicit none
    logical, intent(inout) :: success

    type(distribs_container_type) :: distribs_container
    real(real32), dimension(3) :: cutoff_max

    ! Initialise test data
    cutoff_max = [6.0_real32, 6.0_real32, 6.0_real32]

    ! Call the subroutine to set the cutoff_max
    call distribs_container%set_cutoff_max(cutoff_max)

    ! Check if the cutoff_max was set correctly
    call assert( &
         all( abs( distribs_container%cutoff_max - cutoff_max ) .lt. &
              1.E-6_real32 &
         ), &
         "Cutoff_max was not set correctly", &
         success &
    )

  end subroutine test_set_cutoff_max

  subroutine test_set_radius_distance_tol(success)
    implicit none
    logical, intent(inout) :: success

    type(distribs_container_type) :: distribs_container
    real(real32), dimension(4) :: radius_distance_tol

    ! Initialise test data
    radius_distance_tol = [1.5_real32, 2.5_real32, 3.0_real32, 6.0_real32]

    ! Call the subroutine to set the radius_distance_tol
    call distribs_container%set_radius_distance_tol(radius_distance_tol)

    ! Check if the radius_distance_tol was set correctly
    call assert( &
         all( &
              abs( &
                   distribs_container%radius_distance_tol - radius_distance_tol &
              ) .lt. 1.E-6_real32 &
         ), &
         "Radius_distance_tol was not set correctly", &
         success &
    )

  end subroutine test_set_radius_distance_tol



  subroutine test_create(basis, success)
    !! Test the create subroutine of distribs_container_type
    implicit none
    logical, intent(inout) :: success
    type(basis_type), dimension(:), intent(in) :: basis

    integer :: i, j, k
    integer :: num_pairs
    character(len=3) :: species_tmp
    type(distribs_container_type) :: distribs_container
    type(basis_type), dimension(size(basis,1)) :: basis_list
    character(len=3), dimension(:), allocatable :: elements

    ! Initialise basis_list
    do i = 1, size(basis,1)
       call basis_list(i)%copy(basis(i))
    end do

    ! Test element_database uninitiaised error handling
    write(*,*) "Testing distribs_container_type create error handling"
    call distribs_container%create(basis_list, deallocate_systems=.false.)
    write(*,*) "Handled error: element_database not initialised"

    ! Set element energies
    allocate(elements(0))
    do i = 1, size(basis_list)
       species_loop: do j = 1, basis_list(i)%nspec
          call distribs_container%set_element_energies( &
               [ basis_list(i)%spec(1)%name ], [ -9.027_real32 ] &
          )
          species_tmp = basis_list(i)%spec(j)%name(1:3)
          if(.not.allocated(elements).or.size(elements,1).eq.0) then
             elements = [ species_tmp ]
             cycle species_loop
          end if
          do k = 1, size(elements), 1
             if ( trim(elements(k)) .eq. trim(species_tmp) ) &
                  cycle species_loop
          end do
          elements = [ elements, species_tmp ]
       end do species_loop
    end do
    num_pairs = nint( &
         gamma(real(size(elements) + 2, real32) ) / &
         ( gamma(real(size(elements), real32)) * gamma( 3._real32 ) ) &
    )

    ! Call the create subroutine
    call distribs_container%create(basis_list, deallocate_systems=.false.)

    ! Check if the system is allocated
    call assert( &
         allocated(distribs_container%system),  &
         "system not allocated",  &
         success &
    )

    ! Check number of elements in element_info is correct
    call assert( &
         size(distribs_container%element_info, dim=1) .eq. size(elements),  &
         "Number of elements in element_info is incorrect",  &
         success &
    )

    ! Check symbol of the element is correct
    call assert( &
         any( elements .eq. distribs_container%element_info(1)%name ),  &
         "Symbol of the element is incorrect",  &
         success &
    )

    ! Check element energies are set correctly
    call assert( &
         abs( distribs_container%element_info(1)%energy + 9.027_real32 ) .lt. &
         1.E-6_real32 , &
         "element energies not set correctly",  &
         success &
    )

    ! Check if the 2-/3-/4-body distribution functions are not allocated
    call assert( &
         ( &
              allocated(distribs_container%gdf%df_2body) .or. &
              allocated(distribs_container%gdf%df_3body) .or. &
              allocated(distribs_container%gdf%df_4body) &
         ),  &
         "2-/3-/4-body distribution functions are allocated",  &
         success &
    )

    ! Check number of species and species pairs are correct
    call assert( &
         size(distribs_container%gdf%df_2body, dim=2) .eq. num_pairs,  &
         "Number of species pairs in 2-body distribution function &
         &is incorrect",  &
         success &
    )
    call assert( &
         size(distribs_container%gdf%df_3body, dim=2) .eq. size(elements),  &
         "Number of species in 3-body distribution function &
         &is incorrect",  &
         success &
    )
    call assert( &
         size(distribs_container%gdf%df_4body, dim=2) .eq. size(elements),  &
         "Number of species in 4-body distribution function &
         &is incorrect",  &
         success &
    )

    ! Check if the 2-/3-/4-body distribution functions are not zero
    call assert( &
         any( abs( distribs_container%gdf%df_2body ) .gt. 1.E-6_real32 ),  &
         "2-body distribution functions are zero",  &
         success &
    )
    call assert( &
         any( abs( distribs_container%gdf%df_3body ) .gt. 1.E-6_real32 ),  &
         "3-body distribution functions are zero",  &
         success &
    )
    call assert( &
         any( abs( distribs_container%gdf%df_4body ) .gt. 1.E-6_real32 ),  &
         "4-body distribution functions are zero",  &
         success &
    )

    ! Check if the 2-/3-/4-body distribution functions are not NaN
    call assert( &
         all( .not. isnan( distribs_container%gdf%df_2body ) ),  &
         "2-body distribution functions are NaN",  &
         success &
    )
    call assert( &
         all( .not. isnan( distribs_container%gdf%df_3body ) ),  &
         "3-body distribution functions are NaN",  &
         success &
    )
    call assert( &
         all( .not. isnan( distribs_container%gdf%df_4body ) ),  &
         "4-body distribution functions are NaN",  &
         success &
    )

    ! Check that the maximum value of 2-/3-/4-body distribution functions is 1
    do i = 1, size(distribs_container%gdf%df_2body, dim=2)
       call assert( &
            abs( &
                 maxval(distribs_container%gdf%df_2body(:,i)) - &
                 1._real32 &
            ) .lt. 1.E-6_real32, &
            "Maximum value of 2-body distribution functions is not 1",  &
            success &
       )
    end do
    do i = 1, size(distribs_container%gdf%df_3body, dim=2)
       call assert( &
            abs( &
                 maxval(distribs_container%gdf%df_3body(:,i)) - &
                 1._real32 &
            ) .lt. 1.E-6_real32, &
            "Maximum value of 3-body distribution functions is not 1",  &
            success &
       )
       call assert( &
            abs( &
                 maxval(distribs_container%gdf%df_4body(:,i)) - &
                 1._real32 &
            ) .lt. 1.E-6_real32, &
            "Maximum value of 4-body distribution functions is not 1",  &
            success &
       )
    end do

    ! Check if norm is allocated and not zero
    call assert( &
         allocated(distribs_container%norm_2body) .and. &
         all( abs( distribs_container%norm_2body ) .gt. 1.E-6_real32 ),  &
         "2-body norm is not allocated or zero",  &
         success &
    )
    call assert( &
         allocated(distribs_container%norm_3body) .and. &
         all( abs( distribs_container%norm_3body ) .gt. 1.E-6_real32 ),  &
         "3-body norm is not allocated or zero",  &
         success &
    )
    call assert( &
         allocated(distribs_container%norm_4body) .and. &
         all( abs( distribs_container%norm_4body ) .gt. 1.E-6_real32 ),  &
         "4-body norm is not allocated or zero",  &
         success &
    )

    ! Call the create subroutine again
    call distribs_container%create(basis_list, deallocate_systems=.true.)

    ! Check if the system is deallocated
    call assert( &
         .not.allocated(distribs_container%system),  &
         "system not correctly deallocated",  &
         success &
    )
    
  end subroutine test_create

  subroutine test_update(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), dimension(:), intent(in) :: basis

    integer :: i, j, k
    integer :: num_pairs
    character(len=3) :: species_tmp
    type(distribs_container_type) :: distribs_container
    type(basis_type), dimension(size(basis,1)) :: basis_list
    character(len=3), dimension(:), allocatable :: elements

    ! Initialise basis_list
    do i = 1, size(basis,1)
       call basis_list(i)%copy(basis(i))
    end do

    ! Set host system
    call distribs_container%host_system%set(basis(1))

    ! Set element energies
    do i = 1, size(basis_list)
       species_loop: do j = 1, basis_list(i)%nspec
          call distribs_container%set_element_energies( &
               [ basis_list(i)%spec(1)%name ], [ -9.027_real32 ] &
          )
          species_tmp = basis_list(i)%spec(j)%name(1:3)
          if(.not.allocated(elements)) then
             elements = [ species_tmp ]
             cycle species_loop
          end if
          do k = 1, size(elements), 1
             if ( trim(elements(k)) .eq. trim(species_tmp) ) &
                  cycle species_loop
          end do
          elements = [ elements, species_tmp ]
       end do species_loop
    end do
    num_pairs = nint( &
         gamma(real(size(elements) + 2, real32)) / &
         ( gamma(real(size(elements), real32)) * gamma( 3._real32 ) ) &
    )

    ! Call the create subroutine
    call distribs_container%create([basis_list(1)], deallocate_systems=.false.)

    ! Call the update subroutine
    call distribs_container%update([basis_list(2)], deallocate_systems=.false.)

    ! Check if the system is allocated
    call assert( &
         allocated(distribs_container%system),  &
         "system not allocated",  &
         success &
    )

    ! Call the create subroutine again
    call distribs_container%update([basis_list(2)], deallocate_systems=.true.)

    ! Check if the system is deallocated
    call assert( &
         .not.allocated(distribs_container%system),  &
         "system not correctly deallocated",  &
         success &
    )
    
  end subroutine test_update

  subroutine test_add(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis

    type(distribs_container_type) :: distribs_container
    integer, dimension(1,1,1,1) :: test_array = 1

    ! Call the add subroutine
    call distribs_container%add(basis)

    ! Check number of systems is correct
    call assert( &
         size(distribs_container%system, dim=1) .eq. 1,  &
         "Number of systems is incorrect",  &
         success &
    )

    ! Check if the system information is correct
    call assert( &
         abs( &
              distribs_container%system(1)%energy - basis%energy &
         ) .lt. 1.E-6,  &
         "System energy is incorrect",  &
         success &
    )
    call assert( &
         distribs_container%system(1)%num_atoms .eq. basis%natom,  &
         "Number of atoms is incorrect",  &
         success &
    )

    ! Call the add subroutine
    call distribs_container%add([basis])

    ! Check number of systems is correct
    call assert( &
         size(distribs_container%system, dim=1) .eq. 2,  &
         "Number of systems is incorrect",  &
         success &
    )

    ! Check the add subroutine
    call distribs_container%add(distribs_container%system(1))

    ! Check number of systems is correct
    call assert( &
         size(distribs_container%system, dim=1) .eq. 3,  &
         "Number of systems is incorrect",  &
         success &
    )

    ! Check the add subroutine
    call distribs_container%add(distribs_container%system)

    ! Check number of systems is correct
    call assert( &
         size(distribs_container%system, dim=1) .eq. 6,  &
         "Number of systems is incorrect",  &
         success &
    )

    ! Test unknown type and rank error handling
    write(*,*) "Testing distribs_container_type add error handling"
    call distribs_container%add(1)
    call distribs_container%add([1])
    write(*,*) "Handled error: system default type"
    call distribs_container%add(test_array)
    write(*,*) "Handled error: system default rank"



  end subroutine test_add

  subroutine test_get_element_energies(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis

    type(distribs_container_type) :: distribs_container
    character(len=3), dimension(:), allocatable :: elements
    real(real32), dimension(:), allocatable :: energies

    call distribs_container%set_element_energies(['C  '], [-9.027_real32])
    call distribs_container%add(basis)

    ! Call the get_element_energies subroutine
    call distribs_container%get_element_energies(elements, energies)

    ! Check if the element energies are retrieved correctly
    call assert( &
         size(elements, dim=1) .eq. 1,  &
         "Number of elements is incorrect",  &
         success &
    )
    call assert( &
         size(energies, dim=1) .eq. 1,  &
         "Number of energies is incorrect",  &
         success &
    )
    call assert( &
         trim(elements(1)) .eq. 'C',  &
         "Element symbol is incorrect",  &
         success &
    )
    call assert( &
         abs(energies(1) + 9.027_real32) .lt. 1.E-6_real32,  &
         "Element energy is incorrect",  &
         success &
    )
    
  end subroutine test_get_element_energies

  subroutine test_get_element_energies_staticmem(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis

    type(distribs_container_type) :: distribs_container
    character(len=3), dimension(1) :: elements
    real(real32), dimension(1) :: energies

    call distribs_container%set_element_energies(['C  '], [-9.027_real32])
    call distribs_container%add(basis)

    ! Call the get_element_energies_staticmem subroutine
    call distribs_container%get_element_energies_staticmem(elements, energies)

    ! Check if the element energies are retrieved correctly
    call assert( &
         size(elements, dim=1) .eq. 1,  &
         "Number of elements is incorrect",  &
         success &
    )
    call assert( &
         size(energies, dim=1) .eq. 1,  &
         "Number of energies is incorrect",  &
         success &
    )
    call assert( &
         trim(elements(1)) .eq. 'C',  &
         "Element symbol is incorrect",  &
         success &
    )
    call assert( &
         abs(energies(1) + 9.027_real32) .lt. 1.E-6_real32,  &
         "Element energy is incorrect",  &
         success &
    )
    
  end subroutine test_get_element_energies_staticmem

  subroutine test_set_bond_radii(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis

    integer :: i
    type(distribs_container_type) :: distribs_container
    real(real32), dimension(1) :: radii
    character(len=3), dimension(1,2) :: elements
    real(real32), dimension(:), allocatable :: radii_get
    character(len=3), dimension(:,:), allocatable :: elements_get

    ! Initialise test data
    radii(1) = 12.5_real32
    elements(1,:) = ['C  ', 'C  ']

    ! Call the subroutine to set the bond radii
    call distribs_container%set_bond_radii(elements, radii)
    call distribs_container%add(basis)

    ! Get the bond radii
    call distribs_container%get_bond_radii(elements_get, radii_get)

    ! Check if the number of bond elements is correct
    call assert( &
         size(elements_get, dim=1) .eq. 1,  &
         "Number of bond elements is incorrect",  &
         success &
    )

    do i = 1, 2
       ! Check if the bond elements were set correctly
       call assert( &
            all( elements_get .eq. elements ), &
            "Bond elements were not set correctly", &
            success &
       )
       ! Check if the bond radius was set correctly
       call assert( &
            all( abs( radii_get - radii ) .lt. 1.E-6 ), &
            "Bond radius was not set correctly", &
            success &
       )

       elements_get = '   '
       radii_get = 0.0_real32
       ! Get the bond radii from staticmem
       call distribs_container%get_bond_radii_staticmem(elements_get, radii_get)
    end do

    radii(1) = 14.2_real32
    call distribs_container%set_bond_radii(elements, radii)
    call distribs_container%get_bond_radii(elements_get, radii_get)

    ! Check if the bond radius was set correctly
    call assert( &
         all( abs( radii_get - radii ) .lt. 1.E-6 ), &
         "Bond radius was not set correctly", &
         success &
    )
    
    

  end subroutine test_set_bond_radii


  subroutine test_get_bin(success)
    implicit none
    logical, intent(inout) :: success

    integer :: bin
    type(distribs_container_type) :: distribs_container

    distribs_container%nbins(1) = 10

    ! Check lower bound correct handling
    bin = distribs_container%get_bin(0._real32, 1)
    call assert( &
         bin .eq. 0,  &
         "Bin is incorrect",  &
         success &
    )

    ! Check upper bound correct handling
    bin = distribs_container%get_bin(100._real32, 1)
    call assert( &
         bin .eq. 0,  &
         "Bin is incorrect",  &
         success &
    )

    ! Check middle value correct handling
    bin = distribs_container%get_bin(3._real32, 1)
    call assert( &
         bin .eq. 1 + nint( (distribs_container%nbins(1) - 1) * 2.5 / 5.5 ),  &
         "Bin is incorrect",  &
         success &
    )


  end subroutine test_get_bin

!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_distribs_container

program test_io_utils
  use raffle__io_utils
  implicit none

  ! Test variables
  logical :: success = .true.
  character(100) :: message

  ! Test stop_program subroutine
  test_error_handling = .true.
  message = "Test error message"
  call stop_program(message)

  ! Test print_warning subroutine
  call print_warning("This is a test warning message")
  
  ! Test print_version subroutine
  call print_version()

  ! Test print_build_info subroutine
  call print_build_info()

  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_misc_linalg passed all tests'
  else
     write(0,*) 'test_misc_linalg failed one or more tests'
     stop 1
  end if

end program test_io_utils

program test_edit_geom
  !! Test program for the module edit_geom.
  use raffle__constants, only: real32
  use raffle__geom_rw, only: basis_type
  use raffle__misc_linalg, only: modu
  use raffle__dist_calcs, only: &
       get_min_dist, &
       get_min_dist_between_point_and_atom, &
       get_min_dist_between_point_and_species, &
       get_dist_between_point_and_atom

  implicit none

  type(basis_type) :: bas, bas2
  real(real32) :: rtmp1, rtmp2
  real(real32), dimension(3) :: loc

  logical :: success = .true.


  ! Initialise silicon basis
  bas%sysname = "Silicon"
  bas%nspec = 1
  bas%natom = 2
  allocate(bas%spec(bas%nspec))
  bas%spec(1)%num = 2
  bas%spec(1)%name = 'Si'
  allocate(bas%spec(1)%atom(bas%spec(1)%num, 3))
  bas%spec(1)%atom(1, :) = [0.0, 0.0, 0.0]
  bas%spec(1)%atom(2, :) = [0.25, 0.25, 0.25]

  ! Initialise silicon lattice
  bas%lat(1,:) = [0.0, 2.14, 2.14]
  bas%lat(2,:) = [2.14, 0.0, 2.14]
  bas%lat(3,:) = [2.14, 2.14, 0.0]
  call bas%set_atom_mask()


  !-----------------------------------------------------------------------------
  ! Test get_min_dist
  !-----------------------------------------------------------------------------
  rtmp1 = modu(get_min_dist(bas, loc=[0.9, 0.9, 0.9], lignore_close = .true.))

  loc = [1.0, 1.0, 1.0] - [0.9, 0.9, 0.9]
  loc = loc - ceiling(loc - 0.5)
  loc = matmul(loc, bas%lat)
  rtmp2 = modu(loc)

  if ( abs(rtmp1 - rtmp2) .gt. 1.E-6 ) then
     write(0,*) 'get_min_dist failed'
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! Test get_min_dist_between_point_and_atom
  !-----------------------------------------------------------------------------
  rtmp1 = get_min_dist_between_point_and_atom( &
       bas,  &
       loc=[0.9, 0.9, 0.9],  &
       atom=[1, 1] &
  )

  loc = [1.0, 1.0, 1.0] - [0.9, 0.9, 0.9]
  loc = loc - ceiling(loc - 0.5)
  loc = matmul(loc, bas%lat)
  rtmp2 = modu(loc)

  if ( abs(rtmp1 - rtmp2) .gt. 1.E-6 ) then
     write(0,*) 'get_min_dist_between_point_and_atom failed'
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! Test get_min_dist_between_point_and_species
  !-----------------------------------------------------------------------------
  bas2%sysname = "Si|Ge"
  bas2%nspec = 2
  bas2%natom = 2
  allocate(bas2%spec(bas2%nspec))
  bas2%spec(1)%num = 1
  bas2%spec(1)%name = 'Si'
  allocate(bas2%spec(1)%atom(bas2%spec(1)%num, 3))
  bas2%spec(1)%atom(1, :) = [0.0, 0.0, 0.0]
  bas2%spec(2)%num = 1
  bas2%spec(2)%name = 'Ge'
  allocate(bas2%spec(2)%atom(bas2%spec(2)%num, 3))
  bas2%spec(2)%atom(1, :) = [0.25, 0.25, 0.25]
  call bas2%set_atom_mask()

  rtmp1 = get_min_dist_between_point_and_species( &
       bas2,  &
       loc=[0.9, 0.9, 0.9],  &
       species=1 &
  )
  loc = bas2%spec(1)%atom(1,:3) - [0.9, 0.9, 0.9]
  loc = loc - ceiling(loc - 0.5)
  loc = matmul(loc, bas2%lat)
  rtmp2 = modu(loc)

  if ( abs(rtmp1 - rtmp2) .gt. 1.E-6 ) then
     write(0,*) 'get_min_dist_between_point_and_species failed'
     success = .false.
  end if

  rtmp1 = get_min_dist_between_point_and_species( &
       bas2,  &
       loc=[0.9, 0.9, 0.9],  &
       species=2 &
  )
  loc = bas2%spec(2)%atom(1,:3) - [0.9, 0.9, 0.9]
  loc = loc - ceiling(loc - 0.5)
  loc = matmul(loc, bas2%lat)
  rtmp2 = modu(loc)

  if ( abs(rtmp1 - rtmp2) .gt. 1.E-6 ) then
     write(0,*) 'get_min_dist_between_point_and_species failed'
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! Test get_dist_between_point_and_atom
  !-----------------------------------------------------------------------------
  rtmp1 = get_dist_between_point_and_atom( &
       bas,  &
       loc=[0.9, 0.9, 0.9],  &
       atom=[1, 1] &
  )
  loc = bas%spec(1)%atom(1,:3) - [0.9, 0.9, 0.9]
  loc = matmul(loc, bas%lat)
  rtmp2 = modu(loc)
  if ( abs(rtmp1 - rtmp2) .gt. 1.E-6 ) then
     write(*,*) rtmp1, rtmp2
     write(0,*) 'get_dist_between_point_and_atom failed'
     success = .false.
  end if
  rtmp1 = get_dist_between_point_and_atom( &
       bas,  &
       loc=[0.9, 0.9, 0.9],  &
       atom=[1, 2] &
  )
  loc = bas%spec(1)%atom(2,:3) - [0.9, 0.9, 0.9]
  loc = matmul(loc, bas%lat)
  rtmp2 = modu(loc)
  if ( abs(rtmp1 - rtmp2) .gt. 1.E-6 ) then
     write(*,*) rtmp1, rtmp2
     write(0,*) 'get_dist_between_point_and_atom failed'
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_dist_calcs passed all tests'
  else
     write(0,*) 'test_dist_calcs failed one or more tests'
     stop 1
  end if

end program test_edit_geom

program test_geom_extd
  !! Test program for the module geom_extd.
  use raffle__io_utils
  use raffle__constants, only: real32
  use raffle__geom_extd
  implicit none

  type(extended_basis_type) :: basis_diamond

  logical :: success = .true.

  test_error_handling = .true.

  ! diamond cell
  basis_diamond%nspec = 1
  basis_diamond%natom = 8
  allocate(basis_diamond%spec(basis_diamond%nspec))
  basis_diamond%spec(1)%num = 8
  basis_diamond%spec(1)%name = 'C'
  allocate(basis_diamond%spec(1)%atom(basis_diamond%spec(1)%num, 3))
  basis_diamond%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  basis_diamond%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  basis_diamond%spec(1)%atom(3, :3) = [0.5, 0.0, 0.5]
  basis_diamond%spec(1)%atom(4, :3) = [0.0, 0.5, 0.5]
  basis_diamond%spec(1)%atom(5, :3) = [0.25, 0.25, 0.25]
  basis_diamond%spec(1)%atom(6, :3) = [0.75, 0.75, 0.25]
  basis_diamond%spec(1)%atom(7, :3) = [0.75, 0.25, 0.75]
  basis_diamond%spec(1)%atom(8, :3) = [0.25, 0.75, 0.75]

  basis_diamond%lat(1,:) = [3.5607451090903233, 0.0, 0.0]
  basis_diamond%lat(2,:) = [0.0, 3.5607451090903233, 0.0]
  basis_diamond%lat(3,:) = [0.0, 0.0, 3.5607451090903233]
  basis_diamond%energy = -72.213492

  call test_create_images(basis_diamond, success)
  call test_update_iamges(basis_diamond, success)

  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_geom_extd passed all tests'
  else
     write(0,*) 'test_geom_extd failed one or more tests'
     stop 1
  end if

contains

  subroutine test_create_images(basis, success)
    implicit none
    type(extended_basis_type), intent(in) :: basis
    logical, intent(inout) :: success

    type(extended_basis_type) :: basis_copy

    call basis_copy%copy(basis)

    ! Create images
    call basis_copy%create_images( max_bondlength = 0._real32 )

    ! Check if the number of images is correct
    call assert( &
         basis_copy%num_images .eq. 10, &
         'Number of images is not correct', &
         success &
    )
    call assert( &
         basis_copy%image_spec(1)%num .eq. 10, &
         'Number of images in first species is not correct', &
         success &
    )
    call assert( &
         all( &
              basis_copy%image_spec(1)%atom(:, :) - &
              1._real32 .lt. 1.E-6_real32 &
         ), &
         'Atoms outside of max bondlength', &
         success &
    )

  end subroutine test_create_images

  subroutine test_update_iamges(basis, success)
    implicit none
    type(extended_basis_type), intent(in) :: basis
    logical, intent(inout) :: success

    type(extended_basis_type) :: basis_copy
    integer, dimension(2,1) :: atom_ignore_list

    call basis_copy%copy(basis)
    atom_ignore_list(:,1) = [1, 1]
    call basis_copy%set_atom_mask( atom_ignore_list )

    ! Create images
    call basis_copy%create_images( max_bondlength = 0._real32 )

    ! Check if the number of images is correct
    call assert( &
         basis_copy%num_images .eq. 3, &
         'Number of images is not correct', &
         success &
    )
    call assert( &
         basis_copy%image_spec(1)%num .eq. 3, &
         'Number of images in first species is not correct', &
         success &
    )

    ! Update images
    call basis_copy%update_images( max_bondlength = 0._real32, is = 1, ia = 1 )

    ! Check if the number of images is correct
    call assert( &
         basis_copy%num_images .eq. 10, &
         'Number of images is not correct', &
         success &
    )
    call assert( &
         basis_copy%image_spec(1)%num .eq. 10, &
         'Number of images in first species is not correct', &
         success &
    )
    call assert( &
         all( &
              basis_copy%image_spec(1)%atom(:, :) - &
              1._real32 .lt. 1.E-6_real32 &
         ), &
         'Atoms outside of max bondlength', &
         success &
    )

  end subroutine test_update_iamges

!###############################################################################

  function compare_bas(bas1, bas2) result(output)
    type(extended_basis_type), intent(in) :: bas1, bas2
    logical :: output
    output = .true.

    ! Compare the geometries
    if(any(abs(bas1%lat - bas2%lat).gt.1.E-6)) then
       write(0,*) 'Geometry read/write failed, lattice check failed'
       output = .false.
    end if
    if(bas1%sysname .ne. bas2%sysname) then
       write(0,*) 'Geometry read/write failed, system name check failed'
       write(0,*) bas1%sysname, bas2%sysname
       output = .false.
    end if
    if(bas1%natom .ne. bas2%natom) then
       write(0,*) 'Geometry read/write failed, number of atoms check failed'
       write(0,*) bas1%natom, bas2%natom
       output = .false.
    end if
    if(abs(bas1%energy - bas2%energy).gt.1.E-6) then
       write(0,*) 'Geometry read/write failed, energy check failed'
       write(0,*) bas1%energy, bas2%energy
       output = .false.
    end if

  end function compare_bas

  subroutine uninitialise_bas(bas)
    implicit none
    type(extended_basis_type), intent(inout) :: bas

    bas%natom = 0
    bas%nspec = 0
    bas%lat = 0.E0
    bas%energy = 0.E0
    bas%sysname = ""
    bas%lcart = .false.
    bas%pbc = .true.
    deallocate(bas%spec)
    
  end subroutine uninitialise_bas

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_geom_extd

program test_tools_infile
  use raffle__constants, only: real32
  use raffle__tools_infile
  implicit none


  integer :: ival = 0
  logical :: ltmp1
  real(real32) :: rtmp1
  character(256) :: stmp1
  character(256) :: line

  logical :: success = .true.


  line = "APPLES = string"
  call assign_val(line, stmp1, ival, keyword="APPLES")
  if( trim(stmp1) .ne. "string" .or. ival .ne. 1 )then
     write(0,*) "assign_val failed for string"
     success = .false.
  end if

  line = "ORANGES = 1"
  call assign_val(line, ltmp1, ival, keyword="ORANGES")
  if( .not. ltmp1 .or. ival .ne. 2 )then
     write(0,*) "assign_val failed for logical"
     success = .false.
  end if
  line = "ORANGES = 0"
  call assign_val(line, ltmp1, ival, keyword="ORANGES")
  if( ltmp1 .or. ival .ne. 3 )then
     write(0,*) "assign_val failed for logical"
     success = .false.
  end if
  line = "ORANGES = T"
  call assign_val(line, ltmp1, ival, keyword="ORANGES")
  if( .not. ltmp1 .or. ival .ne. 4 )then
     write(0,*) "assign_val failed for logical"
     success = .false.
  end if
  line = "ORANGES = F"
  call assign_val(line, ltmp1, ival, keyword="ORANGES")
  if( ltmp1 .or. ival .ne. 5 )then
     write(0,*) "assign_val failed for logical"
     success = .false.
  end if
  line = "ORANGES = t"
  call assign_val(line, ltmp1, ival, keyword="ORANGES")
  if( .not. ltmp1 .or. ival .ne. 6 )then
     write(0,*) "assign_val failed for logical"
     success = .false.
  end if
  line = "ORANGES = f"
  call assign_val(line, ltmp1, ival, keyword="ORANGES")
  if( ltmp1 .or. ival .ne. 7 )then
     write(0,*) "assign_val failed for logical"
     success = .false.
  end if

  line = "BANANAS = 1.0 # comment"
  ! ival = line number here
  call rm_comments(line, ival)
  if( trim(line) .ne. "BANANAS = 1.0")then
     write(0,*) "rm_comments failed"
     write(0,'("\",A,"\")') trim(line)
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_tools_infile passed all tests'
  else
     write(0,*) 'test_tools_infile failed one or more tests'
     stop 1
  end if



end program test_tools_infile

program test_place_methods
  use raffle__io_utils
  use raffle__place_methods
  use raffle__distribs_container, only: distribs_container_type
  use raffle__constants, only: real32
  use raffle__geom_rw, only: basis_type
  use raffle__geom_extd, only: extended_basis_type
  use raffle__generator, only: raffle_generator_type
  implicit none

  integer :: num_seed, seed
  logical :: viable = .true.
  type(basis_type) :: basis
  type(extended_basis_type) :: basis_extd
  type(raffle_generator_type) :: generator
  real(real32), dimension(3) :: point
  real(real32), dimension(2, 3) :: bounds
  character(3), dimension(1) :: element_symbols
  real(real32), dimension(1) :: element_energies

  integer, dimension(:), allocatable :: seed_arr
  type(basis_type), allocatable :: database(:)
  integer, dimension(:,:), allocatable :: atom_ignore_list
  
  logical :: success = .true.


  test_error_handling = .true.


  !-----------------------------------------------------------------------------
  ! set up database
  !-----------------------------------------------------------------------------
  allocate(database(1))
  database(1)%nspec = 1
  database(1)%natom = 8
  allocate(database(1)%spec(database(1)%nspec))
  database(1)%spec(1)%num = 8
  database(1)%spec(1)%name = 'C'
  allocate(database(1)%spec(1)%atom(database(1)%spec(1)%num, 3))
  database(1)%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  database(1)%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  database(1)%spec(1)%atom(3, :3) = [0.5, 0.0, 0.5]
  database(1)%spec(1)%atom(4, :3) = [0.0, 0.5, 0.5]
  database(1)%spec(1)%atom(5, :3) = [0.25, 0.25, 0.25]
  database(1)%spec(1)%atom(6, :3) = [0.75, 0.75, 0.25]
  database(1)%spec(1)%atom(7, :3) = [0.75, 0.25, 0.75]
  database(1)%spec(1)%atom(8, :3) = [0.25, 0.75, 0.75]

  database(1)%lat(1,:) = [3.5607451090903233, 0.0, 0.0]
  database(1)%lat(2,:) = [0.0, 3.5607451090903233, 0.0]
  database(1)%lat(3,:) = [0.0, 0.0, 3.5607451090903233]
  database(1)%energy = -72.213492


  ! Initialise basis
  basis%nspec = 1
  allocate(basis%spec(basis%nspec))
  basis%spec(1)%name = 'C'
  basis%spec(1)%num = 2
  allocate(basis%spec(1)%atom(basis%spec(1)%num,3))
  basis%spec(1)%atom(1,:) = [0.0_real32, 0.0_real32, 0.0_real32]
  basis%spec(1)%atom(2,:) = [0.5_real32, 0.5_real32, 0.5_real32]
  basis%lat = 0.0_real32
  basis%lat(1,1) = 5.0_real32
  basis%lat(2,2) = 5.0_real32
  basis%lat(3,3) = 5.0_real32


  !-----------------------------------------------------------------------------
  ! set up distribution functions
  !-----------------------------------------------------------------------------
  bounds(1,:) = 0.25_real32
  bounds(2,:) = 0.75_real32
  call generator%set_host( basis )
  element_symbols(1) = 'C'
  element_energies(1) = -9.0266865
  call generator%distributions%set_element_energies( &
       element_symbols, &
       element_energies &
  )
  call generator%distributions%create( &
       basis_list = database, &
       deallocate_systems = .true. &
  )
  call generator%distributions%set_element_map( &
       [ "C  "] &
  )
  call generator%distributions%host_system%set_element_map( &
       generator%distributions%element_info &
  )
  allocate(atom_ignore_list(2,1))
  atom_ignore_list(:,1) = [1,2]
  seed = 0
  call random_seed(size=num_seed)
  allocate(seed_arr(num_seed))
  seed_arr = seed 
  call random_seed(put=seed_arr)
  call basis_extd%copy(basis)
  call basis_extd%create_images( &
       max_bondlength = 6._real32, &
       atom_ignore_list = atom_ignore_list &
  )


  !-----------------------------------------------------------------------------
  ! test place_method_void
  !-----------------------------------------------------------------------------
  call test_place_method_void(generator%distributions, basis, success)


  !-----------------------------------------------------------------------------
  ! test place_method_rand
  !-----------------------------------------------------------------------------
  viable = .true.
  point = place_method_rand( &
       generator%distributions, &
       bounds, &
       basis_extd, &
       atom_ignore_list, &
       radius_list = [ 0.5_real32 ], &
       max_attempts = 1000, &
       viable = viable &
  )
  if(.not. viable) then
     write(*,*) "test_place_method_rand failed"
     success = .false.
  end if
  if( any( point .gt. 0.75_real32 ) .or. any( point .lt. 0.25_real32 ) ) then
     write(*,*) "test_place_method_rand failed"
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! test place_method_walk
  !-----------------------------------------------------------------------------
  viable = .true.
  point = place_method_walk( &
       generator%distributions, &
       bounds, &
       basis_extd, &
       atom_ignore_list, &
       radius_list = [ 0.5_real32 ], &
       max_attempts = 1000, &
       step_size_fine = 0.1_real32, &
       step_size_coarse = 0.5_real32, &
       viable = viable &
  )
  if(.not. viable) then
     write(*,*) "test_place_method_walk failed, viable = ", viable
     success = .false.
  end if
  if( any( point .gt. 0.75_real32 ) .or. any( point .lt. 0.25_real32 ) ) then
     write(*,*) "test_place_method_walk failed, point = ", point
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! test place_method_growth
  !-----------------------------------------------------------------------------
  viable = .true.
  point = place_method_growth( &
       generator%distributions, &
       prior_point = [0.45_real32, 0.45_real32, 0.45_real32], &
       prior_species = 1, &
       bounds = bounds, &
       basis = basis_extd, &
       atom_ignore_list = atom_ignore_list, &
       radius_list = [ 0.5_real32 ], &
       max_attempts = 1000, &
       step_size_fine = 0.1_real32, &
       step_size_coarse = 0.5_real32, &
       viable = viable &
  )
  if(.not. viable) then
     write(*,*) "test_place_method_growth failed, viable = ", viable
     success = .false.
  end if
  if( any( point .gt. 0.75_real32 ) .or. any( point .lt. 0.25_real32 ) ) then
     write(*,*) "test_place_method_growth failed, point = ", point
     success = .false.
  end if




  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_place_methods passed all tests'
  else
     write(0,*) 'test_place_methods failed one or more tests'
     stop 1
  end if

contains

  subroutine test_place_method_void(distributions, basis, success)
    use raffle__viability, only: get_gridpoints_and_viability
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis
    type(distribs_container_type), intent(in) :: distributions

    integer :: i
    type(extended_basis_type) :: basis_copy
    logical :: viable
    integer, dimension(3) :: grid
    real(real32), dimension(3) :: grid_offset
    real(real32), dimension(3) :: point
    integer, dimension(:,:), allocatable :: atom_ignore_list
    real(real32), dimension(3) :: tolerance
    real(real32), dimension(2,3) :: bounds
    real(real32), dimension(:,:), allocatable :: gridpoints, viability_grid

    ! Initialise test data
    grid = [10, 10, 10]
    bounds(1,:) = 0.0_real32
    bounds(2,:) = 1.0_real32
    allocate(atom_ignore_list(2,1))  ! No atoms to ignore
    atom_ignore_list(:,1) = [1,2]
    grid_offset = [0.5_real32, 0.5_real32, 0.5_real32]

    ! Initialise basis
    call basis_copy%copy(basis)
    call basis_copy%create_images( &
         max_bondlength = 6._real32, &
         atom_ignore_list = atom_ignore_list &
    )

    !---------------------------------------------------------------------------
    ! set up gridpoints
    !---------------------------------------------------------------------------
    gridpoints = get_gridpoints_and_viability( &
         distributions, &
         grid, &
         bounds, &
         basis_copy, &
         [ 1 ], &
         [ distributions%bond_info(:)%radius_covalent ], &
         atom_ignore_list, &
         grid_offset = grid_offset &
    )

    ! Call the void subroutine
    point = place_method_void( &
         gridpoints, basis_copy, &
         atom_ignore_list, &
         viable &
    )

    ! Check if viable
    call assert(viable, "No viable gridpoints found.", success)

    do i = 1, 3
       tolerance(i) = 1._real32 / real(grid(i),real32) / 2._real32
    end do
    ! Check point is correct
    call assert( &
         all( abs( point - 0.5_real32) .lt. tolerance + 1.E-6_real32 ), &
         "Incorrect gridpoint found.", &
         success &
    )

  end subroutine test_place_method_void


!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_place_methods

module raffle__geom_extd
  !! Module to extend the basis set to include images of atoms.
  !!
  !! This module is designed to extend the basis set to include images of atoms
  !! within a specified distance of the unit cell. This is useful for
  !! calculating interactions between atoms that are not within the unit cell.
  use raffle__constants, only: real32, pi
  use raffle__misc_linalg, only: modu, cross, inverse_3x3
  use raffle__geom_rw, only: basis_type, species_type
  implicit none


  private

  public :: extended_basis_type


  type, extends(basis_type) :: extended_basis_type
     !! Extended basis set type
     real(real32) :: max_extension
     !! Maximum distance to extend the basis set
     integer :: num_images
     !! Number of images in the extended basis set
     type(species_type), dimension(:), allocatable :: image_spec
     !! Species type for the images
   contains
     procedure, pass(this) :: create_images
     !! Create the images for the basis set
     procedure, pass(this) :: update_images
     !! Update the images for a specific atom
  end type extended_basis_type

contains

!###############################################################################
  subroutine create_images(this, max_bondlength, atom_ignore_list)
    !! Create the images for the basis set.
    implicit none

    ! Arguments
    class(extended_basis_type), intent(inout) :: this
    !! Parent of the procedure. Instance of the extended basis.
    real(real32), intent(in) :: max_bondlength
    !! Maximum distance to extend the basis set.
    integer, dimension(:,:), intent(in), optional :: atom_ignore_list
    !! List of atoms to ignore when creating images.

    ! Local variables
    integer :: is, ia, i, j, k
    !! Loop indices.
    integer :: amax, bmax, cmax
    !! Maximum number of lattice vectors to consider.
    real(real32), dimension(3) :: vtmp1
    !! Temporary vector for storing atom positions.
    type(species_type), dimension(this%nspec) :: image_species
    !! Temporary store for the images.
    integer, dimension(:,:), allocatable :: atom_ignore_list_
    !! List of atoms to ignore when creating images.


    !---------------------------------------------------------------------------
    ! initialise the atom_ignore_list
    !---------------------------------------------------------------------------
    if(present(atom_ignore_list)) then
       atom_ignore_list_ = atom_ignore_list(:,:)
    else
       allocate(atom_ignore_list_(0,0))
    end if


    !---------------------------------------------------------------------------
    ! get the maximum number of lattice vectors to consider
    ! NOTE: this is not perfect
    !       won't work for extremely acute/obtuse angle cells
    !       (due to diagonal path being shorter than individual lattice vectors)
    !---------------------------------------------------------------------------
    amax = ceiling(max_bondlength/modu(this%lat(1,:)))
    bmax = ceiling(max_bondlength/modu(this%lat(2,:)))
    cmax = ceiling(max_bondlength/modu(this%lat(3,:)))


    spec_loop: do is = 1, this%nspec
       allocate( &
            image_species(is)%atom( &
                 this%spec(is)%num*(2*amax+2)*(2*bmax+2)*(2*cmax+2), &
                 size(this%spec(is)%atom,2) &
            ) &
       )
       image_species(is)%num = 0
       image_species(is)%mass = this%spec(is)%mass
       image_species(is)%charge = this%spec(is)%charge
       image_species(is)%radius = this%spec(is)%radius
       image_species(is)%name = this%spec(is)%name
       atom_loop: do ia = 1, this%spec(is)%num
          do i = 1, size(atom_ignore_list_,2), 1
             if(all(atom_ignore_list_(:,i).eq.[is,ia])) cycle atom_loop
          end do
          do i=-amax,amax+1,1
             vtmp1(1) = this%spec(is)%atom(ia,1) + real(i, real32)
             do j=-bmax,bmax+1,1
                vtmp1(2) = this%spec(is)%atom(ia,2) + real(j, real32)
                do k=-cmax,cmax+1,1
                   if( i .eq. 0 .and. j .eq. 0 .and. k .eq. 0 ) cycle
                   vtmp1(3) = this%spec(is)%atom(ia,3) + real(k, real32)
                   if( get_distance_from_unit_cell(vtmp1, this%lat) .le. &
                        max_bondlength ) then
                      ! add the image to the list
                      image_species(is)%num = image_species(is)%num + 1
                      image_species(is)%atom(image_species(is)%num,:3) = vtmp1
                   end if
                end do
             end do
          end do
       end do atom_loop
    end do spec_loop


    allocate(this%image_spec(this%nspec))
    do is = 1, this%nspec
       this%image_spec(is)%num = image_species(is)%num
       this%image_spec(is)%mass = image_species(is)%mass
       this%image_spec(is)%charge = image_species(is)%charge
       this%image_spec(is)%radius = image_species(is)%radius
       this%image_spec(is)%name = image_species(is)%name
       if(image_species(is)%num .eq. 0) cycle
       allocate(this%image_spec(is)%atom( &
            image_species(is)%num, &
            size(image_species(is)%atom,2) &
       ) )
       this%image_spec(is)%atom(:,:) = &
            image_species(is)%atom(:image_species(is)%num,:)
    end do
    this%num_images = sum( this%image_spec(:)%num )

  end subroutine create_images
!###############################################################################


!###############################################################################
  subroutine update_images(this, max_bondlength, is, ia)
    !! Update the images for a specific atom
    implicit none

    ! Arguments
    class(extended_basis_type), intent(inout) :: this
    !! Parent of the procedure. Instance of the extended basis.
    real(real32), intent(in) :: max_bondlength
    !! Maximum distance to extend the basis set.
    integer, intent(in) :: is, ia
    !! Species and atom index to update.


    ! Local variables
    integer :: i, j, k, num_images, dim
    !! Loop indices.
    integer :: amax, bmax, cmax
    !! Maximum number of lattice vectors to consider.
    type(species_type) :: image_species
    !! Temporary store for the images.
    real(real32), dimension(3) :: vtmp1
    !! Temporary vector for storing atom positions.


    !---------------------------------------------------------------------------
    ! get the maximum number of lattice vectors to consider
    ! NOTE: this is not perfect
    !       won't work for extremely acute/obtuse angle cells
    !       (due to diagonal path being shorter than individual lattice vectors)
    !---------------------------------------------------------------------------
    num_images = this%image_spec(is)%num
    amax = ceiling(max_bondlength/modu(this%lat(1,:)))
    bmax = ceiling(max_bondlength/modu(this%lat(2,:)))
    cmax = ceiling(max_bondlength/modu(this%lat(3,:)))
    dim = 3
    do i = 1, this%nspec
       if ( size(this%spec(i)%atom,2) .gt. dim) dim =  size(this%spec(i)%atom,2)
    end do
    allocate( &
         image_species%atom( &
              num_images + &
              (2*amax+2)*(2*bmax+2)*(2*cmax+2), &
              dim &
         ) &
    )
    if( num_images .ne. 0 ) then
       image_species%atom(:num_images,:3) = &
            this%image_spec(is)%atom(:num_images,:3)
    end if


    do i=-amax,amax+1,1
       vtmp1(1) = this%spec(is)%atom(ia,1) + real(i, real32)
       do j=-bmax,bmax+1,1
          vtmp1(2) = this%spec(is)%atom(ia,2) + real(j, real32)
          do k=-cmax,cmax+1,1
             if( i .eq. 0 .and. j .eq. 0 .and. k .eq. 0 ) cycle
             vtmp1(3) = this%spec(is)%atom(ia,3) + real(k, real32)
             if( get_distance_from_unit_cell(vtmp1, this%lat) .le. &
                  max_bondlength ) then
                ! add the image to the list
                num_images = num_images + 1
                image_species%atom(num_images,:3) = vtmp1
             end if
          end do
       end do
    end do
    if( num_images .eq. this%image_spec(is)%num ) return


    this%image_spec(is)%num = num_images
    if(allocated(this%image_spec(is)%atom)) deallocate(this%image_spec(is)%atom)
    allocate(this%image_spec(is)%atom( &
         num_images, &
         size(image_species%atom,2) &
    ) )
    this%image_spec(is)%atom(:,:) = &
         image_species%atom(:num_images,:)
    deallocate(image_species%atom)
    this%num_images = sum( this%image_spec(:)%num )

  end subroutine update_images
!###############################################################################


!###############################################################################
  function get_distance_from_unit_cell( &
       point, lattice, closest_point, is_cartesian&
  ) result(distance)
    !! Get the distance of a point from the unit cell.
    implicit none

    ! Arguments
    real(real32), intent(in) :: point(3)
    !! Query point.
    real(real32), intent(in) :: lattice(3,3)
    !! Lattice vectors.
    real(real32), intent(out), optional :: closest_point(3)
    !! Closest point on the unit cell surface.
    logical, optional, intent(in) :: is_cartesian
    !! Boolean whether the point is in cartesian coordinates.
    real(real32) :: distance
    !! Distance of the point from the unit cell.

    ! Local variables
    integer :: i, j, k
    !! Loop indices.
    real(real32), dimension(3) :: point_
    !! Point in cartesian coordinates.
    real(real32), dimension(3,3) :: inverse_lattice
    !! Inverse of the lattice vectors.
    real(real32), dimension(3) :: normal
    !! Normal vector to the plane.
    real(real32), dimension(3) :: plane_point
    !! Point on the plane.
    real(real32), dimension(3) :: projection, closest_point_
    !! Projection of the point onto the plane.
    real(real32), dimension(3) :: inverse_projection
    !! Inverse projection of the point onto the plane.
    real(real32) :: min_distance
    !! Minimum distance to the unit cell.
    logical :: is_outside
    !! Boolean whether the point is outside the unit cell.
    integer, dimension(3) :: index_list
    !! List of indices for the lattice vectors.
    logical :: is_cartesian_
    !! Boolean whether the point is in cartesian coordinates.
        

    !---------------------------------------------------------------------------
    ! check if the point is in cartesian coordinates
    !---------------------------------------------------------------------------
    is_outside = .false.
    is_cartesian_ = .false.
    index_list = [1, 2, 3]
    if(present(is_cartesian)) is_cartesian_ = is_cartesian
    inverse_lattice = inverse_3x3( lattice )
    if(is_cartesian_) then
       ! Convert point to fractional coordinates
       ! point_ = matmul(LUinv(lattice), point)
       point_ = point
    else
       point_ = matmul(point, lattice)
    end if

    min_distance = huge(1._real32)

    ! get projection of point onto each face of the lattice
    ! get the length of the projection vector
    ! if negative, then the point is inside the unit cell
    ! if positive, then the point is outside the unit cell
    ! if the projection falls outside of the cell edges, use edge or corner 
    ! distances
    face_loop: do i = 1, 3
       index_list = cshift(index_list, 1)
       plane_point = 0._real32
       direction_loop: do j = 1, 2
          normal = (-1._real32)**j * cross( &
               [ lattice(index_list(2),:3) ], &
               [ lattice(index_list(3),:3) ] &
          )
          normal = normal / norm2(normal)
          projection = project_point_onto_plane(point_, plane_point, normal)

          ! check if point minus projection is negative
          ! if so, it is on the wrong side of the plane and should be ignored
          if( dot_product(point_ - projection, normal) .lt. 0._real32 )then
             plane_point = plane_point + lattice(index_list(1),:)
             cycle direction_loop
          end if
          is_outside = .true.

          ! check if projection is outside the surface
          
          inverse_projection = matmul(projection, inverse_lattice)
          if( &
               any( inverse_projection .lt. 0._real32 ) .or. &
               any( inverse_projection .gt. 1._real32 ) &
          ) then
             ! projection is outside the surface
             ! check if the projection is outside the edges
             ! if it is, then the closest point is the edge or corner
             ! if it is not, then the closest point is the projection
             do k = 1, 3
                if( inverse_projection(k) .lt. 0._real32 ) then
                   inverse_projection(k) = 0._real32
                else if( inverse_projection(k) .gt. 1._real32 ) then
                   inverse_projection(k) = 1._real32
                end if
             end do
          end if
          projection = matmul(inverse_projection, lattice)
          distance = norm2(point_ - projection)
          if( distance .lt. min_distance ) then
             min_distance = distance
             closest_point_ = projection
          end if

          !! makes it apply to the next iteration
          plane_point = plane_point + lattice(index_list(1),:)
       end do direction_loop
    end do face_loop

    if( is_outside ) then
       distance = min_distance
    else
       distance = 0._real32
    end if

    if( present(closest_point) ) then
       if(is_cartesian_) then
          closest_point = closest_point_
       else
          closest_point = matmul(closest_point_, inverse_lattice)
       end if
    end if

  end function get_distance_from_unit_cell
!###############################################################################


!###############################################################################
  function project_point_onto_plane(point, plane_point, normal) result(output)
    !! Project a point onto a plane.
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: point
    !! Point to project.
    real(real32), dimension(3), intent(in) :: plane_point
    !! Point on the plane.
    real(real32), dimension(3), intent(in) :: normal
    !! Normal vector to the plane.
    real(real32), dimension(3) :: output
    !! Projected point.

    ! Local variables
    real(real32) :: distance
    !! Distance of the point from the plane.
    real(real32), dimension(3) :: vector_to_plane
    !! Vector from the point to the plane.
    
    vector_to_plane = point - plane_point

    distance = &
         dot_product(vector_to_plane, normal) / dot_product(normal, normal)

    output = point - distance * normal

  end function project_point_onto_plane
!###############################################################################

end module raffle__geom_extd

program test_cache
  use raffle__io_utils
  use raffle__cache
  use raffle__constants, only: real32
  implicit none

  logical :: success = .true.

  call test_retrieve_unallocated(success)
  call test_store_retrieve_probability_density(success)

  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_cache passed all tests'
  else
     write(0,*) 'test_cache failed one or more tests'
     stop 1
  end if

contains

  subroutine test_store_retrieve_probability_density(success)
    implicit none
    logical, intent(inout) :: success
    real(real32), allocatable :: test_data(:,:), retrieved_data(:,:)
    integer :: i, j

    ! Create test data - a 3x3 matrix with values
    allocate(test_data(3,3))
    do i = 1, 3
      do j = 1, 3
        test_data(i,j) = real(i*10 + j, real32)
      end do
    end do

    ! Store the test data in the cache
    call store_probability_density(test_data)

    ! Retrieve the data from the cache
    retrieved_data = retrieve_probability_density()

    ! Check dimensions match
    if (.not. all(shape(retrieved_data) == shape(test_data))) then
      write(0,*) 'test_store_retrieve_probability_density: array shapes do not match'
      success = .false.
      return
    end if

    ! Check all values match
    do i = 1, 3
      do j = 1, 3
        if (abs(retrieved_data(i,j) - test_data(i,j)) .gt. 1.e-6_real32) then
          write(0,*) &
               'test_store_retrieve_probability_density: values do not match at', &
               i, j, retrieved_data(i,j), test_data(i,j)
          success = .false.
          return
        end if
      end do
    end do

    ! Clean up
    if (allocated(test_data)) deallocate(test_data)
    if (allocated(retrieved_data)) deallocate(retrieved_data)

    write(*,*) 'test_store_retrieve_probability_density: PASSED'
  end subroutine test_store_retrieve_probability_density

  subroutine test_retrieve_unallocated(success)
    implicit none
    logical, intent(inout) :: success
    real(real32), allocatable :: retrieved_data(:,:)

    ! Try to retrieve data when cache is not allocated
    retrieved_data = retrieve_probability_density()

    ! Verify returned array is a scalar with value 0
    if (size(retrieved_data) .ne. 1) then
      write(0,*) &
           'test_retrieve_unallocated: returned array should be scalar but has size', &
           size(retrieved_data)
      success = .false.
      return
    end if

    if (abs(retrieved_data(1,1)) .gt. 1.e-6_real32) then
      write(0,*) &
           'test_retrieve_unallocated: returned value should be 0 but is', &
           retrieved_data(1,1)
      success = .false.
      return
    end if

    ! Clean up
    if (allocated(retrieved_data)) deallocate(retrieved_data)

    write(*,*) 'test_retrieve_unallocated: PASSED'
  end subroutine test_retrieve_unallocated

end program test_cache

module rw_vasprun
  !! Module for reading VASP vasprun.xml files.
  !!
  !! This module provides the procedures for reading the energy and atomic
  !! structure from a VASP vasprun.xml file.
  use raffle__constants, only: real32
  use raffle__io_utils, only: stop_program
  use raffle__geom_rw, only: basis_type
  implicit none


  private

  public :: get_energy_from_vasprun
  public :: get_structure_from_vasprun


contains

!###############################################################################
  recursive subroutine find_section( &
       unit, section, found, name, end_section, depth &
  )
    !! Find a section in a vasprun.xml file.
    !!
    !! This subroutine reads a vasprun.xml file and searches for an embedded
    !! section. The parent sections are the earlier elements of the section
    !! array.
    implicit none

    ! Arguments
    integer, intent(in) :: unit
    !! The unit number of the file.
    character(len=*), dimension(:), intent(in) :: section
    !! The section to find.
    logical, intent(out) :: found
    !! Whether the section was found.
    character(len=*), intent(in), optional :: end_section
    !! The end section to find.
    character(len=*), dimension(:), intent(in), optional :: name
    !! The optional name of the section.
    integer, intent(in), optional :: depth
    !! The current depth of the recursion.

    ! Local variables
    character(len=100) :: line
    !! A buffer for reading lines.
    integer :: ierror, depth_
    !! I/O status, depth.
    character(len=:), allocatable :: &
         section_string, enclosing_section_end_string, name_string
    !! Strings for the section and end section.
    character(len=:), dimension(:), allocatable :: name_
    !! Array of names.


    found = .false.

    !---------------------------------------------------------------------------
    ! handle optional arguments
    !---------------------------------------------------------------------------
    if(present(depth)) then
       depth_ = depth
    else
       depth_ = 0
    end if
    if(present(name)) then
       if(size(name) .ne. size(section)) then
          call stop_program( &
               'name and section must be same size in find_section' &
          )
          return
       end if
       name_ = name
    else
       allocate(character(len=1) :: name_(size(section)))
       name_ = ""
    end if
    if(trim(name_(1)).ne."")then
       name_string = ' name="'//trim(adjustl(name_(1)))//'" >'
    else
       name_string = ">"
    end if


    !---------------------------------------------------------------------------
    ! write the indentation to the section string, based on the depth
    !---------------------------------------------------------------------------
    section_string = &
         repeat(' ', depth_)//'<'//trim(section(1))//trim(name_string)
    if(present(end_section)) then
       enclosing_section_end_string = &
            repeat(' ', max(depth_-1,1))//'</'//trim(end_section)//'>'
    end if


    !---------------------------------------------------------------------------
    ! read the file and search for the section
    !---------------------------------------------------------------------------
    do
       read(unit, '(A)', iostat=ierror) line
       if(is_iostat_end(ierror)) exit
       if(ierror .ne. 0) then
          call stop_program( &
               'Issue encountered when reading vasprun.xml' &
          )
          return
       end if
       if(index(line, trim(section_string)) .eq. 1) then
          found = .true.
          if(size(section) .gt. 1) then
             call find_section(unit, [ section(2:) ], found, &
                  end_section = section(1), &
                  depth = depth_+1, &
                  name = [ name_(2:) ] &
             )
          end if
          exit
       elseif(present(end_section)) then
          if(index(line, trim(enclosing_section_end_string)) .eq. 1) then
             found = .false.
             exit
          end if
       end if
    end do

  end subroutine find_section
!###############################################################################


!###############################################################################
  function get_energy_from_vasprun(unit, found, rewind_file) result(energy)
    !! Get the energy from a vasprun.xml file.
    implicit none

    ! Arguments
    integer, intent(in) :: unit
    !! The unit number of the file.
    logical, intent(out) :: found
    !! Whether the energy was found.
    logical, intent(in), optional :: rewind_file
    !! Whether to rewind the file after reading the energy.
    real(real32) :: energy
    !! The energy of the structure.

    ! Local variables
    integer :: ierror
    !! I/O status.
    logical :: found_ = .false.
    !! Whether the section was found.
    character(len=100) :: line, buffer
    !! A buffer for reading lines.
    real(real32), dimension(:), allocatable :: energy_list
    !! List of energies.
    character(len=32), dimension(3) :: section_list
    !! List of sections.


    found = .false.

    !---------------------------------------------------------------------------
    ! handle optional arguments
    !---------------------------------------------------------------------------
    if(present(rewind_file)) then
       if(rewind_file) rewind(unit)
    end if


    !---------------------------------------------------------------------------
    ! set up and find embedded sections
    !---------------------------------------------------------------------------
    section_list(1) = 'modeling'
    section_list(2) = 'calculation'
    section_list(3) = 'energy'
    call find_section(unit, section_list(1:1), found_)


    !---------------------------------------------------------------------------
    ! read the energy from the file
    !---------------------------------------------------------------------------
    allocate(energy_list(0))
    do
       call find_section(unit, section_list(2:), found_, depth=1)
       if (.not. found_) exit
       read(unit, '(A)', iostat=ierror) line
       if(ierror .ne. 0) then
          call stop_program( &
               'Issue encountered when reading energy from vasprun.xml' &
          )
          return
       end if
       read(line, '(3X, A22, F16.8)') buffer, energy
       energy_list = [ energy_list, energy ]
       found = .true.
    end do

  end function get_energy_from_vasprun
!###############################################################################


!###############################################################################
  subroutine get_structure_from_vasprun(unit, basis, found)
    !! Get the atomic structure from a vasprun.xml file.
    implicit none

    ! Arguments
    integer, intent(in) :: unit
    !! The unit number of the file.
    logical, intent(out), optional :: found
    !! Whether the structure was found.
    type(basis_type) :: basis
    !! The basis of the structure.

    ! Local variables
    integer :: ierror, i, is, ia
    !! I/O status, loop indices.
    logical :: found_ = .false.
    !! Whether the section was found.
    character(len=100) :: line, buffer
    !! A buffer for reading lines.
    character(len=32), dimension(4) :: section_list, name_list
    !! List of sections and names.

    integer :: number
    !! The number of atoms of a given type.
    character(len=3) :: element
    !! The element symbol.
    real(real32) :: mass, valency
    !! The mass and valency of the element.
    character(len=40) :: pseudo
    !! The pseudopotential file name.
    integer, dimension(:), allocatable :: number_list
    !! List of numbers of atoms.
    character(len=3), dimension(:), allocatable :: element_list
    !! List of element symbols.
    real(real32), dimension(:), allocatable :: mass_list, valency_list
    !! List of masses and valencies.
    character(len=40), dimension(:), allocatable :: pseudo_list
    !! List of pseudopotential file names.
    
    
    found = .false.

    !---------------------------------------------------------------------------
    ! set up and find embedded sections for the incar
    !---------------------------------------------------------------------------
    section_list(1) = 'modeling'
    section_list(2) = 'incar'
    call find_section(unit, section_list(:2), found_)
    if(.not. found_) then
       call stop_program('incar section not found in vasprun.xml')
       return
    end if
    read(unit, '(A)', iostat=ierror) line
    if(ierror .ne. 0) then
       call stop_program( &
            'Error encountered when reading incar from vasprun.xml' &
       )
       return
    end if
    read(line, '(2X,A31,A)') buffer, basis%sysname
    basis%sysname = basis%sysname(:index(basis%sysname, '<')-1)


    !---------------------------------------------------------------------------
    ! set up and find embedded sections for the atomtypes
    !---------------------------------------------------------------------------
    section_list(1) = 'modeling'
    section_list(2) = 'atominfo'
    section_list(3) = 'array'
    section_list(4) = 'set'

    name_list(1) = ""
    name_list(2) = ""
    name_list(3) = "atomtypes"
    name_list(4) = ""
    call find_section( &
         unit, section_list(2:), found_, name=name_list(2:), depth=1 &
    )
    if(.not. found_) then
       call stop_program('Section "set" not found in vasprun.xml')
       return
    end if

    !---------------------------------------------------------------------------
    ! read atomtypes data from file
    !---------------------------------------------------------------------------
    i = 0
    do
       i = i + 1
       read(unit, '(A)', iostat=ierror) line
       if(ierror .ne. 0) then
          call stop_program( &
               'Error encountered when reading atomtypes from vasprun.xml' &
          )
          return
       end if
       if(index(line, '   </set>') .eq. 1) exit
       read( line, '(4X,A7, I4, A7, A2, A7, F16.8, A7, F16.8, A7, A40)' ) &
            buffer, number, &
            buffer, element, &
            buffer, mass, &
            buffer, valency, &
            buffer, pseudo
       if(i .eq. 1) then
          number_list  = [ number ]
          element_list = [ element ]
          mass_list    = [ mass ]
          valency_list = [ valency ]
          pseudo_list  = [ pseudo ]
       else
          number_list  = [ number_list, number ]
          element_list = [ element_list, element ]
          mass_list    = [ mass_list, mass ]
          valency_list = [ valency_list, valency ]
          pseudo_list  = [ pseudo_list, pseudo ]
       end if
    end do

    !---------------------------------------------------------------------------
    ! allocate the basis from the atomtypes data
    !---------------------------------------------------------------------------
    basis%natom = sum(number_list)
    basis%nspec = size(element_list)
    allocate(basis%spec(basis%nspec))
    basis%spec(:)%name = element_list
    basis%spec(:)%num  = number_list
    basis%spec(:)%mass = mass_list
    do is = 1, basis%nspec
       allocate(basis%spec(is)%atom(basis%spec(is)%num,3))
    end do


    !---------------------------------------------------------------------------
    ! set up and find embedded sections for the lattice
    !---------------------------------------------------------------------------
    section_list(2) = 'structure'
    section_list(3) = 'crystal'
    section_list(4) = 'varray'
    name_list(2) = "finalpos"
    name_list(3) = ""
    name_list(4) = "basis"
    call find_section( &
         unit, section_list(2:), found_, name=name_list(2:), depth=1 &
    )
    if(.not. found_) then
       call stop_program( &
            'Error encountered when finding structure in vasprun.xml' &
       )
       return
    end if
    do i = 1, 3
       read(unit, '(A)', iostat=ierror) line
       if(ierror .ne. 0) then
          call stop_program( &
               'Error encountered when reading lattice from vasprun.xml' &
          )
          return
       end if
       read( line, '(4X,A3,3(1X,F16.8))' ) buffer, basis%lat(i,:)
    end do


    !---------------------------------------------------------------------------
    ! set up and find embedded sections for the atomic structure
    !---------------------------------------------------------------------------
    section_list(3) = 'varray'
    name_list(3) = "positions"
    call find_section( &
         unit, section_list(3:3), found_, name=name_list(3:3), depth=2 &
    )
    if(.not. found_) then
       call stop_program( &
            'Error encountered when finding structure in vasprun.xml' &
       )
       return
    end if
    ia = 0
    is = 1
    do i = 1, basis%natom
       read(unit, '(A)', iostat=ierror) line
       if(ierror .ne. 0) then
          call stop_program( &
               'Error encountered when reading positions from vasprun.xml' &
          )
          return
       end if
       ia = ia + 1
       if(ia .gt. basis%spec(is)%num) then
          ia = 1
          is = is + 1
       end if
       read( line, '(3X,A3,3(1X,F16.8))' ) buffer, &
            basis%spec(is)%atom(ia,:3)
    end do
    found = .true.

  end subroutine get_structure_from_vasprun
!###############################################################################

end module

program test_evaluator
  use raffle__io_utils
  use raffle__constants, only: real32, pi
  use raffle__misc_linalg, only: modu
  use raffle__geom_rw, only: basis_type, geom_write
  use raffle__geom_extd, only: extended_basis_type
  use raffle__evaluator, only: evaluate_point
  use raffle__generator, only: raffle_generator_type
  use raffle__viability, only: get_gridpoints_and_viability
  implicit none


  integer :: unit
  integer :: i, is, ia, ja, num_points
  integer :: best_loc
  real(real32) :: max_bondlength
  type(extended_basis_type) :: basis_host
  logical :: ltmp1
  type(basis_type), dimension(1) :: database
  character(3), dimension(1) :: element_symbols
  real(real32), dimension(1) :: element_energies
  real(real32), dimension(3) :: tolerance
  integer, dimension(:,:), allocatable :: atom_ignore_list

  integer :: iostat
  logical :: viability_printing
  character(len=256) :: arg, arg_prev, viability_printing_file, fmt

  real(real32), dimension(:,:), allocatable :: gridpoints, viability_grid

  type(raffle_generator_type) :: generator

  logical :: success = .true.

  test_error_handling = .true.


  !-----------------------------------------------------------------------------
  ! check for input argument flags
  !-----------------------------------------------------------------------------
  viability_printing = .false.
  viability_printing_file = 'viability_C.dat'
  if( command_argument_count() .ne. 0 ) then
     i = 1
     do
        call get_command_argument(i, arg, status=iostat)
        if( iostat .ne. 0 ) exit
        if(index(arg,'-').eq.1) then
           if( arg == '-h' .or. arg == '--help' ) then
              ! print description of unit test and associated flags
              write(*,*) "This unit test evaluates the evaluator module using &
                   &the BaTiO3 structure."
              write(*,*) "Flags:"
              write(*,*) "-h, --help: Print this help message"
              write(*,*) "-p, --print [filename]: Print the gridpoints and &
                   &their viability values to a file. If no filename is &
                   &given. Default filename = 'viability_C.dat'."
              stop 0
           elseif( index(arg,'-p').eq.1 .or. index(arg,'--print').eq.1 ) then
              viability_printing = .true.
              if( index(arg,'-p').eq.1 .and. trim(arg).ne.'-p' )then
                 viability_printing_file = trim(adjustl(arg(3:)))
              elseif( index(arg,'--print').eq.1 .and. &
                   trim(arg).ne.'--print' )then
                 viability_printing_file = trim(adjustl(arg(8:)))
              end if
           else
              write(0,*) "Unknown flag: ", arg
              stop 1
           end if
        else
           call get_command_argument(i-1, arg_prev, status=iostat)
           if( index(arg,'-p').eq.1 .or. index(arg,'--print').eq.1 ) then
              viability_printing_file = trim(adjustl(arg))
           else
              write(0,*) "Unknown argument: ", arg
              stop 1
           end if
        end if
        i = i + 1
     end do
  end if


  max_bondlength = 6._real32
  !-----------------------------------------------------------------------------
  ! set up database
  !-----------------------------------------------------------------------------
  database(1)%nspec = 1
  database(1)%natom = 8
  allocate(database(1)%spec(database(1)%nspec))
  database(1)%spec(1)%num = 8
  database(1)%spec(1)%name = 'C'
  allocate(database(1)%spec(1)%atom(database(1)%spec(1)%num, 3))
  database(1)%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  database(1)%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  database(1)%spec(1)%atom(3, :3) = [0.5, 0.0, 0.5]
  database(1)%spec(1)%atom(4, :3) = [0.0, 0.5, 0.5]
  database(1)%spec(1)%atom(5, :3) = [0.25, 0.25, 0.25]
  database(1)%spec(1)%atom(6, :3) = [0.75, 0.75, 0.25]
  database(1)%spec(1)%atom(7, :3) = [0.75, 0.25, 0.75]
  database(1)%spec(1)%atom(8, :3) = [0.25, 0.75, 0.75]

  database(1)%lat(1,:) = [3.5607451090903233, 0.0, 0.0]
  database(1)%lat(2,:) = [0.0, 3.5607451090903233, 0.0]
  database(1)%lat(3,:) = [0.0, 0.0, 3.5607451090903233]
  database(1)%energy = -72.213492


  !-----------------------------------------------------------------------------
  ! set up element energies
  !-----------------------------------------------------------------------------
  element_symbols(1) = 'C'
  element_energies(1) = -9.0266865
  call generator%distributions%set_element_energies( &
       element_symbols, &
       element_energies &
  )


  !-----------------------------------------------------------------------------
  ! set up host structure
  !-----------------------------------------------------------------------------
  basis_host%sysname = 'diamond'
  basis_host%nspec = 1
  allocate(basis_host%spec(basis_host%nspec))
  basis_host%spec(1)%num = 16
  basis_host%spec(1)%name = 'C'
  basis_host%natom = sum(basis_host%spec(:)%num)
  allocate(basis_host%spec(1)%atom(basis_host%spec(1)%num, 3))
  basis_host%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  basis_host%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  basis_host%spec(1)%atom(3, :3) = [0.5, 0.0, 0.25]
  basis_host%spec(1)%atom(4, :3) = [0.0, 0.5, 0.25]
  basis_host%spec(1)%atom(5, :3) = [0.25, 0.25, 0.125]
  basis_host%spec(1)%atom(6, :3) = [0.75, 0.75, 0.125]
  basis_host%spec(1)%atom(7, :3) = [0.75, 0.25, 0.375]
  basis_host%spec(1)%atom(8, :3) = [0.25, 0.75, 0.375]
  basis_host%spec(1)%atom(9, :3) = [0.0, 0.0, 0.5]
  basis_host%spec(1)%atom(10, :3) = [0.5, 0.5, 0.5]
  basis_host%spec(1)%atom(11, :3) = [0.75, 0.25, 0.875]
  basis_host%spec(1)%atom(12, :3) = [0.25, 0.75, 0.875]
  basis_host%spec(1)%atom(13, :3) = [0.0, 0.5, 0.75]
  basis_host%spec(1)%atom(14, :3) = [0.5, 0.0, 0.75]
  basis_host%spec(1)%atom(15, :3) = [0.75, 0.75, 0.625]
  basis_host%spec(1)%atom(16, :3) = [0.25, 0.25, 0.625]
  basis_host%lat(1,:) = [3.560745109, 0.0, 0.0]
  basis_host%lat(2,:) = [0.0, 3.560745109, 0.0]
  basis_host%lat(3,:) = [0.0, 0.0, 7.121490218]

  ! set up atom_ignore_list
  allocate(atom_ignore_list(2,8))
  do i = 1, size(atom_ignore_list,2)
     atom_ignore_list(1,i) = 1
     atom_ignore_list(2,i) = &
          basis_host%spec(1)%num - size(atom_ignore_list,2) + i
  end do

  call basis_host%create_images( &
       max_bondlength = max_bondlength, &
       atom_ignore_list = atom_ignore_list &
  )


  generator%distributions%kBT = 0.2
  call generator%set_host(basis_host)
  call generator%set_grid( grid_spacing = 0.2, grid_offset = [0.0, 0.0, 0.0] )
  generator%distributions%radius_distance_tol = [1.5, 2.5, 3.0, 5.0]
  call generator%distributions%set_width([0.025, pi/200.0, pi/200.0])


  !-----------------------------------------------------------------------------
  ! set up distribution functions
  !-----------------------------------------------------------------------------
  call generator%distributions%create( &
       basis_list = database, &
       deallocate_systems = .true. &
  )
  call generator%distributions%set_element_map( &
       [ "C  "] &
  )
  call generator%distributions%host_system%set_element_map( &
       generator%distributions%element_info &
  )


  !-----------------------------------------------------------------------------
  ! set up gridpoints
  !-----------------------------------------------------------------------------
  num_points = 0
  gridpoints = get_gridpoints_and_viability( &
       generator%distributions, &
       generator%grid, &
       generator%bounds, &
       basis_host, &
       [ 1 ], &
       [ generator%distributions%bond_info(:)%radius_covalent ], &
       atom_ignore_list, &
       grid_offset = generator%grid_offset &
  )
  do i = 1, 3
     tolerance(i) = 1._real32 / real(generator%grid(i),real32) / 2._real32
  end do


  !-----------------------------------------------------------------------------
  ! print viability data to file
  !-----------------------------------------------------------------------------
  if(viability_printing)then
     write(*,*) "Printing viability data to file: ", &
          trim(viability_printing_file)
     open(newunit=unit, file=viability_printing_file)
     write(unit,'("#grid",3(1X,I0),3(1X,F0.3))') &
          generator%grid, generator%grid_offset
     write(unit,'("#lat",3(1X,F0.3))') &
          modu(basis_host%lat(1,:)), &
          modu(basis_host%lat(2,:)), &
          modu(basis_host%lat(3,:))
     write(fmt,'("(""#species"",",I0,"(1X,A3))")') basis_host%nspec
     write(unit,fmt) basis_host%spec(:)%name
     do is = 1, basis_host%nspec
        atom_loop: do ia = 1, basis_host%spec(is)%num
           do i = 1, size(atom_ignore_list,2)
              if( all(atom_ignore_list(:,i).eq.[is,ia]) ) cycle atom_loop
           end do
           write(unit,*) basis_host%spec(is)%atom(ia,:3)
        end do atom_loop
     end do
     write(unit,*)
     do is = 1, basis_host%nspec
        do i = 1, size(gridpoints,dim=2)
           write(unit,*) gridpoints(1:3,i), gridpoints(3+is,i), is
        end do
     end do
     close(unit)
     stop 0
  end if
  

  !-----------------------------------------------------------------------------
  ! call evaluator
  !-----------------------------------------------------------------------------
  allocate(viability_grid(basis_host%nspec,size(gridpoints,2)))
  do ia = 1, size(atom_ignore_list,2)
     viability_grid(:,:) = 0._real32
     do i = 1, size(gridpoints,dim=2)
        viability_grid(1,i) = evaluate_point( generator%distributions, &
             gridpoints(1:3,i), atom_ignore_list(1,ia), basis_host, &
             atom_ignore_list(:,ia:), &
             [ generator%distributions%bond_info(:)%radius_covalent ] &
        )
     end do
     best_loc = maxloc(viability_grid(atom_ignore_list(1,ia),:),dim=1)
     ! Check point is correct
     ltmp1 = .false.
     do ja = ia, size(atom_ignore_list,2), 1
        if( &
             all( &
                  abs( &
                       gridpoints(1:3,best_loc) - &
                       basis_host%spec(1)%atom(atom_ignore_list(2,ja),:3) &
                  ) .lt. tolerance + 1.E-6_real32 &
             ) &
        ) ltmp1 = .true.
     end do
     call assert( &
          ltmp1, &
          "Incorrect gridpoint found.", &
          success &
     )
     call basis_host%update_images( &
          max_bondlength = max_bondlength, &
          is = 1, ia = atom_ignore_list(2,ia) &
     )
  end do


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_evaluator passed all tests'
  else
     write(0,*) 'test_evaluator failed one or more tests'
     stop 1
  end if

contains

!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_evaluator

module raffle__cache
  use raffle__constants, only: real32
  implicit none

  private
  public :: store_probability_density, retrieve_probability_density

  real(real32), allocatable, dimension(:,:), save :: cached_probability_density

contains

  subroutine store_probability_density(probability_density)
    implicit none
    real(real32), intent(in) :: probability_density(:,:)
    if (allocated(cached_probability_density)) &
         deallocate(cached_probability_density)
    allocate(cached_probability_density, source = probability_density)

  end subroutine store_probability_density

  function retrieve_probability_density() result(probability_density)
    implicit none
    real(real32), allocatable :: probability_density(:,:)
    if(.not.allocated(cached_probability_density)) then
       write(0,*) "Probability density not allocated. Returning zero array."
       allocate(probability_density(1,1), source = 0._real32)
    else
       allocate(probability_density, source = cached_probability_density)
    end if
  end function retrieve_probability_density

end module raffle__cache

! Module generator defined in file ../src/lib/mod_generator.f90

!###############################################################################
! stoichiometry derived type
!###############################################################################
subroutine f90wrap_stoichiometry_type__get__element(this, f90wrap_element)
    use raffle__generator, only: stoichiometry_type
    implicit none
    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    integer, intent(in)   :: this(2)
    type(stoichiometry_type_ptr_type) :: this_ptr
    character(3), intent(out) :: f90wrap_element

    this_ptr = transfer(this, this_ptr)
    f90wrap_element = this_ptr%p%element
end subroutine f90wrap_stoichiometry_type__get__element

subroutine f90wrap_stoichiometry_type__set__element(this, f90wrap_element)
    use raffle__generator, only: stoichiometry_type
    implicit none
    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    integer, intent(in)   :: this(2)
    type(stoichiometry_type_ptr_type) :: this_ptr
    character(3), intent(in) :: f90wrap_element

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%element = f90wrap_element
end subroutine f90wrap_stoichiometry_type__set__element

subroutine f90wrap_stoichiometry_type__get__num(this, f90wrap_num)
    use raffle__generator, only: stoichiometry_type
    implicit none
    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    integer, intent(in)   :: this(2)
    type(stoichiometry_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_num

    this_ptr = transfer(this, this_ptr)
    f90wrap_num = this_ptr%p%num
end subroutine f90wrap_stoichiometry_type__get__num

subroutine f90wrap_stoichiometry_type__set__num(this, f90wrap_num)
    use raffle__generator, only: stoichiometry_type
    implicit none
    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    integer, intent(in)   :: this(2)
    type(stoichiometry_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_num

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%num = f90wrap_num
end subroutine f90wrap_stoichiometry_type__set__num

subroutine f90wrap_stoichiometry_type_initialise(this)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    type(stoichiometry_type_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_stoichiometry_type_initialise

subroutine f90wrap_stoichiometry_type_finalise(this)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    type(stoichiometry_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_stoichiometry_type_finalise


subroutine f90wrap_stoich_type_xnum_array__array_getitem__items( &
       this, f90wrap_i, itemsitem)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    integer, intent(in), dimension(2) :: this
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: itemsitem(2)
    type(stoichiometry_type_ptr_type) :: items_ptr

    this_ptr = transfer(this, this_ptr)
    if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%items)) then
        call f90wrap_abort("array index out of range")
    else
        items_ptr%p => this_ptr%p%items(f90wrap_i)
        itemsitem = transfer(items_ptr,itemsitem)
    endif
end subroutine f90wrap_stoich_type_xnum_array__array_getitem__items

subroutine f90wrap_stoich_type_xnum_array__array_setitem__items(this, f90wrap_i, itemsitem)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type stoichiometry_type_ptr_type
        type(stoichiometry_type), pointer :: p => NULL()
    end type stoichiometry_type_ptr_type
    integer, intent(in), dimension(2) :: this
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: itemsitem(2)
    type(stoichiometry_type_ptr_type) :: items_ptr

    this_ptr = transfer(this, this_ptr)
    if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%items)) then
        call f90wrap_abort("array index out of range")
    else
        items_ptr = transfer(itemsitem,items_ptr)
        this_ptr%p%items(f90wrap_i) = items_ptr%p
    endif
end subroutine f90wrap_stoich_type_xnum_array__array_setitem__items

subroutine f90wrap_stoich_type_xnum_array__array_len__items(this, f90wrap_n)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    integer, intent(in), dimension(2) :: this
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_n
    this_ptr = transfer(this, this_ptr)
    f90wrap_n = size(this_ptr%p%items)
end subroutine f90wrap_stoich_type_xnum_array__array_len__items

subroutine f90wrap_stoich_type_xnum_array__array_alloc__items(this, num)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in) :: num
    integer, intent(inout), dimension(2) :: this

    this_ptr = transfer(this, this_ptr)
    allocate(this_ptr%p%items(num))
    this = transfer(this_ptr, this)
end subroutine f90wrap_stoich_type_xnum_array__array_alloc__items

subroutine f90wrap_stoich_type_xnum_array__array_dealloc__items(this)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(inout), dimension(2) :: this

    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p%items)
    this = transfer(this_ptr, this)
end subroutine f90wrap_stoich_type_xnum_array__array_dealloc__items
!###############################################################################


!###############################################################################
! generator contained stoichiometry
!###############################################################################
subroutine f90wrap_generator__stoich_type_xnum_array_initialise(this)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_generator__stoich_type_xnum_array_initialise

subroutine f90wrap_generator__stoich_type_xnum_array_finalise(this)
    use raffle__generator, only: stoichiometry_type
    implicit none

    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type(stoichiometry_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_generator__stoich_type_xnum_array_finalise
!###############################################################################


!###############################################################################
! number of generated structures
!###############################################################################
subroutine f90wrap_raffle_generator_type__get__num_structures( &
     this, f90wrap_num_structures &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_num_structures

    this_ptr = transfer(this, this_ptr)
    f90wrap_num_structures = this_ptr%p%num_structures
end subroutine f90wrap_raffle_generator_type__get__num_structures

subroutine f90wrap_raffle_generator_type__set__num_structures( &
     this, f90wrap_num_structures &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_num_structures

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%num_structures = f90wrap_num_structures
end subroutine f90wrap_raffle_generator_type__set__num_structures
!###############################################################################


!###############################################################################
! host handling
!###############################################################################
subroutine f90wrap_raffle_generator_type__get__host_defined( &
     this, f90wrap_host_is_defined &
)
    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_host_is_defined

    this_ptr = transfer(this, this_ptr)
    f90wrap_host_is_defined = this_ptr%p%distributions%host_system%defined
end subroutine f90wrap_raffle_generator_type__get__host_defined

subroutine f90wrap_raffle_generator_type__get__host(this, f90wrap_host)
    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_host(2)
    type(basis_type_ptr_type) :: host_ptr

    this_ptr = transfer(this, this_ptr)
    host_ptr%p => this_ptr%p%host
    f90wrap_host = transfer(host_ptr, f90wrap_host)
end subroutine f90wrap_raffle_generator_type__get__host

subroutine f90wrap_raffle_generator_type__set__host(this, f90wrap_host)
    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_host(2)
    type(basis_type_ptr_type) :: host_ptr

    this_ptr = transfer(this, this_ptr)
    host_ptr = transfer(f90wrap_host, host_ptr)
    this_ptr%p%host = host_ptr%p
end subroutine f90wrap_raffle_generator_type__set__host
!###############################################################################


!###############################################################################
! viability grid parameters
!###############################################################################
subroutine f90wrap_raffle_generator_type__array__grid( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__generator, only: raffle_generator_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 5
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%grid)
    dloc = loc(this_ptr%p%grid)
end subroutine f90wrap_raffle_generator_type__array__grid

subroutine f90wrap_raffle_generator_type__array__grid_offset( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__generator, only: raffle_generator_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%grid_offset)
    dloc = loc(this_ptr%p%grid_offset)
end subroutine f90wrap_raffle_generator_type__array__grid_offset

subroutine f90wrap_raffle_generator_type__get__grid_spacing( &
     this, f90wrap_grid_spacing &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_grid_spacing

    this_ptr = transfer(this, this_ptr)
    f90wrap_grid_spacing = this_ptr%p%grid_spacing
end subroutine f90wrap_raffle_generator_type__get__grid_spacing

subroutine f90wrap_raffle_generator_type__set__grid_spacing( &
     this, f90wrap_grid_spacing &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_grid_spacing

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%grid_spacing = f90wrap_grid_spacing
end subroutine f90wrap_raffle_generator_type__set__grid_spacing

subroutine f90wrap_raffle_generator_type__array__bounds( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__generator, only: raffle_generator_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 2
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:2) = shape(this_ptr%p%bounds)
    dloc = loc(this_ptr%p%bounds)
end subroutine f90wrap_raffle_generator_type__array__bounds
!###############################################################################


!###############################################################################
! distribution function handling
!###############################################################################
subroutine f90wrap_raffle_generator_type__get__distributions( &
     this, f90wrap_distributions &
)
    use raffle__generator, only: raffle_generator_type
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_distributions(2)
    type(distribs_container_type_ptr_type) :: distributions_ptr

    this_ptr = transfer(this, this_ptr)
    distributions_ptr%p => this_ptr%p%distributions
    f90wrap_distributions = transfer(distributions_ptr,f90wrap_distributions)
end subroutine f90wrap_raffle_generator_type__get__distributions

subroutine f90wrap_raffle_generator_type__set__distributions( &
     this, f90wrap_distributions &
)
    use raffle__generator, only: raffle_generator_type
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_distributions(2)
    type(distribs_container_type_ptr_type) :: distributions_ptr

    this_ptr = transfer(this, this_ptr)
    distributions_ptr = transfer(f90wrap_distributions,distributions_ptr)
    this_ptr%p%distributions = distributions_ptr%p
end subroutine f90wrap_raffle_generator_type__set__distributions
!###############################################################################


!###############################################################################
! random walk parameters
!###############################################################################
subroutine f90wrap_raffle_generator_type__get__max_attempts( &
     this, f90wrap_max_attempts &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_max_attempts

    this_ptr = transfer(this, this_ptr)
    f90wrap_max_attempts = this_ptr%p%max_attempts
end subroutine f90wrap_raffle_generator_type__get__max_attempts

subroutine f90wrap_raffle_generator_type__set__max_attempts( &
     this, f90wrap_max_attempts &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_max_attempts

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%max_attempts = f90wrap_max_attempts
end subroutine f90wrap_raffle_generator_type__set__max_attempts

subroutine f90wrap_raffle_generator_type__get__walk_step_size_coarse( &
     this, f90wrap_walk_step_size_coarse &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_walk_step_size_coarse

    this_ptr = transfer(this, this_ptr)
    f90wrap_walk_step_size_coarse = this_ptr%p%walk_step_size_coarse
end subroutine f90wrap_raffle_generator_type__get__walk_step_size_coarse

subroutine f90wrap_raffle_generator_type__set__walk_step_size_coarse( &
     this, f90wrap_walk_step_size_coarse &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_walk_step_size_coarse

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%walk_step_size_coarse = f90wrap_walk_step_size_coarse
end subroutine f90wrap_raffle_generator_type__set__walk_step_size_coarse

subroutine f90wrap_raffle_generator_type__get__walk_step_size_fine( &
     this, f90wrap_walk_step_size_fine &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_walk_step_size_fine

    this_ptr = transfer(this, this_ptr)
    f90wrap_walk_step_size_fine = this_ptr%p%walk_step_size_fine
end subroutine f90wrap_raffle_generator_type__get__walk_step_size_fine

subroutine f90wrap_raffle_generator_type__set__walk_step_size_fine( &
     this, f90wrap_walk_step_size_fine &
)
    use raffle__generator, only: raffle_generator_type
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(in)   :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_walk_step_size_fine

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%walk_step_size_fine = f90wrap_walk_step_size_fine
end subroutine f90wrap_raffle_generator_type__set__walk_step_size_fine
!###############################################################################


!###############################################################################
! placement method ratio
!###############################################################################
subroutine f90wrap_raffle_generator_type__array__method_ratio( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__generator, only: raffle_generator_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%method_ratio)
    dloc = loc(this_ptr%p%method_ratio)
end subroutine f90wrap_raffle_generator_type__array__method_ratio

subroutine f90wrap_raffle_generator_type__array__method_ratio_default( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__generator, only: raffle_generator_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%method_ratio_default)
    dloc = loc(this_ptr%p%method_ratio_default)
end subroutine f90wrap_raffle_generator_type__array__method_ratio_default
!###############################################################################


!###############################################################################
! generated structures handling
!###############################################################################
subroutine f90wrap_raffle_generator_type__array_getitem__structures( &
     f90wrap_this, f90wrap_i, structuresitem &
)

    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: structuresitem(2)
    type(basis_type_ptr_type) :: structures_ptr

    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%structures)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%structures)) then
            call f90wrap_abort("array index out of range")
        else
            structures_ptr%p => this_ptr%p%structures(f90wrap_i)
            structuresitem = transfer(structures_ptr,structuresitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_raffle_generator_type__array_getitem__structures

subroutine f90wrap_raffle_generator_type__array_setitem__structures( &
     f90wrap_this, f90wrap_i, structuresitem &
)

    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: structuresitem(2)
    type(basis_type_ptr_type) :: structures_ptr

    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%structures)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%structures)) then
            call f90wrap_abort("array index out of range")
        else
            structures_ptr = transfer(structuresitem,structures_ptr)
            this_ptr%p%structures(f90wrap_i) = structures_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_raffle_generator_type__array_setitem__structures

subroutine f90wrap_raffle_generator_type__array_len__structures( &
     f90wrap_this, f90wrap_n &
)

    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(raffle_generator_type_ptr_type) :: this_ptr

    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%structures)) then
        f90wrap_n = size(this_ptr%p%structures)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_raffle_generator_type__array_len__structures
!###############################################################################


!###############################################################################
! generator derived type initialisation and finalisation
!###############################################################################
subroutine f90wrap_generator__raffle_generator_type_initialise(this)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_generator__raffle_generator_type_initialise

subroutine f90wrap_generator__raffle_generator_type_finalise(this)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_generator__raffle_generator_type_finalise
!###############################################################################


!###############################################################################
! set placement method ratio
!###############################################################################
subroutine f90wrap_generator__set_method_ratio_default__binding__rgt( &
     this, method_ratio &
)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(5), intent(in) :: method_ratio

    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_method_ratio_default(method_ratio=method_ratio)
end subroutine f90wrap_generator__set_method_ratio_default__binding__rgt
!###############################################################################


!###############################################################################
! initialise random seed
!###############################################################################
subroutine f90wrap_generator__init_seed__binding__rgt( &
     this, put, get, num_threads, n0, n1 &
)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, optional, intent(in), dimension(n0) :: put
    integer, optional, intent(inout), dimension(n1) :: get
    integer, optional, intent(inout) :: num_threads
    integer :: n0
    !f2py intent(hide), depend(put) :: n0 = shape(put,0)
    integer :: n1
    !f2py intent(hide), depend(get) :: n1 = shape(get,0)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%init_seed(put=put, get=get, num_threads=num_threads)
end subroutine f90wrap_generator__init_seed__binding__rgt
!###############################################################################


!###############################################################################
! generator type procedure bindings
!###############################################################################
subroutine f90wrap_generator__set_host__binding__rgt(this, host)
    use raffle__geom_rw, only: basis_type
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_ptr_type) :: host_ptr
    integer, intent(in), dimension(2) :: host
    this_ptr = transfer(this, this_ptr)
    host_ptr = transfer(host, host_ptr)
    call this_ptr%p%set_host(host=host_ptr%p)
end subroutine f90wrap_generator__set_host__binding__rgt

subroutine f90wrap_generator__get_host__binding__rgt(ret_output, this)
    use raffle__geom_rw, only: basis_type
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: ret_output_ptr
    integer, intent(out), dimension(2) :: ret_output
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    allocate(ret_output_ptr%p)
    ret_output_ptr%p = this_ptr%p%get_host()
    ret_output = transfer(ret_output_ptr, ret_output)
end subroutine f90wrap_generator__get_host__binding__rgt

subroutine f90wrap_generator__prepare_host__binding__rgt( &
     this, interface_location, interface_axis, depth, location_as_fractional, n0 &
)
    use raffle__generator, only: stoichiometry_type
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(n0), intent(in) :: interface_location
    integer, intent(in), optional :: interface_axis
    real(4), intent(in), optional :: depth
    logical, intent(in), optional :: location_as_fractional
    integer :: n0
    !f2py intent(hide), depend(interface_location) :: n0 = shape(interface_location,0)

    type(stoichiometry_type), dimension(:), allocatable :: stoichiometry
    !! Stoichiometry of the atoms removed from the host structure.

    this_ptr = transfer(this, this_ptr)
    stoichiometry = this_ptr%p%prepare_host( &
         interface_location=interface_location, &
         interface_axis=interface_axis, &
         depth=depth, location_as_fractional=location_as_fractional &
    )
end subroutine f90wrap_generator__prepare_host__binding__rgt

subroutine f90wrap_generator__set_grid__binding__raffle_generator_type( &
     this, grid, grid_spacing, grid_offset &
)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, dimension(3), intent(in), optional :: grid
    real(4), intent(in), optional :: grid_spacing
    real(4), dimension(3), intent(in), optional :: grid_offset
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_grid( &
         grid = grid, &
         grid_spacing = grid_spacing, &
         grid_offset = grid_offset &
    )
end subroutine f90wrap_generator__set_grid__binding__raffle_generator_type

subroutine f90wrap_generator__reset_grid__binding__raffle_generator_type(this)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%reset_grid()
end subroutine f90wrap_generator__reset_grid__binding__raffle_generator_type

subroutine f90wrap_generator__set_bounds__binding__rgt(this, bounds)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(2,3), intent(in) :: bounds
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_bounds(bounds=bounds)
end subroutine f90wrap_generator__set_bounds__binding__rgt

subroutine f90wrap_generator__reset_bounds__binding__rgt(this)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%reset_bounds()
end subroutine f90wrap_generator__reset_bounds__binding__rgt

subroutine f90wrap_generator__generate__binding__rgt( &
       this, num_structures, stoichiometry, &
       method_ratio, seed, settings_out_file, verbose, exit_code &
)
    use raffle__geom_rw, only: basis_type
    use raffle__generator, only: raffle_generator_type, stoichiometry_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type


    type stoichiometry_type_xnum_array
        type(stoichiometry_type), dimension(:), allocatable :: items
    end type stoichiometry_type_xnum_array

    type stoichiometry_type_xnum_array_ptr_type
        type(stoichiometry_type_xnum_array), pointer :: p => NULL()
    end type stoichiometry_type_xnum_array_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(in) :: num_structures
    type(stoichiometry_type_xnum_array_ptr_type) :: stoichiometry_ptr
    integer, intent(in), dimension(2) :: stoichiometry
    real(4), intent(in), optional, dimension(5) :: method_ratio
    character*(*), intent(in), optional :: settings_out_file
    integer, intent(in), optional :: seed
    integer, intent(in), optional :: verbose
    integer, intent(out), optional :: exit_code

    this_ptr = transfer(this, this_ptr)
    stoichiometry_ptr = transfer(stoichiometry, stoichiometry_ptr)
    call this_ptr%p%generate( &
         num_structures=num_structures, &
         stoichiometry=stoichiometry_ptr%p%items, &
         method_ratio=method_ratio, &
         seed=seed, &
         settings_out_file=settings_out_file, &
         verbose=verbose, &
         exit_code=exit_code &
    )
end subroutine f90wrap_generator__generate__binding__rgt

subroutine f90wrap_generator__get_structures__binding__rgt(this, ret_structures)
    use raffle__geom_rw, only: basis_type
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(out), dimension(2) :: ret_structures
    type(basis_type_xnum_array_ptr_type) :: ret_structures_ptr

    this_ptr = transfer(this, this_ptr)
    ret_structures_ptr%p%items = this_ptr%p%get_structures()
    ret_structures = transfer(ret_structures_ptr,ret_structures)
end subroutine f90wrap_generator__get_structures__binding__rgt

subroutine f90wrap_generator__set_structures__binding__rgt(this, structures)
    use raffle__geom_rw, only: basis_type
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(in), dimension(2) :: structures
    type(basis_type_xnum_array_ptr_type) :: structures_ptr

    this_ptr = transfer(this, this_ptr)
    structures_ptr = transfer(structures, structures_ptr)
    call this_ptr%p%set_structures(structures_ptr%p%items)
end subroutine f90wrap_generator__set_structures__binding__rgt

subroutine f90wrap_generator__remove_structure__binding__rgt(this, index_bn, n0)
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, dimension(n0), intent(in) :: index_bn
    integer :: n0
    !f2py intent(hide), depend(energy_above_hull_list) :: n0 = shape(energy_above_hull_list,0)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%remove_structure(index=index_bn)
end subroutine f90wrap_generator__remove_structure__binding__rgt

subroutine f90wrap_generator__evaluate__binding__rgt(this, ret_viability, basis)
    use raffle__geom_rw, only: basis_type
    use raffle__generator, only: raffle_generator_type
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), intent(out) :: ret_viability
    type(basis_type_ptr_type) :: basis_ptr
    integer, intent(in), dimension(2) :: basis
    this_ptr = transfer(this, this_ptr)
    basis_ptr = transfer(basis, basis_ptr)
    ret_viability = this_ptr%p%evaluate(basis=basis_ptr%p)
end subroutine f90wrap_generator__evaluate__binding__rgt


subroutine f90wrap_generator__get_probability_density__rgt( &
     this, basis, species_list, grid, grid_offset, grid_spacing, bounds, &
     n_ret_coords, n_ret_points, ret_grid, n0 &
)
    use raffle__generator, only: raffle_generator_type
    use raffle__geom_rw, only: basis_type
    use raffle__cache, only: store_probability_density
    implicit none

    type raffle_generator_type_ptr_type
        type(raffle_generator_type), pointer :: p => NULL()
    end type raffle_generator_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(raffle_generator_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_ptr_type) :: basis_ptr
    integer, intent(in), dimension(2) :: basis
    character(len=3), intent(in), dimension(n0) :: species_list
    integer, dimension(3), intent(in), optional :: grid
    real(4), dimension(3), intent(in), optional :: grid_offset
    real(4), intent(in), optional :: grid_spacing
    real(4), dimension(2,3), intent(in), optional :: bounds
    integer, intent(out) :: n_ret_coords
    integer, intent(out) :: n_ret_points
    integer, dimension(3), intent(out) :: ret_grid
    integer :: n0
    !f2py intent(hide), depend(species_list) :: n0 = shape(species_list,0)

    ! Local temporary array
    real(4), allocatable, dimension(:,:) :: local_probability_density

    ! Call the actual function
    this_ptr = transfer(this, this_ptr)
    basis_ptr = transfer(basis, basis_ptr)
    local_probability_density = this_ptr%p%get_probability_density( &
         basis = basis_ptr%p, &
         species_list = species_list, &
         grid = grid, &
         grid_offset = grid_offset, &
         grid_spacing = grid_spacing, &
         bounds = bounds, &
         grid_output = ret_grid &
    )

    n_ret_coords = size(local_probability_density, 1)
    n_ret_points = size(local_probability_density, 2)

    ! Store local_probability_density in the cache so Python can retrieve it
    call store_probability_density( local_probability_density )
end subroutine f90wrap_generator__get_probability_density__rgt


subroutine f90wrap_retrieve_probability_density(probability_density, n0, n1)
    use raffle__cache, only: retrieve_probability_density
    implicit none

    real(4), dimension(n0,n1) :: probability_density
    integer :: n0
    !f2py intent(hide), depend(probability_density) :: n0 = shape(probability_density,0)
    integer :: n1
    !f2py intent(hide), depend(probability_density) :: n1 = shape(probability_density,1)

    probability_density = retrieve_probability_density()
end subroutine f90wrap_retrieve_probability_density


subroutine f90wrap_generator__print_settings__binding__rgt( &
    this, file &
)
   use raffle__generator, only: raffle_generator_type
   implicit none

   type raffle_generator_type_ptr_type
       type(raffle_generator_type), pointer :: p => NULL()
   end type raffle_generator_type_ptr_type
   type(raffle_generator_type_ptr_type) :: this_ptr
   integer, intent(in), dimension(2) :: this
   character*(*), intent(in) :: file
   this_ptr = transfer(this, this_ptr)
   call this_ptr%p%print_settings(file=file)
end subroutine f90wrap_generator__print_settings__binding__rgt


subroutine f90wrap_generator__read_settings__binding__rgt( &
    this, file &
)
   use raffle__generator, only: raffle_generator_type
   implicit none

   type raffle_generator_type_ptr_type
       type(raffle_generator_type), pointer :: p => NULL()
   end type raffle_generator_type_ptr_type
   type(raffle_generator_type_ptr_type) :: this_ptr
   integer, intent(in), dimension(2) :: this
   character*(*), intent(in) :: file
   this_ptr = transfer(this, this_ptr)
   call this_ptr%p%read_settings(file=file)
end subroutine f90wrap_generator__read_settings__binding__rgt
!###############################################################################

! End of module generator defined in file ../src/lib/mod_generator.f90

module raffle__place_methods
  !! Module containing the placement methods available within RAFFLE.
  !!
  !! This module contains procedures to query points for atom placement.
  !! The available placement methods are:
  !! - void: place the atom in the gridpoint with the largest void space
  !! - rand: place the atom at a random gridpoint
  !! - walk: place the atom using a random walk method
  !! - growth: place the atom using a random walk, with last placement point
  !!        as the starting point
  !! - min:  place the atom at the gridpoint with the highest viability
  use raffle__constants, only: real32, pi
  use raffle__misc_linalg, only: modu, inverse_3x3
  use raffle__geom_extd, only: extended_basis_type
  use raffle__dist_calcs, only: &
       get_min_dist, &
       get_min_dist_between_point_and_species
  use raffle__evaluator, only: evaluate_point
  use raffle__distribs_container, only: distribs_container_type
  implicit none


  private

  public :: &
       place_method_void, place_method_rand, &
       place_method_walk, place_method_growth, &
       place_method_min


contains

!###############################################################################
  function place_method_void( &
       points, basis, atom_ignore_list, viable &
  ) result(point)
    !! VOID placement method.
    !!
    !! This method returns the gridpoint with the lowest neighbour density.
    !! i.e. the point with the lowest density in the cell.
    implicit none

    ! Arguments
    real(real32), dimension(:,:), intent(in) :: points
    !! List of gridpoints to consider.
    type(extended_basis_type), intent(inout) :: basis
    !! Structure to add atom to.
    integer, dimension(:,:), intent(in) :: atom_ignore_list
    !! List of atoms to ignore (i.e. indices of atoms not yet placed).
    logical, intent(out) :: viable
    !! Boolean to indicate if point is viable.
    real(real32), dimension(3) :: point
    !! Point to add atom to.
    
    ! Local variables
    integer :: i, j, k
    !! Loop indices.
    real(real32), dimension(3) :: best_location
    !! Index of best location to place atom.
    real(real32) :: best_location_bond, smallest_bond
    !! Bond lengths.
    real(real32), dimension(3) :: tmpvector
    !! Temporary vector for gridpoint.


    viable = .false.
   
    !---------------------------------------------------------------------------
    ! loop over all gridpoints in the unit cell and find the one with the ...
    ! ... largest void space
    !---------------------------------------------------------------------------
    best_location = 0._real32
    best_location_bond = -huge(1._real32)
    do i = 1, size(points,2)
       smallest_bond = modu(get_min_dist(&
            basis, [ points(1:3,i) ], .false., &
            ignore_list = atom_ignore_list))
       if( smallest_bond .gt. best_location_bond ) then
          best_location_bond = smallest_bond
          best_location = points(1:3,i)
       end if
    end do


    !---------------------------------------------------------------------------
    ! return the gridpoint with the largest void space
    !---------------------------------------------------------------------------
    point = best_location
    viable = .true.

  end function place_method_void
!###############################################################################


!###############################################################################
  function place_method_rand( distribs_container, &
       bounds, &
       basis, atom_ignore_list, radius_list, max_attempts, viable &
  ) result(point)
    !! Random placement method.
    !!
    !! This method places the atom at a random gridpoint.
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    real(real32), dimension(2,3), intent(in) :: bounds
    !! Bounds of the unit cell.
    type(extended_basis_type), intent(inout) :: basis
    !! Structure to add atom to.
    integer, dimension(:,:), intent(in) :: atom_ignore_list
    !! List of atoms to ignore (i.e. indices of atoms not yet placed).
    real(real32), dimension(:), intent(in) :: radius_list
    !! List of radii for each pair of elements.
    integer, intent(in) :: max_attempts
    !! Limit on number of attempts.
    logical, intent(out) :: viable
    !! Boolean to indicate if point is viable.
    real(real32), dimension(3) :: point
    !! Point to add atom to.

    ! Local variables
    integer :: i, is, js
    !! Loop indices.
    real(real32) :: rtmp1
    !! random number.
    real(real32), dimension(3) :: rvec1
    !! random vector.
    integer, dimension(basis%nspec,basis%nspec) :: pair_index


    viable = .false.

    !---------------------------------------------------------------------------
    ! get list of element pair indices
    ! (i.e. the index for bond_info for each element pair)
    !---------------------------------------------------------------------------
    i = 0
    do is = 1, basis%nspec
       do js = 1, basis%nspec
          pair_index(is, js) = distribs_container%get_pair_index( &
               basis%spec(is)%name, basis%spec(js)%name &
          )
       end do
    end do


    !---------------------------------------------------------------------------
    ! find a random gridpoint that is not too close to any other atom
    !---------------------------------------------------------------------------
    atom_loop: do i = 1, max_attempts
       call random_number(rvec1)
       point = bounds(1,:) + ( bounds(2,:) - bounds(1,:) ) * rvec1
       do js = 1, basis%nspec
          if( &
               get_min_dist_between_point_and_species( &
                    basis, point, &
                    species = js, &
                    ignore_list = atom_ignore_list &
               ) .lt. radius_list(pair_index(atom_ignore_list(1,1),js)) * &
               distribs_container%radius_distance_tol(1) &
          )then
             cycle atom_loop
          end if
       end do
       viable = .true.
       exit atom_loop
    end do atom_loop

  end function place_method_rand
!###############################################################################


!###############################################################################
  function place_method_walk( distribs_container, &
       bounds, &
       basis, atom_ignore_list, &
       radius_list, max_attempts, &
       step_size_coarse, step_size_fine, &
       viable &
  ) result(point)
    !! Random walk placement method.
    !!
    !! This method places the atom using a random walk method.
    !! An initial point is chosen at random, and then points nearby are tested
    !! to see if they are more suitable than the current point. If they are,
    !! the query point is moved to the new point and the process is repeated.
    !! The process is repeated, with each point being tested against a random
    !! number. If the random number is less than the suitability of the point,
    !! the atom is placed at that point.
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    real(real32), dimension(2,3), intent(in) :: bounds
    !! Bounds of the unit cell.
    type(extended_basis_type), intent(inout) :: basis
    !! Structure to add atom to.
    integer, intent(in) :: max_attempts
    !! Limit on number of attempts.
    real(real32), intent(in) :: step_size_coarse, step_size_fine
    !! Step sizes for random walk.
    logical, intent(out) :: viable
    !! Boolean to indicate if point is viable.
    integer, dimension(:,:), intent(in) :: atom_ignore_list
    !! List of atoms to ignore (i.e. indices of atoms not yet placed).
    real(real32), dimension(:), intent(in) :: radius_list
    !! List of radii for each pair of elements.
    real(real32), dimension(3) :: point
    !! Point to add atom to.

    ! Local variables
    integer :: i, j
    !! Loop indices.
    integer :: nattempt, nstuck
    !! Number of attempts and number of times stuck at same site
    real(real32) :: rtmp1
    !! Random number.
    real(real32), dimension(3) :: rvec1, abc
    !! Random vector and lattice constants.
    real(real32) :: crude_norm
    !! Crude normalisation.
    real(real32) :: site_value, test_value
    !! Viability values.
    real(real32), dimension(3) :: site_vector, test_vector
    !! Vectors for gridpoints.
   

    viable = .false.

    !---------------------------------------------------------------------------
    ! test a random point in the unit cell
    !---------------------------------------------------------------------------
    do i = 1, 3
       abc(i) = modu(basis%lat(i,:))
    end do
    i = 0
    random_loop : do 
       i = i + 1
       if(i.gt.max_attempts) return  
       call random_number(site_vector)
       site_vector = bounds(1,:) + ( bounds(2,:) - bounds(1,:) ) * site_vector

       site_value = evaluate_point( distribs_container, &
            site_vector, atom_ignore_list(1,1), basis, &
            atom_ignore_list, radius_list &
       )
       call random_number(rtmp1)
       if(rtmp1.lt.site_value) exit random_loop
 
    end do random_loop


    !---------------------------------------------------------------------------
    ! now do a random walk to find a suitable point to place the atom
    !---------------------------------------------------------------------------
    nattempt = 0
    nstuck = 0
    crude_norm = 0.5_real32
    i = 0
    walk_loop : do
       i = i + 1
       if(i.gt.max_attempts) return
       !------------------------------------------------------------------------
       ! if we have tried 10 times, then we need to reduce the step size
       ! get the new test point and map it back into the unit cell
       !------------------------------------------------------------------------
       call random_number(rvec1)
       if(nattempt.ge.10) then 
          test_vector = site_vector + &
               ( rvec1 * 2._real32 - 1._real32 ) * step_size_fine / abc
       else
          test_vector = site_vector + &
               ( rvec1 * 2._real32 - 1._real32 ) * step_size_coarse / abc
       end if
       test_vector = test_vector - floor(test_vector)
       do j = 1, 3
          if(test_vector(j).lt.bounds(1,j) .or. test_vector(j).ge.bounds(2,j)) &
               cycle walk_loop
       end do

       !------------------------------------------------------------------------
       ! evaluate the test point
       !------------------------------------------------------------------------
       test_value = evaluate_point( distribs_container, &
            test_vector, atom_ignore_list(1,1), basis, &
            atom_ignore_list, radius_list &
       )
       if(test_value.lt.1.E-6) cycle walk_loop
       !------------------------------------------------------------------------
       ! if viability of test point is less than current point, then we
       ! are stuck at the current point and need to try again
       !------------------------------------------------------------------------
       if(test_value.lt.site_value) then 
          nstuck = nstuck + 1
          if(nstuck.ge.10) then
             nattempt = nattempt + 1
             if(crude_norm.lt.site_value) &
                  crude_norm = ( &
                       crude_norm + site_value/real(nattempt) &
                  ) / 2._real32

             ! if we have tried 10 times, and still no luck, then we need to
             ! reduce the tolerance
             if(nattempt.ge.10) site_value = site_value / crude_norm
             call random_number(rtmp1)
             if(rtmp1.lt.site_value) exit walk_loop   
          end if   
       else
          nstuck = 0
          site_vector = test_vector
          site_value  = test_value
 
          if(nattempt.ge.10) test_value = test_value / crude_norm
          call random_number(rtmp1)
          if(rtmp1.lt.test_value) exit walk_loop
       end if
 
    end do walk_loop
 
    point = site_vector
    viable=.true.
   
  end function place_method_walk
!###############################################################################


!###############################################################################
  function place_method_growth( distribs_container, &
       prior_point, prior_species, &
       bounds, &
       basis, atom_ignore_list, &
       radius_list, max_attempts, &
       step_size_coarse, step_size_fine, &
       viable &
  ) result(point)
    !! Random walk placement method.
    !!
    !! This method places the atom using a random walk method.
    !! An initial point is chosen at random, and then points nearby are tested
    !! to see if they are more suitable than the current point. If they are,
    !! the query point is moved to the new point and the process is repeated.
    !! The process is repeated, with each point being tested against a random
    !! number. If the random number is less than the suitability of the point,
    !! the atom is placed at that point.
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    real(real32), dimension(3), intent(in) :: prior_point
    !! Point to start walk from.
    integer, intent(in) :: prior_species
    !! Species of last atom placed.
    real(real32), dimension(2,3), intent(in) :: bounds
    !! Bounds of the unit cell.
    type(extended_basis_type), intent(inout) :: basis
    !! Structure to add atom to.
    integer, intent(in) :: max_attempts
    !! Limit on number of attempts.
    real(real32), intent(in) :: step_size_coarse, step_size_fine
    !! Step sizes for random walk.
    logical, intent(out) :: viable
    !! Boolean to indicate if point is viable.
    integer, dimension(:,:), intent(in) :: atom_ignore_list
    !! List of atoms to ignore (i.e. indices of atoms not yet placed).
    real(real32), dimension(:), intent(in) :: radius_list
    !! List of radii for each pair of elements.
    real(real32), dimension(3) :: point
    !! Point to add atom to.

    ! Local variables
    integer :: i, j, idx
    !! Loop indices.
    integer :: nattempt, nstuck
    !! Number of attempts and number of times stuck at same site
    real(real32) :: rtmp1, min_radius
    !! Random number and minimum radius.
    real(real32), dimension(3) :: rvec1, abc
    !! Random vector and lattice constants.
    real(real32) :: crude_norm
    !! Crude normalisation.
    real(real32) :: site_value, test_value
    !! Viability values.
    real(real32), dimension(3) :: site_vector, test_vector
    !! Vectors for gridpoints.
    real(real32), dimension(3,3) :: inverse_lattice
   

    viable = .false.

    !---------------------------------------------------------------------------
    ! get the lattice constants and the inverse lattice
    !---------------------------------------------------------------------------
    do i = 1, 3
       abc(i) = modu(basis%lat(i,:))
    end do
    inverse_lattice = inverse_3x3(basis%lat)


    !---------------------------------------------------------------------------
    ! get the index of the pair of species
    !---------------------------------------------------------------------------
    idx = distribs_container%get_pair_index( &
         basis%spec(prior_species)%name, &
         basis%spec(atom_ignore_list(1,1))%name &
    )
    min_radius = radius_list(idx) * distribs_container%radius_distance_tol(1)


    !---------------------------------------------------------------------------
    ! test a random point within a spherical shell around the prior point
    !---------------------------------------------------------------------------
    i = 0
    shell_loop: do
       i = i + 1
       if(i.gt.max_attempts) return
       call random_number(rvec1)
       ! map rvec1(1) to ring between min_radius and min_radius + 1.0
       rvec1(1) = rvec1(1) + min_radius ! r
       rvec1(2) = rvec1(2) * 2._real32 * pi ! theta
       rvec1(3) = rvec1(3) * pi ! phi
       ! convert from spherical to cartesian
       rvec1 = [ &
            rvec1(1) * cos(rvec1(2)) * sin(rvec1(3)), &
            rvec1(1) * sin(rvec1(2)) * sin(rvec1(3)), &
            rvec1(1) * cos(rvec1(3)) &
       ]
       ! convert from cartesian to direct
       rvec1 = matmul(rvec1, inverse_lattice)
       site_vector = prior_point + rvec1
       do j = 1, 3
          if(site_vector(j).lt.bounds(1,j) .or. site_vector(j).ge.bounds(2,j)) &
               cycle shell_loop
       end do
       ! now evaluate the point and check if it passes the initial criteria
       site_value = evaluate_point( distribs_container, &
            site_vector, atom_ignore_list(1,1), basis, &
            atom_ignore_list, radius_list &
       )
       call random_number(rtmp1)
       if(rtmp1.lt.site_value) exit shell_loop

    end do shell_loop


    !---------------------------------------------------------------------------
    ! now do a random walk to find a suitable point to place the atom
    !---------------------------------------------------------------------------
    nattempt = 0
    nstuck = 0
    crude_norm = 0.5_real32
    i = 0
    walk_loop : do
       i = i + 1
       if(i.gt.max_attempts) return
       !------------------------------------------------------------------------
       ! if we have tried 10 times, then we need to reduce the step size
       ! get the new test point and map it back into the unit cell
       !------------------------------------------------------------------------
       call random_number(rvec1)
       if(nattempt.ge.10) then 
          test_vector = site_vector + &
               ( rvec1 * 2._real32 - 1._real32 ) * step_size_fine / abc
       else
          test_vector = site_vector + &
               ( rvec1 * 2._real32 - 1._real32 ) * step_size_coarse / abc
       end if 
       test_vector = test_vector - floor(test_vector)
       do j = 1, 3
          if(test_vector(j).lt.bounds(1,j) .or. test_vector(j).ge.bounds(2,j)) &
               cycle walk_loop
       end do

       !------------------------------------------------------------------------
       ! evaluate the test point
       !------------------------------------------------------------------------
       test_value = evaluate_point( distribs_container, &
            test_vector, atom_ignore_list(1,1), basis, &
            atom_ignore_list, radius_list &
       )
       if(test_value.lt.1.E-6) cycle walk_loop
       !------------------------------------------------------------------------
       ! if viability of test point is less than current point, then we
       ! are stuck at the current point and need to try again
       !------------------------------------------------------------------------
       if(test_value.lt.site_value) then 
          nstuck = nstuck + 1
          if(nstuck.ge.10) then
             nattempt = nattempt + 1
             if(crude_norm.lt.site_value) &
                  crude_norm = ( &
                       crude_norm + site_value/real(nattempt) &
                  ) / 2._real32

             ! if we have tried 10 times, and still no luck, then we need to
             ! reduce the tolerance
             if(nattempt.ge.10) site_value = site_value / crude_norm
             call random_number(rtmp1)
             if(rtmp1.lt.site_value) exit walk_loop   
          end if   
       else
          nstuck = 0
          site_vector = test_vector
          site_value  = test_value
 
          if(nattempt.ge.10) test_value = test_value / crude_norm
          call random_number(rtmp1)
          if(rtmp1.lt.test_value) exit walk_loop
       end if
 
    end do walk_loop
 
    point = site_vector
    viable=.true.
   
  end function place_method_growth
!###############################################################################


!###############################################################################
  function place_method_min( &
       points, species, &
       species_index_list, viable &
  ) result(point)
    !! Global minimum placement method.
    !!
    !! This method places the atom at the gridpoint with the highest
    !! suitability.
    implicit none

    ! Arguments
    logical, intent(out) :: viable
    !! Boolean to indicate if point is viable.
    integer, intent(in) :: species
    !! Species index to add atom to.
    integer, dimension(:), intent(in) :: species_index_list
    !! List of species indices to add atoms to.
    real(real32), dimension(:,:), intent(in) :: points
    !! List of gridpoints to consider.
    real(real32), dimension(3) :: point
    !! Point to add atom to.

    ! Local variables
    integer :: species_index
    !! Index of species in list.
    integer :: best_gridpoint
    !! Index of best gridpoint.


    viable = .false.

    !---------------------------------------------------------------------------
    ! find the gridpoint with the highest viability
    !---------------------------------------------------------------------------
    species_index = findloc(species_index_list, species, 1)
    best_gridpoint = maxloc(points(3+species_index,:), dim=1)
    if(best_gridpoint.eq.0)then
       return
    elseif(points(3+species,best_gridpoint).lt.1.E-6)then
       return
    end if

    !---------------------------------------------------------------------------
    ! return the gridpoint with the highest viability
    !---------------------------------------------------------------------------
    point = points(1:3,best_gridpoint)
    viable = .true.
   
  end function place_method_min
!###############################################################################

end module raffle__place_methods

! Module raffle__geom_rw defined in file ../src/lib/mod_geom_rw.f90

subroutine f90wrap_species_type__array__atom(this, nd, dtype, dshape, dloc)
    use raffle__geom_rw, only: species_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(species_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%atom)) then
        dshape(1:2) = shape(this_ptr%p%atom)
        dloc = loc(this_ptr%p%atom)
    else
        dloc = 0
    end if
end subroutine f90wrap_species_type__array__atom

subroutine f90wrap_species_type__get__mass(this, f90wrap_mass)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_mass
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_mass = this_ptr%p%mass
end subroutine f90wrap_species_type__get__mass

subroutine f90wrap_species_type__set__mass(this, f90wrap_mass)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_mass
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%mass = f90wrap_mass
end subroutine f90wrap_species_type__set__mass

subroutine f90wrap_species_type__get__charge(this, f90wrap_charge)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_charge
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_charge = this_ptr%p%charge
end subroutine f90wrap_species_type__get__charge

subroutine f90wrap_species_type__set__charge(this, f90wrap_charge)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_charge
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%charge = f90wrap_charge
end subroutine f90wrap_species_type__set__charge

subroutine f90wrap_species_type__get__radius(this, f90wrap_radius)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_radius
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_radius = this_ptr%p%radius
end subroutine f90wrap_species_type__get__radius

subroutine f90wrap_species_type__set__radius(this, f90wrap_radius)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_radius
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%radius = f90wrap_radius
end subroutine f90wrap_species_type__set__radius

subroutine f90wrap_species_type__get__name(this, f90wrap_name)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    character(3), intent(out) :: f90wrap_name
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_name = this_ptr%p%name
end subroutine f90wrap_species_type__get__name

subroutine f90wrap_species_type__set__name(this, f90wrap_name)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    character(3), intent(in) :: f90wrap_name
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%name = f90wrap_name
end subroutine f90wrap_species_type__set__name

subroutine f90wrap_species_type__get__num(this, f90wrap_num)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_num
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_num = this_ptr%p%num
end subroutine f90wrap_species_type__get__num

subroutine f90wrap_species_type__set__num(this, f90wrap_num)
    use raffle__geom_rw, only: species_type
    implicit none
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in)   :: this(2)
    type(species_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_num
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%num = f90wrap_num
end subroutine f90wrap_species_type__set__num

subroutine f90wrap_geom_rw__species_type_initialise(this)
    use raffle__geom_rw, only: species_type
    implicit none
    
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    type(species_type_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_geom_rw__species_type_initialise

subroutine f90wrap_geom_rw__species_type_finalise(this)
    use raffle__geom_rw, only: species_type
    implicit none
    
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    type(species_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_geom_rw__species_type_finalise

subroutine f90wrap_basis_type__array_getitem__spec(f90wrap_this, f90wrap_i, specitem)
    
    use raffle__geom_rw, only: basis_type, species_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: specitem(2)
    type(species_type_ptr_type) :: spec_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%spec)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%spec)) then
            call f90wrap_abort("array index out of range")
        else
            spec_ptr%p => this_ptr%p%spec(f90wrap_i)
            specitem = transfer(spec_ptr,specitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_basis_type__array_getitem__spec

subroutine f90wrap_basis_type__array_setitem__spec(f90wrap_this, f90wrap_i, specitem)
    
    use raffle__geom_rw, only: basis_type, species_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: specitem(2)
    type(species_type_ptr_type) :: spec_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%spec)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%spec)) then
            call f90wrap_abort("array index out of range")
        else
            spec_ptr = transfer(specitem,spec_ptr)
            this_ptr%p%spec(f90wrap_i) = spec_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_basis_type__array_setitem__spec

subroutine f90wrap_basis_type__array_len__spec(f90wrap_this, f90wrap_n)
    
    use raffle__geom_rw, only: basis_type, species_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type species_type_ptr_type
        type(species_type), pointer :: p => NULL()
    end type species_type_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(basis_type_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%spec)) then
        f90wrap_n = size(this_ptr%p%spec)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_basis_type__array_len__spec

subroutine f90wrap_basis_type__get__nspec(this, f90wrap_nspec)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_nspec
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_nspec = this_ptr%p%nspec
end subroutine f90wrap_basis_type__get__nspec

subroutine f90wrap_basis_type__set__nspec(this, f90wrap_nspec)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_nspec
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%nspec = f90wrap_nspec
end subroutine f90wrap_basis_type__set__nspec

subroutine f90wrap_basis_type__get__natom(this, f90wrap_natom)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_natom
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_natom = this_ptr%p%natom
end subroutine f90wrap_basis_type__get__natom

subroutine f90wrap_basis_type__set__natom(this, f90wrap_natom)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_natom
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%natom = f90wrap_natom
end subroutine f90wrap_basis_type__set__natom

subroutine f90wrap_basis_type__get__energy(this, f90wrap_energy)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_energy
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_energy = this_ptr%p%energy
end subroutine f90wrap_basis_type__get__energy

subroutine f90wrap_basis_type__set__energy(this, f90wrap_energy)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_energy
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%energy = f90wrap_energy
end subroutine f90wrap_basis_type__set__energy

subroutine f90wrap_basis_type__array__lat(this, nd, dtype, dshape, dloc)
    use raffle__geom_rw, only: basis_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:2) = shape(this_ptr%p%lat)
    dloc = loc(this_ptr%p%lat)
end subroutine f90wrap_basis_type__array__lat

subroutine f90wrap_basis_type__get__lcart(this, f90wrap_lcart)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_lcart
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_lcart = this_ptr%p%lcart
end subroutine f90wrap_basis_type__get__lcart

subroutine f90wrap_basis_type__set__lcart(this, f90wrap_lcart)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_lcart
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%lcart = f90wrap_lcart
end subroutine f90wrap_basis_type__set__lcart

subroutine f90wrap_basis_type__array__pbc(this, nd, dtype, dshape, dloc)
    use raffle__geom_rw, only: basis_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 5
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%pbc)
    dloc = loc(this_ptr%p%pbc)
end subroutine f90wrap_basis_type__array__pbc

subroutine f90wrap_basis_type__get__sysname(this, f90wrap_sysname)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    character(128), intent(out) :: f90wrap_sysname
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_sysname = this_ptr%p%sysname
end subroutine f90wrap_basis_type__get__sysname

subroutine f90wrap_basis_type__set__sysname(this, f90wrap_sysname)
    use raffle__geom_rw, only: basis_type
    implicit none
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in)   :: this(2)
    type(basis_type_ptr_type) :: this_ptr
    character(128), intent(in) :: f90wrap_sysname
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%sysname = f90wrap_sysname
end subroutine f90wrap_basis_type__set__sysname

subroutine f90wrap_geom_rw__basis_type_initialise(this)
    use raffle__geom_rw, only: basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_geom_rw__basis_type_initialise

subroutine f90wrap_geom_rw__basis_type_finalise(this)
    use raffle__geom_rw, only: basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_geom_rw__basis_type_finalise





subroutine f90wrap_basis_type_xnum_array__array_getitem__items( &
    this, f90wrap_i, itemsitem)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in), dimension(2) :: this
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: itemsitem(2)
    type(basis_type_ptr_type) :: items_ptr
    
    this_ptr = transfer(this, this_ptr)
    if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%items)) then
        call f90wrap_abort("array index out of range")
    else
        items_ptr%p => this_ptr%p%items(f90wrap_i)
        itemsitem = transfer(items_ptr,itemsitem)
    endif
end subroutine f90wrap_basis_type_xnum_array__array_getitem__items

subroutine f90wrap_basis_type_xnum_array__array_setitem__items(this, f90wrap_i, itemsitem)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in), dimension(2) :: this
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: itemsitem(2)
    type(basis_type_ptr_type) :: items_ptr
    
    this_ptr = transfer(this, this_ptr)
    if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%items)) then
        call f90wrap_abort("array index out of range")
    else
        items_ptr = transfer(itemsitem,items_ptr)
        this_ptr%p%items(f90wrap_i) = items_ptr%p
    endif
end subroutine f90wrap_basis_type_xnum_array__array_setitem__items

subroutine f90wrap_basis_type_xnum_array__array_len__items(this, f90wrap_n)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    integer, intent(in), dimension(2) :: this
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_n
    this_ptr = transfer(this, this_ptr)
    f90wrap_n = size(this_ptr%p%items)
end subroutine f90wrap_basis_type_xnum_array__array_len__items

subroutine f90wrap_basis_type_xnum_array__array_alloc__items(this, num)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in) :: num
    integer, intent(inout), dimension(2) :: this

    this_ptr = transfer(this, this_ptr)
    allocate(this_ptr%p%items(num))
    this = transfer(this_ptr, this)
end subroutine f90wrap_basis_type_xnum_array__array_alloc__items

subroutine f90wrap_basis_type_xnum_array__array_dealloc__items(this)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(inout), dimension(2) :: this

    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p%items)
    this = transfer(this_ptr, this)
end subroutine f90wrap_basis_type_xnum_array__array_dealloc__items

subroutine f90wrap_geom_rw__basis_type_xnum_array_initialise(this)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_geom_rw__basis_type_xnum_array_initialise

subroutine f90wrap_geom_rw__basis_type_xnum_array_finalise(this)
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(basis_type_xnum_array_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_geom_rw__basis_type_xnum_array_finalise




subroutine f90wrap_geom_rw__allocate_species__binding__basis_type( &
       this, num_species, species_symbols, species_count, atoms, n0, &
       n1, n2, n3)
    use raffle__geom_rw, only: basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(in), optional :: num_species
    character(3), intent(in), optional, dimension(n0) :: species_symbols
    integer, intent(in), optional, dimension(n1) :: species_count
    real(4), intent(in), optional, dimension(n2,n3) :: atoms
    integer :: n0
    !f2py intent(hide), depend(species_symbols) :: n0 = shape(species_symbols,0)
    integer :: n1
    !f2py intent(hide), depend(species_count) :: n1 = shape(species_count,0)
    integer :: n2
    !f2py intent(hide), depend(atoms) :: n2 = shape(atoms,0)
    integer :: n3
    !f2py intent(hide), depend(atoms) :: n3 = shape(atoms,1)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%allocate_species( &
         num_species=num_species, &
         species_symbols=species_symbols, &
         species_count=species_count, &
         atoms=atoms &
    )
end subroutine f90wrap_geom_rw__allocate_species__binding__basis_type

subroutine f90wrap_geom_rw__convert__binding__basis_type(this)
    use raffle__geom_rw, only: basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%convert()
end subroutine f90wrap_geom_rw__convert__binding__basis_type

subroutine f90wrap_geom_rw__copy__binding__basis_type(this, basis, length)
    use raffle__geom_rw, only: basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_ptr_type) :: basis_ptr
    integer, intent(in), dimension(2) :: basis
    integer, intent(in), optional :: length
    this_ptr = transfer(this, this_ptr)
    basis_ptr = transfer(basis, basis_ptr)
    call this_ptr%p%copy(basis=basis_ptr%p, length=length)
end subroutine f90wrap_geom_rw__copy__binding__basis_type

subroutine f90wrap_geom_rw__get_lattice_constants__binding__basis_type(this, ret_output, radians)
    use raffle__geom_rw, only: basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(basis_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(2,3), intent(out) :: ret_output
    logical, intent(in), optional :: radians
    this_ptr = transfer(this, this_ptr)
    ret_output = this_ptr%p%get_lattice_constants(radians=radians)
end subroutine f90wrap_geom_rw__get_lattice_constants__binding__basis_type

subroutine f90wrap_geom_rw__geom_read(unit, basis, length, iostat)
    use raffle__geom_rw, only: geom_read, basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in) :: unit
    type(basis_type_ptr_type) :: basis_ptr
    integer, intent(out), dimension(2) :: basis
    integer, optional, intent(in) :: length
    integer, optional, intent(inout) :: iostat
    allocate(basis_ptr%p)
    call geom_read(UNIT=unit, basis=basis_ptr%p, length=length, iostat=iostat)
    basis = transfer(basis_ptr, basis)
end subroutine f90wrap_geom_rw__geom_read

subroutine f90wrap_geom_rw__geom_write(unit, basis)
    use raffle__geom_rw, only: geom_write, basis_type
    implicit none
    
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    integer, intent(in) :: unit
    type(basis_type_ptr_type) :: basis_ptr
    integer, intent(in), dimension(2) :: basis
    basis_ptr = transfer(basis, basis_ptr)
    call geom_write(UNIT=unit, basis=basis_ptr%p)
end subroutine f90wrap_geom_rw__geom_write

subroutine f90wrap_geom_rw__get_element_properties(element, charge, mass, radius)
    use raffle__geom_rw, only: get_element_properties
    implicit none
    
    character(3), intent(in) :: element
    real(4), optional, intent(inout) :: charge
    real(4), optional, intent(inout) :: mass
    real(4), optional, intent(inout) :: radius
    call get_element_properties( &
         element=element, &
         charge=charge, &
         mass=mass, &
         radius=radius &
    )
end subroutine f90wrap_geom_rw__get_element_properties

subroutine f90wrap_geom_rw__get__igeom_input(f90wrap_igeom_input)
    use raffle__geom_rw, only: raffle__geom_rw_igeom_input => igeom_input
    implicit none
    integer, intent(out) :: f90wrap_igeom_input
    
    f90wrap_igeom_input = raffle__geom_rw_igeom_input
end subroutine f90wrap_geom_rw__get__igeom_input

subroutine f90wrap_geom_rw__set__igeom_input(f90wrap_igeom_input)
    use raffle__geom_rw, only: raffle__geom_rw_igeom_input => igeom_input
    implicit none
    integer, intent(in) :: f90wrap_igeom_input
    
    raffle__geom_rw_igeom_input = f90wrap_igeom_input
end subroutine f90wrap_geom_rw__set__igeom_input

subroutine f90wrap_geom_rw__get__igeom_output(f90wrap_igeom_output)
    use raffle__geom_rw, only: raffle__geom_rw_igeom_output => igeom_output
    implicit none
    integer, intent(out) :: f90wrap_igeom_output
    
    f90wrap_igeom_output = raffle__geom_rw_igeom_output
end subroutine f90wrap_geom_rw__get__igeom_output

subroutine f90wrap_geom_rw__set__igeom_output(f90wrap_igeom_output)
    use raffle__geom_rw, only: raffle__geom_rw_igeom_output => igeom_output
    implicit none
    integer, intent(in) :: f90wrap_igeom_output
    
    raffle__geom_rw_igeom_output = f90wrap_igeom_output
end subroutine f90wrap_geom_rw__set__igeom_output

! End of module raffle__geom_rw defined in file ../src/lib/mod_geom_rw.f90

module raffle__misc
  !! Module contains various miscellaneous functions and subroutines.
  use raffle__constants, only: real32
  use raffle__io_utils, only: stop_program
  implicit none


  private

  public :: sort1D, sort2D, sort_str, sort_str_order
  public :: set, swap
  public :: shuffle
  public :: icount, grep, flagmaker
  public :: jump, file_check, touch, to_upper, to_lower
  public :: strip_null


  interface sort1D
     !! Sort a 1D array from min to max.
     procedure isort1D,rsort1D
  end interface sort1D

  interface sort2D
     !! Sort a 2D array from min to max along the first column.
     procedure isort2D,rsort2D
  end interface sort2D

  interface set
     !! Reduce an array to its unique elements.
     procedure iset,rset, cset
  end interface set

  interface swap
     !! Swap two elements.
     procedure iswap, rswap, rswap_vec, cswap
  end interface swap

  interface shuffle
     !! Shuffle an array.
     procedure ishuffle, rshuffle
  end interface shuffle



contains

!###############################################################################
  subroutine sort_str(list, lcase)
    !! Sort a list of strings.
    implicit none

    ! Arguments
    character(*), dimension(:), intent(inout) :: list
    !! List of strings to be sorted.
    logical, optional, intent(in) :: lcase
    !! Optional. Boolean whether case insensitive sorting is required.
    !! Default is .false.

    ! Local variables
    integer :: i,loc
    !! Loop index.
    integer :: charlen
    !! Length of the strings.
    logical :: lcase_
    !! Boolean whether case insensitive sorting is required.
    character(:), allocatable, dimension(:) :: tlist
    !! Temporary list for case insensitive sorting.

    charlen = len(list(1))
    if(present(lcase))then
       lcase_ = lcase
    else
       lcase_ = .false.
    end if
    if(lcase_)then
       allocate(character(len=charlen) :: tlist(size(list)))
       tlist = list
       do i = 1, size(tlist)
          list(i) = to_upper(list(i))
       end do
    end if
    do i = 1, size(list)
       loc = minloc(list(i:),dim=1)
       if(loc.eq.1) cycle
       if(lcase_) call cswap(tlist(i),tlist(loc+i-1))
       call cswap(list(i),list(loc+i-1))
    end do
    if(lcase_) list=tlist

  end subroutine sort_str
!###############################################################################


!###############################################################################
  function sort_str_order(list,lcase) result(order)
    !! Sort a list of strings and return the order.
    implicit none

    ! Arguments
    character(*), dimension(:), intent(inout) :: list
    !! List of strings to be sorted.
    logical, optional, intent(in) :: lcase
    !! Optional. Boolean whether case insensitive sorting is required.
    !! Default is .false.

    ! Local variables
    integer :: i,loc
    !! Loop index.
    integer :: charlen
    !! Length of the strings.
    logical :: lcase_
    !! Boolean whether case insensitive sorting is required.
    character(:), allocatable, dimension(:) :: tlist
    !! Temporary list for case insensitive sorting.

    integer, allocatable, dimension(:) :: torder,order
    !! Order of the sorted list.

    charlen = len(list(1))
    lcase_ = .false.
    if(present(lcase))then
       if(lcase)then
          lcase_ = lcase
          allocate(character(len=charlen) :: tlist(size(list)))
          tlist = list
          do i = 1, size(tlist)
             list(i) = to_upper(list(i))
          end do
       end if
    end if

    allocate(torder(size(list)))
    do i = 1, size(list)
       torder(i) = i
    end do

    do i = 1, size(list)
       loc = minloc(list(i:),dim=1)
       if(loc.eq.1) cycle
       if(lcase_) call cswap(tlist(i),tlist(loc+i-1))
       call cswap(list(i),list(loc+i-1))
       call iswap(torder(i),torder(loc+i-1))
    end do

    allocate(order(size(list)))
    do i = 1, size(list)
       order(i) = findloc(torder,i,dim=1)
    end do

    if(lcase_) list=tlist

    return
  end function sort_str_order
!###############################################################################


!###############################################################################
  subroutine isort1D(arr1,arr2,reverse)
    !! Sort a 1D integer array from min to max.
    implicit none

    ! Arguments
    integer, dimension(:), intent(inout) :: arr1
    !! Array to be sorted.
    integer, dimension(:),intent(inout),optional :: arr2
    !! Optional. Second array to be sorted.
    logical, optional, intent(in) :: reverse
    !! Optional. Boolean whether to sort in reverse order.

    ! Local variables
    integer :: i,dim,loc
    !! Loop index.
    integer :: ibuff
    !! Buffer for swapping elements.
    logical :: reverse_
    !! Boolean whether to sort in reverse order.

    if(present(reverse))then
       reverse_=reverse
    else
       reverse_=.false.
    end if

    dim=size(arr1,dim=1)
    do i = 1, dim
       if(reverse_)then
          loc=maxloc(arr1(i:dim),dim=1)+i-1
       else
          loc=minloc(arr1(i:dim),dim=1)+i-1
       end if
       ibuff=arr1(i)
       arr1(i)=arr1(loc)
       arr1(loc)=ibuff

       if(present(arr2)) then
          ibuff=arr2(i)
          arr2(i)=arr2(loc)
          arr2(loc)=ibuff
       end if
    end do

    return
  end subroutine isort1D
!###############################################################################


!###############################################################################
  subroutine rsort1D(arr1,arr2,reverse)
    !! Sort a 1D real array from min to max.
    implicit none

    ! Arguments
    real(real32), dimension(:), intent(inout) :: arr1
    !! Array to be sorted.
    integer, dimension(:),intent(inout),optional :: arr2
    !! Optional. Second array to be sorted.
    logical, optional, intent(in) :: reverse
    !! Optional. Boolean whether to sort in reverse order.

    ! Local variables
    integer :: i,dim,loc
    !! Loop index.
    integer :: ibuff
    !! Buffer for swapping elements.
    real(real32) :: rbuff
    !! Buffer for swapping elements.
    logical :: reverse_
    !! Boolean whether to sort in reverse order.

    if(present(reverse))then
       reverse_=reverse
    else
       reverse_=.false.
    end if

    dim=size(arr1,dim=1)
    do i = 1, dim
       select case(reverse_)
       case(.true.)
          loc=maxloc(arr1(i:dim),dim=1)+i-1
       case default
          loc=minloc(arr1(i:dim),dim=1)+i-1
       end select
       rbuff     = arr1(i)
       arr1(i)   = arr1(loc)
       arr1(loc) = rbuff

       if(present(arr2)) then
          ibuff     = arr2(i)
          arr2(i)   = arr2(loc)
          arr2(loc) = ibuff
       end if
    end do

    return
  end subroutine rsort1D
!###############################################################################


!###############################################################################
  pure recursive subroutine quicksort(arr, low, high)
    !! Sort a 1D real array from min to max.
    !!
    !! This is a recursive implementation of the quicksort algorithm.
    implicit none

    ! Arguments
    real(real32), dimension(:), intent(inout) :: arr
    !! Array to be sorted.
    integer, intent(in) :: low, high
    !! Lower and upper bounds of the array to be sorted.

    ! Local variables
    integer :: i, j
    !! Loop indices.
    real(real32) :: pivot, temp
    !! Pivot element and temporary buffer.

    if (low .lt. high) then
       pivot = arr((low + high) / 2)
       i = low
       j = high
       do
          do while (arr(i) .lt. pivot .and. i .lt. high)
             i = i + 1
          end do
          do while (arr(j) .gt. pivot .and. j .gt. low)
             j = j - 1
          end do
          if (i .le. j) then
             temp = arr(i)
             arr(i) = arr(j)
             arr(j) = temp
             i = i + 1
             j = j - 1
          end if
          ! Exit the loop when indices cross
          if (i .gt. j) exit
       end do
       ! Recursively apply quicksort to both partitions
       if (low .lt. j) call quicksort(arr, low, j)
       if (i .lt. high) call quicksort(arr, i, high)
    end if
  end subroutine quicksort
!###############################################################################


!###############################################################################
  subroutine isort2D(arr, idx)
    !! Sort a 2D array along the first column.
    implicit none

    ! Arguments
    integer, intent(in) :: idx
    !! Index of 1st column to sort by.
    integer, dimension(:,:), intent(inout) :: arr
    !! Array to be sorted.

    ! Local variables
    integer :: i
    !! Loop indices.
    integer :: len, loc
    !! Length of the array and location of the minimum element.
    integer, dimension(size(arr,dim=1)) :: buff
    !! Buffer for swapping elements.

    len = size(arr,dim=2)
    do i = 1, len
       loc = minloc(arr(idx,i:len),dim=1)
       if(loc.eq.1) cycle
       loc = loc + i - 1
       buff(:)    = arr(:,i)
       arr(:,i)   = arr(:,loc)
       arr(:,loc) = buff(:)
    end do

  end subroutine isort2D
!###############################################################################


!###############################################################################
  subroutine rsort2D(arr, idx)
    !! Sort a 2D array along the first column.
    implicit none

    ! Arguments
    integer, intent(in) :: idx
    !! Index of 1st column to sort by.
    real(real32), dimension(:,:), intent(inout) :: arr
    !! Array to be sorted.

    ! Local variables
    integer :: i
    !! Loop indices.
    integer :: len, loc
    !! Length of the array and location of the minimum element.
    real(real32), dimension(size(arr,dim=1)) :: buff
    !! Buffer for swapping elements.

    len = size(arr,dim=2)
    do i = 1, len
       loc = minloc(arr(idx,i:len),dim=1)
       if(loc.eq.1) cycle
       loc = loc + i - 1
       buff(:)    = arr(:,i)
       arr(:,i)   = arr(:,loc)
       arr(:,loc) = buff(:)
    end do

  end subroutine rsort2D
!###############################################################################


!###############################################################################
  subroutine iset(arr)
    !! Reduce an integer array to its unique elements.
    implicit none

    ! Arguments
    integer, dimension(:), allocatable, intent(inout) :: arr
    !! Array to be reduced.

    ! Local variables
    integer :: i,n
    !! Loop index.
    integer, dimension(:), allocatable :: tmp_arr
    !! Temporary array for storing unique elements.


    call sort1D(arr)
    allocate(tmp_arr(size(arr)))

    tmp_arr(1) = arr(1)
    n=1
    do i = 2, size(arr)
       if(arr(i)==tmp_arr(n)) cycle
       n = n + 1
       tmp_arr(n) = arr(i)
    end do
    deallocate(arr); allocate(arr(n))
    arr(:n) = tmp_arr(:n)
    !call move_alloc(tmp_arr, arr)

  end subroutine iset
!###############################################################################


!###############################################################################
  subroutine rset(arr, tol, count_list)
    !! Reduce a real array to its unique elements.
    implicit none

    ! Arguments
    real(real32), dimension(:), allocatable, intent(inout) :: arr
    !! Array to be reduced.
    real(real32), intent(in), optional :: tol
    !! Tolerance for comparing real numbers.
    integer, dimension(:), allocatable, intent(out), optional :: count_list
    !! List of counts for each unique element.

    ! Local variables
    integer :: i,n
    !! Loop index.
    real(real32) :: tol_
    !! Tolerance for comparing real numbers.
    real(real32), dimension(:), allocatable :: tmp_arr
    !! Temporary array for storing unique elements.
    integer, dimension(:), allocatable :: count_list_
    !! List of counts for each unique element.


    if(present(tol))then
       tol_ = tol
    else
       tol_ = 1.E-4_real32
    end if

    call quicksort(arr, 1, size(arr))
    allocate(tmp_arr(size(arr)))
    allocate(count_list_(size(arr)), source = 1)

    tmp_arr(1) = arr(1)
    n=1
    do i = 2, size(arr)
       if(abs(arr(i)-tmp_arr(n)).lt.tol_)then
          count_list_(i) = count_list_(i) + 1
          cycle
       end if
       n = n + 1
       tmp_arr(n) = arr(i)
    end do
    deallocate(arr); allocate(arr(n))
    arr(:n) = tmp_arr(:n)
    if(present(count_list)) count_list = count_list_(:n)

  end subroutine rset
!###############################################################################


!###############################################################################
  subroutine cset(arr,lcase,lkeep_size)
    !! Reduce a character array to its unique elements.
    !!
    !! This subroutine reduces a character array to its unique elements.
    !! i.e. each string in the array is compared with the rest of the strings
    !! in the array and if a match is found, the string is removed.
    !! This results in only the unique strings being preserved.
    implicit none

    ! Arguments
    character(*), allocatable, dimension(:), intent(inout) :: arr
    !! Array to be reduced.
    logical, intent(in), optional :: lcase
    !! Optional. Boolean whether to perform case insensitive comparison.
    logical, intent(in), optional :: lkeep_size
    !! Optional. Boolean whether to keep the original size of the array.

    ! Local variables
    integer :: i, n
    !! Loop index.
    logical :: lkeep_size_
    !! Boolean whether to keep the original size of the array.
    character(len=:), allocatable, dimension(:) :: tmp_arr
    !! Temporary array for storing unique elements.
    logical :: lcase_
    !! Boolean whether to perform case insensitive comparison.


    if(present(lcase))then
       lcase_ = lcase
    else
       lcase_ = .false.
    end if
    call sort_str(arr,lcase_)

    allocate(character(len=len(arr(1))) :: tmp_arr(size(arr)))
    tmp_arr(1) = arr(1)
    n=1

    do i = 2, size(arr)
       if(lcase_) arr(i) = to_lower(arr(i))
       if(trim(arr(i)).eq.trim(tmp_arr(n))) cycle
       n = n + 1
       tmp_arr(n) = arr(i)
    end do
    if(present(lkeep_size))then
       lkeep_size_=lkeep_size
    else
       lkeep_size_=.false.
    end if

    if(lkeep_size_)then
       call move_alloc(tmp_arr,arr)
    else
       deallocate(arr)
       allocate(arr(n))
       arr(:n) = tmp_arr(:n)
    end if

  end subroutine cset
!###############################################################################


!###############################################################################
  subroutine iswap(value1,value2)
    !! Swap two integers.
    implicit none

    ! Arguments
    integer, intent(inout) :: value1, value2
    !! Integers to be swapped.

    ! Local variables
    integer :: itmp1
    !! Temporary buffer for swapping elements.

    itmp1  = value1
    value1 = value2
    value2 = itmp1
  end subroutine iswap
!###############################################################################


!###############################################################################
  subroutine rswap(value1,value2)
    !! Swap two reals.
    implicit none

    ! Arguments
    real(real32), intent(inout) :: value1, value2
    !! Reals to be swapped.

    ! Local variables
    real(real32) :: rtmp1
    !! Temporary buffer for swapping elements.

    rtmp1  = value1
    value1 = value2
    value2 = rtmp1
  end subroutine rswap
!###############################################################################


!###############################################################################
  subroutine cswap(c1,c2)
    !! Swap two character strings.
    implicit none

    ! Arguments
    character(*), intent(inout) :: c1, c2
    !! Strings to be swapped.

    ! Local variables
    character(len=:), allocatable :: ctmp
    !! Temporary buffer for swapping elements.

    ctmp=c1
    c1=c2
    c2=ctmp
  end subroutine cswap
!###############################################################################


!###############################################################################
  subroutine rswap_vec(vec1,vec2)
    !! Swap two real vectors.
    implicit none

    ! Arguments
    real(real32),dimension(:), intent(inout) :: vec1, vec2
    !! Vectors to be swapped.

    ! Local variables
    real(real32),allocatable,dimension(:)::tvec
    !! Temporary buffer for swapping elements.

    allocate(tvec(size(vec1)))
    tvec=vec1(:)
    vec1(:)=vec2(:)
    vec2(:)=tvec
  end subroutine rswap_vec
!###############################################################################


!###############################################################################
  subroutine ishuffle(arr,dim,seed)
    !! Shuffle a 2D integer array.
    implicit none

    ! Arguments
    integer, dimension(:,:), intent(inout) :: arr
    !! Array to be shuffled.
    integer, intent(in) :: dim
    !! Dimension to shuffle along.
    integer, intent(in), optional :: seed
    !! Seed for random number generator.

    ! Local variables
    integer :: iseed
    !! Seed for random number generator.
    integer :: i, j, k, n_data, iother, istart
    !! Loop indices.
    integer :: i1s,i2s,i1e,i2e,j1s,j2s,j1e,j2e
    !! Indices for swapping elements.
    real(real32) :: r
    !! Random number for shuffling.
    integer, allocatable, dimension(:,:) :: tlist
    !! Temporary list for swapping elements.


    if(present(seed)) iseed = seed

    call random_seed(iseed)
    n_data = size(arr,dim=dim)
    if(dim.eq.1)then
       iother = 2
       i2s=1;i2e=size(arr,dim=iother)
       j2s=1;j2e=size(arr,dim=iother)
       allocate(tlist(1,size(arr,dim=iother)))
    else
       iother = 1
       i1s=1;i1e=size(arr,dim=iother)
       j1s=1;j1e=size(arr,dim=iother)
       allocate(tlist(size(arr,dim=iother),1))
    end if
    istart=1
    do k = 1, 2
       do i = 1, n_data
          call random_number(r)
          j = istart + floor((n_data+1-istart)*r)
          if(dim.eq.1)then
             i1s=i;i1e=i
             j1s=j;j1e=j
          else
             i2s=i;i2e=i
             j2s=j;j2e=j
          end if
          tlist(:,:) = arr(i1s:i1e,i2s:i2e)
          arr(i1s:i1e,i2s:i2e) = arr(j1s:j1e,j2s:j2e)
          arr(j1s:j1e,j2s:j2e) = tlist(:,:)
       end do
    end do

  end subroutine ishuffle
!###############################################################################


!###############################################################################
  subroutine rshuffle(arr,dim,seed)
    !! Shuffle a 2D real array.
    implicit none

    ! Arguments
    real(real32), dimension(:,:), intent(inout) :: arr
    !! Array to be shuffled.
    integer, intent(in) :: dim
    !! Dimension to shuffle along.
    integer, intent(in), optional :: seed
    !! Seed for random number generator.

    ! Local variables
    integer :: iseed
    !! Seed for random number generator.
    integer :: i, j, k, n_data, iother, istart
    !! Loop indices.
    integer :: i1s,i2s,i1e,i2e,j1s,j2s,j1e,j2e
    !! Indices for swapping elements.
    real(real32) :: r
    !! Random number for shuffling.
    real(real32), allocatable, dimension(:,:) :: tlist
    !! Temporary list for swapping elements.


    if(present(seed)) iseed = seed

    call random_seed(iseed)
    n_data = size(arr,dim=dim)
    if(dim.eq.1)then
       iother = 2
       i2s=1;i2e=size(arr,dim=iother)
       j2s=1;j2e=size(arr,dim=iother)
    else
       iother = 1
       i1s=1;i1e=size(arr,dim=iother)
       j1s=1;j1e=size(arr,dim=iother)
    end if
    istart=1
    allocate(tlist(1,size(arr,dim=iother)))
    do k = 1, 2
       do i = 1, n_data
          call random_number(r)
          j = istart + floor((n_data+1-istart)*r)
          if(dim.eq.1)then
             i1s=i;i1e=i
             j1s=j;j1e=j
          else
             i2s=i;i2e=i
             j2s=j;j2e=j
          end if
          tlist(1:1,:) = arr(i1s:i1e,i2s:i2e)
          arr(i1s:i1e,i2s:i2e) = arr(j1s:j1e,j2s:j2e)
          arr(j1s:j1e,j2s:j2e) = tlist(1:1,:)
       end do
    end do

  end subroutine rshuffle
!###############################################################################


!###############################################################################
  integer function icount(line,fs)
    !! Count the number of fields separated by specified delimiter.
    !!
    !! This function counts the number of fields separated by a specified
    !! delimiter in a string. The default delimiter is a space.
    implicit none

    ! Arguments
    character(*) :: line
    !! String to be counted.
    character(*), intent(in), optional :: fs
    !! Optional. Delimiter (aka field separator).

    ! Local variables
    integer :: k
    !! Loop index.
    integer :: items, pos, length
    !! Number of fields and position in the string.
    character(len=:), allocatable :: fs_
    !! Delimiter (aka field separator).


    items=0
    pos=1
    length=1
    if(present(fs)) length=len(trim(fs))
    allocate(character(len=length) :: fs_)
    if(present(fs)) then
       fs_=trim(fs)
    else
       fs_=" "
    end if

    loop: do
       k=verify(line(pos:),fs_)
       if (k.eq.0) exit loop
       items=items+1
       pos=k+pos-1
       k=scan(line(pos:),fs_)
       if (k.eq.0) exit loop
       pos=k+pos-1
    end do loop
    icount=items

  end function icount
!###############################################################################


!###############################################################################
  subroutine grep(unit,input,lstart,lline,success)
    !! Search a file for a pattern.
    !!
    !! This subroutine searches a file for a pattern. It can search for the
    !! first line that contains the pattern or for the first line that starts
    !! with the pattern.
    implicit none

    ! Arguments
    integer :: unit
    !! Unit number of the file.
    character(*) :: input
    !! Pattern to search for.
    logical, intent(in), optional :: lstart
    !! Optional. Boolean whether to rewind file.
    logical, intent(in), optional :: lline
    !! Optional. Boolean whether the pattern is at the start of the line.
    logical, intent(out), optional :: success
    !! Optional. Boolean whether the pattern is found.

    ! Local variables
    integer :: iostat
    !! I/O status.
    character(1024) :: buffer
    !! Buffer for reading lines.
    logical :: lline_
    !! Boolean whether the pattern is at the start of the line.
    logical :: success_
    !! Boolean whether the pattern is found.


    lline_ = .false.
    success_ = .false.
    if(present(lstart))then
       if(lstart) rewind(unit)
    else
       rewind(unit)
    end if

    if(present(lline)) lline_ = lline
    if(lline_)then
       wholeloop: do
          read(unit,'(A100)',iostat=iostat) buffer
          if(is_iostat_end(iostat))then
             exit wholeloop
          elseif(iostat.ne.0)then
             call stop_program('I/O stat error encounted when reading file')
          end if
          if(index(trim(buffer),trim(input)).eq.1)then
             success_ = .true.
             exit wholeloop
          end if
       end do wholeloop
    else
       greploop: do
          read(unit,'(A100)',iostat=iostat) buffer
          if(is_iostat_end(iostat))then
             exit greploop
          elseif(iostat.ne.0)then
             call stop_program('I/O stat error encounted when reading file')
          end if
          if(index(trim(buffer),trim(input)).ne.0)then
             success_ = .true.
             exit greploop
          end if
       end do greploop
    end if

    if(present(success)) success = success_
  end subroutine grep
!###############################################################################


!###############################################################################
  subroutine flagmaker(buffer,flag,i,skip,empty)
    !! Assign variables of flags from get_command_argument.
    implicit none

    ! Arguments
    character(*), intent(inout) :: buffer
    !! Buffer to be assigned a flag.
    character(*), intent(in) :: flag
    !! Flag to look for.
    integer :: i
    !! Index of command argument.
    logical :: skip
    !! Boolean whether to skip the next argument.
    logical, intent(out) :: empty
    !! Boolean whether the buffer is empty.


    skip = .false.
    empty = .false.
    if(len(trim(buffer)).eq.len(trim(flag))) then
       call get_command_argument(i+1,buffer)
       if(scan(buffer,'-').eq.1.or.buffer.eq.'') then
          buffer=""
          empty=.true.
       else
          skip=.true.
       end if
    else
       buffer=buffer(len(trim(flag))+1:)
    end if

  end subroutine flagmaker
!###############################################################################


!###############################################################################
  subroutine jump(unit,linenum)
    !! Go to a specific line in a file.
    implicit none

    ! Arguments
    integer :: unit
    !! Unit number of the file.
    integer :: linenum
    !! Line number to jump to.

    ! Local variables
    integer :: i
    !! Loop index.


    rewind(unit)
    do i = 1, linenum, 1
       read(unit,*)
    end do

  end subroutine jump
!###############################################################################


!###############################################################################
  subroutine file_check(unit,filename,action)
    !! Check if a file exists and open it.
    implicit none

    ! Arguments
    integer, intent(inout) :: unit
    !! Unit number of the file.
    character(*), intent(inout) :: filename
    !! Name of the file.
    character(len=20), optional, intent(in) :: action
    !! Optional. Action to be taken on the file.

    ! Local variables
    integer :: i
    !! Loop index.
    integer :: iostat
    !! I/O status.
    character(20) :: action_
    !! Action to be taken on the file.
    logical :: filefound
    !! Boolean whether the file is found.


    action_="READWRITE"
    if(present(action)) action_=action
    action_=to_upper(action_)
    do i = 1, 5
       inquire(file=trim(filename),exist=filefound)
       if(.not.filefound) then
          write(6,'("File name ",A," not found.")')&
               "'"//trim(filename)//"'"
          write(6,'("Supply another filename: ")')
          read(*,*) filename
       else
          write(6,'("Using file ",A)')  &
               "'"//trim(filename)//"'"
          exit
       end if
       if(i.ge.4) then
          stop "Nope"
       end if
    end do
    if(trim(adjustl(action_)).eq.'NONE')then
       write(6,*) "File found, but not opened."
    else
       open(newunit=unit,file=trim(filename),&
            action=trim(action_),iostat=iostat)
    end if

  end subroutine file_check
!###############################################################################


!###############################################################################
  subroutine touch(file)
    !! Create a directory if it does not exist.
    implicit none

    ! Arguments
    character(*), intent(in) :: file
    !! Directory to be created.

    ! Local variables
    logical :: exists
    !! Boolean whether the directory exists.

    inquire(file=file, exist=exists)
    if(.not.exists) call execute_command_line("mkdir -p "//file)
  end subroutine touch
!###############################################################################


!###############################################################################
  function to_upper(buffer) result(upper)
    !! Convert a string to upper case.
    implicit none

    ! Arguments
    character(*), intent(in) :: buffer
    !! String to be converted to upper case.
    character(len=:),allocatable :: upper
    !! Upper case string.

    ! Local variables
    integer :: i,j
    !! Loop index.


    allocate(character(len=len(buffer)) :: upper)
    do i = 1, len(buffer)
       j=iachar(buffer(i:i))
       if(j.ge.iachar("a").and.j.le.iachar("z"))then
          upper(i:i)=achar(j-32)
       else
          upper(i:i)=buffer(i:i)
       end if
    end do

  end function to_upper
!###############################################################################


!###############################################################################
  function to_lower(buffer) result(lower)
    !! Convert a string to lower case.
    implicit none

    ! Arguments
    character(*), intent(in) :: buffer
    !! String to be converted to lower case.
    character(len=:), allocatable :: lower
    !! Lower case string.

    ! Local variables
    integer :: i,j
    !! Loop index.


    allocate(character(len=len(buffer)) :: lower)
    do i = 1, len(buffer)
       j=iachar(buffer(i:i))
       if(j.ge.iachar("A").and.j.le.iachar("Z"))then
          lower(i:i)=achar(j+32)
       else
          lower(i:i)=buffer(i:i)
       end if
    end do

  end function to_lower
!###############################################################################


!###############################################################################
  function strip_null(buffer) result(stripped)
    !! Strip null characters from a string.
    !!
    !! This is meant for handling strings passed from Python, which gain
    !! null characters at the end. The procedure finds the first null
    !! character and truncates the string at that point.
    !! Null characters are represented by ASCII code 0.
    implicit none

    ! Arguments
    character(*), intent(in) :: buffer
    !! String to be stripped.
    character(len=len(buffer)) :: stripped
    !! Stripped string.

    ! Local variables
    integer :: i
    !! Loop index.

    stripped = ""
    do i = 1, len(buffer)
       if(iachar(buffer(i:i)).ne.0)then
          stripped(i:i)=buffer(i:i)
       else
          exit
       end if
    end do

  end function strip_null
!###############################################################################

end module raffle__misc

module raffle__constants
  !! Module with global constants
  !!
  !! This module contains global constants that may be used throughout the
  !! library.
  implicit none
  integer, parameter, public :: real32 = Selected_real_kind(6,37)!(15,307)
  real(real32), parameter, public :: tau = 8._real32 * atan(1._real32)
  real(real32), parameter, public :: pi = 4._real32 * atan(1._real32)
  real(real32), parameter, public :: c = 0.26246582250210965422_real32
  real(real32), parameter, public :: c_vasp = 0.262465831_real32
  real(real32), parameter, public :: INF = huge(0._real32)
  complex(real32), parameter, public :: imag=(0._real32, 1._real32)
end module raffle__constants

program raffle_program
  !! Main program for the interface-based random structure search.
  !!
  !! This program generates random structures based on the host structure and
  !! the distribution functions of the elements and bonds. The structures are
  !! generated using a random structure generator, which is based on the
  !! the RAFFLE method.
  use raffle__constants, only: real32
  use raffle__io_utils, only: stop_program
  use raffle__misc, only: touch
  use inputs
  use read_structures, only: get_gdfs_from_data
  use raffle, only: raffle_generator_type, distribs_container_type
  use raffle__geom_rw, only: geom_read, geom_write, basis_type
  implicit none

  ! Local variables
  integer :: i, unit, itmp1
  !! Loop index, unit number, temporary integer
  character(1024) :: buffer
  !! Buffer for strings
  character(:), allocatable :: next_dir
  !! Next directory name
  type(basis_type) :: host

  real(real32), dimension(:), allocatable :: tmp_energies
  !! Temporary array for element energies
  character(len=3), dimension(:), allocatable :: tmp_symbols
  !! Temporary array for element symbols

  type(raffle_generator_type) :: generator
  !! Random structure generator


  !-----------------------------------------------------------------------------
  ! read input file
  !-----------------------------------------------------------------------------
  call set_global_vars()


  !-----------------------------------------------------------------------------
  ! check the task and run the appropriate case
  !-----------------------------------------------------------------------------
  ! 0) Run structure search
  ! 1) Continue structure search
  select case(task)
  case(0)
     allocate(character(len=len_trim(output_dir)+1) :: next_dir)
     write(next_dir, '(A,"0")') trim(output_dir)
     write(*,'("Running host-based random structure search for ",I0,&
          &" structures")' &
     ) num_structures
  case(1)
     call get_next_directory(trim(output_dir), itmp1, next_dir)
     write(*,'("Running iteration ",I0,&
          &" of host-based random structure search for ",I0," structures")' &
     ) itmp1 + 1, num_structures
  case default
     call stop_program("Invalid option")
  end select


  !-----------------------------------------------------------------------------
  ! set the element energies and bond radii, if they are provided
  !-----------------------------------------------------------------------------
  if(allocated(element_symbols).and.allocated(element_energies)) then
     call generator%distributions%set_element_energies( &
          element_symbols, &
          element_energies &
     )
  end if

  if(allocated(bond_pairs).and.allocated(pair_radii)) then
     call generator%distributions%set_bond_radii( &
          bond_pairs, &
          pair_radii &
     )
  end if


  !-----------------------------------------------------------------------------
  ! read structures from the database and generate gvectors
  !-----------------------------------------------------------------------------
  generator%distributions = get_gdfs_from_data( &
       input_dir    = database_list, &
       file_format  = database_format, &
       distribs_container_template = distribs_container_type(&
            width = width_list, &
            sigma = sigma_list, &
            cutoff_min = cutoff_min_list, &
            cutoff_max = cutoff_max_list ) &
  )

  call generator%distributions%write_2body(file="2body.txt")
  call generator%distributions%write_3body(file="3body.txt")
  call generator%distributions%write_4body(file="4body.txt")

  call generator%distributions%get_element_energies( &
       tmp_symbols, &
       tmp_energies &
  )
  do i = 1, size(tmp_symbols)
     write(*,*) "Element ", tmp_symbols(i), " energy: ", tmp_energies(i)
  end do


  !-----------------------------------------------------------------------------
  ! set the host structure
  !-----------------------------------------------------------------------------
  open(newunit=unit, file=filename_host, status='old')
  call geom_read(unit, host)
  call generator%set_host(host)
  close(unit)
  if(grid_spacing.gt.1.E-6.and.all(grid.ne.0))then
     call stop_program('Cannot specify grid spacing and grid at the same time')
  elseif(grid_spacing.gt.1.E-6)then
     call generator%set_grid(grid_spacing = grid_spacing)
  elseif(all(grid.ne.0))then
     call generator%set_grid(grid = grid)
  end if


  !-----------------------------------------------------------------------------
  ! generate random structures
  !-----------------------------------------------------------------------------
  write(*,*) "Generating structures"
  call generator%generate( num_structures, &
       stoich, &
       method_ratio )
  write(*,*) "Structures have been successfully generated"


  !-----------------------------------------------------------------------------
  ! save generated structures
  !-----------------------------------------------------------------------------
  do i = 1, generator%num_structures
     write(buffer,'(A,"/struc",I0.3)') trim(next_dir),i
     call touch(buffer)
     open(newunit = unit, file=trim(buffer)//"/POSCAR")
     call geom_write(unit, generator%structures(i))
     close(unit)
  end do

contains

!###############################################################################
  subroutine get_next_directory(prefix, num, next_dir)
    !! Get the next directory name
    implicit none

    ! Arguments
    character(len=*), intent(in) :: prefix
    !! Prefix of the directory name
    integer, intent(out) :: num
    !! Number of directories with the prefix
    character(len=:), allocatable, intent(out) :: next_dir
    !! Next directory name

    ! Local variables
    integer :: i, ierror, itmp1, max_num
    !! Loop index, error code, temporary integer
    integer :: unit
    !! Unit number for the pipe
    character(len=1024) :: pattern, line, ctmp1
    !! Pattern to match directories
    character(len=1024), dimension(:), allocatable :: dir_list
    !! List of directories

    ! Initialise variables
    num = 0
    max_num = 0
    pattern = trim(prefix) // "[0-9]*"

    ! Command to list directories matching the pattern
    call execute_command_line('ls -d ' // trim(pattern) // ' 2>/dev/null')

    ! Open a pipe to execute the command
    open( newunit=unit, file='iter_count.txt', &
         status='old', action='read', iostat=ierror)
    if (ierror .ne. 0) then
       call stop_program('Opening pipe to list directories')
       return
    end if

    ! Read the output of the command and get number of directories
    allocate(dir_list(0))  ! Allocate a large enough array
    num = 0
    do
       read(unit, '(A)', iostat=ierror) line
       if (ierror .ne. 0) exit
       dir_list = [ dir_list, line ]
       num = num + 1
    end do
    close(unit)

    ! Count the number of matching directories and find the highest number
    do i = 1, num
       ctmp1 = dir_list(i)
       ctmp1 = ctmp1(index(ctmp1,prefix)+len_trim(prefix):)
       read(ctmp1, *, iostat=ierror) itmp1
       if (ierror .eq. 0) then
          if (itmp1 .gt. max_num) max_num = itmp1
       end if
    end do

    ! Determine the next directory name
    allocate(character(len=len_trim(prefix)+ceiling(max_num/10.0)) :: next_dir)
    write(next_dir, '(A,I0)') prefix, max_num + 1

    ! Deallocate the array
    deallocate(dir_list)
  end subroutine get_next_directory
!###############################################################################

end program raffle_program

program test_generator
  use raffle__io_utils
  use raffle__misc_linalg, only: modu
  use raffle__constants, only: real32
  use raffle__geom_rw, only: basis_type
  use raffle__generator, only: raffle_generator_type, stoichiometry_type
  implicit none

  integer :: i, newunit
  real(real32) :: rtmp1
  logical :: exists
  character(len=100) :: filename
  type(raffle_generator_type) :: generator, generator2
  class(raffle_generator_type), allocatable :: generator_var
  type(basis_type) :: basis_host, basis_host_expected
  type(basis_type), dimension(1) :: database
  type(basis_type), dimension(:), allocatable :: structures, structures_store
  integer, dimension(3) :: grid
  character(3), dimension(1) :: element_symbols
  real(real32), dimension(1) :: element_energies
  real(real32), dimension(3) :: tolerance
  real(real32), dimension(2, 3) :: bounds

  logical :: success = .true.

  test_error_handling = .true.


  !-----------------------------------------------------------------------------
  ! test generator setup
  !-----------------------------------------------------------------------------
  generator_var = raffle_generator_type( &
       width = [ 1.0, 1.0, 1.0 ], &
       sigma = [ 0.1, 0.1, 0.1 ], &
       cutoff_min = [ 0.0, 0.0, 0.0 ], &
       cutoff_max = [ 1.0, 1.0, 1.0 ] &
  )
  call assert( &
       all( abs( generator_var%distributions%width - 1.0 ) .lt. 1.E-6 ), &
       'Generator failed to set width', &
       success &
  )
  call assert( &
       all( abs( generator_var%distributions%sigma - 0.1 ) .lt. 1.E-6 ), &
       'Generator failed to set sigma', &
       success &
  )
  call assert( &
       all( abs( generator_var%distributions%cutoff_min - 0.0 ) .lt. 1.E-6 ), &
       'Generator failed to set cutoff_min', &
       success &
  )
  call assert( &
       all( abs( generator_var%distributions%cutoff_max - 1.0 ) .lt. 1.E-6 ), &
       'Generator failed to set cutoff_max', &
       success &
  )
  write(*,*) "Testing generator missing host handling"
  call generator_var%generate( num_structures = 1, &
       stoichiometry = [ stoichiometry_type(element='C  ', num = 8) ], &
       method_ratio = [0.0, 0.0, 0.0, 0.0, 1.0], &
       seed = 0, &
       verbose = 1 &
  )
  call assert( &
       generator_var%num_structures .eq. 0, &
       'Generator failed to handle missing host structure', &
       success &
  )
  write(*,*) "Handled missing host"
  deallocate(generator_var)


  !-----------------------------------------------------------------------------
  ! set up database
  !-----------------------------------------------------------------------------
  database(1)%nspec = 1
  database(1)%natom = 8
  allocate(database(1)%spec(database(1)%nspec))
  database(1)%spec(1)%num = 8
  database(1)%spec(1)%name = 'C'
  allocate(database(1)%spec(1)%atom(database(1)%spec(1)%num, 3))
  database(1)%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  database(1)%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  database(1)%spec(1)%atom(3, :3) = [0.5, 0.0, 0.5]
  database(1)%spec(1)%atom(4, :3) = [0.0, 0.5, 0.5]
  database(1)%spec(1)%atom(5, :3) = [0.25, 0.25, 0.25]
  database(1)%spec(1)%atom(6, :3) = [0.75, 0.75, 0.25]
  database(1)%spec(1)%atom(7, :3) = [0.75, 0.25, 0.75]
  database(1)%spec(1)%atom(8, :3) = [0.25, 0.75, 0.75]

  database(1)%lat(1,:) = [3.5607451090903233, 0.0, 0.0]
  database(1)%lat(2,:) = [0.0, 3.5607451090903233, 0.0]
  database(1)%lat(3,:) = [0.0, 0.0, 3.5607451090903233]
  database(1)%energy = -72.213492


  !-----------------------------------------------------------------------------
  ! set up element energies
  !-----------------------------------------------------------------------------
  element_symbols(1) = 'C'
  element_energies(1) = -9.0266865
  call generator%distributions%set_element_energies( &
       element_symbols, &
       element_energies &
  )


  !-----------------------------------------------------------------------------
  ! set up host structure
  !-----------------------------------------------------------------------------
  basis_host%sysname = 'diamond'
  basis_host%nspec = 1
  allocate(basis_host%spec(basis_host%nspec))
  basis_host%spec(1)%num = 8
  basis_host%spec(1)%name = 'C'
  basis_host%natom = sum(basis_host%spec(:)%num)
  allocate(basis_host%spec(1)%atom(basis_host%spec(1)%num, 3))
  basis_host%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  basis_host%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  basis_host%spec(1)%atom(3, :3) = [0.5, 0.0, 0.25]
  basis_host%spec(1)%atom(4, :3) = [0.0, 0.5, 0.25]
  basis_host%spec(1)%atom(5, :3) = [0.25, 0.25, 0.125]
  basis_host%spec(1)%atom(6, :3) = [0.75, 0.75, 0.125]
  basis_host%spec(1)%atom(7, :3) = [0.75, 0.25, 0.375]
  basis_host%spec(1)%atom(8, :3) = [0.25, 0.75, 0.375]
  basis_host%lat(1,:) = [3.560745109, 0.0, 0.0]
  basis_host%lat(2,:) = [0.0, 3.560745109, 0.0]
  basis_host%lat(3,:) = [0.0, 0.0, 7.121490218]


  !-----------------------------------------------------------------------------
  ! test generator setup with host
  !-----------------------------------------------------------------------------
  generator_var = raffle_generator_type(host = basis_host)
  do i = 1, 3
     tolerance(i) = 1.E-6_real32 / modu(basis_host%lat(i,:))
  end do
  call assert(compare_bas(generator_var%host, basis_host, tolerance), &
       'Generator failed to set host structure', &
       success &
  )
  deallocate(generator_var)


  !-----------------------------------------------------------------------------
  ! set up expected generated host structure
  !-----------------------------------------------------------------------------
  basis_host_expected%sysname = 'diamond+inserts'
  basis_host_expected%nspec = 1
  allocate(basis_host_expected%spec(basis_host_expected%nspec))
  basis_host_expected%spec(1)%num = 16
  basis_host_expected%spec(1)%name = 'C'
  basis_host_expected%natom = sum(basis_host_expected%spec(:)%num)
  allocate(basis_host_expected%spec(1)%atom(basis_host_expected%spec(1)%num, 3))
  basis_host_expected%spec(1)%atom(1, :3) = [0.0, 0.0, 0.0]
  basis_host_expected%spec(1)%atom(2, :3) = [0.5, 0.5, 0.0]
  basis_host_expected%spec(1)%atom(3, :3) = [0.5, 0.0, 0.25]
  basis_host_expected%spec(1)%atom(4, :3) = [0.0, 0.5, 0.25]
  basis_host_expected%spec(1)%atom(5, :3) = [0.25, 0.25, 0.125]
  basis_host_expected%spec(1)%atom(6, :3) = [0.75, 0.75, 0.125]
  basis_host_expected%spec(1)%atom(7, :3) = [0.75, 0.25, 0.375]
  basis_host_expected%spec(1)%atom(8, :3) = [0.25, 0.75, 0.375]
  basis_host_expected%spec(1)%atom(9, :3) = [0.75, 0.25, 0.875]
  basis_host_expected%spec(1)%atom(10, :3) = [0.75, 0.75, 0.625]
  basis_host_expected%spec(1)%atom(11, :3) = [0.5, 0.0, 0.75]
  basis_host_expected%spec(1)%atom(12, :3) = [0.25, 0.25, 0.625]
  basis_host_expected%spec(1)%atom(13, :3) = [0.25, 0.75, 0.875]
  basis_host_expected%spec(1)%atom(14, :3) = [0.5, 0.5, 0.5]
  basis_host_expected%spec(1)%atom(15, :3) = [0.0, 0.5, 0.75]
  basis_host_expected%spec(1)%atom(16, :3) = [0.0, 0.0, 0.5]
  basis_host_expected%lat(1,:) = [3.560745109, 0.0, 0.0]
  basis_host_expected%lat(2,:) = [0.0, 3.560745109, 0.0]
  basis_host_expected%lat(3,:) = [0.0, 0.0, 7.121490218]


  !-----------------------------------------------------------------------------
  ! set up host
  !-----------------------------------------------------------------------------
  call generator%set_host( basis_host )
  do i = 1, 3
     tolerance(i) = 1.E-6_real32 / modu(basis_host%lat(i,:))
  end do
  call assert(compare_bas(generator%host, basis_host, tolerance), &
       'Generator failed to set host structure', &
       success &
  )

  !-----------------------------------------------------------------------------
  ! test grid setup
  !-----------------------------------------------------------------------------
  write(*,*) "Testing grid error handling"
  call generator%set_grid( grid = [ 1, 1, 1 ], grid_spacing = 0.2 )
  call assert( &
       all( generator%grid .eq. 0 ), &
       'Generator failed to handle invalid grid', &
       success &
  )
  write(*,*) "Handled grid setup error"
  call generator%set_grid( grid = [ 1, 1, 1 ] )
  call assert( &
       all( generator%grid .eq. 1 ), &
       'Generator failed to handle grid', &
       success &
  )

  ! check grid resetting
  call generator%reset_grid()
  call assert( &
       all( generator%grid .eq. 0 ), &
       'Generator failed to reset grid', &
       success &
  )

  ! check grid spacing
  call generator%set_grid( grid_spacing = 0.2 )
  call assert( &
       all( generator%grid .eq. [ 18, 18, 36 ] ), &
       'Generator failed to handle grid_spacing', &
       success &
  )

  ! check grid_offset
  call generator%set_grid( grid_spacing = 0.2, grid_offset = [0.1, 0.2, 0.3] )
  call assert( &
       all( &
            abs( &
                 generator%grid_offset - &
                 [0.1, 0.2, 0.3] &
            ) .lt. 1.E-6_real32 &
       ), &
       'Generator failed to handle grid_offset', &
       success &
  )

  call generator%reset_grid()


  !-----------------------------------------------------------------------------
  ! set up bounds
  !-----------------------------------------------------------------------------

  ! check initial bounds
  bounds(1,:) = [ 0.0, 0.0, 0.0 ]
  bounds(2,:) = [ 1.0, 1.0, 1.0 ]
  call assert( &
       all( &
            abs( &
                 generator%bounds - &
                 bounds &
            ) .lt. 1.E-6_real32 &
       ), &
       'Generator failed to handle bounds', &
       success &
  )

  ! check bounds setting
  bounds(1,:) = [ 0.3, 0.4, 0.5 ]
  bounds(2,:) = [ 0.6, 0.7, 0.8 ]
  call generator%set_bounds( bounds = bounds )
  call assert( &
       all( &
            abs( &
                 generator%bounds - &
                 bounds &
            ) .lt. 1.E-6_real32 &
       ), &
       'Generator failed to handle bounds', &
       success &
  )

  ! check bounds resetting
  call generator%reset_bounds()
  bounds(1,:) = [ 0.0, 0.0, 0.0 ]
  bounds(2,:) = [ 1.0, 1.0, 1.0 ]
  call assert( &
       all( &
            abs( &
                 generator%bounds - &
                 bounds &
            ) .lt. 1.E-6_real32 &
       ), &
       'Generator failed to handle bounds', &
       success &
  )

  ! check grid setting with bounds
  bounds(1,:) = [ 0.0, 0.25, 0.5 ]
  bounds(2,:) = [ 1.0, 1.0, 1.0 ]
  call generator%set_bounds( bounds = bounds )
  call generator%set_grid( grid_spacing = 0.2 )
  grid(1) = nint( generator%host%lat(1,1) / 0.2 )
  grid(2) = nint( 0.75 * generator%host%lat(2,2) / 0.2 )
  grid(3) = nint( 0.5 * generator%host%lat(3,3) / 0.2 )
  call assert( &
        all( generator%grid .eq. grid ), &
        'Generator failed to handle grid_spacing with bounds', &
        success &
  )

  call generator%reset_bounds()
  call generator%reset_grid()


  !-----------------------------------------------------------------------------
  ! set up generator
  !-----------------------------------------------------------------------------
  generator%distributions%kBT = 0.2
  call generator%set_grid( grid_spacing = 0.2, grid_offset = [0.0, 0.0, 0.0] )
  generator%distributions%radius_distance_tol = [1.5, 2.5, 3.0, 6.0]
  do i = 1, 3
     tolerance(i) = 1._real32 / real(generator%grid(i),real32) / 2._real32
  end do


  !-----------------------------------------------------------------------------
  ! set up distribution functions
  !-----------------------------------------------------------------------------
  call generator%distributions%create( &
       basis_list = database, &
       deallocate_systems = .true. &
  )

  !-----------------------------------------------------------------------------
  ! test generator random seed and no printing
  !-----------------------------------------------------------------------------
  call generator%generate( num_structures = 0, &
       stoichiometry = [ stoichiometry_type(element='C  ', num = 8) ], &
       method_ratio = [0.0, 0.0, 0.0, 0.0, 1.0] &
  )

  !-----------------------------------------------------------------------------
  ! generate random structures
  !-----------------------------------------------------------------------------
  call generator%generate( num_structures = 1, &
       stoichiometry = [ stoichiometry_type(element='C  ', num = 8) ], &
       method_ratio = [0.0, 0.0, 0.0, 0.0, 1.0], &
       seed = 0, &
       verbose = 1 &
  )


  !-----------------------------------------------------------------------------
  ! compare the generated host structure
  !-----------------------------------------------------------------------------
  call assert(&
       compare_bas(generator%structures(1), basis_host_expected, tolerance), &
       'Generated host structure does not match expected host structure', &
       success &
  )


  !-----------------------------------------------------------------------------
  ! check adding a new structure
  !-----------------------------------------------------------------------------
  call generator%generate( num_structures = 2, &
       stoichiometry = [ stoichiometry_type(element='C  ', num = 12) ], &
       method_ratio = [0.0, 0.0, 0.0, 0.0, 1.0], &
       seed = 0, &
       verbose = 1 &
  )
  call assert( &
       generator%num_structures .eq. 3, &
       'Generator failed to add a new structure', &
       success &
  )
  call assert( &
       size(generator%structures) .eq. 3, &
       'Generator failed to add a new structure', &
       success &
  )


  !-----------------------------------------------------------------------------
  ! handle structures
  !-----------------------------------------------------------------------------
  structures_store = generator%get_structures()
  call assert( &
       size(structures_store) .eq. 3, &
       'Generator failed to get structures', &
       success &
  )
  call generator%remove_structure(1)
  structures = generator%get_structures()
  call assert( &
       size(structures) .eq. 2, &
       'Generator failed to remove structure', &
       success &
  )
  call generator%set_structures( structures_store )
  structures = generator%get_structures()
  call assert( &
       size(structures) .eq. 3, &
       'Generator failed to set structures', &
       success &
  )
  rtmp1 = generator%evaluate( structures_store(1) )
  call assert( &
       rtmp1 .gt. 0.0, &
       'Generator failed to evaluate structure', &
       success &
  )


  !-----------------------------------------------------------------------------
  ! test generator printing and reading
  !-----------------------------------------------------------------------------
  filename = '.raffle_unit_test_settings.txt'
  do i = 1, 100
     inquire(file=filename, exist=exists)
     if(exists) then
        write(filename,'(A,I0,A)') '.raffle_unit_test_settings', i, '.txt'
        cycle
     elseif(i.ge.100)then
        write(0,*) 'Generator failed to find a unique filename'
        write(0,*) 'Will not write over existing file, so test cannot continue'
        write(0,*) 'Please remove the file: ', filename
        write(0,*) 'This is a test error, not a failure'
        success = .false.
        stop 1
     end if
     exit
  end do

  call generator%print_settings(filename)
  inquire(file=filename, exist=exists)
  call assert( &
       exists, &
       'Generator failed to print settings', &
       success &
  )

  call generator2%read_settings(filename)
  call assert( &
       all( generator2%grid .eq. generator%grid), &
       'Generator failed to read grid settings', &
       success &
  )
  call assert( &
       all( abs( generator2%bounds - generator%bounds ) .lt. 1.E-6 ), &
       'Generator failed to read bounds settings', &
       success &
  )
  call assert( &
       generator2%max_attempts .eq. generator%max_attempts, &
       'Generator failed to read max_attempts settings', &
       success &
  )
  call assert( &
       abs( &
            generator2%walk_step_size_coarse - &
            generator%walk_step_size_coarse &
       ) .lt. 1.E-6, &
       'Generator failed to read walk_step_size_coarse settings', &
       success &
  )
  call assert( &
       abs( &
            generator2%walk_step_size_fine - generator%walk_step_size_fine &
       ) .lt. 1.E-6, &
       'Generator failed to read walk_step_size_fine settings', &
       success &
  )
  call assert( &
       abs( &
            generator2%distributions%kBT - generator%distributions%kBT &
       ) .lt. 1.E-6, &
       'Generator failed to read kBT settings', &
       success &
  )
  call assert( &
       all( abs( &
            generator2%distributions%width - generator%distributions%width &
       ) .lt. 1.E-6 ), &
       'Generator failed to read width settings', &
       success &
  )
  call assert( &
       all( abs( &
            generator2%distributions%sigma - generator%distributions%sigma &
       ) .lt. 1.E-6 ), &
       'Generator failed to read sigma settings', &
       success &
  )
  call assert( &
       all( abs( &
            generator2%distributions%cutoff_min - &
            generator%distributions%cutoff_min &
       ) .lt. 1.E-6 ), &
       'Generator failed to read cutoff_min settings', &
       success &
  )
  call assert( &
       all( abs( &
            generator2%distributions%cutoff_max - &
            generator%distributions%cutoff_max &
       ) .lt. 1.E-6 ), &
       'Generator failed to read cutoff_max settings', &
       success &
  )
  call assert( &
       all( abs( &
            generator2%distributions%radius_distance_tol - &
            generator%distributions%radius_distance_tol &
       ) .lt. 1.E-6 ), &
       'Generator failed to read radius_distance_tol settings', &
       success &
  )

  open(newunit=newunit, file=filename, status='old')
  close(newunit, status='delete')


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_generator passed all tests'
  else
     write(0,*) 'test_generator failed one or more tests'
     stop 1
  end if

contains

  function compare_bas(bas1, bas2, tolerance) result(output)
    implicit none
    type(basis_type), intent(in) :: bas1, bas2
    real(real32), dimension(3), intent(in) :: tolerance
    logical :: output

    integer :: is, ia, ja
    logical :: ltmp1
    output = .true.

    ! Compare the geometries
    if(any(abs(bas1%lat - bas2%lat).gt.1.E-6)) then
       output = .false.
    end if
    if(bas1%sysname .ne. bas2%sysname) then
       output = .false.
    end if
    if(bas1%natom .ne. bas2%natom) then
       output = .false.
    end if

    do is = 1, bas1%nspec
       do ia = 1, bas1%spec(is)%num
          ltmp1 = .false.
          do ja = 1, bas2%spec(is)%num
             if( &
                  all( &
                       abs( &
                            bas1%spec(is)%atom(ia,:3) - &
                            bas2%spec(is)%atom(ja,:3) - &
                            ceiling( &
                                 bas1%spec(is)%atom(ia,:3) - &
                                 bas2%spec(is)%atom(ja,:3) - &
                                 0.5_real32 &
                            ) &
                       ) .lt. 2._real32 * tolerance + 1.E-6_real32 &
                  ) &
             ) ltmp1 = .true.
          end do
          if(.not. ltmp1) then
             write(0,*) 'Generator failed to produce expected atom: ', is, ia
             write(0,*) bas1%spec(is)%atom(ia,:3), bas2%spec(is)%atom(ia,:3)
             output = .false.
          end if
       end do
    end do

  end function compare_bas

!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_generator

program test_place_methods
  use raffle__io_utils
  use raffle__viability
  use raffle__distribs_container, only: distribs_container_type
  use raffle__constants, only: real32
  use raffle__geom_rw, only: basis_type
  use raffle__geom_extd, only: extended_basis_type
  implicit none

  type(basis_type) :: basis
  logical :: success = .true.

  test_error_handling = .true.

  ! Initialise basis
  basis%nspec = 1
  allocate(basis%spec(basis%nspec))
  basis%spec(1)%name = 'C'
  basis%spec(1)%num = 2
  allocate(basis%spec(1)%atom(basis%spec(1)%num,3))
  basis%spec(1)%atom(1,:) = [0.0_real32, 0.0_real32, 0.0_real32]
  basis%spec(1)%atom(2,:) = [0.5_real32, 0.5_real32, 0.5_real32]
  basis%lat = 0.0_real32
  basis%lat(1,1) = 5.0_real32
  basis%lat(2,2) = 5.0_real32
  basis%lat(3,3) = 5.0_real32


  call test_get_gridpoints_and_viability(basis, success)
  call test_update_gridpoints_and_viability(basis, success)


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_place_methods passed all tests'
  else
     write(0,*) 'test_place_methods failed one or more tests'
     stop 1
  end if

contains

  subroutine test_get_gridpoints_and_viability(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis

    integer :: i
    type(extended_basis_type) :: basis_copy
    type(distribs_container_type) :: distribs_container
    integer, dimension(3) :: grid
    integer, dimension(:,:), allocatable :: atom_ignore_list
    real(real32), dimension(:), allocatable :: radius_list
    real(real32) :: lowtol
    real(real32), dimension(:,:), allocatable :: points
    real(real32), dimension(3) :: grid_offset
    real(real32), dimension(2,3) :: bounds

    ! Initialise test data
    grid = [10, 10, 10]
    bounds(1,:) = 0.0_real32
    bounds(2,:) = 1.0_real32
    allocate(atom_ignore_list(2,1))  ! No atoms to ignore
    atom_ignore_list(:,1) = [1,2]
    allocate(radius_list(1))
    radius_list = 1.0_real32
    lowtol = 0.5_real32
    grid_offset = [0.5_real32, 0.5_real32, 0.5_real32]

    ! Initialise basis
    call basis_copy%copy(basis)
    call basis_copy%create_images( &
         max_bondlength = distribs_container%cutoff_max(1), &
         atom_ignore_list = atom_ignore_list &
    )

    ! Initialise gvector container
    call distribs_container%set_element_energies( &
         [basis%spec(:)%name], &
         [ ( 0.0_real32, i = 1, basis%nspec ) ] &
    )
    call distribs_container%create([basis])

    ! Call the function to test
    points = get_gridpoints_and_viability( &
         distribs_container, &
         grid, bounds, & 
         basis_copy, &
         [ 1 ], &
         radius_list, &
         atom_ignore_list, &
         grid_offset &
    )

    ! Check points exist
    call assert(size(points, 2) .gt. 0, "No viable gridpoints found.", success)
    
    ! Check number of points
    call assert( &
         size(points, 2) .lt. 1000, &
         "Incorrect number of gridpoints found.", &
         success &
    )
    ! Check number of points
    call assert( &
         size(points, 2) .eq. 864, &
         "Incorrect number of gridpoints found.", &
         success &
    )

  end subroutine test_get_gridpoints_and_viability

  subroutine test_update_gridpoints_and_viability(basis, success)
    implicit none
    logical, intent(inout) :: success
    type(basis_type), intent(in) :: basis

    integer :: i
    type(extended_basis_type) :: basis_copy
    type(distribs_container_type) :: distribs_container
    integer, dimension(3) :: grid
    integer, dimension(:,:), allocatable :: atom_ignore_list
    real(real32), dimension(:), allocatable :: radius_list
    real(real32) :: lowtol
    real(real32), dimension(:,:), allocatable :: points
    real(real32), dimension(3) :: grid_offset
    real(real32), dimension(2,3) :: bounds

    ! Initialise test data
    grid = [10, 10, 10]
    bounds(1,:) = 0.0_real32
    bounds(2,:) = 1.0_real32
    allocate(atom_ignore_list(2,1))  ! No atoms to ignore
    atom_ignore_list(:,1) = [1,2]
    allocate(radius_list(1))
    radius_list = 1.0_real32 !!! NO!!! USING CARBON RADIUS
    lowtol = 0.5_real32
    grid_offset = [0.5_real32, 0.5_real32, 0.5_real32]

    ! Initialise basis
    call basis_copy%copy(basis)
    call basis_copy%create_images( &
         max_bondlength = distribs_container%cutoff_max(1), &
         atom_ignore_list = atom_ignore_list &
    )

    ! Initialise gvector container
    call distribs_container%set_element_energies( &
         [basis%spec(:)%name], &
         [ ( 0.0_real32, i = 1, basis%nspec ) ] &
    )
    call distribs_container%create([basis])

    ! Call the function to test
    points = get_gridpoints_and_viability( &
         distribs_container, &
         grid, bounds, &
         basis_copy, &
         [ 1 ], &
         radius_list, &
         atom_ignore_list, &
         grid_offset &
    )

    ! Call the update subroutine
    call update_gridpoints_and_viability( &
         points, distribs_container, basis_copy, &
         [1], &
         [1,2], &
         radius_list, &
         atom_ignore_list &
    )

    ! Check points exist
    call assert(size(points, 2) .gt. 0, "No viable gridpoints found.", success)

    ! Check number of points
    call assert( &
         size(points, 2) .lt. 1000, &
         "Incorrect number of gridpoints found.", &
         success &
    )

    ! Check number of points
    call assert( &
         size(points, 2) .eq. 728, &
         "Incorrect number of gridpoints found.", &
         success &
    )

    ! Call the update subroutine
    distribs_container%radius_distance_tol(1) = 100._real32
    call update_gridpoints_and_viability( &
         points, distribs_container, basis_copy, &
         [1], &
         [1,2], &
         radius_list, &
         atom_ignore_list &
    )

    ! Check all points have been removed
    call assert(.not.allocated(points), "Some grid points remain.", success)

  end subroutine test_update_gridpoints_and_viability


!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_place_methods

module raffle__misc_linalg
  !! Module contains various linear algebra functions and subroutines.
  use raffle__constants, only: real32, pi
  implicit none


  private

  public :: modu, cross
  public :: get_distance, get_angle, get_dihedral_angle
  public :: get_improper_dihedral_angle
  public :: inverse_3x3


  interface get_angle
     procedure get_angle_from_points, get_angle_from_vectors
  end interface get_angle

  interface get_dihedral_angle
     procedure get_dihedral_angle_from_points, get_dihedral_angle_from_vectors
  end interface get_dihedral_angle

  interface get_improper_dihedral_angle
     procedure get_improper_dihedral_angle_from_points, &
          get_improper_dihedral_angle_from_vectors
  end interface get_improper_dihedral_angle

contains

!###############################################################################
  pure function modu(vector)
    !! Return the magnitude of a vector of any size.
    implicit none

    ! Arguments
    real(real32),dimension(:), intent(in) :: vector
    !! Input vector.
    real(real32) :: modu
    !! Output magnitude.

    modu = abs( sqrt( sum(vector(:)**2) ) )
  end function modu
!###############################################################################


!###############################################################################
  pure function cross(a,b)
    !! Return the cross product of two vectors.
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: a, b
    !! Input vectors.
    real(real32), dimension(3) :: cross
    !! Output cross product.

    cross(1) = a(2) * b(3) - a(3) * b(2)
    cross(2) = a(3) * b(1) - a(1) * b(3)
    cross(3) = a(1) * b(2) - a(2) * b(1)

  end function cross
!###############################################################################


!###############################################################################
  pure function get_distance(point1, point2) result(distance)
    !! Return the distance between two points.
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: point1, point2
    !! Input points.
    real(real32) :: distance
    !! Output distance.

    distance = modu( point1 - point2 )

    return
  end function get_distance
!###############################################################################


!###############################################################################
  pure function get_angle_from_vectors(vector1, vector2) result(angle)
    !! Return the angle between two vectors.
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: vector1, vector2
    !! Input vectors.
    real(real32) :: angle
    !! Output angle.

    angle =  dot_product(vector1,vector2) / &
         ( modu(vector1) * modu(vector2) )
    if(angle .ge. 1._real32)then
       angle = 0._real32
    elseif(angle .le. -1._real32)then
       angle = pi
    else
       angle = acos(angle)
    end if
  end function get_angle_from_vectors
!###############################################################################


!###############################################################################
  pure function get_angle_from_points(point1, point2, point3) result(angle)
    !! Return the angle formed by three points.
    !!
    !! The angle is formed by the path point1 -> point2 -> point3.
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: point1, point2, point3
    !! Input points.
    real(real32) :: angle
    !! Output angle.

    angle = dot_product( point1 - point2, point3 - point2 ) / &
         ( modu( point1 - point2 ) * modu( point3 - point2 ) )
    if(angle .ge. 1._real32)then
       angle = 0._real32
    elseif(angle .le. -1._real32)then
       angle = pi
    else
       angle = acos(angle)
    end if
  end function get_angle_from_points
!###############################################################################


!###############################################################################
  pure function get_dihedral_angle_from_vectors( &
       vector1, vector2, vector3) result(angle)
    !! Return the dihedral angle between two planes.
    !!
    !! The dihedral angle is the angle between the plane defined by the cross
    !! product of two vectors and a third vector.
    !! i.e. ( vector1 x vector2 ) . vector3
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: vector1, vector2, vector3
    !! Input vectors.
    real(real32) :: angle
    !! Output angle.

    angle = get_angle(cross(vector1, vector2), vector3)

  end function get_dihedral_angle_from_vectors
!###############################################################################


!###############################################################################
  pure function get_dihedral_angle_from_points( &
       point1, point2, point3, point4 &
  ) result(angle)
    !! Return the dihedral angle between two planes.
    !!
    !! The dihedral angle is the angle between the plane defined by four points.
    !! i.e. ( point2 - point1 ) x ( point3 - point2 ) . ( point4 - point2 )
    !! alt. angle between plane point1point2point3 and vector point2point4
    implicit none
    real(real32), dimension(3), intent(in) :: point1, point2, point3, point4
    real(real32) :: angle
  
    angle = get_angle(cross(point2 - point1, point3 - point2), point4 - point2)
  
  end function get_dihedral_angle_from_points
!###############################################################################


!###############################################################################
  pure function get_improper_dihedral_angle_from_vectors( &
       vector1, vector2, vector3 &
  ) result(angle)
    !! Return the improper dihedral angle between two planes.
    !!
    !! The improper dihedral angle is the angle between two planes made by
    !! three vectors.
    !! i.e. ( vector1 x vector2 ) . ( vector2 x vector3 )
    !! alt. angle between plane vector1vector2 and vector2vector3
    implicit none
    real(real32), dimension(3), intent(in) :: vector1, vector2, vector3
    real(real32) :: angle

    angle = get_angle( &
         cross(vector1, vector2), &
         cross(vector2, vector3) &
    )
    !! map angle back into the range [0, pi]
    if(angle .gt. pi) angle = 2._real32 * pi - angle


  end function get_improper_dihedral_angle_from_vectors
!###############################################################################


!###############################################################################
  pure function get_improper_dihedral_angle_from_points( &
       point1, point2, point3, point4 &
  ) result(angle)
    !! Return the improper dihedral angle between two planes.
    !!
    !! The dihedral angle is the angle between the plane defined by four points.
    !! i.e. ( point2 - point1 ) x ( point3 - point1 ) . 
    !! ( point4 - point2 ) x ( point3 - point1 )
    !! alt. angle between plane point1point2point3 and point1point3point4
    implicit none
    real(real32), dimension(3), intent(in) :: point1, point2, point3, point4
    real(real32) :: angle

    angle = get_angle( &
         cross(point2 - point1, point3 - point1), &
         cross(point3 - point1, point4 - point1) &
    )

  end function get_improper_dihedral_angle_from_points
!###############################################################################


!###############################################################################
  pure function inverse_3x3(mat) result(output)
    implicit none
    real(real32) :: det
    real(real32), dimension(3,3) :: output
    real(real32), dimension(3,3), intent(in) :: mat

    det = &
         mat(1,1) * mat(2,2) * mat(3,3) - mat(1,1) * mat(2,3) * mat(3,2) - &
         mat(1,2) * mat(2,1) * mat(3,3) + mat(1,2) * mat(2,3) * mat(3,1) + &
         mat(1,3) * mat(2,1) * mat(3,2) - mat(1,3) * mat(2,2) * mat(3,1)

    output(1,1) = +1._real32 / det * (mat(2,2) * mat(3,3) - mat(2,3) * mat(3,2))
    output(2,1) = -1._real32 / det * (mat(2,1) * mat(3,3) - mat(2,3) * mat(3,1))
    output(3,1) = +1._real32 / det * (mat(2,1) * mat(3,2) - mat(2,2) * mat(3,1))
    output(1,2) = -1._real32 / det * (mat(1,2) * mat(3,3) - mat(1,3) * mat(3,2))
    output(2,2) = +1._real32 / det * (mat(1,1) * mat(3,3) - mat(1,3) * mat(3,1))
    output(3,2) = -1._real32 / det * (mat(1,1) * mat(3,2) - mat(1,2) * mat(3,1))
    output(1,3) = +1._real32 / det * (mat(1,2) * mat(2,3) - mat(1,3) * mat(2,2))
    output(2,3) = -1._real32 / det * (mat(1,1) * mat(2,3) - mat(1,3) * mat(2,1))
    output(3,3) = +1._real32 / det * (mat(1,1) * mat(2,2) - mat(1,2) * mat(2,1))

  end function inverse_3x3
!###############################################################################

end module raffle__misc_linalg

module raffle__distribs
  !! Module for handling distribution functions.
  !!
  !! This module contains the types and subroutines for generating distribution
  !! fucntions for individual materials.
  !! The distribution functions are used as fingerprints for atomic structures
  !! to identify similarities and differences between structures.
  use raffle__constants, only: real32, pi
  use raffle__io_utils, only: stop_program, print_warning
  use raffle__misc, only: strip_null, sort_str
  use raffle__misc_maths, only: triangular_number
  use raffle__misc_linalg, only: get_angle, get_improper_dihedral_angle, modu
  use raffle__geom_rw, only: basis_type, get_element_properties
  use raffle__geom_extd, only: extended_basis_type
  use raffle__element_utils, only: &
       element_type, element_bond_type, &
       element_database, element_bond_database
  implicit none

  
  private

  public :: distribs_base_type, distribs_type, get_distrib
  
  
  type :: distribs_base_type
     !! Base type for distribution functions.
     real(real32), dimension(:,:), allocatable :: df_2body
     !! 2-body distribution function.
     real(real32), dimension(:,:), allocatable :: df_3body
     !! 3-body distribution function.
     real(real32), dimension(:,:), allocatable :: df_4body
     !! 4-body distribution function.
  end type distribs_base_type

  type, extends(distribs_base_type) :: distribs_type
     !! Type for distribution functions.
     !!
     !! This type contains the distribution functions for a single atomic
     !! structure. It also contains other structure properties, including:
     !! - energy
     !! - stoichiometry
     !! - elements
     !! - number of atoms
     integer :: num_atoms = 0
     !! Number of atoms in the structure.
     real(real32) :: energy = 0.0_real32
     !! Energy of the structure.
     real(real32) :: energy_above_hull = 0.0_real32
     !! Energy above the hull of the structure.
     logical :: from_host = .false.
     !! Boolean whether the structure is derived from the host.
     integer, dimension(:), allocatable :: stoichiometry
     !! Stoichiometry of the structure.
     character(len=3), dimension(:), allocatable :: element_symbols
     !! Elements contained within the structure.
     integer, dimension(:), allocatable :: num_pairs, num_per_species
     !! Number of pairs and number of pairs per species.
     real(real32), dimension(:), allocatable :: weight_pair, weight_per_species
     !! Weights for the 2-body and species distribution functions.
   contains
     procedure, pass(this) :: calculate
  end type distribs_type


contains

!###############################################################################
  subroutine set_bond_radius_to_default(elements)
    !! Set the bond radius to the default value.
    !!
    !! The default value is the average of the covalent radii of the elements.
    implicit none

    ! Arguments
    character(len=3), dimension(2), intent(in) :: elements
    !! Element symbols.

    ! Local variables
    integer :: idx1, idx2
    !! Index of the elements in the element database.
    real(real32) :: radius, radius1, radius2
    !! Average of covalent radii.
    character(256) :: warn_msg



    write(warn_msg,'("No bond data for element pair ",A," and ",A)') &
         elements(1), elements(2)
    warn_msg = trim(warn_msg) // &
         achar(13) // achar(10) // &
         "Setting bond to average of covalent radii"
    call print_warning(warn_msg)
    if(.not.allocated(element_database)) allocate(element_database(0))
    idx1 = findloc([ element_database(:)%name ], &
         elements(1), dim=1)
    if(idx1.lt.1)then
       call get_element_properties(elements(1), radius=radius1)
       element_database = [ element_database, &
            element_type(name=elements(1), radius=radius1) ]
       idx1 = size(element_database)
    end if
    idx2 = findloc([ element_database(:)%name ], &
         elements(2), dim=1)
    if(idx2.lt.1)then
       call get_element_properties(elements(2), radius=radius2)
       element_database = [ element_database, &
            element_type(name=elements(2), radius=radius2) ]
       idx2 = size(element_database)
    end if
    radius = ( element_database(idx1)%radius + &
         element_database(idx2)%radius ) / 2._real32
    if(.not.allocated(element_bond_database)) &
         allocate(element_bond_database(0))
    element_bond_database = [ element_bond_database, &
         element_bond_type(elements=[ &
              elements(1), &
              elements(2) &
         ], radius=radius) &
    ]
    call sort_str( &
         element_bond_database(size(element_bond_database))%element &
    )

  end subroutine set_bond_radius_to_default
!###############################################################################


!###############################################################################
  subroutine calculate(this, basis, &
       nbins, width, sigma, cutoff_min, cutoff_max, radius_distance_tol)
    !! Calculate the distribution functions for the container.
    !!
    !! This procedure calculates the 2-, 3-, and 4-body distribution function 
    !! for a given atomic structure (i.e. basis).
    implicit none

    ! Arguments
    class(distribs_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    type(basis_type), intent(in) :: basis
    !! Atomic structure.
    integer, dimension(3), intent(in), optional :: nbins
    !! Optional. Number of bins for the distribution functions.
    real(real32), dimension(3), intent(in), optional :: width, sigma
    !! Optional. Width and sigma for the distribution functions.
    real(real32), dimension(3), intent(in), optional :: cutoff_min, cutoff_max
    !! Optional. Cutoff minimum and maximum for the distribution functions.
    real(real32), dimension(4), intent(in), optional :: radius_distance_tol
    !! Tolerance for the distance between atoms for 3- and 4-body.

    ! Local variables
    integer, dimension(3) :: nbins_
    !! Number of bins for the distribution functions.
    real(real32), dimension(3) :: sigma_
    !! Sigma for the distribution functions.
    real(real32), dimension(3) :: width_
    !! Width of the bins for the distribution functions.
    real(real32), dimension(3) :: cutoff_min_
    !! Cutoff minimum for the distribution functions.
    real(real32), dimension(3) :: cutoff_max_
    !! Cutoff maximum for the distribution functions.
    type(element_bond_type), dimension(:), allocatable :: bond_info
    !! Bond information for radii.
    real(real32), dimension(4) :: radius_distance_tol_
    !! Tolerance for the distance between atoms for 3- and 4-body.


    integer :: i, b, itmp1, idx
    !! Loop index.
    integer :: is, js, ia, ja, ka, la
    !! Loop index.
    integer :: num_pairs
    !! Number of pairs and angles.
    real(real32) :: bondlength
    !! Temporary real variables.
    logical :: success
    !! Boolean for success.
    type(extended_basis_type) :: basis_extd
    !! Extended basis of the system.
    type(extended_basis_type) :: neighbour_basis
    !! Basis for storing neighbour data.
    real(real32), dimension(3) :: eta
    !! Parameters for the distribution functions.
    real(real32), allocatable, dimension(:) :: angle_list, bondlength_list, &
         distance
    !! Temporary real arrays.
    integer, allocatable, dimension(:,:) :: pair_index
    !! Index of element pairs.


    !---------------------------------------------------------------------------
    ! initialise optional variables
    !---------------------------------------------------------------------------
    if(present(cutoff_min))then
       cutoff_min_ = cutoff_min
    else
       cutoff_min_ = [0.5_real32, 0._real32, 0._real32]
    end if
    if(present(cutoff_max))then
       cutoff_max_ = cutoff_max
    else
       cutoff_max_ = [6._real32, pi, pi]
    end if
    if(present(width))then
       width_ = width
    else
       width_ = [0.25_real32, pi/64._real32, pi/64._real32]
    end if
    if(present(sigma))then
       sigma_ = sigma
    else
       sigma_ = [0.1_real32, 0.1_real32, 0.1_real32]
    end if
    if(present(nbins))then
       nbins_ = nbins
       width_ = ( cutoff_max_ - cutoff_min_ )/real( nbins_ - 1, real32 )
    else
       nbins_ = 1 + nint( (cutoff_max_ - cutoff_min_)/width_ )
    end if
    if(present(radius_distance_tol))then
       radius_distance_tol_ = radius_distance_tol
    else
       radius_distance_tol_ = [1.5_real32, 2.5_real32, 3._real32, 6._real32]
    end if
       


    !---------------------------------------------------------------------------
    ! get the number of pairs of species
    ! (this uses a combination calculator with repetition)
    !---------------------------------------------------------------------------
    num_pairs = nint( &
         gamma(real(basis%nspec + 2, real32)) / &
         ( gamma(real(basis%nspec, real32)) * gamma( 3._real32 ) ) &
    )
    allocate(this%element_symbols(basis%nspec))
    do is = 1, basis%nspec
       this%element_symbols(is) = strip_null(basis%spec(is)%name)
    end do
    i = 0
    allocate(bond_info(num_pairs))
    allocate(pair_index(basis%nspec,basis%nspec))
    do is = 1, basis%nspec, 1
       do js = is, basis%nspec, 1
          i = i + 1
          pair_index(js,is) = i
          pair_index(is,js) = i
          call bond_info(i)%set( &
               this%element_symbols(is), &
               this%element_symbols(js), success &
          )
          if(success) cycle
          call set_bond_radius_to_default( [ &
               this%element_symbols(is), &
               this%element_symbols(js) &
          ] )
          call bond_info(i)%set( &
               this%element_symbols(is), &
               this%element_symbols(js), success &
          )
       end do
    end do


    !---------------------------------------------------------------------------
    ! get the stoichiometry, energy, and number of atoms
    !---------------------------------------------------------------------------
    this%stoichiometry = basis%spec(:)%num
    this%energy = basis%energy
    this%num_atoms = basis%natom


    !---------------------------------------------------------------------------
    ! calculate the gaussian width and allocate the distribution functions
    !---------------------------------------------------------------------------
    eta = 1._real32 / ( 2._real32 * sigma_**2._real32 )
    allocate(this%num_pairs(num_pairs), source = 0)
    allocate(this%num_per_species(basis%nspec), source = 0)
    allocate(this%weight_pair(num_pairs), source = 0._real32)
    allocate(this%weight_per_species(basis%nspec), source = 0._real32)
    allocate(this%df_2body(nbins_(1), num_pairs), source = 0._real32)
    allocate(this%df_3body(nbins_(2), basis%nspec), source = 0._real32)
    allocate(this%df_4body(nbins_(3), basis%nspec), source = 0._real32)


    !---------------------------------------------------------------------------
    ! create the extended basis and neighbour basis
    !---------------------------------------------------------------------------
    call basis_extd%copy(basis)
    call basis_extd%create_images( max_bondlength = cutoff_max_(1) )
    allocate(bondlength_list(basis_extd%natom+basis_extd%num_images))

    allocate(neighbour_basis%spec(1))
    allocate(neighbour_basis%image_spec(1))
    allocate(neighbour_basis%spec(1)%atom( &
         sum(basis_extd%spec(:)%num)+sum(basis_extd%image_spec(:)%num), 3 &
    ) )
    allocate(neighbour_basis%image_spec(1)%atom( &
         sum(basis_extd%spec(:)%num)+sum(basis_extd%image_spec(:)%num), 3 &
    ) )
    neighbour_basis%nspec = basis%nspec
    neighbour_basis%natom = 0
    neighbour_basis%num_images = 0
    neighbour_basis%lat = basis%lat


    !---------------------------------------------------------------------------
    ! calculate the distribution functions
    !---------------------------------------------------------------------------
    do is = 1, basis%nspec
       do ia = 1, basis%spec(is)%num
          allocate(distance(basis_extd%natom+basis_extd%num_images))
          neighbour_basis%spec(1)%num = 0
          neighbour_basis%image_spec(1)%num = 0
          do js = 1, basis%nspec
             itmp1 = 0

             !------------------------------------------------------------------
             ! loop over all atoms inside the unit cell
             !------------------------------------------------------------------
             atom_loop: do ja = 1, basis_extd%spec(js)%num

                associate( vector =>  matmul( &
                     [ &
                          basis_extd%spec(js)%atom(ja,1:3) - &
                          basis_extd%spec(is)%atom(ia,1:3) &
                     ], basis_extd%lat ) &
                )
                   bondlength = modu( vector )
                   
                   if( &
                        bondlength .lt. cutoff_min_(1) .or. &
                        bondlength .gt. cutoff_max_(1) &
                   ) cycle atom_loop
                  
                   ! add 2-body bond to store if within tolerances for 3-body
                   ! distance
                   if( &
                        bondlength .ge. ( &
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(1) &
                        ) .and. &
                        bondlength .le. ( &
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(2) &
                        ) &
                   ) then
                      neighbour_basis%spec(1)%num = &
                           neighbour_basis%spec(1)%num + 1
                      neighbour_basis%spec(1)%atom( &
                           neighbour_basis%spec(1)%num,1:3) = vector
                   end if

                   ! add 2-body bond to store if within tolerances for 4-body
                   ! distance
                   if( &
                        bondlength .ge. ( & 
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(3) &
                        ) .and. &
                        bondlength .le. ( &
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(4) &
                        ) &
                   ) then
                      neighbour_basis%image_spec(1)%num = &
                           neighbour_basis%image_spec(1)%num + 1
                      neighbour_basis%image_spec(1)%atom( &
                           neighbour_basis%image_spec(1)%num,1:3) = vector
                   end if

                   !if(js.lt.js.or.(is.eq.js.and.ja.le.ia)) cycle
                   itmp1 = itmp1 + 1
                   bondlength_list(itmp1) = bondlength
                   distance(itmp1) = 1._real32
                
                end associate
             end do atom_loop


             !------------------------------------------------------------------
             ! loop over all image atoms outside of the unit cell
             !------------------------------------------------------------------
             image_loop: do ja = 1, basis_extd%image_spec(js)%num
                associate( vector =>  matmul( &
                     [ &
                          basis_extd%image_spec(js)%atom(ja,1:3) - &
                          basis_extd%spec(is)%atom(ia,1:3) &
                     ], basis_extd%lat ) &
                )

                   bondlength = modu( vector )
                   
                   if( &
                        bondlength .lt. cutoff_min_(1) .or. &
                        bondlength .gt. cutoff_max_(1) &
                   ) cycle image_loop
                  
                   ! add 2-body bond to store if within tolerances for 3-body
                   ! distance
                   if( &
                        bondlength .ge. ( &
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(1) &
                        ) .and. &
                        bondlength .le. ( &
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(2) &
                        ) &
                   ) then
                      neighbour_basis%spec(1)%num = &
                           neighbour_basis%spec(1)%num + 1
                      neighbour_basis%spec(1)%atom( &
                           neighbour_basis%spec(1)%num,1:3 &
                      ) = vector
                   end if

                   ! add 2-body bond to store if within tolerances for 4-body
                   ! distance
                   if( &
                        bondlength .ge. ( & 
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(3) &
                        ) .and. &
                        bondlength .le. ( &
                             bond_info(pair_index(is, js))%radius_covalent * &
                             radius_distance_tol_(4) &
                        ) &
                   ) then
                      neighbour_basis%image_spec(1)%num = &
                           neighbour_basis%image_spec(1)%num + 1
                      neighbour_basis%image_spec(1)%atom( &
                           neighbour_basis%image_spec(1)%num,1:3 &
                      ) = vector
                   end if

                   itmp1 = itmp1 + 1
                   bondlength_list(itmp1) = bondlength
                   distance(itmp1) = 1._real32
                
                end associate
             end do image_loop

             !------------------------------------------------------------------
             ! calculate the 2-body distribution function contributions from
             ! atom (is,ia) for species pair (is,js)
             !------------------------------------------------------------------
             if(itmp1.gt.0)then
                this%df_2body(:,pair_index(is, js)) = &
                     this%df_2body(:,pair_index(is, js)) + &
                     get_distrib( &
                          bondlength_list(:itmp1), &
                          nbins_(1), eta(1), width_(1), &
                          cutoff_min_(1), &
                          scale_list = distance(:itmp1) &
                     )
                this%weight_pair(pair_index(is, js)) = &
                     this%weight_pair(pair_index(is, js)) + &
                     4._real32 * sum( &
                          ( &
                               bond_info(pair_index(is, js))%radius_covalent / &
                               bondlength_list(:itmp1) ) ** 2 &
                     )
                this%num_pairs(pair_index(is, js)) = &
                     this%num_pairs(pair_index(is, js)) + itmp1
                this%weight_per_species(is) = &
                     this%weight_per_species(is) + &
                     4._real32 * sum( &
                          ( &
                               bond_info(pair_index(is, js))%radius_covalent / &
                               bondlength_list(:itmp1) ) ** 2 &
                     )
                this%num_per_species(is) = this%num_per_species(is) + itmp1
             end if

          end do
          deallocate(distance)


          !---------------------------------------------------------------------
          ! calculate the 3-body distribution function for atom (is,ia)
          !---------------------------------------------------------------------
          if(neighbour_basis%spec(1)%num.le.1) cycle
          associate( &
               num_angles => &
               triangular_number( neighbour_basis%spec(1)%num - 1 ) &
          )
             allocate( angle_list(num_angles), distance(num_angles) )
          end associate
          do concurrent ( ja = 1:neighbour_basis%spec(1)%num:1 )
             do concurrent ( ka = ja + 1:neighbour_basis%spec(1)%num:1 )
                idx = nint( &
                     (ja - 1) * (neighbour_basis%spec(1)%num - ja / 2.0) + &
                     (ka - ja) &
                )
                angle_list(idx) = get_angle( &
                     [ neighbour_basis%spec(1)%atom(ja,:3) ], &
                     [ neighbour_basis%spec(1)%atom(ka,:3) ] &
                )
                distance(idx) = &
                     ( &
                          modu(neighbour_basis%spec(1)%atom(ja,:3)) ** 2 * &
                          modu(neighbour_basis%spec(1)%atom(ka,:3)) ** 2 &
                     )
             end do
          end do
          ! a NaN in the angle refers to one where two of the vectors are
          ! parallel, so the angle is undefined
          do i = 1, size(angle_list)
             if(isnan(angle_list(i)))then
                angle_list(i) = -huge(1._real32)
                distance(i) =  1._real32
             end if
          end do
          this%df_3body(:,is) = this%df_3body(:,is) + &
               get_distrib( &
                    angle_list, &
                    nbins_(2), eta(2), width_(2), &
                    cutoff_min_(2), &
                    scale_list = distance &
               )
          deallocate( angle_list, distance )


          !---------------------------------------------------------------------
          ! calculate the 4-body distribution function for atom (is,ia)
          !---------------------------------------------------------------------
          if(neighbour_basis%image_spec(1)%num.eq.0) cycle
          associate( &
               num_angles => &
               triangular_number( neighbour_basis%spec(1)%num - 1 ) * &
               neighbour_basis%image_spec(1)%num &
          )
             allocate( angle_list(num_angles), distance(num_angles) )
          end associate
          idx = 0
          do concurrent ( &
               ja = 1:neighbour_basis%spec(1)%num:1, &
               la = 1:neighbour_basis%image_spec(1)%num:1 &
          )
             do concurrent ( ka = ja + 1:neighbour_basis%spec(1)%num:1 )
                idx = nint( &
                     (ja - 1) * (neighbour_basis%spec(1)%num - ja / 2.0) + &
                     (ka - ja - 1) &
                ) * neighbour_basis%image_spec(1)%num + la
                angle_list(idx) = &
                     get_improper_dihedral_angle( &
                          [ neighbour_basis%spec(1)%atom(ja,:3) ], &
                          [ neighbour_basis%spec(1)%atom(ka,:3) ], &
                          [ neighbour_basis%image_spec(1)%atom(la,:3) ] &
                     )
                distance(idx) = &
                     modu(neighbour_basis%spec(1)%atom(ja,:3)) ** 2 * &
                     modu(neighbour_basis%spec(1)%atom(ka,:3)) ** 2 * &
                     modu(neighbour_basis%image_spec(1)%atom(la,:3)) ** 2
             end do
          end do
          ! a NaN in the angle refers to one where two of the vectors are
          ! parallel, so the angle is undefined
          do i = 1, size(angle_list)
             if(isnan(angle_list(i)))then
                angle_list(i) = -huge(1._real32)
                distance(i) =  1._real32
             end if
          end do
          this%df_4body(:,is) = this%df_4body(:,is) + &
               get_distrib( &
                    angle_list, &
                    nbins_(3), eta(3), width_(3), &
                    cutoff_min_(3), &
                    scale_list = distance &
               )
          deallocate( angle_list, distance )

       end do
    end do

    !---------------------------------------------------------------------------
    ! apply the cutoff function to the 2-body distribution function
    !---------------------------------------------------------------------------
    do b = 1, nbins_(1)
       this%df_2body(b,:) = this%df_2body(b,:) / ( cutoff_min_(1) + &
            width_(1) * real(b-1, real32) ) ** 2
    end do


    !---------------------------------------------------------------------------
    ! renormalise the distribution functions so that area under the curve is 1
    !---------------------------------------------------------------------------
    do i = 1, num_pairs
       if(any(abs(this%df_2body(:,i)).gt.1.E-6))then
          this%df_2body(:,i) = this%df_2body(:,i) / sum(this%df_2body(:,i))
       end if
    end do
    do is = 1, basis%nspec
       if(any(abs(this%df_3body(:,is)).gt.1.E-6))then
          this%df_3body(:,is) = this%df_3body(:,is) / sum(this%df_3body(:,is))
       end if
       if(any(abs(this%df_4body(:,is)).gt.1.E-6))then
          this%df_4body(:,is) = this%df_4body(:,is) / sum(this%df_4body(:,is))
       end if
    end do


    !---------------------------------------------------------------------------
    ! check for NaN in the distribution functions
    !---------------------------------------------------------------------------
    if(any(isnan(this%df_2body)))then
       call stop_program('NaN in 2-body distribution function')
    end if
    if(any(isnan(this%df_3body)))then
       call stop_program('NaN in 3-body distribution function')
    end if
    if(any(isnan(this%df_4body)))then
       call stop_program('NaN in 4-body distribution function')
    end if

  end subroutine calculate
!###############################################################################


!###############################################################################
  function get_distrib(value_list, nbins, eta, width, cutoff_min, &
       scale_list ) result(output)
    !! Calculate the angular distribution function for a list of values.
    implicit none

    ! Arguments
    integer, intent(in) :: nbins
    !! Number of bins for the distribution functions.
    real(real32), intent(in) :: eta, width, cutoff_min
    !! Parameters for the distribution functions.
    real(real32), dimension(:), intent(in) :: value_list
    !! List of angles.
    real(real32), dimension(:), intent(in) :: scale_list
    !! List of scaling for each angle (distance**3 or distance**4)
    real(real32), dimension(nbins) :: output
    !! Distribution function for the list of values.

    ! Local variables
    integer :: i, j, b, bin
    !! Loop index.
    integer :: max_num_steps
    !! Maximum number of steps.
    integer, dimension(3,2) :: loop_limits
    !! Loop limits for the 3-body distribution function.


    max_num_steps = ceiling( sqrt(16._real32/eta) / width )
    output = 0._real32

    !---------------------------------------------------------------------------
    ! calculate the distribution function for a list of values
    !---------------------------------------------------------------------------
    do i = 1, size(value_list), 1

       !------------------------------------------------------------------------
       ! get the bin closest to the value
       !------------------------------------------------------------------------
       bin = nint( ( value_list(i) - cutoff_min ) / width ) + 1
       if( &
            bin .lt. 1 - max_num_steps .or. &
            bin .gt. nbins + max_num_steps &
       ) cycle


       !------------------------------------------------------------------------
       ! calculate the gaussian for this bond
       !------------------------------------------------------------------------
       loop_limits(:,1) = &
            [ min(nbins, bin), min(nbins, bin + max_num_steps), 1 ]
       loop_limits(:,2) = &
            [ max(0, bin - 1), max(1, bin - max_num_steps), -1 ]


       !------------------------------------------------------------------------
       ! do forward and backward loops to add gaussian from its centre
       !------------------------------------------------------------------------
       do concurrent ( j = 1:2 )
          do concurrent ( &
               b = loop_limits(1,j):loop_limits(2,j):loop_limits(3,j) &
          )
             output(b) = output(b) + &
                  exp( &
                       -eta * ( &
                            value_list(i) - &
                            ( width * real(b-1, real32) + cutoff_min ) &
                       ) ** 2._real32 &
                  ) / scale_list(i)
          end do
       end do
    end do
    output = output * sqrt( eta / pi ) / real(size(value_list,1),real32)

  end function get_distrib
!###############################################################################

end module raffle__distribs

! Module raffle__distribs_container defined in file ../src/lib/mod_distribs_container.f90

!###############################################################################
! number of evaluated systems
!###############################################################################
subroutine f90wrap_distribs_container_type__get__iteration( &
     this, f90wrap_iteration &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_iteration

    this_ptr = transfer(this, this_ptr)
    f90wrap_iteration = this_ptr%p%iteration
end subroutine f90wrap_distribs_container_type__get__iteration

subroutine f90wrap_distribs_container_type__set__iteration( &
     this, f90wrap_iteration &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_iteration

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%iteration = f90wrap_iteration
end subroutine f90wrap_distribs_container_type__set__iteration

subroutine f90wrap_distribs_container_type__get__num_evaluated( &
     this, f90wrap_num_evaluated &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_num_evaluated

    this_ptr = transfer(this, this_ptr)
    f90wrap_num_evaluated = this_ptr%p%num_evaluated
end subroutine f90wrap_distribs_container_type__get__num_evaluated

subroutine f90wrap_distribs_container_type__set__num_evaluated( &
     this, f90wrap_num_evaluated &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_num_evaluated

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%num_evaluated = f90wrap_num_evaluated
end subroutine f90wrap_distribs_container_type__set__num_evaluated

subroutine f90wrap_distribs_container_type__get__num_evaluated_allocated( &
     this, f90wrap_num_evaluated_allocated &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_num_evaluated_allocated

    this_ptr = transfer(this, this_ptr)
    f90wrap_num_evaluated_allocated = this_ptr%p%num_evaluated_allocated
end subroutine f90wrap_distribs_container_type__get__num_evaluated_allocated

subroutine f90wrap_distribs_container_type__set__num_evaluated_allocated( &
     this, f90wrap_num_evaluated_allocated &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_num_evaluated_allocated

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%num_evaluated_allocated = f90wrap_num_evaluated_allocated
end subroutine f90wrap_distribs_container_type__set__num_evaluated_allocated
!###############################################################################


!###############################################################################
! energy scaling
!###############################################################################
subroutine f90wrap_distribs_container_type__get__kBT(this, f90wrap_kBT)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_kBT

    this_ptr = transfer(this, this_ptr)
    f90wrap_kBT = this_ptr%p%kBT
end subroutine f90wrap_distribs_container_type__get__kBT

subroutine f90wrap_distribs_container_type__set__kBT(this, f90wrap_kBT)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_kBT

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%kBT = f90wrap_kBT
end subroutine f90wrap_distribs_container_type__set__kBT
!###############################################################################


!###############################################################################
! convergence history
!###############################################################################
subroutine f90wrap_distribs_container_type__get__history_len( &
     this, f90wrap_history_len &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(out) :: f90wrap_history_len

    this_ptr = transfer(this, this_ptr)
    f90wrap_history_len = this_ptr%p%history_len
end subroutine f90wrap_distribs_container_type__get__history_len

subroutine f90wrap_distribs_container_type__set__history_len( &
     this, f90wrap_history_len &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_history_len

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%history_len = f90wrap_history_len
end subroutine f90wrap_distribs_container_type__set__history_len

subroutine f90wrap_distribs_container_type__array__history_deltas( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%history_deltas)) then
        dshape(1:1) = shape(this_ptr%p%history_deltas)
        dloc = loc(this_ptr%p%history_deltas)
    else
        dloc = 0
    end if
end subroutine f90wrap_distribs_container_type__array__history_deltas
!###############################################################################


!###############################################################################
! boolean for using hull weighting or empirical method
!###############################################################################
subroutine f90wrap_distribs_container_type__get__weight_by_hull( &
     this, f90wrap_weight_by_hull &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_weight_by_hull

    this_ptr = transfer(this, this_ptr)
    f90wrap_weight_by_hull = this_ptr%p%weight_by_hull
end subroutine f90wrap_distribs_container_type__get__weight_by_hull

subroutine f90wrap_distribs_container_type__set__weight_by_hull( &
     this, f90wrap_weight_by_hull &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_weight_by_hull

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%weight_by_hull = f90wrap_weight_by_hull
end subroutine f90wrap_distribs_container_type__set__weight_by_hull
!###############################################################################


!###############################################################################
! viability default values
!###############################################################################
subroutine f90wrap_distribs_container_type__get__viability_3body_default( &
     this, f90wrap_viability_3body_default &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_viability_3body_default

    this_ptr = transfer(this, this_ptr)
    f90wrap_viability_3body_default = this_ptr%p%viability_3body_default
end subroutine f90wrap_distribs_container_type__get__viability_3body_default

subroutine f90wrap_distribs_container_type__set__viability_3body_default( &
     this, f90wrap_viability_3body_default &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_viability_3body_default

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%viability_3body_default = f90wrap_viability_3body_default
end subroutine f90wrap_distribs_container_type__set__viability_3body_default

subroutine f90wrap_distribs_container_type__get__viability_4body_default( &
     this, f90wrap_viability_4body_default &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    real(4), intent(out) :: f90wrap_viability_4body_default

    this_ptr = transfer(this, this_ptr)
    f90wrap_viability_4body_default = this_ptr%p%viability_4body_default
end subroutine f90wrap_distribs_container_type__get__viability_4body_default

subroutine f90wrap_distribs_container_type__set__viability_4body_default( &
     this, f90wrap_viability_4body_default &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    real(4), intent(in) :: f90wrap_viability_4body_default

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%viability_4body_default = f90wrap_viability_4body_default
end subroutine f90wrap_distribs_container_type__set__viability_4body_default

subroutine f90wrap_distribs_container_type__get__smooth_viability( &
     this, f90wrap_smooth_viability &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_smooth_viability

    this_ptr = transfer(this, this_ptr)
    f90wrap_smooth_viability = this_ptr%p%smooth_viability
end subroutine f90wrap_distribs_container_type__get__smooth_viability

subroutine f90wrap_distribs_container_type__set__smooth_viability( &
     this, f90wrap_smooth_viability &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_smooth_viability

    this_ptr = transfer(this, this_ptr)
    this_ptr%p%smooth_viability = f90wrap_smooth_viability
end subroutine f90wrap_distribs_container_type__set__smooth_viability
!###############################################################################


!###############################################################################
! parameters for the distribution functions
!###############################################################################
subroutine f90wrap_distribs_container_type__array__nbins( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 5
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%nbins)
    dloc = loc(this_ptr%p%nbins)
end subroutine f90wrap_distribs_container_type__array__nbins

subroutine f90wrap_distribs_container_type__array__sigma( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%sigma)
    dloc = loc(this_ptr%p%sigma)
end subroutine f90wrap_distribs_container_type__array__sigma

subroutine f90wrap_distribs_container_type__array__width( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%width)
    dloc = loc(this_ptr%p%width)
end subroutine f90wrap_distribs_container_type__array__width

subroutine f90wrap_distribs_container_type__array__cutoff_min( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%cutoff_min)
    dloc = loc(this_ptr%p%cutoff_min)
end subroutine f90wrap_distribs_container_type__array__cutoff_min

subroutine f90wrap_distribs_container_type__array__cutoff_max( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%cutoff_max)
    dloc = loc(this_ptr%p%cutoff_max)
end subroutine f90wrap_distribs_container_type__array__cutoff_max

subroutine f90wrap_distribs_container_type__array__radius_distance_tol( &
     this, nd, dtype, dshape, dloc &
)
    use raffle__distribs_container, only: distribs_container_type
    use, intrinsic :: iso_c_binding, only : c_int
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer(c_int), intent(in) :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer(c_int), intent(out) :: nd
    integer(c_int), intent(out) :: dtype
    integer(c_int), dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc

    nd = 1
    dtype = 11
    this_ptr = transfer(this, this_ptr)
    dshape(1:1) = shape(this_ptr%p%radius_distance_tol)
    dloc = loc(this_ptr%p%radius_distance_tol)
end subroutine f90wrap_distribs_container_type__array__radius_distance_tol
!###############################################################################


!###############################################################################
! distributions container type initialiser and finaliser
!###############################################################################
subroutine f90wrap_raffle__dc__dc_type_initialise(this)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_raffle__dc__dc_type_initialise

subroutine f90wrap_raffle__dc__dc_type_finalise(this)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_raffle__dc__dc_type_finalise
!###############################################################################


!###############################################################################
! procedures to set distribution function parameters
!###############################################################################
subroutine f90wrap_raffle__dc__set_width__binding__dc_type( &
     this, width &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(3), intent(in) :: width
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_width(width=width)
end subroutine f90wrap_raffle__dc__set_width__binding__dc_type

subroutine f90wrap_raffle__dc__set_sigma__binding__dc_type( &
     this, sigma &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(3), intent(in) :: sigma
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_sigma(sigma=sigma)
end subroutine f90wrap_raffle__dc__set_sigma__binding__dc_type

subroutine f90wrap_raffle__dc__set_cutoff_min__binding__dc_type( &
     this, cutoff_min &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(3), intent(in) :: cutoff_min
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_cutoff_min(cutoff_min=cutoff_min)
end subroutine f90wrap_raffle__dc__set_cutoff_min__binding__dc_type

subroutine f90wrap_raffle__dc__set_cutoff_max__binding__dc_type( &
     this, cutoff_max &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(3), intent(in) :: cutoff_max
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_cutoff_max(cutoff_max=cutoff_max)
end subroutine f90wrap_raffle__dc__set_cutoff_max__binding__dc_type

subroutine f90wrap_raffle__dc__set_radius_distance_tol__binding__dc_type( &
     this, radius_distance_tol &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), dimension(4), intent(in) :: radius_distance_tol
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_radius_distance_tol( &
         radius_distance_tol=radius_distance_tol &
    )
end subroutine f90wrap_raffle__dc__set_radius_distance_tol__binding__dc_type

subroutine f90wrap_raffle__dc__set_history_len__binding__dc_type( &
     this, history_len &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(in) :: history_len
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_history_len(history_len=history_len)
end subroutine f90wrap_raffle__dc__set_history_len__binding__dc_type
!###############################################################################


!###############################################################################
! create and update the generalised distribution functions
!###############################################################################
subroutine f90wrap_raffle__dc__create__binding__dc_type( &
     this, basis_list, deallocate_systems, verbose, energy_above_hull_list, n0 &
)
    use raffle__geom_rw, only: basis_type
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_xnum_array_ptr_type) :: basis_list_ptr
    integer, intent(in), dimension(2) :: basis_list
    logical, intent(in), optional :: deallocate_systems
    integer, intent(in), optional :: verbose
    real(4), dimension(n0), intent(in), optional :: energy_above_hull_list
    integer :: n0
    !f2py intent(hide), depend(energy_above_hull_list) :: n0 = shape(energy_above_hull_list,0)

    this_ptr = transfer(this, this_ptr)
    basis_list_ptr = transfer(basis_list, basis_list_ptr)
    call this_ptr%p%create( &
         basis_list=basis_list_ptr%p%items, &
         energy_above_hull_list=energy_above_hull_list, &
         deallocate_systems=deallocate_systems, &
         verbose=verbose &
    )
end subroutine f90wrap_raffle__dc__create__binding__dc_type

subroutine f90wrap_raffle__dc__update__binding__dc_type( &
       this, basis_list, &
         from_host, deallocate_systems, verbose, energy_above_hull_list, n0 &
)
    use raffle__geom_rw, only: basis_type
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type

    type basis_type_xnum_array
        type(basis_type), dimension(:), allocatable :: items
    end type basis_type_xnum_array

    type basis_type_xnum_array_ptr_type
        type(basis_type_xnum_array), pointer :: p => NULL()
    end type basis_type_xnum_array_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_xnum_array_ptr_type) :: basis_list_ptr
    integer, intent(in), dimension(2) :: basis_list
    logical, intent(in), optional :: from_host
    logical, intent(in), optional :: deallocate_systems
    integer, intent(in), optional :: verbose
    real(4), dimension(n0), intent(in), optional :: energy_above_hull_list
    integer :: n0
    !f2py intent(hide), depend(energy_above_hull_list) :: n0 = shape(energy_above_hull_list,0)

    this_ptr = transfer(this, this_ptr)
    basis_list_ptr = transfer(basis_list, basis_list_ptr)
    call this_ptr%p%update(basis_list=basis_list_ptr%p%items, &
         energy_above_hull_list=energy_above_hull_list, &
         from_host=from_host, &
         deallocate_systems=deallocate_systems, &
         verbose=verbose &
    )
end subroutine f90wrap_raffle__dc__update__binding__dc_type
!###############################################################################


!###############################################################################
! deallocate systems procedure
!###############################################################################
subroutine f90wrap_raffle__dc__deallocate_systems__binding__dc_type( &
     this &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%deallocate_systems()
end subroutine f90wrap_raffle__dc__deallocate_systems__binding__dc_type
!###############################################################################


!###############################################################################
! add an individual basis to the set of distribution functions
! this does not update the generalised distribution function
!###############################################################################
subroutine f90wrap_raffle__dc__add_basis__binding__dc_type( &
     this, basis &
)
    use raffle__geom_rw, only: basis_type
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_ptr_type) :: basis_ptr
    integer, intent(in), dimension(2) :: basis
    this_ptr = transfer(this, this_ptr)
    basis_ptr = transfer(basis, basis_ptr)
    call this_ptr%p%add_basis(basis=basis_ptr%p)
end subroutine f90wrap_raffle__dc__add_basis__binding__dc_type
!###############################################################################


!###############################################################################
! get the number of elements in the distribution container
!###############################################################################
subroutine f90wrap_raffle__dc__get__num_elements( &
     this, ret_num_elements &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    integer, intent(in)   :: this(2)
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(out) :: ret_num_elements

    this_ptr = transfer(this, this_ptr)
    if(.not.allocated(this_ptr%p%element_info)) then
        ret_num_elements = 0
    else
        ret_num_elements = size(this_ptr%p%element_info,1)
    end if
end subroutine f90wrap_raffle__dc__get__num_elements
!###############################################################################

!###############################################################################
! handle element reference energies and element pair bond radii
!###############################################################################
subroutine f90wrap_raffle__dc__set_element_energy__binding__dc_type( &
     this, element, energy &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), intent(in) :: element
    real(4), intent(in) :: energy
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_element_energy(element=element, energy=energy)
end subroutine f90wrap_raffle__dc__set_element_energy__binding__dc_type

subroutine f90wrap_raffle__dc__set_element_energies__binding__dc_type( &
     this, elements, energies, n0 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), dimension(n0), intent(in) :: elements
    real(4), dimension(n0), intent(in) :: energies
    integer :: n0
    !f2py intent(hide), depend(elements) :: n0 = shape(elements,0)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_element_energies(elements=elements, energies=energies)
end subroutine f90wrap_raffle__dc__set_element_energies__binding__dc_type

subroutine f90wrap_raffle__dc__get_element_energies_sm__binding__dc_type( &
     this, elements, energies, n0 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), intent(inout), dimension(n0) :: elements
    real(4), intent(inout), dimension(n0) :: energies
    integer :: n0
    !f2py intent(hide), depend(elements) :: n0 = shape(elements,0)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%get_element_energies_staticmem(elements=elements, energies=energies)
end subroutine f90wrap_raffle__dc__get_element_energies_sm__binding__dc_type


subroutine f90wrap_raffle__dc__set_bond_radius__binding__dc_type( &
     this, elements, radius &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), dimension(2), intent(in) :: elements
    real(4), intent(in) :: radius
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_bond_radius(elements=elements, radius=radius)
end subroutine f90wrap_raffle__dc__set_bond_radius__binding__dc_type

subroutine f90wrap_raffle__dc__set_bond_radii__binding__dc_type( &
     this, elements, radii, n0, n1, n2 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), intent(in), dimension(n0,n1) :: elements
    real(4), intent(in), dimension(n2) :: radii
    integer :: n0
    !f2py intent(hide), depend(elements) :: n0 = shape(elements,0)
    integer :: n1
    !f2py intent(hide), depend(elements) :: n1 = shape(elements,1)
    integer :: n2
    !f2py intent(hide), depend(radii) :: n2 = shape(radii,0)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%set_bond_radii(elements=elements, radii=radii)
end subroutine f90wrap_raffle__dc__set_bond_radii__binding__dc_type

subroutine f90wrap_raffle__dc__get_bond_radii_staticmem__binding__dc_type( &
     this, elements, radii, n0 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), intent(inout), dimension(n0,2) :: elements
    real(4), intent(inout), dimension(n0) :: radii
    integer :: n0
    !f2py intent(hide), depend(elements) :: n0 = shape(elements,0)
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%get_bond_radii_staticmem(elements=elements, radii=radii)
end subroutine f90wrap_raffle__dc__get_bond_radii_staticmem__binding__dc_type
!###############################################################################


!###############################################################################
! initialise generalised distribution functions
!###############################################################################
subroutine f90wrap_raffle__dc__initialise_gdfs__binding__dc_type(this)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%initialise_gdfs()
end subroutine f90wrap_raffle__dc__initialise_gdfs__binding__dc_type
!###############################################################################


!###############################################################################
! evolve the generalised distribution functions
!###############################################################################
subroutine f90wrap_raffle__dc__evolve__binding__dc_type(this) !, system)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    ! type distribs_type_ptr_type
    !     type(distribs_type), pointer :: p => NULL()
    ! end type distribs_type_ptr_type
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    ! type(distribs_type_ptr_type) :: system_ptr
    ! integer, optional, intent(in), dimension(2) :: system
    this_ptr = transfer(this, this_ptr)
    ! if (present(system)) then
    !     system_ptr = transfer(system, system_ptr)
    ! else
    !     system_ptr%p => null()
    ! end if
    call this_ptr%p%evolve() !system=system_ptr%p)
end subroutine f90wrap_raffle__dc__evolve__binding__dc_type
!###############################################################################


!###############################################################################
! check for convergence of the descriptor
!###############################################################################
subroutine f90wrap_raffle__dc__is_converged__binding__dc_type( &
     this, ret_converged, threshold &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    logical, intent(out) :: ret_converged
    real(4), intent(in), optional :: threshold
    this_ptr = transfer(this, this_ptr)
    ret_converged = this_ptr%p%is_converged(threshold=threshold)
end subroutine f90wrap_raffle__dc__is_converged__binding__dc_type
!###############################################################################


!###############################################################################
! read and write distribution functions to file
!###############################################################################
subroutine f90wrap_raffle__dc__read_gdfs__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%read_gdfs(file=file)
end subroutine f90wrap_raffle__dc__read_gdfs__binding__dc_type

subroutine f90wrap_raffle__dc__write_gdfs__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%write_gdfs(file=file)
end subroutine f90wrap_raffle__dc__write_gdfs__binding__dc_type

subroutine f90wrap_raffle__dc__read_dfs__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%read_dfs(file=file)
end subroutine f90wrap_raffle__dc__read_dfs__binding__dc_type

subroutine f90wrap_raffle__dc__write_dfs__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%write_dfs(file=file)
end subroutine f90wrap_raffle__dc__write_dfs__binding__dc_type

subroutine f90wrap_raffle__dc__write_2body__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%write_2body(file=file)
end subroutine f90wrap_raffle__dc__write_2body__binding__dc_type

subroutine f90wrap_raffle__dc__write_3body__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%write_3body(file=file)
end subroutine f90wrap_raffle__dc__write_3body__binding__dc_type

subroutine f90wrap_raffle__dc__write_4body__binding__dc_type( &
     this, file &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character*(*), intent(in) :: file
    this_ptr = transfer(this, this_ptr)
    call this_ptr%p%write_4body(file=file)
end subroutine f90wrap_raffle__dc__write_4body__binding__dc_type
!###############################################################################


!###############################################################################
! bin and pair index handling
!###############################################################################
subroutine f90wrap_raffle__dc__get_pair_index__binding__dc_type( &
     this, species1, ret_idx, species2 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    character(3), intent(in) :: species1
    integer, intent(out) :: ret_idx
    character(3), intent(in) :: species2
    this_ptr = transfer(this, this_ptr)
    ret_idx = this_ptr%p%get_pair_index(species1=species1, species2=species2)
end subroutine f90wrap_raffle__dc__get_pair_index__binding__dc_type

subroutine f90wrap_raffle__dc__get_bin__binding__dc_type( &
     this, value, ret_bin, dim &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    real(4), intent(in) :: value
    integer, intent(out) :: ret_bin
    integer, intent(in) :: dim
    this_ptr = transfer(this, this_ptr)
    ret_bin = this_ptr%p%get_bin(value=value, dim=dim)
end subroutine f90wrap_raffle__dc__get_bin__binding__dc_type
!###############################################################################


!###############################################################################
! get the generalised descriptor n-body components
!###############################################################################
subroutine f90wrap_raffle__dc__get_2body__binding__dc_type( &
    this, ret_output, n0, n1 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    real(4), intent(out), dimension(n0,n1) :: ret_output
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer :: n0
    integer :: n1
    this_ptr = transfer(this, this_ptr)
    ret_output = this_ptr%p%get_2body()
end subroutine f90wrap_raffle__dc__get_2body__binding__dc_type

subroutine f90wrap_raffle__dc__get_3body__binding__dc_type( &
     this, ret_output, n0, n1 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    real(4), intent(out), dimension(n0,n1) :: ret_output
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer :: n0
    integer :: n1
    this_ptr = transfer(this, this_ptr)
    ret_output = this_ptr%p%get_3body()
end subroutine f90wrap_raffle__dc__get_3body__binding__dc_type

subroutine f90wrap_raffle__dc__get_4body__binding__dc_type( &
     this, ret_output, n0, n1 &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    real(4), intent(out), dimension(n0,n1) :: ret_output
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer :: n0
    integer :: n1
    this_ptr = transfer(this, this_ptr)
    ret_output = this_ptr%p%get_4body()
end subroutine f90wrap_raffle__dc__get_4body__binding__dc_type

subroutine f90wrap_raffle__dc__generate_fingerprint_python__dc_type( &
     this, structure, output_2body, output_3body, output_4body, &
     n0, n1, n2, n3, n4, n5 &
)
    use raffle__distribs_container, only: distribs_container_type
    use raffle__geom_rw, only: basis_type
    implicit none

    type basis_type_ptr_type
        type(basis_type), pointer :: p => NULL()
    end type basis_type_ptr_type
    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    type(basis_type_ptr_type) :: structure_ptr
    integer, intent(in), dimension(2) :: structure
    real(4), intent(inout), dimension(n0,n1) :: output_2body
    real(4), intent(inout), dimension(n2,n3) :: output_3body
    real(4), intent(inout), dimension(n4,n5) :: output_4body
    integer :: n0
    !f2py intent(hide), depend(output_2body) :: n0 = shape(output_2body,0)
    integer :: n1
    !f2py intent(hide), depend(output_2body) :: n1 = shape(output_2body,1)
    integer :: n2
    !f2py intent(hide), depend(output_3body) :: n2 = shape(output_3body,0)
    integer :: n3
    !f2py intent(hide), depend(output_3body) :: n3 = shape(output_3body,1)
    integer :: n4
    !f2py intent(hide), depend(output_4body) :: n4 = shape(output_4body,0)
    integer :: n5
    !f2py intent(hide), depend(output_4body) :: n5 = shape(output_4body,1)
    this_ptr = transfer(this, this_ptr)
    structure_ptr = transfer(structure, structure_ptr)
    call this_ptr%p%generate_fingerprint_python( &
        structure=structure_ptr%p, output_2body=output_2body, &
        output_3body=output_3body, output_4body=output_4body &
    )
end subroutine f90wrap_raffle__dc__generate_fingerprint_python__dc_type

subroutine f90wrap_raffle__dc__get_num_species__dc_type( &
     this, ret_num_species &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(out) :: ret_num_species
    this_ptr = transfer(this, this_ptr)
    ret_num_species = size(this_ptr%p%element_info, dim = 1)
end subroutine f90wrap_raffle__dc__get_num_species__dc_type

subroutine f90wrap_raffle__dc__get_num_pairs__dc_type( &
     this, ret_num_pairs &
)
    use raffle__distribs_container, only: distribs_container_type
    implicit none

    type distribs_container_type_ptr_type
        type(distribs_container_type), pointer :: p => NULL()
    end type distribs_container_type_ptr_type
    type(distribs_container_type_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    integer, intent(out) :: ret_num_pairs
    this_ptr = transfer(this, this_ptr)
    ret_num_pairs = size(this_ptr%p%bond_info, dim = 1)
end subroutine f90wrap_raffle__dc__get_num_pairs__dc_type
!###############################################################################

! End of module raffle__distribs_container defined in file ../src/lib/mod_distribs_container.f90

module raffle__element_utils
  !! Module for storing and handling element and bond data.
  !!
  !! This module contains the element and bond types, and the element and bond
  !! databases. The element and bond databases are used to store the properties
  !! of the elements and bonds in the system, respectively.
  !! The element and bond types are used by other modules to store the
  !! properties relevant to an individual system.
  use raffle__constants, only: real32
  use raffle__io_utils, only: print_warning
  implicit none

  private

  public :: element_type, element_bond_type
  public :: element_database, element_bond_database


  type :: element_type
     !! Type for storing the properties of an element.
     character(len=3) :: name
     real(real32) :: mass = 0._real32
     real(real32) :: charge = 0._real32
     real(real32) :: radius = 0._real32
     real(real32) :: energy = 0._real32
   contains
     procedure, pass(this) :: set => set_element
  end type element_type
  type(element_type), dimension(:), allocatable :: element_database


  type :: element_bond_type
     !! Type for storing the properties of a bond between two elements.    
     real(real32) :: radius_covalent = 0._real32
     character(3), dimension(2) :: element
   contains
     procedure, pass(this) :: set => set_bond
  end type element_bond_type
  type(element_bond_type), dimension(:), allocatable :: element_bond_database
  
   
  interface element_type
     !! Constructor for the element type.
     module function init_element_type( &
          name, mass, charge, energy) result(element)
       character(len=3), intent(in) :: name
       real(real32), intent(in), optional :: mass, charge, energy
       type(element_type) :: element
     end function init_element_type
  end interface element_type

   
  interface element_bond_type
     !! Constructor for the element bond type.
     module function init_element_bond_type( &
          elements, radius) result(bond)
       character(len=3), dimension(2), intent(in) :: elements
       real(real32), intent(in), optional :: radius
       type(element_bond_type) :: bond
     end function init_element_bond_type
  end interface element_bond_type


contains

!###############################################################################
  module function init_element_type(name, mass, charge, energy) result(element)
    !! Initialise an instance of the element_type.
    !!
    !! This function initialises an instance of the element_type with the
    !! provided properties.
    implicit none

    ! Arguments
    character(len=3), intent(in) :: name
    !! Element name.
    real(real32), intent(in), optional :: mass, charge, energy
    !! Element mass, charge, and energy.

    type(element_type) :: element
    !! Instance of element_type.

    element%name = name
    if(present(mass)) element%mass= mass
    if(present(charge)) element%charge = charge
    if(present(energy)) element%energy = energy

  end function init_element_type
!###############################################################################


!###############################################################################
  module function init_element_bond_type(elements, radius) result(bond)
    !! Initialise an instance of the element_bond_type.
    !!
    !! This function initialises an instance of the element_bond_type with the
    !! provided properties.
    implicit none

    ! Arguments
    character(len=3), dimension(2), intent(in) :: elements
    !! Element names.
    real(real32), intent(in), optional :: radius
    !! Element radius.

    type(element_bond_type) :: bond
    !! Instance of bond_type.

    bond%element = elements
    if(present(radius)) bond%radius_covalent = radius

  end function init_element_bond_type
!###############################################################################


!###############################################################################
  subroutine set_element(this, name, in_database)
    !! Set the element properties.
    !!
    !! This subroutine sets the properties of an element instance with data from
    !! the element database.
    !! Element properties include the mass, charge, radius, and reference energy
    !! of the element.
    implicit none

    ! Arguments
    class(element_type), intent(inout) :: this
    !! Parent. Instance of element_type.
    character(len=3), intent(in) :: name
    !! Element name.
    logical, intent(out), optional :: in_database
    !! Boolean whether pair is in database.

    ! Local variables
    integer :: i
    !! Loop index.
    character(256) :: warn_msg
    !! Warning message.


    if(present(in_database)) in_database = .false.
    if(allocated(element_database))then
       do i = 1, size(element_database)
          if(trim(element_database(i)%name) .eq. trim(name))then
             this%name = element_database(i)%name
             this%mass = element_database(i)%mass
             this%charge = element_database(i)%charge
             this%radius = element_database(i)%radius
             this%energy = element_database(i)%energy
             if(present(in_database)) in_database = .true.
             return
          end if
       end do
    end if

    write(warn_msg,'("Element ",A," not found in element database")') trim(name)
    call print_warning(warn_msg)

  end subroutine set_element
!###############################################################################


!###############################################################################
  subroutine set_bond(this, element_1, element_2, in_database)
    !! Set the bond properties for a pair of elements.
    !!
    !! This subroutine sets the properties of a bond instance with data from
    !! the bond database.
    !! Bond properties include the covalent radius of the bond.
    implicit none

    ! Arguments
    class(element_bond_type), intent(inout) :: this
    !! Parent. Instance of element_bond_type.
    character(len=3), intent(in) :: element_1, element_2
    !! Element names.
    logical, intent(out), optional :: in_database
    !! Boolean whether pair is in database.

    ! Local variables
    integer :: i
    !! Loop index.
    character(256) :: warn_msg
    !! Warning message.


    if(present(in_database)) in_database = .false.
    if(allocated(element_bond_database))then
       do i = 1, size(element_bond_database)
          if( &
               ( &
                    trim(element_bond_database(i)%element(1)) .eq. &
                    trim(element_1) .and. &
                    ( &
                         trim(element_bond_database(i)%element(2)) .eq. &
                         trim(element_2) &
                    ) &
               ) .or. ( &
                    trim(element_bond_database(i)%element(1)) .eq. &
                    trim(element_2) .and. &
                    ( &
                         trim(element_bond_database(i)%element(2)) .eq. &
                         trim(element_1) &
                    ) &
               ) &
          )then
             this%element = element_bond_database(i)%element
             this%radius_covalent = element_bond_database(i)%radius_covalent
             if(present(in_database)) in_database = .true.
             return
          end if
       end do
    end if

    write(warn_msg, &
         '("Bond between ",A," and ",A," not found in bond database")' &
    ) &
         trim(element_1), trim(element_2)
    call print_warning(warn_msg)

  end subroutine set_bond
!###############################################################################

end module raffle__element_utils

program test_geom_rw
  !! Test program for the module geom_rw.
  use raffle__constants, only: pi,real32
  use raffle__geom_rw, only: &
       basis_type, &
       geom_read, geom_write, &
       igeom_input, igeom_output, &
       get_element_properties
  implicit none

  integer :: unit, iostat, i
  real(real32) :: mass, charge, radius
  type(basis_type) :: bas1, bas2
  class(basis_type), allocatable :: bas
  real(real32), dimension(3,3) :: atoms

  character(len=256) :: cwd, filename = 'test/data/POSCAR_Si'
  logical :: exist, check
  logical :: success = .true.
  character(len=3), dimension(118) :: element_list
  real(real32), dimension(:,:), allocatable :: positions


  ! Read the geometry
  call getcwd(cwd)
  filename = trim(cwd)//"/"//filename
  inquire(file=trim(filename), exist=exist)
  if(.not.exist) then
     write(0,*) "Filepath: ", filename
     write(0,*) 'Geometry file not found'
     success = .false.
     stop 1
  end if
  open(newunit=unit, file=trim(filename), status='old', action='read')
  call geom_read(unit, bas1, iostat=iostat)
  if(iostat .ne. 0) then
     write(0,*) 'Geometry read failed'
     success = .false.
  end if
  close(unit)


  !-----------------------------------------------------------------------------
  ! test basis_type initialisation
  !-----------------------------------------------------------------------------
  bas = basis_type(bas1)
  check = compare_bas(bas, bas1)
  if(.not.check)then
     write(0,*) 'basis_type initialisation failed'
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! test allocate_species
  !-----------------------------------------------------------------------------
  call bas%allocate_species()
  if(bas%nspec .ne. 1) then
     write(0,*) 'allocate_species failed, nspec changed'
     write(0,*) bas%nspec
     success = .false.
  end if
  call bas%allocate_species()
  if(size(bas%spec,1) .ne. bas%nspec) then
     write(0,*) 'allocate_species failed, spec array size not equal to nspec'
     write(0,*) bas%nspec
     success = .false.
  end if
  call bas%allocate_species(2)
  if(bas%nspec .ne. 2 .or. size(bas%spec,1) .ne. 2) then
     write(0,*) 'allocate_species failed, &
          &nspec or spec array size not equal to 2'
     write(0,*) bas%nspec
     success = .false.
  end if
  atoms(1,:3) = [0.0, 0.0, 0.0]
  atoms(2,:3) = [0.5, 0.5, 0.5]
  atoms(3,:3) = [0.0, 0.0, 0.5]
  call bas%allocate_species( &
       num_species = 2, &
       species_symbols = ['Si ', 'O  '], &
       species_count = [1, 2], &
       atoms = atoms &
  )
  if(bas%nspec .ne. 2 .or. size(bas%spec,1) .ne. 2) then
     write(0,*) 'allocate_species failed, &
          &nspec or spec array size not equal to 2'
     write(0,*) bas%nspec
     success = .false.
  end if
  if(bas%spec(1)%num .ne. 1 .or. bas%spec(2)%num .ne. 2) then
     write(0,*) 'allocate_species failed, &
          &num not equal to species_count'
     write(0,*) bas%spec(1)%num, bas%spec(2)%num
     success = .false.
  end if
  if(trim(bas%spec(1)%name) .ne. 'Si' .or. trim(bas%spec(2)%name) .ne. 'O') then
     write(0,*) 'allocate_species failed, &
          &name not equal to species_symbols'
     write(0,*) bas%spec(1)%name, bas%spec(2)%name
     success = .false.
  end if
  if(any(abs(bas%spec(2)%atom(1,1:3) - 0.5).gt.1.E-6))then
     write(0,*) 'allocate_species failed, atom positions not equal to atoms'
     write(0,*) bas%spec(2)%atom(1,1:3)
     success = .false.
  end if



  !-----------------------------------------------------------------------------
  ! test VASP geometry read/write
  !-----------------------------------------------------------------------------
  igeom_input = 1
  igeom_output = 1
  ! Write the geometry
  open(newunit=unit, status='scratch')
  call geom_write(unit, bas1)
  rewind(unit)
  call geom_read(unit, bas2, iostat=iostat)
  if(iostat .ne. 0) then
     write(0,*) 'Geometry read or write failed'
     success = .false.
  end if
  close(unit)
  check = compare_bas(bas1, bas2)
  if(.not.check)then
     write(0,*) 'VASP geometry read/write failed'
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! test extXYZ geometry read/write
  !-----------------------------------------------------------------------------
  bas1%energy = 12.E0
  bas1%sysname = ""
  call uninitialise_bas(bas2)
  igeom_input = 6
  igeom_output = 6
  ! Write the geometry
  open(newunit=unit, status='scratch')
  call geom_write(unit, bas1)
  rewind(unit)
  call geom_read(unit, bas2, iostat=iostat)
  if(iostat .ne. 0) then
     write(0,*) 'Geometry read or write failed'
     success = .false.
  end if
  close(unit)
  check = compare_bas(bas1, bas2)
  if(.not.check)then
     write(0,*) 'extXYZ geometry read/write failed'
     success = .false.
  end if

  
  !-----------------------------------------------------------------------------
  ! test copy geometry
  !-----------------------------------------------------------------------------
  call uninitialise_bas(bas2)
  call bas2%copy(bas1)
  check = compare_bas(bas1, bas2)
  if(.not.check) success = .false.

  
  !-----------------------------------------------------------------------------
  ! test coordinate system conversion
  !-----------------------------------------------------------------------------
  allocate(positions(bas1%spec(1)%num, 3))
  do i = 1, bas1%spec(1)%num
     positions(i,:) = matmul(bas1%lat, bas1%spec(1)%atom(i,:3))
  end do
  call bas1%convert()
  if(.not.bas1%lcart) then
     write(0,*) 'Coordinate system conversion failed, lcart check failed'
     write(*,*) bas1%lcart
     success = .false.
  end if
  if(any(abs(positions - bas1%spec(1)%atom(:,:3)).gt.1.E-6)) then
     write(0,*) 'Coordinate system conversion failed, atom positions &
          &check failed'
     success = .false.
  end if

  
  !-----------------------------------------------------------------------------
  ! test element parameters
  !-----------------------------------------------------------------------------
  if(abs(bas1%spec(1)%mass - 28.085E0).gt.1.E-6) then
     write(0,*) 'Element parameters failed, mass check failed'
     write(0,*) bas1%spec(1)%mass
     success = .false.
  end if
  if(abs(bas1%spec(1)%charge - 14.0E0).gt.1.E-6) then
     write(0,*) 'Element parameters failed, charge check failed'
     write(0,*) bas1%spec(1)%charge
     success = .false.
  end if
  if(abs(bas1%spec(1)%radius - 1.11E0).gt.1.E-6) then
     write(0,*) 'Element parameters failed, radius check failed'
     write(0,*) bas1%spec(1)%radius
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! test element properties
  !-----------------------------------------------------------------------------
  element_list = [ &
       'H  ', 'He ', &
       'Li ', 'Be ', 'B  ', 'C  ', 'N  ', 'O  ', 'F  ', 'Ne ', &
       'Na ', 'Mg ', 'Al ', 'Si ', 'P  ', 'S  ', 'Cl ', 'Ar ', &
       'K  ', 'Ca ', &
       'Sc ', 'Ti ', 'V  ', 'Cr ', 'Mn ', 'Fe ', 'Co ', 'Ni ', 'Cu ', 'Zn ', &
       'Ga ', 'Ge ', 'As ', 'Se ', 'Br ', 'Kr ', &
       'Rb ', 'Sr ', 'Y  ', &
       'Zr ', 'Nb ', 'Mo ', 'Tc ', 'Ru ', 'Rh ', 'Pd ', 'Ag ', 'Cd ', &
       'In ', 'Sn ', 'Sb ', 'Te ', 'I  ', 'Xe ', &
       'Cs ', 'Ba ', 'La ', &
       'Ce ', 'Pr ', 'Nd ', 'Pm ', 'Sm ', 'Eu ', 'Gd ', 'Tb ', 'Dy ', &
       'Ho ', 'Er ', 'Tm ', 'Yb ', 'Lu ', &
       'Hf ', 'Ta ', 'W  ', 'Re ', 'Os ', 'Ir ', 'Pt ', 'Au ', 'Hg ', &
       'Tl ', 'Pb ', 'Bi ', 'Po ', 'At ', 'Rn ', &
       'Fr ', 'Ra ', 'Ac ', &
       'Th ', 'Pa ', 'U  ', 'Np ', 'Pu ', 'Am ', 'Cm ', 'Bk ', 'Cf ', &
       'Es ', 'Fm ', 'Md ', 'No ', 'Lr ', &
       'Rf ', 'Db ', 'Sg ', 'Bh ', 'Hs ', 'Mt ', 'Ds ', &
       'Rg ', 'Cn ', 'Nh ', 'Fl ', 'Mc ', 'Lv ', 'Ts ', 'Og ' &
  ]

  do i = 1, size(element_list)
     call get_element_properties(element_list(i), &
          mass = mass, &
          charge = charge, &
          radius = radius &
     )
     if(mass.lt.1.E-6) then
        write(0,*) 'Element properties failed, mass check failed'
        write(*,*) element_list(i), mass
        success = .false.
     end if
     if(charge.lt.1.E-6) then
        write(0,*) 'Element properties failed, charge check failed'
        write(*,*) element_list(i), charge
        success = .false.
     end if
     if(radius.lt.1.E-6) then
        write(0,*) 'Element properties failed, radius check failed'
        write(*,*) element_list(i), radius
        success = .false.
     end if
  end do

  call get_element_properties('X  ', &
       mass = mass, &
       charge = charge, &
       radius = radius &
  )
  if(mass.gt.1.E-6) then
     write(0,*) 'Element properties failed, mass check failed'
     write(*,*) 'X', mass
     success = .false.
  end if
  if(charge.gt.1.E-6) then
     write(0,*) 'Element properties failed, charge check failed'
     write(*,*) 'X', charge
     success = .false.
  end if
  if(radius.gt.1.E-6) then
     write(0,*) 'Element properties failed, radius check failed'
     write(*,*) 'X', radius
     success = .false.
  end if


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_geom_rw passed all tests'
  else
     write(0,*) 'test_geom_rw failed one or more tests'
     stop 1
  end if


contains

  function compare_bas(bas1, bas2) result(output)
    type(basis_type), intent(in) :: bas1, bas2
    logical :: output
    output = .true.

    ! Compare the geometries
    if(any(abs(bas1%lat - bas2%lat).gt.1.E-6)) then
       write(0,*) 'Geometry read/write failed, lattice check failed'
       output = .false.
    end if
    if(bas1%sysname .ne. bas2%sysname) then
       write(0,*) 'Geometry read/write failed, system name check failed'
       write(0,*) bas1%sysname, bas2%sysname
       output = .false.
    end if
    if(bas1%natom .ne. bas2%natom) then
       write(0,*) 'Geometry read/write failed, number of atoms check failed'
       write(0,*) bas1%natom, bas2%natom
       output = .false.
    end if
    if(abs(bas1%energy - bas2%energy).gt.1.E-6) then
       write(0,*) 'Geometry read/write failed, energy check failed'
       write(0,*) bas1%energy, bas2%energy
       output = .false.
    end if

  end function compare_bas

  subroutine uninitialise_bas(bas)
    implicit none
    type(basis_type), intent(inout) :: bas

    bas%natom = 0
    bas%nspec = 0
    bas%lat = 0.E0
    bas%energy = 0.E0
    bas%sysname = ""
    bas%lcart = .false.
    bas%pbc = .true.
    deallocate(bas%spec)
    
  end subroutine uninitialise_bas

end program test_geom_rw

program test_misc_linalg
  use raffle__io_utils
  use raffle__misc_linalg
  use raffle__constants, only: real32, pi
  implicit none

  logical :: success = .true.

  test_error_handling = .true.


  call test_modu(success)
  call test_cross(success)
  call test_get_distance(success)
  call test_get_angle_from_vectors(success)
  call test_get_angle_from_points(success)
  call test_get_dihedral_angle_from_vectors(success)
  call test_get_dihedral_angle_from_points(success)
  call test_inverse_3x3(success)


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_misc_linalg passed all tests'
  else
     write(0,*) 'test_misc_linalg failed one or more tests'
     stop 1
  end if

contains

  subroutine test_modu(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: vector
    real(real32) :: result
    vector = [3.0_real32, 4.0_real32, 0.0_real32]
    result = modu(vector)
    call assert_almost_equal_scalar( &
         result, 5.0_real32, 1.E-6_real32, &
         "modu", success &
    )
  end subroutine test_modu

  subroutine test_cross(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: a, b, result
    a = [1.0_real32, 0.0_real32, 0.0_real32]
    b = [0.0_real32, 1.0_real32, 0.0_real32]
    result = cross(a, b)
    call assert_almost_equal_vector( &
         result, [0.0_real32, 0.0_real32, 1.0_real32], 1.E-6_real32, &
         "cross", success &
    )
  end subroutine test_cross

  subroutine test_get_distance(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: point1, point2
    real(real32) :: result
    point1 = [1.0_real32, 2.0_real32, 3.0_real32]
    point2 = [4.0_real32, 6.0_real32, 8.0_real32]
    result = get_distance(point1, point2)
    call assert_almost_equal_scalar( &
         result, 7.0710678118654755_real32, 1.E-6_real32, &
         "get_angle_from_vectors", success &
    )
  end subroutine test_get_distance

  subroutine test_get_angle_from_vectors(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: vector1, vector2
    real(real32) :: result
    vector1 = [1.0_real32, 0.0_real32, 0.0_real32]
    vector2 = [0.0_real32, 1.0_real32, 0.0_real32]
    result = get_angle(vector1, vector2)
    call assert_almost_equal_scalar( &
         result, pi/2.0_real32, 1.E-6_real32, &
         "get_angle_from_vectors", success &
    )
  end subroutine test_get_angle_from_vectors

  subroutine test_get_angle_from_points(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: point1, point2, point3
    real(real32) :: result
    point1 = [1.0_real32, 0.0_real32, 0.0_real32]
    point2 = [0.0_real32, 0.0_real32, 0.0_real32]
    point3 = [0.0_real32, 1.0_real32, 0.0_real32]
    result = get_angle(point1, point2, point3)
    call assert_almost_equal_scalar( &
         result, pi/2.0_real32, 1.E-6_real32, &
         "get_angle_from_points", success &
    )
  end subroutine test_get_angle_from_points

  subroutine test_get_dihedral_angle_from_vectors(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: vector1, vector2, vector3
    real(real32) :: result
    vector1 = [1.0_real32, 0.0_real32, 0.0_real32]
    vector2 = [0.0_real32, 1.0_real32, 0.0_real32]
    vector3 = [1.0_real32, 0.0_real32, 0.0_real32]
    result = get_dihedral_angle(vector1, vector2, vector3)
    call assert_almost_equal_scalar( &
         result, pi/2.0_real32, 1.E-6_real32, &
         "get_dihedral_angle_from_vectors", success &
    )
  end subroutine test_get_dihedral_angle_from_vectors

  subroutine test_get_dihedral_angle_from_points(success)
    logical, intent(inout) :: success
    real(real32), dimension(3) :: point1, point2, point3, point4
    real(real32) :: result
    point1 = [1.0_real32, 0.0_real32, 0.0_real32]
    point2 = [0.0_real32, 0.0_real32, 0.0_real32]
    point3 = [0.0_real32, 1.0_real32, 0.0_real32]
    point4 = [1.0_real32, 0.0_real32, .0_real32]
    result = get_dihedral_angle(point1, point2, point3, point4)
    call assert_almost_equal_scalar( &
         result, pi/2.0_real32, 1.E-6_real32, &
         "get_dihedral_angle_from_points", success &
    )
  end subroutine test_get_dihedral_angle_from_points

  subroutine test_inverse_3x3(success)
    logical, intent(inout) :: success
    real(real32), dimension(3,3) :: matrix, result, expected
    matrix = reshape([ &
         4.0_real32, 3.0_real32, 0.0_real32, &
         3.0_real32, 2.0_real32, 1.0_real32, &
         0.0_real32, 1.0_real32, 1.0_real32 &
    ], [3,3])
    expected = reshape([ &
         -1.0_real32, 3.0_real32, -3.0_real32, &
         3.0_real32, -4.0_real32, 4.0_real32, &
         -3.0_real32, 4.0_real32, 1.0_real32 &
    ], [3,3])
    expected = expected / 5.0_real32
    result = inverse_3x3(matrix)
    call assert_almost_equal_matrix( &
         result, expected, 1.E-6_real32, "inverse_3x3", success &
    )
  end subroutine test_inverse_3x3

  subroutine assert_almost_equal_scalar(actual, expected, tol, message, success)
    real(real32), intent(in) :: actual
    real(real32), intent(in) :: expected
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    real(real32), intent(in) :: tol

    if( abs(actual - expected) .gt. tol ) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert_almost_equal_scalar

  subroutine assert_almost_equal_vector(actual, expected, tol, message, success)
    real(real32), dimension(:), intent(in) :: actual
    real(real32), dimension(..), intent(in) :: expected
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    real(real32), intent(in) :: tol

    select rank(expected)
    rank(0)
       if( any( abs(actual - expected) .gt. tol ) ) then
          write(0,*) "Test failed: ", message
          success = .false.
       end if
    rank(1)
       if( any( abs(actual - expected) .gt. tol ) ) then
          write(0,*) "Test failed: ", message
          success = .false.
       end if
    end select
  end subroutine assert_almost_equal_vector

  subroutine assert_almost_equal_matrix(actual, expected, tol, message, success)
    real(real32), dimension(:,:), intent(in) :: actual
    real(real32), dimension(..), intent(in) :: expected
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    real(real32), intent(in) :: tol

    select rank(expected)
    rank(0)
       if( any( abs(actual - expected) .gt. tol ) ) then
          write(0,*) "Test failed: ", message
          success = .false.
       end if
    rank(2)
       if( any( abs(actual - expected) .gt. tol ) ) then
          write(0,*) "Test failed: ", message
          success = .false.
       end if
    end select
  end subroutine assert_almost_equal_matrix

end program test_misc_linalg

module raffle__geom_rw
  !! Module to store, read and write geometry files
  !!
  !! This module contains the procedures to read and write geometry files.
  !! It also contains the derived types used to store the geometry data.
  use raffle__constants, only: pi,real32
  use raffle__io_utils, only: stop_program, print_warning
  use raffle__misc, only: to_upper, to_lower, jump, icount, strip_null
  use raffle__misc_linalg, only: modu, inverse_3x3
  implicit none


  private

  public :: igeom_input, igeom_output
  public :: basis_type, species_type
  public :: geom_read, geom_write
  public :: get_element_properties


  integer :: igeom_input = 1
  !! geometry input file format
  !! 1 = VASP
  ! 2 = CASTEP
  !! 3 = Quantum Espresso
  !! 4 = CRYSTAL
  !! 5 = XYZ
  !! 6 = extended XYZ
  integer :: igeom_output = 1
  !! geometry output file format

  type :: species_type
     !! Derived type to store information about a species/element.
     real(real32), allocatable ,dimension(:,:) :: atom
     !! The atomic positions of the species.
     real(real32) :: mass
     !! The mass of the species.
     real(real32) :: charge
     !! The charge of the species.
     real(real32) :: radius
     !! The radius of the species.
     character(len=3) :: name
     !! The name of the species.
     integer :: num
     !! The number of atoms of this species.
  end type species_type
  type :: basis_type
     !! Derived type to store information about a basis.
     type(species_type), allocatable, dimension(:) :: spec
     !! Information about each species in the basis.
     integer :: nspec = 0
     !! The number of species in the basis.
     integer :: natom = 0
     !! The number of atoms in the basis.
     real(real32) :: energy = 0._real32
     !! The energy of the basis.
     real(real32) :: lat(3,3) = 0._real32
     !! The lattice vectors of the basis.
     logical :: lcart = .false.
     !! Boolean whether the basis is in cartesian coordinates.
     logical, dimension(3) :: pbc = .true.
     !! Boolean whether the basis has periodic boundary conditions.
     character(len=128) :: sysname = "default"
     !! The name of the system.
   contains
     procedure, pass(this) :: allocate_species
     !! Procedure to allocate the species in the basis.
     procedure, pass(this) :: convert
     !! Procedure to convert the basis to cartesian coordinates.
     procedure, pass(this) :: copy
     !! Procedure to copy the basis.
     procedure, pass(this) :: get_lattice_constants
     !! Procedure to get the lattice constants of the basis.
     procedure, pass(this) :: remove_atom
     !! Procedure to remove an atom from the basis.
     procedure, pass(this) :: remove_atoms
     !! Procedure to remove atoms from the basis.
  end type basis_type


  interface basis_type
     module function init_basis_type(basis) result(output)
       !! Initialise the basis type.
       type(basis_type), intent(in), optional :: basis
       !! Optional. Basis to copy.
       type(basis_type) :: output
       !! The basis to initialise.
     end function init_basis_type
  end interface basis_type



contains

!###############################################################################
  module function init_basis_type(basis) result(output)
    !! Initialise the basis type.
    implicit none

    ! Arguments
    type(basis_type), intent(in), optional :: basis
    !! Optional. Basis to copy.
    type(basis_type) :: output
    !! The basis to initialise.

    if(present(basis)) call output%copy(basis)

  end function init_basis_type
!###############################################################################


!###############################################################################
  subroutine allocate_species( &
       this, num_species, &
       species_symbols, species_count, atoms )
    !! Allocate the species in the basis.
    implicit none

    ! Arguments
    class(basis_type), intent(inout) :: this
    !! Parent. The basis to allocate the species in.
    integer, intent(in), optional :: num_species
    !! Optional. The number of species in the basis.
    character(3), dimension(:), intent(in), optional :: species_symbols
    !! Optional. The symbols of the species.
    integer, dimension(:), intent(in), optional :: species_count
    !! Optional. The number of atoms of each species.
    real(real32), dimension(:,:), intent(in), optional :: atoms
    !! Optional. The atomic positions of the species.
    
    ! Local variables
    integer :: i, istart, iend
    !! Loop index.

    if(present(num_species)) this%nspec = num_species

    if(allocated(this%spec)) deallocate(this%spec)
    allocate(this%spec(this%nspec))

    species_check: if(present(species_symbols))then
       if(size(species_symbols).ne.this%nspec) exit species_check
       this%spec(:)%name = species_symbols
    end if species_check

    natom_check: if(present(species_count))then
       if(size(species_count).ne.this%nspec) exit natom_check
       this%spec(:)%num = species_count
       istart = 1
       do i = 1, this%nspec
          iend = istart + this%spec(i)%num - 1
          allocate(this%spec(i)%atom(this%spec(i)%num,3))
          if(present(atoms))then
             this%spec(i)%atom = atoms(istart:iend,:3)
          end if
          istart = iend + 1
       end do
    end if natom_check
    
    do i = 1, this%nspec
       call get_element_properties( &
            this%spec(i)%name, &
            mass = this%spec(i)%mass, &
            charge = this%spec(i)%charge, &
            radius = this%spec(i)%radius )
    end do
       
  end subroutine allocate_species
!###############################################################################

  
!###############################################################################
  subroutine geom_read(UNIT, basis, length, iostat)
    !! Read geometry from a file.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to read from.
    type(basis_type), intent(out) :: basis
    !! The basis to read the geometry into.
    integer, optional, intent(in) :: length
    !! Optional. The dimension of the basis atom positions.
    integer, optional, intent(out) :: iostat
    !! Optional. The I/O status of the read.

    ! Local variables
    integer :: i
    !! Loop index.
    integer :: length_
    !! The dimension of the basis atom positions.
    integer :: iostat_
    !! The I/O status of the read.


    length_ = 3
    iostat_ = 0
    if(present(length)) length_=length

    select case(igeom_input)
    case(1)
       call VASP_geom_read(UNIT, basis, length_, iostat_)
    case(2)
       call CASTEP_geom_read(UNIT, basis, length_)
    case(3)
       call QE_geom_read(UNIT, basis, length_)
    case(4)
       call stop_program("Not yet set up for CRYSTAL")
       return
    case(5)
       call XYZ_geom_read(UNIT, basis, length_, iostat_)
       call print_warning("XYZ file format does not contain lattice data")
    case(6)
       call extXYZ_geom_read(UNIT, basis, length_, iostat_)
    end select
    if(iostat_.ne.0) then
       if(present(iostat)) iostat = iostat_
       return
    else
       if(present(iostat)) iostat = 0
    end if
    if(length_.eq.4)then
       do i = 1, basis%nspec
          basis%spec(i)%atom(:,4)=1._real32
       end do
    end if
    do i = 1, basis%nspec
       call get_element_properties( &
            basis%spec(i)%name, &
            mass = basis%spec(i)%mass, &
            charge = basis%spec(i)%charge, &
            radius = basis%spec(i)%radius )
    end do

  end subroutine geom_read
!###############################################################################


!###############################################################################
  subroutine geom_write(UNIT, basis)
    !! Write geometry to a file.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to write to.
    class(basis_type), intent(in) :: basis
    !! The basis to write the geometry from.

    ! MAKE IT CHANGE HERE IF USER SPECIFIES LCART OR NOT
    ! AND GIVE IT THE CASTEP AND QE OPTION OF LABC !

    select case(igeom_output)
    case(1)
       call VASP_geom_write(UNIT,basis)
    case(2)
       call CASTEP_geom_write(UNIT,basis)
    case(3)
       call QE_geom_write(UNIT,basis)
    case(4)
       call stop_program("ERROR: Not yet set up for CRYSTAL")
       return
    case(5)   
       call XYZ_geom_write(UNIT,basis)
    case(6)
       call extXYZ_geom_write(UNIT,basis)
    end select

  end subroutine geom_write
!###############################################################################


!###############################################################################
  subroutine VASP_geom_read(UNIT, basis, length, iostat)
    !! Read the structure in vasp poscar style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to read from.
    type(basis_type), intent(out) :: basis
    !! The basis to read the geometry into.
    integer, intent(in), optional :: length
    !! Optional. The dimension of the basis atom positions.
    integer, intent(out), optional :: iostat
    !! Optional. The I/O status of the read.

    integer :: Reason
    !! The I/O status of the read.
    integer :: pos, count
    !! Temporary integer variables.
    real(real32) :: scal
    !! The scaling factor of the lattice.
    character(len=100) :: lspec
    !! The species names and number of each atomic species.
    character(len=1024) :: buffer
    !! Temporary character variable.
    integer :: i, j, k
    !! Loop index.
    integer :: length_
    !! The dimension of the basis atom positions.
    integer :: iostat_
    !! The I/O status of the read.


    length_ = 3
    iostat_ = 0
    !---------------------------------------------------------------------------
    ! determine dimension of basis (include translation dimension for symmetry?)
    !---------------------------------------------------------------------------
    if(present(length)) length_ = length


    !---------------------------------------------------------------------------
    ! read system name
    !---------------------------------------------------------------------------
    read(UNIT,'(A)',iostat=Reason) basis%sysname
    if(Reason.ne.0)then
       write(0,'("ERROR: The file is not in POSCAR format.")')
       write(0,*) "Expected system name, got: ",trim(basis%sysname)
       iostat_ = 1
       if(present(iostat)) iostat = iostat_
       return
    end if
    read(UNIT,*) scal


    !---------------------------------------------------------------------------
    ! read lattice
    !---------------------------------------------------------------------------
    do i = 1, 3
       read(UNIT,*) (basis%lat(i,j),j=1,3)
    end do
    basis%lat=scal*basis%lat


    !---------------------------------------------------------------------------
    ! read species names and number of each atomic species
    !---------------------------------------------------------------------------
    read(UNIT,'(A)') lspec
    basis%nspec = icount(lspec)
    allocate(basis%spec(basis%nspec))
    if(verify(lspec,' 0123456789').ne.0) then
       count=0;pos=1
       speccount: do
          i=verify(lspec(pos:), ' ')
          if (i.eq.0) exit speccount
          count=count+1
          pos=i+pos-1
          i=scan(lspec(pos:), ' ')
          if (i.eq.0) exit speccount
          basis%spec(count)%name=lspec(pos:pos+i-1)
          pos=i+pos-1
       end do speccount

       read(UNIT,*) (basis%spec(j)%num,j=1,basis%nspec)
    else !only numbers
       do count = 1, basis%nspec
          write(basis%spec(count)%name,'(I0)') count
       end do
       read(lspec,*) (basis%spec(j)%num,j=1,basis%nspec)
    end if


    !---------------------------------------------------------------------------
    ! determines whether input basis is in direct or cartesian coordinates
    !---------------------------------------------------------------------------
    basis%lcart=.false.
    read(UNIT,'(A)') buffer
    buffer = to_lower(buffer)
    if(verify(trim(buffer),'direct').eq.0) basis%lcart=.false.
    if(verify(trim(buffer),'cartesian').eq.0) basis%lcart=.true.


    !---------------------------------------------------------------------------
    ! read basis
    !---------------------------------------------------------------------------
    do i = 1, basis%nspec
       allocate(basis%spec(i)%atom(basis%spec(i)%num,length_))
       basis%spec(i)%atom(:,:)=0._real32
       do j = 1, basis%spec(i)%num
          read(UNIT,*) (basis%spec(i)%atom(j,k),k=1,3)
       end do
    end do


    !---------------------------------------------------------------------------
    ! convert basis if in cartesian coordinates
    !---------------------------------------------------------------------------
    if(basis%lcart) call basis%convert()


    !---------------------------------------------------------------------------
    ! normalise basis to between 0 and 1 in direct coordinates
    !---------------------------------------------------------------------------
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          do k = 1, 3
             basis%spec(i)%atom(j,k)=&
                  basis%spec(i)%atom(j,k)-floor(basis%spec(i)%atom(j,k))
          end do
       end do
    end do
    basis%natom=sum(basis%spec(:)%num)
 
    if(present(iostat)) iostat = iostat_
 
  end subroutine VASP_geom_read
!###############################################################################


!###############################################################################
  subroutine VASP_geom_write(UNIT, basis, cartesian)
    !! Write the structure in vasp poscar style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to write to.
    class(basis_type), intent(in) :: basis
    !! The basis to write the geometry from.
    logical, intent(in), optional :: cartesian
    !! Optional. Whether to write the basis in cartesian coordinates.

    ! Local variables
    integer :: i,j
    !! Loop index.
    character(100) :: fmt
    !! Format string.
    character(10) :: string
    !! String to determine whether to write in direct or cartesian coordinates.


    string="Direct"
    if(present(cartesian))then
       if(cartesian) string="Cartesian"
    end if

    write(UNIT,'(A)') trim(adjustl(basis%sysname))
    write(UNIT,'(F15.9)') 1._real32
    do i = 1, 3
       write(UNIT,'(3(F15.9))') basis%lat(i,:)
    end do
    write(fmt,'("(",I0,"(A,1X))")') basis%nspec
    write(UNIT,trim(adjustl(fmt))) (adjustl(basis%spec(j)%name),j=1,basis%nspec)
    write(fmt,'("(",I0,"(I0,5X))")') basis%nspec
    write(UNIT,trim(adjustl(fmt))) (basis%spec(j)%num,j=1,basis%nspec)
    write(UNIT,'(A)') trim(adjustl(string))
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          write(UNIT,'(3(F15.9))') basis%spec(i)%atom(j,1:3)
       end do
    end do

  end subroutine VASP_geom_write
!###############################################################################


!###############################################################################
  subroutine QE_geom_read(UNIT,basis,length)
    !! Read the structure in Quantum Espresso style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to read from.
    type(basis_type), intent(out) :: basis
    !! The basis to read the geometry into.
    integer, intent(in), optional :: length
    !! Optional. The dimension of the basis atom positions.

    ! Local variables
    integer :: Reason
    !! The I/O status of the read.
    integer :: i, j, k, iline
    !! Loop index.
    integer :: length_ = 3
    !! The dimension of the basis atom positions.
    integer, dimension(1000) :: tmp_natom
    !! Temporary array to store the number of atoms of each species.
    real(real32), dimension(3) :: tmpvec
    !! Temporary array to store the atomic positions.
    character(len=3) :: ctmp
    !! Temporary character variable.
    character(256) :: stop_msg
    !! Error message.
    character(len=3), dimension(1000) :: tmp_spec
    !! Temporary array to store the species names.
    character(len=1024) :: buffer, buffer2
    !! Temporary character variables.


    !---------------------------------------------------------------------------
    ! determine dimension of basis (include translation dimension for symmetry?)
    !---------------------------------------------------------------------------
    if(present(length)) length_ = length
    basis%lcart = .false.
    basis%sysname = "Converted_from_geom_file"


    !---------------------------------------------------------------------------
    ! read lattice
    !---------------------------------------------------------------------------
    rewind UNIT
    cellparam: do
       read(UNIT,'(A)',iostat=Reason) buffer
       if(Reason.ne.0)then
          call stop_program( &
               "An issue with the QE input file format has been encountered." &
          )
          return
       end if
       if(index(trim(buffer),"ibrav").ne.0)then
          write(stop_msg,*) &
               "Internal error in QE_geom_read" // &
               achar(13) // achar(10) // &
               "  Subroutine not yet set up to read IBRAV lattices"
          call stop_program(stop_msg)
          return
       end if
       if(verify("CELL_PARAMETERS",buffer).eq.0) then
          exit cellparam
       end if
    end do cellparam
    do i = 1, 3
       read(UNIT,*) (basis%lat(i,j),j=1,3)
    end do


    !---------------------------------------------------------------------------
    ! determines whether input basis is in direct or cartesian coordinates
    !---------------------------------------------------------------------------
    iline=0
    rewind UNIT
    basfind: do
       read(UNIT,'(A)',iostat=Reason) buffer
       iline=iline+1
       if(verify("ATOMIC_POSITIONS",buffer).eq.0)then
          backspace(UNIT)
          read(UNIT,*) buffer,buffer2
          if(verify("crystal",buffer2).eq.0) basis%lcart = .false.
          if(verify("angstrom",buffer2).eq.0) basis%lcart = .true.
          exit basfind
       end if
    end do basfind
 
 
    !---------------------------------------------------------------------------
    ! read basis
    !---------------------------------------------------------------------------
    basis%natom = 0
    basis%nspec = 0
    tmp_natom   = 1
    basread: do
       read(UNIT,'(A)',iostat=Reason) buffer
       read(buffer,*) ctmp
       if(Reason.ne.0) exit
       if(trim(ctmp).eq.'') exit
       if(verify(buffer,' 0123456789').eq.0) exit
       basis%natom = basis%natom + 1
       if(.not.any(tmp_spec(1:basis%nspec).eq.ctmp))then
          basis%nspec = basis%nspec + 1
          tmp_spec(basis%nspec) = ctmp
       else
          where(tmp_spec(1:basis%nspec).eq.ctmp)
             tmp_natom(1:basis%nspec) = tmp_natom(1:basis%nspec) + 1
          end where
       end if
    end do basread

    allocate(basis%spec(basis%nspec))
    basis%spec(1:basis%nspec)%name = tmp_spec(1:basis%nspec)
    do i = 1, basis%nspec
       basis%spec(i)%num = 0
       allocate(basis%spec(i)%atom(tmp_natom(i),length_))
    end do

    call jump(UNIT,iline)
    basread2: do i = 1, basis%natom
       read(UNIT,*,iostat=Reason) ctmp,tmpvec(1:3)
       do j = 1, basis%nspec
          if(basis%spec(j)%name.eq.ctmp)then
             basis%spec(j)%num = basis%spec(j)%num + 1
             basis%spec(j)%atom(basis%spec(j)%num,1:3) = tmpvec(1:3)
             exit
          end if
       end do
    end do basread2


    !---------------------------------------------------------------------------
    ! convert basis if in cartesian coordinates
    !---------------------------------------------------------------------------
    if(basis%lcart) call basis%convert()


    !---------------------------------------------------------------------------
    ! normalise basis to between 0 and 1 in direct coordinates
    !---------------------------------------------------------------------------
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          do k = 1, 3
             basis%spec(i)%atom(j,k) = &
                  basis%spec(i)%atom(j,k) - floor( basis%spec(i)%atom(j,k) )
          end do
       end do
    end do
    basis%natom=sum(basis%spec(:)%num)

  end subroutine QE_geom_read
!###############################################################################


!###############################################################################
  subroutine QE_geom_write(UNIT, basis, cartesian)
    !! Write the structure in Quantum Espresso style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to write to.
    class(basis_type), intent(in) :: basis
    !! The basis to write the geometry from.
    logical, intent(in), optional :: cartesian
    !! Optional. Whether to write the basis in cartesian coordinates.

    ! Local variables
    integer :: i,j
    !! Loop index.
    character(10) :: string
    !! String to determine whether to write in crystal or angstrom coordinates.


    string="crystal"
    if(present(cartesian))then
       if(cartesian) string="angstrom"
    end if


    write(UNIT,'("CELL_PARAMETERS angstrom")')
    do i = 1, 3
       write(UNIT,'(3(F15.9))') basis%lat(i,:)
    end do
    write(UNIT,'("ATOMIC_SPECIES")')
    do i = 1, basis%nspec
       write(UNIT,'(A)') trim(adjustl(basis%spec(i)%name))
    end do
    write(UNIT,'("ATOMIC_POSITIONS",1X,A)') trim(adjustl(string))
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          write(UNIT,'(A5,1X,3(F15.9))') &
               basis%spec(i)%name,basis%spec(i)%atom(j,1:3)
       end do
    end do

  end subroutine QE_geom_write
!###############################################################################


!###############################################################################
  subroutine CASTEP_geom_read(UNIT, basis, length)
    !! Read the structure in CASTEP style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to read from.
    type(basis_type), intent(out) :: basis
    !! The basis to read the geometry into.
    integer, intent(in), optional :: length
    !! Optional. The dimension of the basis atom positions.

    ! Local variables
    integer :: Reason
    !! The I/O status of the read.
    integer :: i, j, k, iline
    !! Loop index.
    integer :: length_ = 3
    !! The dimension of the basis atom positions.
    integer :: itmp1
    !! Temporary integer variable.
    character(len=3) :: ctmp
    !! Temporary character variable.
    character(len=20) :: units
    !! Units of the lattice vectors.
    character(len=200) :: buffer, store
    !! Temporary character variables.
    logical :: labc
    !! Logical variable to determine whether the lattice is in abc or 
    !! cartesian coordinates.
    integer, dimension(1000) :: tmp_natom
    !! Temporary array to store the number of atoms of each species.
    real(real32), dimension(3) :: abc, angle, dvtmp1
    !! Temporary arrays to store the lattice vectors.
    character(len=3), dimension(1000) :: tmp_spec
    !! Temporary array to store the species names.

   
    !---------------------------------------------------------------------------
    ! determine dimension of basis (include translation dimension for symmetry?)
    !---------------------------------------------------------------------------
    if(present(length)) length_ = length


    !---------------------------------------------------------------------------
    ! reading loop of file
    !---------------------------------------------------------------------------
    tmp_spec = ""
    tmp_natom = 0
    iline = 0
    labc = .true.
    basis%sysname = "from CASTEP"
    rewind(UNIT)
    readloop: do
       iline=iline+1
       read(UNIT,'(A)',iostat=Reason) buffer
       if(Reason.ne.0) exit
       buffer=to_upper(buffer)
       if(scan(trim(adjustl(buffer)),'%').ne.1) cycle readloop
       if(index(trim(adjustl(buffer)),'%END').eq.1) cycle readloop
       read(buffer,*) store, buffer
       if(trim(buffer).eq.'') cycle readloop
       !------------------------------------------------------------------------
       ! read lattice
       !------------------------------------------------------------------------
       lattice_if: if(index(trim(buffer),"LATTICE").eq.1)then
          if(index(trim(buffer),"ABC").ne.0) labc = .true.
          if(index(trim(buffer),"CART").ne.0) labc = .false.
          store = ""
          itmp1 = 0
          lattice_loop: do 
             itmp1 = itmp1 + 1
             read(UNIT,'(A)',iostat=Reason) buffer
             if(Reason.ne.0) exit lattice_loop
             if(scan(trim(adjustl(buffer)),'%').eq.1) exit lattice_loop
             if(itmp1.eq.5)then
                call stop_program( &
                     "Too many lines in LATTICE block of structure file" &
                )
                return
             end if
             store=trim(store)//" "//trim(buffer)
          end do lattice_loop
          iline=iline+itmp1

          if(labc)then
             read(store,*) units,(abc(i),i=1,3), (angle(j),j=1,3)
             basis%lat = convert_abc_to_lat(abc,angle,.false.)
          else
             read(store,*) units,(basis%lat(i,:),i=1,3)
          end if
          cycle readloop
       end if lattice_if

       !------------------------------------------------------------------------
       ! read basis
       !------------------------------------------------------------------------
       basis_if: if(index(trim(buffer),"POSITIONS").eq.1) then
          if(index(trim(buffer),"ABS").ne.0) basis%lcart=.true.
          if(index(trim(buffer),"FRAC").ne.0) basis%lcart=.false.
          itmp1 = 0
          basis_loop1: do
             read(UNIT,'(A)',iostat=Reason) buffer
             if(Reason.ne.0) exit basis_loop1
             if(scan(trim(adjustl(buffer)),'%').eq.1) exit basis_loop1
             read(buffer,*) ctmp
             if(trim(ctmp).eq.'') exit
             if(verify(buffer,' 0123456789').eq.0) exit
             basis%natom = basis%natom + 1
             if(.not.any(tmp_spec(1:basis%nspec).eq.ctmp))then
                basis%nspec = basis%nspec+1
                tmp_natom(basis%nspec) = 1
                tmp_spec(basis%nspec)  = ctmp
             else
                where(tmp_spec(1:basis%nspec).eq.ctmp)
                   tmp_natom(1:basis%nspec) = tmp_natom(1:basis%nspec) + 1
                end where
             end if
          end do basis_loop1

          allocate(basis%spec(basis%nspec))
          basis%spec(1:basis%nspec)%name = tmp_spec(1:basis%nspec)
          do i = 1, basis%nspec
             basis%spec(i)%num = 0
             allocate(basis%spec(i)%atom(tmp_natom(i),length_))
          end do

          call jump(UNIT,iline)
          basis_loop2: do i = 1, basis%natom
             read(UNIT,'(A)',iostat=Reason) buffer
             if(Reason.ne.0)then
                call stop_program("Internal error in assigning the basis")
                return
             end if
             read(buffer,*) ctmp,dvtmp1(1:3)
             species_loop: do j = 1, basis%nspec
                if(basis%spec(j)%name.eq.ctmp)then
                   basis%spec(j)%num = basis%spec(j)%num + 1
                   basis%spec(j)%atom(basis%spec(j)%num,1:3) = dvtmp1(1:3)
                   exit species_loop
                end if
             end do species_loop
          end do basis_loop2

       end if basis_if
    end do readloop


    !---------------------------------------------------------------------------
    ! convert basis if in cartesian coordinates
    !---------------------------------------------------------------------------
    if(basis%lcart) call basis%convert()


    !---------------------------------------------------------------------------
    ! normalise basis to between 0 and 1 in direct coordinates
    !---------------------------------------------------------------------------
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          do k = 1, 3
             basis%spec(i)%atom(j,k) = &
                  basis%spec(i)%atom(j,k) - floor( basis%spec(i)%atom(j,k) )
          end do
       end do
    end do
    basis%natom=sum(basis%spec(:)%num)

  end subroutine CASTEP_geom_read
!###############################################################################


!###############################################################################
  subroutine CASTEP_geom_write(UNIT, basis, labc, cartesian)
    !! Write the structure in CASTEP style format.
    implicit none

    ! Arguments
    integer :: UNIT
    !! The unit number of the file to write to.
    class(basis_type), intent(in) :: basis
    !! The basis to write the geometry from.
    logical, intent(in), optional :: labc
    !! Optional. Boolean whether to write the lattice in abc format.
    logical, intent(in), optional :: cartesian
    !! Optional. Boolean whether to write basis in cartesian coordinates.

    ! Local variables
    integer :: i, j
    !! Loop index.
    real(real32), dimension(2,3) :: abc_angle
    !! Temporary arrays to store the lattice vectors.
    character(4) :: string_lat, string_bas
    !! Strings specifying lattice and basis format
    character(len=256) :: stop_msg
    !! Error message.


    string_lat="CART"
    if(present(labc))then
       if(labc) string_lat="ABC"
    end if

    string_bas="FRAC"
    if(present(cartesian))then
       if(cartesian)then
          string_bas="ABS"
          write(stop_msg,*) &
               "Internal error in CASTEP_geom_write" // &
               achar(13) // achar(10) // &
               "  Subroutine not yet set up to output cartesian coordinates"
          call stop_program(stop_msg)
          return
       end if
    end if

    write(UNIT,'("%block LATTICE_",A)') trim(string_lat)
    write(UNIT,'("ang")')
    if(present(labc))then
       if(labc)then
          abc_angle = convert_lat_to_abc(basis%lat)
          write(UNIT,'(3(F15.9))') abc_angle(1,:)
          write(UNIT,'(3(F15.9))') abc_angle(2,:)
          goto 10
       end if
    end if
    do i = 1, 3
       write(UNIT,'(3(F15.9))') basis%lat(i,:)
    end do

10  write(UNIT,'("%endblock LATTICE_",A)') trim(string_lat)

    write(UNIT,*)
    write(UNIT,'("%block POSITIONS_",A)') trim(string_bas)
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          write(UNIT,'(A5,1X,3(F15.9))') &
               basis%spec(i)%name,basis%spec(i)%atom(j,1:3)
       end do
    end do
    write(UNIT,'("%endblock POSITIONS_",A)') trim(string_bas)

  end subroutine CASTEP_geom_write
!###############################################################################


!###############################################################################
  subroutine XYZ_geom_read(UNIT, basis, length, iostat)
    !! Read the structure in xyz style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to read from.
    type(basis_type), intent(out) :: basis
    !! The basis to read the geometry into.
    integer, intent(in), optional :: length
    !! Optional. The dimension of the basis atom positions.
    integer, intent(out), optional :: iostat
    !! Optional. The I/O status of the read.

    ! Local variables
    integer :: Reason
    !! The I/O status of the read.
    integer :: i, j
    !! Loop index.
    integer, allocatable, dimension(:) :: tmp_num
    !! Temporary array to store the number of atoms of each species.
    real(real32), dimension(3) :: vec
    !! Temporary array to store the atomic positions.
    real(real32), allocatable, dimension(:,:,:) :: tmp_bas
    !! Temporary array to store the atomic positions.
    character(len=3) :: ctmp
    !! Temporary character variable.
    character(len=3), allocatable, dimension(:) :: tmp_spec
    !! Temporary array to store the species names.
    integer :: length_
    !! The dimension of the basis atom positions.
    integer :: iostat_
    !! The I/O status of the read.


    length_ = 3
    iostat_ = 0
    if(present(length)) length_ = length


    read(UNIT,*,iostat=Reason) basis%natom
    if(Reason.ne.0)then
       write(0,'("ERROR: The file is not in xyz format.")')
       iostat_ = 1
       if(present(iostat)) iostat = iostat_
       return
    end if
    read(UNIT,'(A)',iostat=Reason) basis%sysname


    !---------------------------------------------------------------------------
    ! read basis
    !---------------------------------------------------------------------------
    allocate(tmp_spec(basis%natom))
    allocate(tmp_num(basis%natom))
    allocate(tmp_bas(basis%natom,basis%natom,length_))
    tmp_num(:) = 0
    tmp_spec = ""
    tmp_bas = 0
    basis%nspec = 0
    do i = 1, basis%natom
       read(UNIT,*,iostat=Reason) ctmp,vec(1:3)
       if(.not.any(tmp_spec(1:basis%nspec).eq.ctmp))then
          basis%nspec = basis%nspec + 1
          tmp_spec(basis%nspec) = ctmp
          tmp_bas(basis%nspec,1,1:3) = vec(1:3)
          tmp_num(basis%nspec) = 1
       else
          checkspec: do j = 1, basis%nspec
             if(tmp_spec(j).eq.ctmp)then
                tmp_num(j) = tmp_num(j)+1
                tmp_bas(j,tmp_num(j),1:3) = vec(1:3)
                exit checkspec
             end if
          end do checkspec
       end if
    end do
 
 
    !---------------------------------------------------------------------------
    ! move basis from temporary basis to main basis.
    ! done to allow for correct allocation of number of and per species
    !---------------------------------------------------------------------------
    allocate(basis%spec(basis%nspec))
    do i = 1, basis%nspec
       basis%spec(i)%name = tmp_spec(i)
       basis%spec(i)%num  = tmp_num(i)
       allocate(basis%spec(i)%atom(tmp_num(i),length_))
       basis%spec(i)%atom(:,:) = 0
       basis%spec(i)%atom(1:tmp_num(i),1:3) = tmp_bas(i,1:tmp_num(i),1:3)
    end do
 
    if(present(iostat)) iostat = iostat_
 
  end subroutine XYZ_geom_read
!###############################################################################


!###############################################################################
  subroutine XYZ_geom_write(UNIT,basis)
    !! Write the structure in xyz style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to write to.
    class(basis_type), intent(in) :: basis
    !! The basis to write the geometry from.

    ! Local variables
    integer :: i, j
    !! Loop index.


    write(UNIT,'("I0")') basis%natom
    write(UNIT,'("A")') basis%sysname
    do i = 1, basis%nspec
       do j = 1, basis%spec(i)%num
          write(UNIT,'(A5,1X,3(F15.9))') &
               basis%spec(i)%name,basis%spec(i)%atom(j,1:3)
       end do
    end do

  end subroutine XYZ_geom_write
!###############################################################################


!###############################################################################
  subroutine extXYZ_geom_read(UNIT, basis, length, iostat)
    !! Read the structure in extended xyz style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to read from.
    type(basis_type), intent(out) :: basis
    !! The basis to read the geometry into.
    integer, intent(in), optional :: length
    !! Optional. The dimension of the basis atom positions.
    integer, intent(out), optional :: iostat
    !! Optional. The I/O status of the read.

    ! Local variables
    integer :: Reason
    !! The I/O status of the read.
    integer :: i, j
    !! Loop index.
    integer :: index1, index2
    !! Index variables.
    integer, allocatable, dimension(:) :: tmp_num
    !! Temporary array to store the number of atoms of each species.
    real(real32), dimension(3) :: vec
    !! Temporary array to store the atomic positions.
    real(real32), allocatable, dimension(:,:,:) :: tmp_bas
    !! Temporary array to store the atomic positions.
    character(len=3) :: ctmp
    !! Temporary character variable.
    character(len=3), allocatable, dimension(:) :: tmp_spec
    !! Temporary array to store the species names.
    character(len=1024) :: buffer
    !! Temporary character variable.
    integer :: length_ = 3
    !! The dimension of the basis atom positions.
    integer :: iostat_ = 0
    !! The I/O status of the read.


    basis%lcart=.true.
    if(present(length)) length_ = length


    !---------------------------------------------------------------------------
    ! read system information
    !---------------------------------------------------------------------------
    read(UNIT,*,iostat=Reason) basis%natom
    if(Reason.ne.0)then
       write(0,'("ERROR: The file is not in xyz format.")')
       iostat_ = 1
       if(present(iostat)) iostat = iostat_
       return
    end if
    read(UNIT,'(A)',iostat=Reason) buffer
    if(Reason.ne.0)then
       write(0,'("ERROR: The file is not in xyz format.")')
       iostat_ = 1
       if(present(iostat)) iostat = iostat_
       return
    end if
    index1 = index(buffer,'Lattice="') + 9
    index2 = index(buffer(index1:),'"') + index1 - 2
    read(buffer(index1:index2),*) ( ( basis%lat(i,j), j = 1, 3), i = 1, 3)
 
    index1 = index(buffer,'free_energy=') + 12
    read(buffer(index1:),*) basis%energy
 
 
    !---------------------------------------------------------------------------
    ! read basis
    !---------------------------------------------------------------------------
    allocate(tmp_spec(basis%natom))
    allocate(tmp_num(basis%natom))
    allocate(tmp_bas(basis%natom,basis%natom,length_))
    tmp_num(:) = 0
    tmp_spec = ""
    tmp_bas = 0
    basis%nspec = 0
    do i = 1, basis%natom
       read(UNIT,*,iostat=Reason) ctmp, vec(1:3)
       if(.not.any(tmp_spec(1:basis%nspec).eq.ctmp))then
          basis%nspec=basis%nspec+1
          tmp_spec(basis%nspec) = trim(adjustl(ctmp))
          tmp_bas(basis%nspec,1,1:3) = vec(1:3)
          tmp_num(basis%nspec) = 1
       else
          checkspec: do j = 1, basis%nspec
             if(tmp_spec(j).eq.ctmp)then
                tmp_num(j) = tmp_num(j) + 1
                tmp_bas(j,tmp_num(j),1:3) = vec(1:3)
                exit checkspec
             end if
          end do checkspec
       end if
    end do
 
 
    !---------------------------------------------------------------------------
    ! move basis from temporary basis to main basis.
    ! done to allow for correct allocation of number of and per species
    !---------------------------------------------------------------------------
    allocate(basis%spec(basis%nspec))
    basis%sysname = ""
    do i = 1, basis%nspec
       basis%spec(i)%name = tmp_spec(i)
       basis%spec(i)%num = tmp_num(i)
       allocate(basis%spec(i)%atom(tmp_num(i),length_))
       basis%spec(i)%atom(:,:) = 0
       basis%spec(i)%atom(1:tmp_num(i),1:3) = tmp_bas(i,1:tmp_num(i),1:3)
       write(buffer,'(I0,A)') basis%spec(i)%num,trim(basis%spec(i)%name)
       basis%sysname = basis%sysname//trim(buffer)
       if(i.lt.basis%nspec) basis%sysname = trim(adjustl(basis%sysname))//"_"
    end do
 
    if(present(iostat)) iostat = iostat_
 
  end subroutine extXYZ_geom_read
!###############################################################################


!###############################################################################
  subroutine extXYZ_geom_write(UNIT, basis)
    !! Write the structure in extended xyz style format.
    implicit none

    ! Arguments
    integer, intent(in) :: UNIT
    !! The unit number of the file to write to.
    class(basis_type), intent(in) :: basis
    !! The basis to write the geometry from.

    ! Local variables
    integer :: i, j
    !! Loop index.


    write(UNIT,'(I0)') basis%natom
    write(UNIT,'(A,8(F0.8,1X),F0.8,A)', advance="no") &
         'Lattice="',((basis%lat(i,j),j=1,3),i=1,3),'"'
    write(UNIT,'(A,F0.8)', advance="no") ' free_energy=',basis%energy
    write(UNIT,'(A)', advance="no") ' pbc="T T T"'
    if(basis%lcart)then
       do i = 1, basis%nspec
          do j = 1, basis%spec(i)%num
             write(UNIT,'(A8,3(1X, F16.8))') &
                  basis%spec(i)%name,basis%spec(i)%atom(j,1:3)
          end do
       end do
    else
       do i = 1, basis%nspec
          do j = 1, basis%spec(i)%num
             write(UNIT,'(A8,3(1X, F16.8))') basis%spec(i)%name, &
                  matmul(basis%spec(i)%atom(j,1:3),basis%lat)
          end do
       end do
    end if

  end subroutine extXYZ_geom_write
!###############################################################################


!###############################################################################
  subroutine convert(this)
    !! Convert the basis between direct and cartesian coordinates.
    implicit none
   
    ! Arguments
    class(basis_type), intent(inout) :: this
    !! Parent. The basis to convert.

    ! Local variables
    integer :: is, ia
    !! Loop index.
    real(real32), dimension(3,3) :: lattice
    !! The reciprocal lattice vectors.

   
    if(this%lcart)then
       lattice = inverse_3x3( this%lat )
    else
       lattice = this%lat
    end if

    this%lcart = .not.this%lcart
    do is = 1, this%nspec
       do ia = 1, this%spec(is)%num
          this%spec(is)%atom(ia,1:3) = &
               matmul( this%spec(is)%atom(ia,1:3), lattice )
       end do
    end do
   
  end subroutine convert
!###############################################################################


!#############################################################################
  function convert_abc_to_lat(abc,angle,radians) result(lattice)
    !! Convert the lattice from abc and αβγ to lattice matrix.
    implicit none

    ! Arguments
    real(real32), dimension(3), intent(in) :: abc, angle
    !! lattice constants
    logical, intent(in), optional :: radians
    !! Optional. Boolean whether angles are in radians.
    real(real32), dimension(3,3) :: lattice
    !! The lattice matrix.

    ! Local variables
    real(real32), dimension(3) :: in_angle
    !! The lattice angles in radians.



    in_angle = angle
    if(present(radians))then
       if(.not.radians) in_angle = angle*pi/180._real32
    end if

    lattice=0._real32

    lattice(1,1)=abc(1)
    lattice(2,:2)=(/abc(2)*cos(in_angle(3)),abc(2)*sin(in_angle(3))/)

    lattice(3,1) = abc(3)*cos(in_angle(2))
    lattice(3,2) = abc(3)*(cos(in_angle(1)) - cos(in_angle(2))*&
         cos(in_angle(3)))/sin(in_angle(3))
    lattice(3,3) = sqrt(abc(3)**2._real32 - &
         lattice(3,1)**2._real32 - &
         lattice(3,2)**2._real32)

  end function convert_abc_to_lat
!###############################################################################


!###############################################################################
  function convert_lat_to_abc(lattice, radians) result(abc_angle)
    !! Convert the lattice from lattice matrix to abc and αβγ.
    implicit none

    ! Arguments
    real(real32), dimension(3,3), intent(in) :: lattice
    !! The lattice matrix.
    logical, intent(in), optional :: radians
    !! Optional. Boolean whether to return angles in radians.
    real(real32), dimension(2,3) :: abc_angle
    !! The lattice constants and angles.

    ! Local variables
    integer :: i
    !! Loop index.


    do i = 1, 3
       abc_angle(1,i)=modu(lattice(i,:))
    end do
    do i = 1, 3
    end do
    abc_angle(2,1)=acos(dot_product(lattice(2,:),lattice(3,:))/&
         (abc_angle(1,2)*abc_angle(1,3)))
    abc_angle(2,3)=acos(dot_product(lattice(1,:),lattice(3,:))/&
         (abc_angle(1,1)*abc_angle(1,3)))
    abc_angle(2,3)=acos(dot_product(lattice(1,:),lattice(2,:))/&
         (abc_angle(1,1)*abc_angle(1,2)))

    if(present(radians))then
       if(.not.radians) abc_angle(2,:)=abc_angle(2,:)*180._real32/pi
    end if

  end function convert_lat_to_abc
!###############################################################################


!###############################################################################
  function get_lattice_constants(this, radians) result(output)
    !! Convert the lattice from lattice matrix to abc and αβγ.
    implicit none

    ! Arguments
    class(basis_type), intent(in) :: this
    !! Parent. The basis.
    logical, intent(in), optional :: radians
    !! Optional. Boolean whether to return angles in radians.
    real(real32), dimension(2,3) :: output
    !! The lattice constants and angles.

    ! Local variables
    logical :: radians_
    !! Boolean whether to return angles in radians.


    radians_ = .true.
    if(present(radians)) radians_ = radians

    output = convert_lat_to_abc(this%lat, radians_)

  end function get_lattice_constants
!###############################################################################


!###############################################################################
  subroutine copy(this, basis, length)
    !! Copy the basis.
    implicit none

    ! Arguments
    class(basis_type), intent(inout) :: this
    !! Parent. The basis to copy into.
    class(basis_type), intent(in) :: basis
    !! The basis to copy from.
    integer, intent(in), optional :: length
    !! The dimension of the basis atom positions.


    ! Local variables
    integer :: i
    !! Loop index.
    integer :: length_, length_input
    !! The dimension of the basis atom positions.


    !---------------------------------------------------------------------------
    ! determines whether user wants output basis extra translational dimension
    !---------------------------------------------------------------------------
    length_input = size(basis%spec(1)%atom(1,:),dim=1)
    if(present(length))then
       length_ = length
    else
       length_ = length_input
    end if


    !---------------------------------------------------------------------------
    ! if already allocated, deallocates output basis
    !---------------------------------------------------------------------------
    if(allocated(this%spec))then
       do i = 1, this%nspec
          if(allocated(this%spec(i)%atom)) deallocate(this%spec(i)%atom)
       end do
       deallocate(this%spec)
    end if


    !---------------------------------------------------------------------------
    ! allocates output basis and clones data from input basis to output basis
    !---------------------------------------------------------------------------
    allocate(this%spec(basis%nspec))
    do i = 1, basis%nspec
       allocate(this%spec(i)%atom(&
            basis%spec(i)%num,length_))

       this%spec(i)%atom(:,:3) = basis%spec(i)%atom(:,:3)
       if(length_input.eq.length_)then
          this%spec(i)%atom(:,:length_) = basis%spec(i)%atom(:,:length_)
       elseif(length_input.gt.length_)then
          this%spec(i)%atom(:,:3) = basis%spec(i)%atom(:,:3)
       elseif(length_input.lt.length_)then
          this%spec(i)%atom(:,:3) = basis%spec(i)%atom(:,:3)
          this%spec(i)%atom(:,4) = 1._real32
       end if
       this%spec(i)%num = basis%spec(i)%num
       this%spec(i)%name = strip_null(basis%spec(i)%name)

       this%spec(i)%mass = basis%spec(i)%mass
       this%spec(i)%charge = basis%spec(i)%charge
       this%spec(i)%radius = basis%spec(i)%radius
    end do
    this%nspec = basis%nspec
    this%natom = basis%natom
    this%lcart = basis%lcart
    this%sysname = basis%sysname
    this%energy = basis%energy
    this%lat = basis%lat
    this%pbc = basis%pbc

  end subroutine copy
!###############################################################################


!###############################################################################
  subroutine remove_atom(this, ispec, iatom)
    !! Remove an atom from the basis.
    implicit none

    ! Arguments
    class(basis_type), intent(inout) :: this
    !! Parent. The basis.
    integer, intent(in) :: ispec, iatom
    !! The species and atom to remove.

    ! Local variables
    integer :: i
    !! Loop index.
    real(real32), dimension(:,:), allocatable :: atom
    !! Temporary array to store the atomic positions.


    !---------------------------------------------------------------------------
    ! remove atom from basis
    !---------------------------------------------------------------------------
    do i = 1, this%nspec
       if(i.eq.ispec)then
          if(iatom.gt.this%spec(i)%num)then
             call stop_program("Atom to remove does not exist")
             return
          end if
          allocate(atom(this%spec(i)%num-1,size(this%spec(i)%atom,2)))
          atom(1:iatom-1:1,:) = this%spec(i)%atom(1:iatom-1:1,:)
          atom(iatom:this%spec(i)%num-1:1,:) = &
               this%spec(i)%atom(iatom+1:this%spec(i)%num:1,:)
          this%spec(i)%atom = atom
          deallocate(atom)
          this%spec(i)%num = this%spec(i)%num - 1
          this%natom = this%natom - 1
          if(this%spec(i)%num.eq.0)then
             deallocate(this%spec(i)%atom)
             if(this%nspec.eq.0)then
                deallocate(this%spec)
                this%lcart = .true.
                this%sysname = ""
                this%energy = 0._real32
                this%lat = 0._real32
                this%pbc = .true.
             end if
          end if
       end if
    end do

  end subroutine remove_atom
!###############################################################################


!###############################################################################
  subroutine remove_atoms(this, atoms)
    !! Remove atoms from the basis.
    use raffle__misc, only: swap
    implicit none

    ! Arguments
    class(basis_type), intent(inout) :: this
    !! Parent. The basis.
    integer, dimension(:,:), intent(in) :: atoms
    !! The atoms to remove (2, number of atoms to remove)
    !! 1st value of 1st dimension is the species number
    !! 2nd value of 1st dimension is the atom number
    !! 2nd dimension is the number of atoms to remove

    ! Local variables
    integer :: is, ia, i
    !! Loop index.
    integer :: n, m, start_idx, end_idx, loc
    !! Index variables.
    integer :: num_species
    !! The number of species.
    integer, dimension(:,:), allocatable :: atoms_ordered
    !! The atoms to remove ordered by species and atom
    real(real32), dimension(:,:), allocatable :: atom
    !! Temporary array to store the atomic positions.


    !---------------------------------------------------------------------------
    ! reorder atoms to remove
    !---------------------------------------------------------------------------
    allocate(atoms_ordered, source=atoms)
    n = size(atoms_ordered, 1)
    m = size(atoms_ordered, 2)

    do i = 1, m
       loc = maxloc(atoms_ordered(1, i:n), dim=1) + i - 1
       if (loc .ne. i) then
          call swap(atoms_ordered(1, i), atoms_ordered(1, loc))
          call swap(atoms_ordered(2, i), atoms_ordered(2, loc))
       end if
    end do
    num_species = this%nspec
    do is = 1, num_species
       start_idx = findloc(atoms_ordered(1, :), is, dim=1)
       end_idx   = findloc(atoms_ordered(1, :), is, dim=1, back=.true.)
       if (start_idx .eq. 0) cycle
       do ia = start_idx, end_idx, 1
          loc = maxloc( &
               atoms_ordered(2, ia:end_idx), &
               dim=1 &
          ) + ia - 1
          if (loc .ne. ia) then
             call swap(atoms_ordered(1, ia), atoms_ordered(1, loc))
             call swap(atoms_ordered(2, ia), atoms_ordered(2, loc))
          end if
       end do
    end do


    !---------------------------------------------------------------------------
    ! remove atoms from basis
    !---------------------------------------------------------------------------
    do i = 1, size(atoms_ordered, 2)
       call this%remove_atom(atoms_ordered(1, i), atoms_ordered(2, i))
    end do

    do is = 1, this%nspec
       if (this%spec(is)%num .eq. 0) then
          this%spec = [ this%spec(1:is-1), this%spec(is+1:) ]
          this%nspec = this%nspec - 1
       end if
    end do

  end subroutine remove_atoms
!###############################################################################


!###############################################################################
  subroutine get_element_properties(element, charge, mass, radius)
    !! Set the mass and charge of the element
    implicit none

    ! Arguments
    character(len=3), intent(in) :: element
    !! Element name.
    real(real32), intent(out), optional :: charge
    !! Charge of the element.
    real(real32), intent(out), optional :: mass
    !! Mass of the element.
    real(real32), intent(out), optional :: radius
    !! Radius of the element.

    ! Local variables
    real(real32) :: mass_, charge_, radius_
    !! Mass, charge and radius of the element.

    select case(element)
    case('H')
       mass_ = 1.00784_real32
       charge_ = 1.0_real32
       radius_ = 0.31_real32
    case('He')
       mass_ = 4.0026_real32
       charge_ = 2.0_real32
       radius_ = 0.28_real32
    case('Li')
       mass_ = 6.94_real32
       charge_ = 3.0_real32
       radius_ = 1.28_real32
    case('Be')
       mass_ = 9.0122_real32
       charge_ = 4.0_real32
       radius_ = 0.96_real32
    case('B')
       mass_ = 10.81_real32
       charge_ = 5.0_real32
       radius_ = 0.84_real32
    case('C')
       mass_ = 12.011_real32
       charge_ = 6.0_real32
       radius_ = 0.76_real32
    case('N')
       mass_ = 14.007_real32
       charge_ = 7.0_real32
       radius_ = 0.71_real32
    case('O')
       mass_ = 15.999_real32
       charge_ = 8.0_real32
       radius_ = 0.66_real32
    case('F')
       mass_ = 18.998_real32
       charge_ = 9.0_real32
       radius_ = 0.57_real32
    case('Ne')
       mass_ = 20.180_real32
       charge_ = 10.0_real32
       radius_ = 0.58_real32
    case('Na')
       mass_ = 22.989_real32
       charge_ = 11.0_real32
       radius_ = 1.66_real32
    case('Mg')
       mass_ = 24.305_real32
       charge_ = 12.0_real32
       radius_ = 1.41_real32
    case('Al')
       mass_ = 26.982_real32
       charge_ = 13.0_real32
       radius_ = 1.21_real32
    case('Si')
       mass_ = 28.085_real32
       charge_ = 14.0_real32
       radius_ = 1.11_real32
    case('P')
       mass_ = 30.974_real32
       charge_ = 15.0_real32
       radius_ = 1.07_real32
    case('S')  
       mass_ = 32.06_real32
       charge_ = 16.0_real32
       radius_ = 1.05_real32
    case('Cl')
       mass_ = 35.453_real32
       charge_ = 17.0_real32
       radius_ = 1.02_real32
    case('Ar')
       mass_ = 39.948_real32
       charge_ = 18.0_real32
       radius_ = 1.06_real32
    case('K')
       mass_ = 39.098_real32
       charge_ = 19.0_real32
       radius_ = 2.03_real32
    case('Ca')
       mass_ = 40.078_real32
       charge_ = 20.0_real32
       radius_ = 1.74_real32
    case('Sc')
       mass_ = 44.956_real32
       charge_ = 21.0_real32
       radius_ = 1.44_real32
    case('Ti')
       mass_ = 47.867_real32
       charge_ = 22.0_real32
       radius_ = 1.32_real32
    case('V')
       mass_ = 50.942_real32
       charge_ = 23.0_real32
       radius_ = 1.22_real32
    case('Cr')
       mass_ = 51.996_real32
       charge_ = 24.0_real32
       radius_ = 1.18_real32
    case('Mn')
       mass_ = 54.938_real32
       charge_ = 25.0_real32
       radius_ = 1.17_real32
    case('Fe')
       mass_ = 55.845_real32
       charge_ = 26.0_real32
       radius_ = 1.17_real32
    case('Co')
       mass_ = 58.933_real32
       charge_ = 27.0_real32
       radius_ = 1.16_real32
    case('Ni')
       mass_ = 58.693_real32
       charge_ = 28.0_real32
       radius_ = 1.15_real32
    case('Cu')
       mass_ = 63.546_real32
       charge_ = 29.0_real32
       radius_ = 1.17_real32
    case('Zn')
       mass_ = 65.38_real32
       charge_ = 30.0_real32
       radius_ = 1.25_real32
    case('Ga')
       mass_ = 69.723_real32
       charge_ = 31.0_real32
       radius_ = 1.26_real32
    case('Ge')
       mass_ = 72.63_real32
       charge_ = 32.0_real32
       radius_ = 1.22_real32
    case('As')
       mass_ = 74.922_real32
       charge_ = 33.0_real32
       radius_ = 1.19_real32
    case('Se')
       mass_ = 78.971_real32
       charge_ = 34.0_real32
       radius_ = 1.16_real32
    case('Br')
       mass_ = 79.904_real32
       charge_ = 35.0_real32
       radius_ = 1.14_real32
    case('Kr')
       mass_ = 83.798_real32
       charge_ = 36.0_real32
       radius_ = 1.12_real32
    case('Rb')
       mass_ = 85.468_real32
       charge_ = 37.0_real32
       radius_ = 2.16_real32
    case('Sr')
       mass_ = 87.62_real32
       charge_ = 38.0_real32
       radius_ = 1.91_real32
    case('Y')
       mass_ = 88.906_real32
       charge_ = 39.0_real32
       radius_ = 1.62_real32
    case('Zr')
       mass_ = 91.224_real32
       charge_ = 40.0_real32
       radius_ = 1.45_real32
    case('Nb')
       mass_ = 92.906_real32
       charge_ = 41.0_real32
       radius_ = 1.34_real32
    case('Mo')
       mass_ = 95.95_real32
       charge_ = 42.0_real32
       radius_ = 1.3_real32
    case('Tc')
       mass_ = 98.0_real32
       charge_ = 43.0_real32
       radius_ = 1.27_real32
    case('Ru')
       mass_ = 101.07_real32
       charge_ = 44.0_real32
       radius_ = 1.25_real32
    case('Rh')
       mass_ = 102.91_real32
       charge_ = 45.0_real32
       radius_ = 1.25_real32
    case('Pd')
       mass_ = 106.42_real32
       charge_ = 46.0_real32
       radius_ = 1.28_real32
    case('Ag')
       mass_ = 107.87_real32
       charge_ = 47.0_real32
       radius_ = 1.34_real32
    case('Cd')
       mass_ = 112.41_real32
       charge_ = 48.0_real32
       radius_ = 1.48_real32
    case('In')
       mass_ = 114.82_real32
       charge_ = 49.0_real32
       radius_ = 1.44_real32
    case('Sn')
       mass_ = 118.71_real32
       charge_ = 50.0_real32
       radius_ = 1.41_real32
    case('Sb')
       mass_ = 121.76_real32
       charge_ = 51.0_real32
       radius_ = 1.38_real32
    case('Te')
       mass_ = 127.6_real32
       charge_ = 52.0_real32
       radius_ = 1.35_real32
    case('I')
       mass_ = 126.9_real32
       charge_ = 53.0_real32
       radius_ = 1.33_real32
    case('Xe')
       mass_ = 131.29_real32
       charge_ = 54.0_real32
       radius_ = 1.31_real32
    case('Cs')
       mass_ = 132.91_real32
       charge_ = 55.0_real32
       radius_ = 2.35_real32
    case('Ba')
       mass_ = 137.33_real32
       charge_ = 56.0_real32
       radius_ = 1.98_real32
    case('La')
       mass_ = 138.91_real32
       charge_ = 57.0_real32
       radius_ = 1.69_real32
    case('Ce')
       mass_ = 140.12_real32
       charge_ = 58.0_real32
       radius_ = 1.65_real32
    case('Pr')
       mass_ = 140.91_real32
       charge_ = 59.0_real32
       radius_ = 1.65_real32
    case('Nd')
       mass_ = 144.24_real32
       charge_ = 60.0_real32
       radius_ = 1.64_real32
    case('Pm')
       mass_ = 145.0_real32
       charge_ = 61.0_real32
       radius_ = 1.63_real32
    case('Sm')
       mass_ = 150.36_real32
       charge_ = 62.0_real32
       radius_ = 1.62_real32
    case('Eu')
       mass_ = 152.0_real32
       charge_ = 63.0_real32
       radius_ = 1.85_real32
    case('Gd')
       mass_ = 157.25_real32
       charge_ = 64.0_real32
       radius_ = 1.61_real32
    case('Tb')
       mass_ = 158.93_real32
       charge_ = 65.0_real32
       radius_ = 1.59_real32
    case('Dy')
       mass_ = 162.5_real32
       charge_ = 66.0_real32
       radius_ = 1.59_real32
    case('Ho')
       mass_ = 164.93_real32
       charge_ = 67.0_real32
       radius_ = 1.58_real32
    case('Er')
       mass_ = 167.26_real32
       charge_ = 68.0_real32
       radius_ = 1.57_real32
    case('Tm')
       mass_ = 168.93_real32
       charge_ = 69.0_real32
       radius_ = 1.56_real32
    case('Yb')
       mass_ = 173.05_real32
       charge_ = 70.0_real32
       radius_ = 1.74_real32
    case('Lu')
       mass_ = 174.97_real32
       charge_ = 71.0_real32
       radius_ = 1.56_real32
    case('Hf')
       mass_ = 178.49_real32
       charge_ = 72.0_real32
       radius_ = 1.44_real32
    case('Ta')
       mass_ = 180.95_real32
       charge_ = 73.0_real32
       radius_ = 1.34_real32
    case('W')
       mass_ = 183.84_real32
       charge_ = 74.0_real32
       radius_ = 1.3_real32
    case('Re')
       mass_ = 186.21_real32
       charge_ = 75.0_real32
       radius_ = 1.28_real32
    case('Os')
       mass_ = 190.23_real32
       charge_ = 76.0_real32
       radius_ = 1.26_real32
    case('Ir')
       mass_ = 192.22_real32
       charge_ = 77.0_real32
       radius_ = 1.27_real32
    case('Pt')
       mass_ = 195.08_real32
       charge_ = 78.0_real32
       radius_ = 1.3_real32
    case('Au')
       mass_ = 196.97_real32
       charge_ = 79.0_real32
       radius_ = 1.34_real32
    case('Hg')
       mass_ = 200.59_real32
       charge_ = 80.0_real32
       radius_ = 1.49_real32
    case('Tl')
       mass_ = 204.38_real32
       charge_ = 81.0_real32
       radius_ = 1.48_real32
    case('Pb')
       mass_ = 207.2_real32
       charge_ = 82.0_real32
       radius_ = 1.47_real32
    case('Bi')
       mass_ = 208.98_real32
       charge_ = 83.0_real32
       radius_ = 1.46_real32
    case('Po')
       mass_ = 209.0_real32
       charge_ = 84.0_real32
       radius_ = 1.45_real32
    case('At')
       mass_ = 210.0_real32
       charge_ = 85.0_real32
       radius_ = 1.44_real32
    case('Rn')
       mass_ = 222.0_real32
       charge_ = 86.0_real32
       radius_ = 1.43_real32
    case('Fr')
       mass_ = 223.0_real32
       charge_ = 87.0_real32
       radius_ = 2.6_real32
    case('Ra')
       mass_ = 226.0_real32
       charge_ = 88.0_real32
       radius_ = 2.21_real32
    case('Ac')
       mass_ = 227.0_real32
       charge_ = 89.0_real32
       radius_ = 1.86_real32
    case('Th')
       mass_ = 232.04_real32
       charge_ = 90.0_real32
       radius_ = 1.75_real32
    case('Pa')
       mass_ = 231.04_real32
       charge_ = 91.0_real32
       radius_ = 1.61_real32
    case('U')
       mass_ = 238.03_real32
       charge_ = 92.0_real32
       radius_ = 1.58_real32
    case('Np')
       mass_ = 237.0_real32
       charge_ = 93.0_real32
       radius_ = 1.55_real32
    case('Pu')
       mass_ = 244.0_real32
       charge_ = 94.0_real32
       radius_ = 1.53_real32
    case('Am')
       mass_ = 243.0_real32
       charge_ = 95.0_real32
       radius_ = 1.51_real32
    case('Cm')
       mass_ = 247.0_real32
       charge_ = 96.0_real32
       radius_ = 1.69_real32
    case('Bk')
       mass_ = 247.0_real32
       charge_ = 97.0_real32
       radius_ = 1.48_real32
    case('Cf')
       mass_ = 251.0_real32
       charge_ = 98.0_real32
       radius_ = 1.47_real32
    case('Es')
       mass_ = 252.0_real32
       charge_ = 99.0_real32
       radius_ = 1.46_real32
    case('Fm')
       mass_ = 257.0_real32
       charge_ = 100.0_real32
       radius_ = 1.45_real32
    case('Md')
       mass_ = 258.0_real32
       charge_ = 101.0_real32
       radius_ = 1.44_real32
    case('No')
       mass_ = 259.0_real32
       charge_ = 102.0_real32
       radius_ = 1.43_real32
    case('Lr')
       mass_ = 262.0_real32
       charge_ = 103.0_real32
       radius_ = 1.62_real32
    case('Rf')
       mass_ = 267.0_real32
       charge_ = 104.0_real32
       radius_ = 1.57_real32
    case('Db')
       mass_ = 270.0_real32
       charge_ = 105.0_real32
       radius_ = 1.49_real32
    case('Sg')
       mass_ = 271.0_real32
       charge_ = 106.0_real32
       radius_ = 1.43_real32
    case('Bh')
       mass_ = 270.0_real32
       charge_ = 107.0_real32
       radius_ = 1.41_real32
    case('Hs')
       mass_ = 277.0_real32
       charge_ = 108.0_real32
       radius_ = 1.34_real32
    case('Mt')
       mass_ = 276.0_real32
       charge_ = 109.0_real32
       radius_ = 1.29_real32
    case('Ds')
       mass_ = 281.0_real32
       charge_ = 110.0_real32
       radius_ = 1.28_real32
    case('Rg')
       mass_ = 280.0_real32
       charge_ = 111.0_real32
       radius_ = 1.21_real32
    case('Cn')
       mass_ = 285.0_real32
       charge_ = 112.0_real32
       radius_ = 1.22_real32
    case('Nh')
       mass_ = 284.0_real32
       charge_ = 113.0_real32
       radius_ = 1.21_real32
    case('Fl')
       mass_ = 289.0_real32
       charge_ = 114.0_real32
       radius_ = 1.21_real32
    case('Mc')
       mass_ = 288.0_real32
       charge_ = 115.0_real32
       radius_ = 1.21_real32
    case('Lv')
       mass_ = 293.0_real32
       charge_ = 116.0_real32
       radius_ = 1.21_real32
    case('Ts')
       mass_ = 294.0_real32
       charge_ = 117.0_real32
       radius_ = 1.21_real32
    case('Og')
       mass_ = 294.0_real32
       charge_ = 118.0_real32
       radius_ = 1.21_real32
    case default
       ! handle unknown element
       mass_ = 0.0_real32
       charge_ = 0.0_real32
       radius_ = 0.0_real32
    end select

    !---------------------------------------------------------------------------
    ! Return the values
    !---------------------------------------------------------------------------
    if(present(mass)) mass = mass_
    if(present(charge)) charge = charge_
    if(present(radius)) radius = radius_

  end subroutine get_element_properties
!###############################################################################

end module raffle__geom_rw

module read_structures
  !! Module for reading structures from various file formats.
  !!
  !! This module takes a list of directories and reads in the structures from
  !! the contained files. The structures are then converted to a set of
  !! generalised vectors (gvectors, aka distribution functions).
  !! NOTE: This does not currently handle relaxations in POSCAR/CONTCAR format.
  !! NOTE: This does not currently restart from a printed distribs_container.
  use raffle__constants, only: real32
  use raffle__io_utils, only: stop_program
  use raffle__misc, only: grep
  use raffle__misc_linalg, only: modu
  use raffle__geom_rw, only: basis_type, geom_read, geom_write, igeom_input
  use rw_vasprun, only: get_energy_from_vasprun, get_structure_from_vasprun
  use raffle__distribs_container, only: distribs_container_type
  implicit none


  private

  public :: get_gdfs_from_data


contains

!###############################################################################
  function get_gdfs_from_data(input_dir, &
       file_format, distribs_container_template &
  ) result(distribs_container)
    !! Read structures from the input directories and generate the generalised
    !! distribution functions.
    implicit none

    ! Arguments
    character(1024), dimension(..), intent(in) :: input_dir
    !! List of directories containing the structures to be read.
    type(distribs_container_type), intent(in), optional :: &
         distribs_container_template
    !! Optional. A template distribs_container to be used.
    type(distribs_container_type), allocatable :: distribs_container
    !! The distribs_container containing the distribution functions.
    character(*), intent(in), optional :: file_format
    !! Optional. The format of the input files. Default is vasprun.xml.

    ! Local variables
    integer :: i, j
    !! Loop indices.
    integer :: ifile_format
    !! The format of the input files.
    integer :: num_structures
    !! The number of structures read.
    real(real32) :: energy
    !! The energy of the structure.
    character(50) :: buffer
    !! A buffer for reading strings.
    character(256) :: format
    !! A format string for writing output.
    logical :: success
    !! Boolean for success of file operations.

    integer :: unit
    !! File units.
    integer :: iostat
    !! I/O status.
    type(basis_type) :: basis
    !! The basis of the structure.
    type(basis_type), dimension(:), allocatable :: basis_list
    !! The list of bases.
    character(256) :: stop_msg
    !! The stop message.
    character(256), dimension(:), allocatable :: structure_list
    !! The list of structure files.


    !---------------------------------------------------------------------------
    ! handle optional arguments
    !---------------------------------------------------------------------------
    if(present(distribs_container_template)) then
       distribs_container = distribs_container_template
    else
       distribs_container = distribs_container_type()
    end if

    if(present(file_format)) then
       select case(trim(adjustl(file_format)))
       case('vasprun.xml','xml','vasprun')
          ifile_format = 0
       case('POSCAR','OUTCAR')
          ifile_format = 1
          igeom_input = 1
       case('xyz','extxyz')
          ifile_format = 2
          igeom_input = 6
       case default
          write(stop_msg,'("Unknown file format: ",A)') file_format
          call stop_program(stop_msg)
          return
       end select
    else
       ifile_format = 0
    end if


    !---------------------------------------------------------------------------
    ! read the list of structure files from the input directories
    !---------------------------------------------------------------------------
    ! inquire(file='distribs_container.dat', exist=success)
    ! if(success) then
    !    call distribs_container%read('distribs_container.dat')
    !    goto 100
    ! end if
    select rank(dir_ptr => input_dir)
    rank(0)
       structure_list = [ get_structure_list( dir_ptr, ifile_format ) ]
    rank(1)
       do i = 1, size(dir_ptr)
          if(i.eq.1)then
             structure_list = [ &
                  get_structure_list( dir_ptr(i), ifile_format ) &
             ]
          else
             structure_list = [ &
                  structure_list, &
                  get_structure_list( dir_ptr(i), ifile_format ) &
             ]
          end if
       end do
    end select


    !---------------------------------------------------------------------------
    ! read the structures from the list of files
    !---------------------------------------------------------------------------
    num_structures = 0
    allocate(basis_list(0))
    do i = 1, size(structure_list)
       write(*,*) "Reading structure: ", trim(adjustl(structure_list(i)))
       select case(ifile_format)
       case(0) ! vasprun.xml
          open( &
               newunit=unit, &
               file=trim(adjustl(structure_list(i)))//"/vasprun.xml" &
          )
          write(*,*) "Reading structures from xml"
          basis%energy = get_energy_from_vasprun(unit, success)
          if(.not.success) cycle
          rewind(unit)
          call get_structure_from_vasprun(unit, basis, success)
          if(.not.success) cycle
          close(unit)
       case(1) ! POSCAR/OUTCAR
          open(newunit=unit, file=trim(adjustl(structure_list(i)))//"/POSCAR")
          write(*,*) "Reading structures from POSCAR"
          call geom_read(unit, basis)
          close(unit)
          open(newunit=unit, file=trim(adjustl(structure_list(i)))//"/OUTCAR")
          call grep( &
               unit, 'free  energy   TOTEN  =', &
               lline=.false., success=success &
          )
          if(.not.success) cycle
          backspace(unit)
          read(unit,*) buffer, buffer, buffer, buffer, energy
          close(unit)
          basis%energy = energy
       case(2) ! extended xyz
          open(newunit=unit, file=trim(adjustl(structure_list(i))))
          write(*,*) "Reading structures from xyz"
          do
             read(unit,'(A)',iostat=iostat) buffer
             if(iostat .ne. 0) exit
             if(trim(buffer).eq."") cycle
             backspace(unit)
             call geom_read(unit, basis)

             num_structures = num_structures + 1
             write(format,'&
                  &("(""Found structure: "",I4,"" with energy: "",&
                  &F13.7,"" and formula:"",",I0,"(1X,A,I0))")' &
             ) basis%nspec
             write(*,format) &
                  num_structures, &
                  basis%energy, &
                  ( &
                       trim(basis%spec(j)%name), basis%spec(j)%num, &
                       j=1, basis%nspec &
                  )
             basis_list = [ basis_list, basis ]
          end do
          cycle
       end select

       write(*,*) &
            "Found structure: ", trim(adjustl(structure_list(i))), &
            " with energy: ", basis%energy
       basis_list = [ basis_list, basis ]
       num_structures = num_structures + 1
    end do


    !---------------------------------------------------------------------------
    ! generate the generalised distribution functions
    !---------------------------------------------------------------------------
    call distribs_container%create(basis_list)

    igeom_input = 1

  end function get_gdfs_from_data
!###############################################################################


!###############################################################################
  function get_structure_list(input_dir, ifile_format) result(structure_list)
    !! Get a list of structures from a directory.
    implicit none

    ! Arguments
    character(*), intent(in) :: input_dir
    !! The directory containing the structures.
    integer, intent(in) :: ifile_format
    !! The format of the input files.
    character(256), dimension(:), allocatable :: structure_list
    !! The list of structure files.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: iostat
    !! I/O status.
    character(256) :: name
    !! The name of the structure file.
    character(256) :: stop_msg
    !! The stop message.
    logical :: file_exists, addit_file_exists, structures_found
    !! Booleans for file existence.


    !---------------------------------------------------------------------------
    ! get the list of structure files using the command line
    !---------------------------------------------------------------------------
    structures_found = .false.
    call execute_command_line( &
         "ls "//trim(adjustl(input_dir))//"/. >structures.txt", wait = .TRUE. )
    open(newunit=unit, file="structures.txt", status="old")
    do
       read(unit,'(A)',iostat=iostat) name
       if(is_iostat_end(iostat)) exit
       name = trim(adjustl(input_dir))//"/"//trim(adjustl(name))
       select case(ifile_format)
       case(0)
          inquire(file=trim(name)//"/vasprun.xml", exist=file_exists)
       case(1)
          inquire(file=trim(name)//"/POSCAR", exist=file_exists)
          inquire(file=trim(name)//"/OUTCAR", exist=addit_file_exists)
          file_exists = file_exists.and.addit_file_exists
       case(2)
          inquire(file=trim(name), exist=file_exists)
          file_exists = file_exists.and.(index(name, ".xyz") .gt. 0)
          if(.not.file_exists)then
             inquire(file=trim(name)//"/data.xyz", exist=file_exists)
             if(file_exists) name = trim(name)//"/data.xyz"
          end if
       end select
       if(.not.file_exists) cycle
       if(structures_found) then
          structure_list = [ structure_list, name ]
       else
          structure_list = [ name ]
          structures_found = .true.
       end if
    end do
    close(unit)

    if(.not.structures_found) then
       write(stop_msg,'("No structures found in directory: """,A, &
            &""" with format: ",I0)' &
       ) trim(input_dir), ifile_format
       call stop_program(stop_msg)
       return
    end if

  end function get_structure_list
!###############################################################################

end module read_structures

program test_mod_element_utils
  use raffle__element_utils
  use raffle__geom_rw, only: get_element_properties
  use raffle__constants, only: real32
  implicit none

  ! Local variables
  class(element_type), allocatable :: element
  class(element_bond_type), allocatable :: bond

  integer :: i
  logical :: in_database
  character(len=3), dimension(:), allocatable :: element_list

  logical :: success = .true.

  ! Initialise the element database
  allocate(element_list(118))
  element_list = [ &
       'H  ', 'He ', 'Li ', 'Be ', 'B  ', 'C  ', 'N  ', 'O  ', 'F  ', 'Ne ', &
       'Na ', 'Mg ', 'Al ', 'Si ', 'P  ', 'S  ', 'Cl ', 'Ar ', 'K  ', 'Ca ', &
       'Sc ', 'Ti ', 'V  ', 'Cr ', 'Mn ', 'Fe ', 'Co ', 'Ni ', 'Cu ', 'Zn ', &
       'Ga ', 'Ge ', 'As ', 'Se ', 'Br ', 'Kr ', 'Rb ', 'Sr ', 'Y  ', 'Zr ', &
       'Nb ', 'Mo ', 'Tc ', 'Ru ', 'Rh ', 'Pd ', 'Ag ', 'Cd ', 'In ', 'Sn ', &
       'Sb ', 'Te ', 'I  ', 'Xe ', 'Cs ', 'Ba ', 'La ', 'Ce ', 'Pr ', 'Nd ', &
       'Pm ', 'Sm ', 'Eu ', 'Gd ', 'Tb ', 'Dy ', 'Ho ', 'Er ', 'Tm ', 'Yb ', &
       'Lu ', 'Hf ', 'Ta ', 'W  ', 'Re ', 'Os ', 'Ir ', 'Pt ', 'Au ', 'Hg ', &
       'Tl ', 'Pb ', 'Bi ', 'Po ', 'At ', 'Rn ', 'Fr ', 'Ra ', 'Ac ', 'Th ', &
       'Pa ', 'U  ', 'Np ', 'Pu ', 'Am ', 'Cm ', 'Bk ', 'Cf ', 'Es ', 'Fm ', &
       'Md ', 'No ', 'Lr ', 'Rf ', 'Db ', 'Sg ', 'Bh ', 'Hs ', 'Mt ', 'Ds ', &
       'Rg ', 'Cn ', 'Nh ', 'Fl ', 'Mc ', 'Lv ', 'Ts ', 'Og ' &
  ]

  allocate(element_database(size(element_list)))
  do i = 1, size(element_list)
     element_database(i)%name = element_list(i)
     call get_element_properties( &
          element_list(i), &
          mass = element_database(i)%mass, &
          charge = element_database(i)%charge, &
          radius = element_database(i)%radius &
     )
  end do


  ! Test element initialization
  element = element_type( &
       name='H  ', &
       mass=1.008_real32, &
       charge=0.0_real32, &
       energy=13.6_real32 &
  )
  call assert( &
       trim(element%name) .eq. "H", &
       "Element name initialisation failed", &
       success &
  )
  call assert( &
       abs(element%mass - 1.008_real32) .lt. 1.E-6, &
       "Element mass initialisation failed", &
       success &
  )
  call assert( &
       abs(element%charge) .lt. 1.E-6, &
       "Element charge initialisation failed", &
       success &
  )
  call assert( &
       abs(element%energy - 13.6_real32) .lt. 1.E-6, &
       "Element energy initialisation failed", &
       success &
  )

  ! Test setting element properties
  call element%set('C  ', in_database)
  call assert( &
       trim(element%name) .eq. "C", &
       "Element name setting failed", &
       success &
  )
  call assert( &
       abs(element%mass - 12.011_real32) .lt. 1.E-6, &
       "Element mass setting failed", &
       success &
  )
  call assert( &
       abs(element%charge - 6._real32) .lt. 1.E-6, &
       "Element charge setting failed", &
       success &
  )
  call assert( &
       abs(element%radius - 0.76_real32) .lt. 1.E-6, &
       "Element radius setting failed", &
       success &
  )
  call assert( &
       in_database, &
       "Element in_database setting failed", &
       success &
  )

  ! Test bond initialisation
  bond = element_bond_type(elements=['H  ', 'O  '], radius=0.96_real32)

  ! Test setting bond properties
  call bond%set('C  ', 'O  ', in_database)


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_elements passed all tests'
  else
     write(0,*) 'test_elements failed one or more tests'
     stop 1
  end if

contains

!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_mod_element_utils

module raffle__misc_maths
  !! Module for miscellaneous mathematical functions.
  use raffle__io_utils, only: stop_program
  use raffle__constants, only: real32
  implicit none


  private

  public :: lnsum, triangular_number, set_difference



contains

!###############################################################################
  function lnsum(n)
    !! Return the sum of the logs of the integers from 1 to n.
    implicit none

    ! Arguments
    integer :: n
    !! The upper limit of the range.
    real(real32) :: lnsum
    !! The sum of the logs of the integers from 1 to n.

    ! Local variables
    integer :: i
    !! Loop index.

    lnsum = 0._real32
    do i = 1, n
       lnsum = lnsum + log( real(i, real32) )
    end do

    return
  end function lnsum
!###############################################################################


!###############################################################################
  integer function triangular_number(n)
    !! Return the nth triangular number.
    implicit none

    ! Arguments
    integer :: n
    !! The index of the triangular number to return.
    triangular_number = n * ( n + 1 ) / 2
  end function triangular_number
!###############################################################################


!###############################################################################
  function set_difference(a, b, set_min_zero)
    !! Return the set difference of two arrays.
    implicit none

    ! Arguments
    real(real32), dimension(:), intent(in) :: a
    !! The first array.
    real(real32), dimension(:), intent(in) :: b
    !! The second array.
    logical, optional :: set_min_zero
    !! Boolean to set the maximum value of the output array to zero.
    real(real32), dimension(size(a)) :: set_difference
    !! The set difference of the two arrays.

    ! Local variables
    integer :: i
    !! Loop indices.
    logical :: set_min_zero_
    !! Boolean to set all values below zero to zero.


    if(present(set_min_zero)) then
       set_min_zero_ = set_min_zero
    else
       set_min_zero_ = .false.
    end if

    if(size(a,1) .ne. size(b,1)) then
       call stop_program('Arrays must be the same size.')
       return
    end if

    if(set_min_zero_)then
       do i = 1, size(a,1)
          set_difference(i) = max(0.0_real32, a(i) - b(i))
       end do
    else
       set_difference = a - b
    end if

  end function set_difference
!###############################################################################

end module raffle__misc_maths

program test_misc
  use raffle__io_utils
  use raffle__misc
  use raffle__constants, only: real32
  implicit none

  logical :: success = .true.

  test_error_handling = .true.

  call test_sort_str(success)
  call test_sort_str_order(success)
  call test_isort1D(success)
  call test_rsort1D(success)
  call test_iset(success)
  call test_rset(success)
  call test_cset(success)
  call test_ishuffle(success)
  call test_rshuffle(success)
  call test_icount(success)
  call test_to_upper(success)
  call test_to_lower(success)
  call test_strip_null(success)
  call test_grep(success)
  call test_jump(success)
  call test_rswap(success)
  call test_rswap_vec(success)


  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_misc passed all tests'
  else
     write(0,*) 'test_misc failed one or more tests'
     stop 1
  end if

contains

  subroutine test_sort_str(success)
    implicit none
    logical, intent(inout) :: success
    character(len=20), dimension(5) :: list
    character(len=20), dimension(5) :: expected_list
    list = [ &
         'banana    ', 'apple     ', 'cherry    ', 'date      ', 'elderberry' &
    ]
    expected_list = [ &
         'apple     ', 'banana    ', 'cherry    ', 'date      ', 'elderberry' &
    ]
    call sort_str(list)
    call assert( &
         all(list .eq. expected_list), &
         'test_sort_str failed', success &
    )

    list = [ &
         'Banana    ', 'cherry    ', 'banana    ', 'date      ', 'elderberry' &
    ]
    expected_list = [ &
         'Banana    ', 'banana    ', 'cherry    ', 'date      ', 'elderberry' &
    ]
    call sort_str(list, lcase=.true.)
    call assert( &
         all(list .eq. expected_list), &
         'test_sort_str failed with ignore case', success &
    )
  end subroutine test_sort_str

  subroutine test_sort_str_order(success)
    implicit none
    logical, intent(inout) :: success
    character(len=20), dimension(5) :: list
    integer, dimension(5) :: expected_order = (/ 2, 1, 3, 4, 5 /)
    integer, dimension(:), allocatable :: order
    list = [ &
         'banana    ', 'apple     ', 'cherry    ', 'date      ', 'elderberry' &
    ]
    allocate(order, source=sort_str_order(list))
    call assert( &
         all(order .eq. expected_order), &
         'test_sort_str_order failed', success &
    )

    list = [ &
         'banana    ', 'cherry    ', 'Banana    ', 'date      ', 'elderberry' &
    ]
    expected_order = [ 1, 3, 2, 4, 5 ]
    order = sort_str_order(list, lcase=.true.)
    call assert( &
         all(order .eq. expected_order), &
         'test_sort_str_order failed with ignore case', success &
    )
  end subroutine test_sort_str_order

  subroutine test_isort1D(success)
    implicit none
    logical, intent(inout) :: success
    integer, dimension(5) :: arr = [5, 3, 4, 1, 2]
    integer, dimension(5) :: expected_arr = [1, 2, 3, 4, 5]
    call sort1D(arr)
    call assert( &
         all(arr .eq. expected_arr), &
         'test_isort1D failed', success &
    )
    expected_arr = [5, 4, 3, 2, 1]
    call sort1D(arr, reverse=.true.)
    call assert( &
         all(arr .eq. expected_arr), &
         'test_isort1D failed with reverse', success &
    )
  end subroutine test_isort1D

  subroutine test_rsort1D(success)
    implicit none
    logical, intent(inout) :: success
    real(real32), dimension(5) :: arr = &
         [5._real32, 3._real32, 4._real32, 1._real32, 2._real32]
    real(real32), dimension(5) :: expected_arr = &
         [1._real32, 2._real32, 3._real32, 4._real32, 5._real32]
    call sort1D(arr)
    call assert( &
         all( abs(arr - expected_arr) .lt. 1.E-6), &
         'test_rsort1D failed', success &
    )
    expected_arr = [5._real32, 4._real32, 3._real32, 2._real32, 1._real32]
    call sort1D(arr, reverse=.true.)
    call assert( &
         all(arr .eq. expected_arr), &
         'test_rsort1D failed with reverse', success &
    )
  end subroutine test_rsort1D

  subroutine test_iset(success)
    implicit none
    logical, intent(inout) :: success
    integer, dimension(:), allocatable :: arr
    integer, dimension(:), allocatable :: expected_arr
    allocate(arr(6))
    arr = [1, 2, 2, 3, 3, 3]
    allocate(expected_arr(3))
    expected_arr = [1, 2, 3]
    call set(arr)
    call assert( &
         all(arr .eq. expected_arr), &
         'test_iset failed', success &
    )
  end subroutine test_iset

  subroutine test_rset(success)
    implicit none
    logical, intent(inout) :: success
    real(real32), dimension(:), allocatable :: arr
    real(real32), dimension(:), allocatable :: expected_arr
    allocate(arr(6))
    arr = [1._real32, 2._real32, 2._real32, 3._real32, 3._real32, 3._real32]
    allocate(expected_arr(3))
    expected_arr = [1._real32, 2._real32, 3._real32]
    call set(arr)
    call assert( &
         all( abs(arr - expected_arr) .lt. 1.E-6), &
         'test_rset failed', success &
    )
    arr = [1._real32, 2._real32, 2.00001_real32, 3._real32, 3._real32]
    expected_arr = [1._real32, 2._real32, 2.00001_real32, 3._real32]
    call set(arr, tol=1.E-6)
    call assert( &
         all( abs(arr - expected_arr) .lt. 1.E-6), &
         'test_rset failed with lower tolerance', success &
    )
  end subroutine test_rset

  subroutine test_cset(success)
    implicit none
    logical, intent(inout) :: success
    character(len=20), dimension(:), allocatable :: arr
    character(len=20), dimension(:), allocatable :: expected_arr
    allocate(arr(6))
    arr(:) = [ 'apple ', 'banana', 'banana', 'cherry', 'cherry', 'cherry' ]
    allocate(expected_arr(3))
    expected_arr(:) = [ 'apple ', 'banana', 'cherry' ]
    call set(arr)
    call assert( &
         all(arr .eq. expected_arr), &
         'test_cset failed', success &
    )
    deallocate(arr)
    allocate(arr(6))
    arr = [ 'apple ', 'Banana', 'banana', 'cherry', 'cherry', 'cherry' ]
    expected_arr(:) = [ 'apple ', 'banana', 'cherry' ]
    call set(arr, lcase=.true.)
    call assert( &
         all(arr .eq. expected_arr), &
         'test_cset failed with ignore case', success &
    )
    deallocate(arr)
    allocate(arr(6))
    arr = [ 'apple ', 'Banana', 'banana', 'cherry', 'cherry', 'cherry' ]
    deallocate(expected_arr)
    allocate(expected_arr(6))
    expected_arr(:4) = &
         [ 'Banana', 'apple ', 'banana', 'cherry' ]
    expected_arr(5:) = ''
    call set(arr, lkeep_size=.true.)
    call assert( &
         size(arr) .eq. 6, &
         'test_cset failed to keep size', success &
    )
    call assert( &
         all(arr(:4) .eq. expected_arr(:4)), &
         'test_cset failed with keep_size', success &
    )
  end subroutine test_cset

  subroutine test_ishuffle(success)
    implicit none
    logical, intent(inout) :: success
    integer  :: i
    logical :: ltmp1
    integer :: arr(1,5)
    integer :: original_arr(1,5)

    arr(1,:) = [1, 2, 3, 4, 5]
    original_arr(1,:) = arr(1,:)
    call shuffle(arr, dim=2, seed=0)
    ltmp1 = .true.
    do i = 1, size(arr,dim=2)
       if(all(abs(arr(1,i) - original_arr(1,:)).gt.0)) then
          ltmp1 = .false.
          exit
       end if
    end do
    call assert(ltmp1, "ishuffle failed", success)
  end subroutine test_ishuffle

  subroutine test_rshuffle(success)
    implicit none
    logical, intent(inout) :: success
    integer  :: i
    logical :: ltmp1
    real(real32) :: arr(1,5)
    real(real32) :: original_arr(1,5)

    arr(1,:) = [1._real32, 2._real32, 3._real32, 4._real32, 5._real32]
    original_arr(1,:) = arr(1,:)
    call shuffle(arr, dim=2, seed=0)
    ltmp1 = .true.
    do i = 1, size(arr,dim=2)
       if(all(abs(arr(1,i) - original_arr(1,:)).gt.1.E-6)) then
          ltmp1 = .false.
          exit
       end if
    end do
    call assert(ltmp1, "rshuffle failed", success)
  end subroutine test_rshuffle

  subroutine test_icount(success)
    implicit none
    logical, intent(inout) :: success
    character(len=20) :: line = "apple,banana,cherry"
    integer :: count

    count = icount(line, ",")
    call assert(count .eq. 3, "icount failed", success)
  end subroutine test_icount

  subroutine test_to_upper(success)
    implicit none
    logical, intent(inout) :: success
    character(len=10) :: str
    character(len=10) :: expected_str

    str = "hello"
    expected_str = "HELLO"
    str = to_upper(str)
    call assert(trim(str) .eq. trim(expected_str), "to_upper failed", success)
  end subroutine test_to_upper

  subroutine test_to_lower(success)
    implicit none
    logical, intent(inout) :: success
    character(len=10) :: str
    character(len=10) :: expected_str

    str = "HELLO"
    expected_str = "hello"
    str = to_lower(str)
    call assert(trim(str) .eq. trim(expected_str), "to_lower failed", success)
  end subroutine test_to_lower

  subroutine test_strip_null(success)
    implicit none
    logical, intent(inout) :: success
    character(len=16) :: str
    character(len=16) :: expected_str

    str = "hello"//char(0)//"world"
    expected_str = "hello"
    str = strip_null(str)
    call assert(trim(str) .eq. trim(expected_str), "strip_null failed", success)
  end subroutine test_strip_null

  subroutine test_grep(success)
    implicit none
    logical, intent(inout) :: success
    integer :: unit
    logical :: success_tmp

    ! Create a temporary scratch file for testing
    open(newunit=unit, status='scratch', action='readwrite')
    write(unit, '(A)') 'This is a test line.'
    write(unit, '(A)') 'Another line with test pattern.'
    write(unit, '(A)') 'Yet another line.'
    rewind(unit)

    ! Test case 1: Pattern found in the middle of the line
    call grep(unit, 'test pattern', success=success_tmp)
    call assert(success_tmp, 'Pattern not found', success)
    rewind(unit)

    ! Test case 2: Pattern not found
    call grep(unit, 'nonexistent pattern', lstart=.true., success=success_tmp)
    call assert(.not. success_tmp, 'Nonexistent pattern found', success)
    rewind(unit)

    ! Test case 3: Pattern at the start of the line
    call grep(unit, 'This is', lline=.true., success=success_tmp)
    call assert(success_tmp, 'Pattern at start of line not found', success)
    close(unit, status='delete')

  end subroutine test_grep

  subroutine test_jump(success)
    implicit none
    logical, intent(inout) :: success
    integer :: i, j, unit

    open(newunit=unit, status='scratch', action='readwrite')
    do i = 1, 10
       write(unit, '(I0)') i
    end do

    ! Test case 1: Jump to the end of the file
    do i = 1, 10
       rewind(unit)
       call jump(unit, i)
       backspace(unit)
       read(unit, *) j
       call assert(j .eq. i, 'Jump failed', success)
    end do

  end subroutine test_jump

  subroutine test_rswap(success)
    implicit none
    logical, intent(inout) :: success
    real(real32) :: a = 1._real32
    real(real32) :: b = 2._real32
    real(real32) :: expected_a = 2._real32
    real(real32) :: expected_b = 1._real32

    call swap(a, b)
    call assert( &
         abs(a - expected_a).lt. 1.E-6 .and. &
         abs(b - expected_b).lt. 1.E-6, &
         "rswap failed", success &
    )
    
  end subroutine test_rswap

  subroutine test_rswap_vec(success)
    implicit none
    logical, intent(inout) :: success
    real(real32), dimension(2) :: a = [1._real32, 2._real32]
    real(real32), dimension(2) :: b = [3._real32, 4._real32]

    call swap(a, b)
    call assert( &
         all( abs(a - [3._real32, 4._real32]) .lt. 1.E-6_real32 ) .and. &
         all( abs(b - [1._real32, 2._real32]) .lt. 1.E-6_real32 ), &
         "rswap_vec failed", success &
    )

  end subroutine test_rswap_vec

!###############################################################################

  subroutine assert(condition, message, success)
    implicit none
    logical, intent(in) :: condition
    character(len=*), intent(in) :: message
    logical, intent(inout) :: success
    if (.not. condition) then
       write(0,*) "Test failed: ", message
       success = .false.
    end if
  end subroutine assert

end program test_misc

module raffle__distribs_container
  !! Module for handling the distribution function container.
  !!
  !! This module defines the distribution function container and associated
  !! procedures.
  !! The container holds the distribution functions for a set of atomic
  !! structures, alongside parameters for initialising the distributions.
  !! The container also holds the generalised distribution functions, built
  !! from the distribution functions of the individual systems.
  !! The generalised distribution functions are used to evaluate the viability
  !! of a new structure.
  use raffle__constants, only: real32, pi
  use raffle__io_utils, only: stop_program, print_warning, suppress_warnings
  use raffle__misc, only: set, icount, strip_null, sort_str
  use raffle__misc_maths, only: triangular_number, set_difference
  use raffle__geom_rw, only: basis_type, get_element_properties
  use raffle__element_utils, only: &
       element_type, element_bond_type, &
       element_database, element_bond_database
  use raffle__distribs, only: distribs_base_type, distribs_type, get_distrib
  use raffle__distribs_host, only: distribs_host_type
  implicit none


  private

  public :: distribs_container_type


  type :: distribs_container_type
     !! Container for distribution functions.
     !!
     !! This type contains the distribution functions for a set of atomic
     !! structures, alongside parameters for initialising the distributions.
     integer :: iteration = -1
     !! Iteration number for the update of the distribution functions.
     integer :: num_evaluated = 0
     !! Number of evaluated systems.
     integer :: num_evaluated_allocated = 0
     !! Number of evaluated systems still allocated.
     real(real32) :: kBT = 0.2_real32
     !! Boltzmann constant times temperature.
     integer :: history_len = 0
     !! Length of the history for the distribution functions.
     real(real32), dimension(:), allocatable :: history_deltas
     !! History of the changes in the distribution functions.
     logical :: weight_by_hull = .false.
     !! Boolean whether to weight the distribution functions by the energy
     !! above the hull. If false, the formation energy from the element
     !! reference energies is used.
     real(real32) :: &
          viability_2body_default = 0.1_real32, &
          viability_3body_default = 0.1_real32, &
          viability_4body_default = 0.1_real32
     !! Default viability for the 2-, 3-, and 4-body distribution functions.
     logical :: smooth_viability = .true.
     !! DEV FEATURE. Boolean whether to smooth the viability evaluation.
     logical, dimension(:), allocatable :: &
          in_dataset_2body, in_dataset_3body, in_dataset_4body
     !! Whether the 2-, 3-, and 4-body distribution functions are in
     !! the dataset.
     real(real32), dimension(:), allocatable :: &
          best_energy_pair, &
          best_energy_per_species
     !! Best energy for the 2-body and species distribution functions.
     integer, dimension(3) :: nbins = -1
     !! Number of bins for the 2-, 3-, and 4-body distribution functions.
     real(real32), dimension(3) :: &
          sigma = [ 0.1_real32, 0.1_real32, 0.1_real32 ]
     !! Sigma of the gaussians used in the 2-, 3-, and 4-body
     !! distribution functions.
     real(real32), dimension(3) :: &
          width = [ 0.025_real32, pi/64._real32, pi/64._real32 ]
     !! Width of the bins used in the 2-, 3-, and 4-body distribution functions.
     real(real32), dimension(3) :: width_inv
     !! Inverse of the width of the bins used in the 2-, 3-, and 4-body
     real(real32), dimension(3) :: &
          cutoff_min = [ 0.5_real32, 0._real32, 0._real32 ]
     !! Minimum cutoff for the 2-, 3-, and 4-body distribution functions.
     real(real32), dimension(3) :: &
          cutoff_max = [ 6._real32, pi, pi ]
     !! Maximum cutoff for the 2-, 3-, and 4-body distribution functions.
     real(real32), dimension(4) :: &
          radius_distance_tol = [ 1.5_real32, 2.5_real32, 3._real32, 6._real32 ]
     !! Tolerance for the distance between atoms for 3- and 4-body.
     !! index 1 = lower bound for 3-body
     !! index 2 = upper bound for 3-body
     !! index 3 = lower bound for 4-body
     !! index 4 = upper bound for 4-body
     real(real32), dimension(:), allocatable :: &
          norm_2body, norm_3body, norm_4body
     !! Normalisation factors for the 2-, 3-, and 4-body distribution functions.
     type(distribs_base_type) :: gdf
     !! Generalised distribution functions for all systems.
     !! Generated from combining the energy-weighted distribution functions
     !! of all systems
     integer, dimension(:), allocatable :: element_map
     !! Mapping of host elements to distribution function elements.
     type(distribs_host_type) :: host_system
     !! Host structure for the distribution functions.
     type(distribs_type), dimension(:), allocatable :: system
     !! Distribution functions for each system.
     type(element_type), dimension(:), allocatable :: element_info
     !! Information about the elements in the container.
     type(element_bond_type), dimension(:), allocatable :: bond_info
     !! Information about the 2-body bonds in the container.
   contains
     procedure, pass(this) :: set_width
     !! Set the width of the bins used in the 2-, 3-, and 4-body.
     procedure, pass(this) :: set_sigma
     !! Set the sigma of the gaussians used in the 2-, 3-, and 4-body.
     procedure, pass(this) :: set_cutoff_min
     !! Set the minimum cutoff for the 2-, 3-, and 4-body.
     procedure, pass(this) :: set_cutoff_max
     !! Set the maximum cutoff for the 2-, 3-, and 4-body.
     procedure, pass(this) :: set_radius_distance_tol
     !! Set the tolerance for the distance between atoms for 3- and 4-body.
     procedure, pass(this) :: set_history_len
     !! Set the length of the history for the distribution functions.

     procedure, pass(this) :: create
     !! Create the distribution functions for all systems, and the learned one.
     procedure, pass(this) :: update
     !! Update the distribution functions for all systems, and the learned one.

     procedure, pass(this) :: deallocate_systems
     !! Deallocate the systems in the container.

     procedure, pass(this) :: add, add_basis
     !! Add a system to the container.

     procedure, pass(this), private :: set_element_info
     !! Set the list of elements for the container.
     procedure, pass(this), private :: update_element_info
     !! Update the element information in the container.
     procedure, pass(this) :: add_to_element_info
     !! Add an element to the container.
     procedure, pass(this) :: set_element_energy
     !! Set the energy of an element in the container.
     procedure, pass(this) :: set_element_energies
     !! Set the energies of elements in the container.
     procedure, pass(this) :: get_element_energies
     !! Return the energies of elements in the container.
     procedure, pass(this) :: get_element_energies_staticmem
     !! Return the energies of elements in the container.
     !! Used in Python interface.

     procedure, pass(this) :: set_element_map
     !! Set the mapping of elements to distribution function elements.
     procedure, pass(this), private :: set_bond_info
     !! Set the 2-body bond information for the container.
     procedure, pass(this), private :: update_bond_info
     !! Update the bond information in the container.
     procedure, pass(this) :: set_bond_radius
     !! Set the radius of a bond in the container.
     procedure, pass(this) :: set_bond_radii
     !! Set the radii of multiple bonds in the container.
     procedure, pass(this) :: get_bond_radii
     !! Return the radii of all bonds in the container.
     procedure, pass(this) :: get_bond_radii_staticmem
     !! Return the radii of all bonds in the container.
     !! Used in Python interface.

     procedure, pass(this) :: set_best_energy
     !! Set the best energy and system in the container.
     procedure, pass(this) :: initialise_gdfs
     !! Initialise the distribution functions in the container.
     procedure, pass(this) :: set_gdfs_to_default
     !! Set the generalised distribution function to the default value.
     procedure, pass(this) :: evolve
     !! Evolve the learned distribution function.
     procedure, pass(this) :: is_converged
     !! Check if the learned distribution function has converged.

     procedure, pass(this) :: write_gdfs
     !! Write the generalised distribution functions to a file.
     procedure, pass(this) :: read_gdfs
     !! Read the generalised distribution functions from a file.
     procedure, pass(this) :: write_dfs
     !! Write all distribution functions to a file.
     procedure, pass(this) :: read_dfs
     !! Read all distribution functions from a file.
     procedure, pass(this) :: write_2body
     !! Write the learned 2-body distribution function to a file.
     procedure, pass(this) :: write_3body
     !! Write the learned 3-body distribution function to a file.
     procedure, pass(this) :: write_4body
     !! Write the learned 4-body distribution function to a file.
     procedure, pass(this) :: get_pair_index
     !! Return the index for bond_info given two elements.
     procedure, pass(this) :: get_element_index
     !! Return the index for element_info given one element.
     procedure, pass(this) :: set_num_bins
     !! Set the number of bins for the n-body distribution functions.
     procedure, pass(this) :: get_bin
     !! Return the bin index for a given distance.
     procedure, pass(this) :: get_2body
     !! Return the 2-body distribution function.
     procedure, pass(this) :: get_3body
     !! Return the 3-body distribution function.
     procedure, pass(this) :: get_4body
     !! Return the 4-body distribution function.

     procedure, pass(this) :: generate_fingerprint
     !! Calculate the distribution functions for a given system.
     procedure, pass(this) :: generate_fingerprint_python
     !! Calculate the distribution functions for a given system.
  end type distribs_container_type

  interface distribs_container_type
     !! Interface for the distribution functions container.
     module function init_distribs_container( &
          nbins, width, sigma, cutoff_min, cutoff_max, &
          history_len &
     ) result(distribs_container)
       !! Initialise the distribution functions container.
       integer, dimension(3), intent(in), optional :: nbins
       !! Optional. Number of bins for the 2-, 3-, and 4-body distribution
       !! functions.
       real(real32), dimension(3), intent(in), optional :: width, sigma
       !! Optional. Width and sigma of the gaussians used in the 2-, 3-, and
       !! 4-body.
       real(real32), dimension(3), intent(in), optional :: &
            cutoff_min, cutoff_max
       !! Optional. Minimum and maximum cutoff for the 2-, 3-, and 4-body.
       integer, intent(in), optional :: history_len
       !! Optional. Length of the history for the distribution functions.
       type(distribs_container_type) :: distribs_container
       !! Instance of the distribution functions container.
     end function init_distribs_container
  end interface distribs_container_type


contains

!###############################################################################
  module function init_distribs_container( &
       nbins, width, sigma, &
       cutoff_min, cutoff_max, &
       history_len &
  ) result(distribs_container)
    !! Initialise the distribution functions container.
    implicit none

    ! Arguments
    integer, dimension(3), intent(in), optional :: nbins
    !! Optional. Number of bins for the 2-, 3-, and 4-body distribution
    !! functions.
    real(real32), dimension(3), intent(in), optional :: width, sigma
    !! Optional. Width and sigma of the gaussians used in the 2-, 3-, and
    !! 4-body.
    real(real32), dimension(3), intent(in), optional :: cutoff_min, cutoff_max
    !! Optional. Minimum and maximum cutoff for the 2-, 3-, and 4-body.
    integer, intent(in), optional :: history_len
    !! Optional. Length of the history for the distribution functions.
    type(distribs_container_type) :: distribs_container
    !! Instance of the distribution functions container.

    ! Local variables
    character(256) :: stop_msg
    !! Error message.


    if(present(nbins))then
       if(all(nbins .gt. 0)) distribs_container%nbins = nbins
    end if

    if(present(width))then
       if(all(width.ge.0._real32)) distribs_container%width = width
    end if

    if(present(sigma))then
       if(all(sigma.ge.0._real32)) distribs_container%sigma = sigma
    end if

    if(present(cutoff_min))then
       if(any(cutoff_min.ge.0._real32)) &
            distribs_container%cutoff_min = cutoff_min
    end if
    if(present(cutoff_max))then
       if(all(cutoff_max.ge.0._real32)) &
            distribs_container%cutoff_max = cutoff_max
    end if
    if( &
         any(distribs_container%cutoff_max .le. distribs_container%cutoff_min) &
    )then
       write(stop_msg,*) &
            "cutoff_max <= cutoff_min" // &
            achar(13) // achar(10) // &
            "cutoff min: ", distribs_container%cutoff_min, &
            achar(13) // achar(10) // &
            "cutoff max: ", distribs_container%cutoff_max
       call stop_program( stop_msg )
       return
    end if


    if(present(history_len)) distribs_container%history_len = history_len
    if(allocated(distribs_container%history_deltas)) &
         deallocate(distribs_container%history_deltas)
    if(distribs_container%history_len.ge.0) &
         allocate( &
              distribs_container%history_deltas( &
                   distribs_container%history_len &
              ), &
              source = huge(0._real32) &
         )

  end function init_distribs_container
!###############################################################################


!###############################################################################
  subroutine set_width(this, width)
    !! Set the width of the gaussians used in the 2-, 3-, and 4-body
    !! distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(3), intent(in) :: width
    !! Width of the gaussians used in the 2-, 3-, and 4-body
    !! distribution functions.

    this%width = width

  end subroutine set_width
!###############################################################################


!###############################################################################
  subroutine set_sigma(this, sigma)
    !! Set the sigma of the gaussians used in the 2-, 3-, and 4-body
    !! distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(3), intent(in) :: sigma
    !! Sigma of the gaussians used in the 2-, 3-, and 4-body distribution
    !! functions.

    this%sigma = sigma

  end subroutine set_sigma
!###############################################################################


!###############################################################################
  subroutine set_cutoff_min(this, cutoff_min)
    !! Set the minimum cutoff for the 2-, 3-, and 4-body distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(3), intent(in) :: cutoff_min
    !! Minimum cutoff for the 2-, 3-, and 4-body distribution functions.

    this%cutoff_min = cutoff_min

  end subroutine set_cutoff_min
!###############################################################################


!###############################################################################
  subroutine set_cutoff_max(this, cutoff_max)
    !! Set the maximum cutoff for the 2-, 3-, and 4-body distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(3), intent(in) :: cutoff_max
    !! Maximum cutoff for the 2-, 3-, and 4-body distribution functions.

    this%cutoff_max = cutoff_max

  end subroutine set_cutoff_max
!###############################################################################


!###############################################################################
  subroutine set_radius_distance_tol(this, radius_distance_tol)
    !! Set the tolerance for the distance between atoms for 3- and 4-body.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(4), intent(in) :: radius_distance_tol
    !! Tolerance for the distance between atoms for 3- and 4-body.

    this%radius_distance_tol = radius_distance_tol

  end subroutine set_radius_distance_tol
!###############################################################################


!###############################################################################
  subroutine set_history_len(this, history_len)
    !! Set the length of the history for the distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    integer, intent(in) :: history_len
    !! Length of the history for the distribution functions.

    ! Local variables
    integer :: min_len
    !! Minimum length of the history.
    real(real32), dimension(:), allocatable :: history_deltas
    !! History of the changes in the distribution functions.

    if(history_len.gt.0)then
       allocate(history_deltas(history_len), source = huge(0._real32) )
       if(allocated(this%history_deltas))then
          min_len = min(this%history_len, history_len)
          history_deltas(1:min_len) = this%history_deltas(1:min_len)
          deallocate(this%history_deltas)
       end if
       call move_alloc(history_deltas, this%history_deltas)
    else
       if(allocated(this%history_deltas)) deallocate(this%history_deltas)
    end if
    this%history_len = history_len

  end subroutine set_history_len
!###############################################################################


!###############################################################################
  subroutine create( &
       this, basis_list, energy_above_hull_list, deallocate_systems, &
       verbose &
  )
    !! create the distribution functions from the input file
    implicit none
    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    type(basis_type), dimension(:), intent(in) :: basis_list
    !! List of basis structures.
    real(real32), dimension(:), intent(in), optional :: energy_above_hull_list
    !! List of energies above the hull for the structures.
    logical, intent(in), optional :: deallocate_systems
    !! Boolean whether to deallocate the systems after the
    !! distribution functions are created.
    integer, intent(in), optional :: verbose
    !! Verbosity level.

    ! Local variables
    logical :: deallocate_systems_
    !! Boolean whether to deallocate the systems after the distribution
    character(256) :: stop_msg
    !! Error message.
    integer :: verbose_
    !! Verbosity level.
    logical :: suppress_warnings_store
    !! Boolean to store the suppress_warnings value.


    ! Set the verbosity level
    verbose_ = 0
    if(present(verbose)) verbose_ = verbose
    if(verbose_ .eq. 0)then
       suppress_warnings_store = suppress_warnings
       suppress_warnings = .true.
    end if

    ! Check if element_database is allocated
    if(.not.allocated(element_database))then
       write(stop_msg,*) "element_database not allocated" // &
            achar(13) // achar(10) // &
            "Run the set_element_energies() procedure of " // &
            "distribs_container_type before calling create()"
       call stop_program( stop_msg )
       return
    end if

    ! Check if energy_above_hull_list and basis_list are the same size
    if(present(energy_above_hull_list))then
       if(size(energy_above_hull_list).eq.0)then
          this%weight_by_hull = .false.
       elseif(size(energy_above_hull_list) .ne. size(basis_list))then
          this%weight_by_hull = .true.
          write(stop_msg,*) "energy_above_hull_list and basis_list " // &
               "not the same size" // &
               achar(13) // achar(10) // &
               "energy_above_hull_list: ", size(energy_above_hull_list), &
               achar(13) // achar(10) // &
               "basis_list: ", size(basis_list)
          call stop_program( stop_msg )
          return
       end if
    end if
    if(this%weight_by_hull.and..not.present(energy_above_hull_list))then
       write(stop_msg,*) "energy_above_hull_list not present" // &
            achar(13) // achar(10) // &
            "energy_above_hull_list must be present when using hull weighting"
       call stop_program( stop_msg )
       return
    end if


    ! Check if deallocate_systems is present
    deallocate_systems_ = .true.
    if(present(deallocate_systems)) deallocate_systems_ = deallocate_systems

    this%num_evaluated = 0
    this%num_evaluated_allocated = 0
    if(allocated(this%gdf%df_2body)) deallocate(this%gdf%df_2body)
    if(allocated(this%gdf%df_3body)) deallocate(this%gdf%df_3body)
    if(allocated(this%gdf%df_4body)) deallocate(this%gdf%df_4body)
    if(allocated(this%norm_2body)) deallocate(this%norm_2body)
    if(allocated(this%norm_3body)) deallocate(this%norm_3body)
    if(allocated(this%norm_4body)) deallocate(this%norm_4body)
    if(allocated(this%system)) deallocate(this%system)
    if(allocated(this%in_dataset_2body)) deallocate(this%in_dataset_2body)
    if(allocated(this%in_dataset_3body)) deallocate(this%in_dataset_3body)
    if(allocated(this%in_dataset_4body)) deallocate(this%in_dataset_4body)
    if(allocated(this%best_energy_pair)) deallocate(this%best_energy_pair)
    if(allocated(this%best_energy_per_species)) &
         deallocate(this%best_energy_per_species)
    allocate(this%system(0))
    call this%add(basis_list)
    if(present(energy_above_hull_list).and.this%weight_by_hull)then
       this%system(:)%energy_above_hull = energy_above_hull_list(:)
    end if
    call this%set_bond_info()
    call this%evolve()
    if(deallocate_systems_) call this%deallocate_systems()
    if(this%host_system%defined) &
         call this%host_system%set_element_map(this%element_info)

    if(verbose_ .eq. 0)then
       suppress_warnings = suppress_warnings_store
    end if

    this%iteration = 0

  end subroutine create
!###############################################################################


!###############################################################################
  subroutine update( &
       this, basis_list, energy_above_hull_list, from_host, &
       deallocate_systems, &
       verbose &
  )
    !! update the distribution functions from the input file
    implicit none
    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    type(basis_type), dimension(:), intent(in) :: basis_list
    !! List of basis structures.
    real(real32), dimension(:), intent(in), optional :: energy_above_hull_list
    !! List of energies above the hull for the structures.
    logical, intent(in), optional :: from_host
    !! Optional. Boolean whether structures are derived from the host.
    logical, intent(in), optional :: deallocate_systems
    !! Boolean whether to deallocate the systems after the
    !! distribution functions are created.
    integer, intent(in), optional :: verbose
    !! Verbosity level.

    ! Local variables
    integer :: i
    !! Loop index.
    logical :: deallocate_systems_
    !! Boolean whether to deallocate the systems after the distribution
    logical :: from_host_
    !! Boolean whether structures are derived from the host.
    character(256) :: stop_msg
    !! Error message.
    integer :: verbose_
    !! Verbosity level.
    logical :: suppress_warnings_store
    !! Boolean to store the suppress_warnings value.
    type(distribs_base_type) :: gdf_old


    ! Set the verbosity level
    verbose_ = 0
    if(present(verbose)) verbose_ = verbose
    if(verbose_ .eq. 0)then
       suppress_warnings_store = suppress_warnings
       suppress_warnings = .true.
    end if

    ! Check if energy_above_hull_list and basis_list are the same size
    if(present(energy_above_hull_list))then
       if(size(energy_above_hull_list).eq.0 .and. .not. this%weight_by_hull)then
       elseif(size(energy_above_hull_list) .ne. size(basis_list) .and. &
            this%weight_by_hull &
       )then
          write(stop_msg,*) "energy_above_hull_list and basis_list " // &
               "not the same size whilst using hull weighting" // &
               achar(13) // achar(10) // &
               "energy_above_hull_list: ", size(energy_above_hull_list), &
               achar(13) // achar(10) // &
               "basis_list: ", size(basis_list)
          call stop_program( stop_msg )
          return
       end if
    end if
    if(this%weight_by_hull.and..not.present(energy_above_hull_list))then
       write(stop_msg,*) "energy_above_hull_list not present" // &
            achar(13) // achar(10) // &
            "energy_above_hull_list must be present when using hull weighting"
       call stop_program( stop_msg )
       return
    end if

    ! Check if from_host is present
    if(present(from_host))then
       from_host_ = from_host
       if(this%weight_by_hull.and.from_host_)then
          write(stop_msg,*) "Hull weighting and from_host are incompatible" // &
               achar(13) // achar(10) // &
               "Set from_host = .false. to use hull weighting"
          call stop_program( stop_msg )
          return
       end if
    else
       if(this%weight_by_hull)then
          from_host_ = .false.
       else
          from_host_ = .true.
       end if
    end if

    ! Check if deallocate_systems is present
    deallocate_systems_ = .true.
    if(present(deallocate_systems)) deallocate_systems_ = deallocate_systems

    ! Add the new basis structures
    call this%add(basis_list)
    call this%update_bond_info()
    if(present(energy_above_hull_list).and.this%weight_by_hull)then
       this%system(this%num_evaluated_allocated + 1:)%energy_above_hull = &
            energy_above_hull_list(:)
    end if

    ! If the structures are derived from the host, subtract the interface energy
    if(from_host_)then
       if(.not.this%host_system%defined)then
          write(stop_msg,*) "host not set" // &
               achar(13) // achar(10) // &
               "Run the set_host() procedure of parent of" // &
               "distribs_container_type before calling create()"
          call stop_program( stop_msg )
          return
       else
          if(.not.allocated(this%host_system%df_2body))then
             call this%host_system%calculate( &
                  this%host_system%basis, &
                  width = this%width, &
                  sigma = this%sigma, &
                  cutoff_min = this%cutoff_min, &
                  cutoff_max = this%cutoff_max, &
                  radius_distance_tol = this%radius_distance_tol &
             )
          end if
          call this%host_system%calculate_interface_energy(this%element_info)
          do i = this%num_evaluated_allocated + 1, size(this%system), 1
             this%system(i)%from_host = .true.
             this%system(i)%energy = this%system(i)%energy - &
                  this%host_system%interface_energy
             this%system(i)%num_atoms = this%system(i)%num_atoms - &
                  this%host_system%num_atoms
          end do
       end if
    end if


    ! If history_len is set, temporarily store the old descriptor
    if(this%history_len.gt.0)then
       gdf_old = this%gdf
       this%history_deltas(2:) = this%history_deltas(1:this%history_len-1)
    end if

    ! Evolve the distribution functions
    call this%evolve()
    if(deallocate_systems_) call this%deallocate_systems()
    if(this%host_system%defined) &
         call this%host_system%set_element_map(this%element_info)

    ! Evaluate the change in the descriptor from the last iteration
    if(this%history_len.gt.0.and.this%num_evaluated.gt.0)then
       this%history_deltas(1) = this%gdf%compare(gdf_old)
    end if

    if(verbose_ .eq. 0)then
       suppress_warnings = suppress_warnings_store
    end if

    this%iteration = this%iteration + 1

  end subroutine update
!###############################################################################


!###############################################################################
  subroutine deallocate_systems(this)
    !! Deallocate the systems in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.

    if(allocated(this%system)) deallocate(this%system)
    this%num_evaluated_allocated = 0

  end subroutine deallocate_systems
!###############################################################################


!###############################################################################
  subroutine write_gdfs(this, file)
    !! Write the generalised distribution functions to a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to write the generalised distribution functions to.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: i
    !! Loop index.
    character(256) :: fmt
    !! Format string.
    character(256) :: stop_msg
    !! Error message.

    if(.not.allocated(this%gdf%df_2body))then
       write(stop_msg,*) &
            "Generalised distribution functions are not allocated." // &
            achar(13) // achar(10) // &
            "create() or read() must be called before writing the " // &
            "generalised distribution functions."
       call stop_program( stop_msg )
       return
    end if
    open(newunit=unit, file=file)
    write(unit, '("# history_len ",I0)') this%history_len
    write(fmt, '("(""# history_deltas""",I0,"(1X,ES0.8))")') &
         size(this%history_deltas)
    write(unit, fmt) this%history_deltas
    write(unit, '("# nbins",3(1X,I0))') this%nbins
    write(unit, '("# width",3(1X,ES0.8))') this%width
    write(unit, '("# sigma",3(1X,ES0.8))') this%sigma
    write(unit, '("# cutoff_min",3(1X,ES0.8))') this%cutoff_min
    write(unit, '("# cutoff_max",3(1X,ES0.8))') this%cutoff_max
    write(unit, '("# radius_distance_tol",4(1X,ES0.4))') &
         this%radius_distance_tol
    write(fmt, '("(""# "",A,",I0,"(1X,A))")') size(this%element_info)
    write(unit, fmt) "elements", this%element_info(:)%name
    write(fmt, '("(""# "",A,",I0,"(1X,ES0.4))")') size(this%element_info)
    write(unit, fmt) "energies", this%element_info(:)%energy
    write(unit, fmt) "best_energy_per_element", this%best_energy_per_species
    write(unit, fmt) "3-body_norm", this%norm_3body
    write(unit, fmt) "4-body_norm", this%norm_4body
    write(fmt, '("(""# "",A,",I0,"(1X,L1))")') size(this%element_info)
    write(unit, fmt) "in_dataset_3body", this%in_dataset_3body
    write(unit, fmt) "in_dataset_4body", this%in_dataset_4body
    write(fmt, '("(""# "",A,",I0,"(1X,A))")') size(this%bond_info)
    write(unit, fmt) "element_pairs", &
         ( &
              trim(this%bond_info(i)%element(1)) // "-" // &
              trim(this%bond_info(i)%element(2)), &
              i = 1, size(this%bond_info) &
         )
    write(fmt, '("(""# "",A,",I0,"(1X,ES0.4))")') size(this%bond_info)
    write(unit, fmt) "radii", this%bond_info(:)%radius_covalent
    write(unit, fmt) "best_energy_per_pair", this%best_energy_pair
    write(unit, fmt) "2-body_norm", this%norm_2body
    write(fmt, '("(""# "",A,",I0,"(1X,L1))")') size(this%bond_info)
    write(unit, fmt) "in_dataset_2body", this%in_dataset_2body
    write(unit, *)
    write(unit, '("# 2-body")')
    write(fmt,'("(""# bond-length "",",I0,"(1X,A))")') size(this%bond_info)
    write(unit, fmt) &
         ( &
              trim(this%bond_info(i)%element(1)) // "-" // &
              trim(this%bond_info(i)%element(2)), &
              i = 1, size(this%bond_info) &
         )
    do i = 1, this%nbins(1)
       write(unit, *) &
            this%cutoff_min(1) + this%width(1) * ( i - 1 ), &
            this%gdf%df_2body(i,:)
    end do
    write(unit, *)
    write(unit, '("# 3-body")')
    write(fmt,'("(""# bond-angle "",",I0,"(1X,A))")') size(this%bond_info)
    write(unit, fmt) this%element_info(:)%name
    do i = 1, this%nbins(2)
       write(unit, *) &
            this%cutoff_min(2) + this%width(2) * ( i - 1 ), &
            this%gdf%df_3body(i,:)
    end do
    write(unit, *)
    write(unit, '("# 4-body")')
    write(fmt,'("(""# dihedral-angle "",",I0,"(1X,A))")') size(this%bond_info)
    write(unit, fmt) this%element_info(:)%name
    do i = 1, this%nbins(3)
       write(unit, *) &
            this%cutoff_min(2) + this%width(2) * ( i - 1 ), &
            this%gdf%df_4body(i,:)
    end do
    close(unit)

  end subroutine write_gdfs
!###############################################################################


!###############################################################################
  subroutine read_gdfs(this, file)
    !! Read the generalised distribution functions from a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to read the generalised distribution functions from.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: iostat
    !! I/O status.

    integer :: i
    !! Loop index.
    integer :: nspec
    !! Number of species.
    logical :: exist
    !! Boolean whether the file exists.
    character(256) :: buffer, buffer1
    !! Buffer for reading lines.

    ! check if file exists
    inquire(file=file, exist=exist)
    if(.not.exist)then
       call stop_program( "File does not exist" )
       return
    end if

    ! read the file
    open(newunit=unit, file=file)
    do
       read(unit, '(A)', iostat=iostat) buffer
       if(iostat.ne.0) exit
       buffer = trim(adjustl(buffer))
       if(trim(buffer) .eq. "") cycle
       if(buffer(1:1) .ne. "#") cycle
       ! get the header
       buffer = trim(adjustl(buffer(2:)))
       if(trim(adjustl(buffer)) .eq. "2-body") exit
       if(index(buffer, "history_len") .ne. 0) then
          read(buffer, *) buffer1, this%history_len
          call this%set_history_len(this%history_len)
       else if(index(buffer, "history_deltas") .ne. 0) then
          read(buffer, *) buffer1, this%history_deltas
       else if(index(buffer, "nbins") .ne. 0) then
          read(buffer, *) buffer1, this%nbins
       else if(index(buffer, "width") .ne. 0) then
          read(buffer, *) buffer1, this%width
       else if(index(buffer, "sigma") .ne. 0) then
          read(buffer, *) buffer1, this%sigma
       else if(index(buffer, "cutoff_min") .ne. 0) then
          read(buffer, *) buffer1, this%cutoff_min
       else if(index(buffer, "cutoff_max") .ne. 0) then
          read(buffer, *) buffer1, this%cutoff_max
       else if(index(buffer, "radius_distance_tol") .ne. 0) then
          read(buffer, *) buffer1, this%radius_distance_tol
       else if(index(buffer, "elements") .ne. 0) then
          nspec = icount(buffer(index(buffer,"elements")+8:))
          if(allocated(this%element_info)) deallocate(this%element_info)
          allocate(this%element_info(nspec))
          read(buffer, *) buffer1, this%element_info(:)%name
       else if(index(buffer, "energies") .ne. 0) then
          read(buffer, *) buffer1, this%element_info(:)%energy
          do i = 1, nspec
             call this%set_element_energy( &
                  this%element_info(i)%name, &
                  this%element_info(i)%energy &
             )
             call this%element_info(i)%set(this%element_info(i)%name)
          end do
          call this%update_bond_info()
          allocate(this%best_energy_per_species(nspec))
          allocate(this%norm_3body(nspec))
          allocate(this%norm_4body(nspec))
          allocate(this%in_dataset_3body(nspec))
          allocate(this%in_dataset_4body(nspec))
          allocate(this%best_energy_pair(size(this%bond_info)))
          allocate(this%norm_2body(size(this%bond_info)))
          allocate(this%in_dataset_2body(size(this%bond_info)))
       else if(index(buffer, "best_energy_per_element") .ne. 0) then
          read(buffer, *) buffer1, this%best_energy_per_species
       else if(index(buffer, "3-body_norm") .ne. 0) then
          read(buffer, *) buffer1, this%norm_3body
       else if(index(buffer, "4-body_norm") .ne. 0) then
          read(buffer, *) buffer1, this%norm_4body
       else if(index(buffer, "in_dataset_3body") .ne. 0) then
          read(buffer, *) buffer1, this%in_dataset_3body
       else if(index(buffer, "in_dataset_4body") .ne. 0) then
          read(buffer, *) buffer1, this%in_dataset_4body
       else if(index(buffer, "element_pairs") .ne. 0) then
          read(buffer, *) buffer1, this%bond_info(:)%element(1)
          read(buffer, *) buffer1, this%bond_info(:)%element(2)
       else if(index(buffer, "radii") .ne. 0) then
          read(buffer, *) buffer1, this%bond_info(:)%radius_covalent
       else if(index(buffer, "best_energy_per_pair") .ne. 0) then
          read(buffer, *) buffer1, this%best_energy_pair
       else if(index(buffer, "3-body_norm") .ne. 0) then
          read(buffer, *) buffer1, this%norm_3body
       else if(index(buffer, "4-body_norm") .ne. 0) then
          read(buffer, *) buffer1, this%norm_4body
       else if(index(buffer, "in_dataset_3body") .ne. 0) then
          read(buffer, *) buffer1, this%in_dataset_3body
       else if(index(buffer, "in_dataset_4body") .ne. 0) then
          read(buffer, *) buffer1, this%in_dataset_4body
       else if(index(buffer, "2-body_norm") .ne. 0) then
          read(buffer, *) buffer1, this%norm_2body
       else if(index(buffer, "in_dataset_2body") .ne. 0) then
          read(buffer, *) buffer1, this%in_dataset_2body
       else
          write(0,*) "Unknown header: ", trim(buffer)
          cycle
       end if
    end do

    read(unit, *)
    allocate(this%gdf%df_2body(this%nbins(1),size(this%bond_info)))
    do i = 1, this%nbins(1)
       read(unit, *) buffer, this%gdf%df_2body(i,:)
    end do
    read(unit, *)
    read(unit, *)
    read(unit, *)
    allocate(this%gdf%df_3body(this%nbins(2),nspec))
    do i = 1, this%nbins(2)
       read(unit, *) buffer, this%gdf%df_3body(i,:)
    end do
    read(unit, *)
    read(unit, *)
    read(unit, *)
    allocate(this%gdf%df_4body(this%nbins(3),nspec))
    do i = 1, this%nbins(3)
       read(unit, *) buffer, this%gdf%df_4body(i,:)
    end do
    close(unit)

  end subroutine read_gdfs
!###############################################################################


!###############################################################################
  subroutine write_dfs(this, file)
    !! Write all distribution functions for each system to a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to write the distribution functions to.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: i, j
    !! Loop indices.
    character(256) :: stop_msg
    !! Error message.

    if(.not.allocated(this%system))then
       write(stop_msg,*) "No systems to write" // &
            achar(13) // achar(10) // &
            "Systems either not created or deallocated after evolve" // &
            achar(13) // achar(10) // &
            "To stop automatic deallocation, " // &
            "use the following flag in create()" // &
            achar(13) // achar(10) // &
            "   deallocate_systems = .false."
       call stop_program( stop_msg )
       return
    end if
    open(newunit=unit, file=file)
    write(unit, *) "nbins", this%nbins
    write(unit, *) "width", this%width
    write(unit, *) "sigma", this%sigma
    write(unit, *) "cutoff_min", this%cutoff_min
    write(unit, *) "cutoff_max", this%cutoff_max
    write(unit, *)
    do i = 1, size(this%system,1)
       write(unit, *) this%system(i)%energy
       write(unit, *) this%system(i)%element_symbols
       write(unit, *) this%system(i)%stoichiometry
       do j = 1, this%nbins(1)
          write(unit, *) this%system(i)%df_2body(j,:)
       end do
       do j = 1, this%nbins(2)
          write(unit, *) this%system(i)%df_3body(j,:)
       end do
       do j = 1, this%nbins(3)
          write(unit, *) this%system(i)%df_4body(j,:)
       end do
       write(unit, *)
    end do
    close(unit)

  end subroutine write_dfs
!###############################################################################


!###############################################################################
  subroutine read_dfs(this, file)
    !! Read all distribution functions for each system from a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to read the distribution functions from.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: j
    !! Loop indices.
    integer :: iostat
    !! I/O status.
    integer :: num_species, num_pairs
    !! Number of species and pairs.
    character(256) :: buffer
    !! Buffer for reading lines.
    type(distribs_type) :: system
    !! System to read distribution functions into.


    open(newunit=unit, file=file)
    read(unit, *) buffer, this%nbins
    read(unit, *) buffer, this%width
    read(unit, *) buffer, this%sigma
    read(unit, *) buffer, this%cutoff_min
    read(unit, *) buffer, this%cutoff_max
    do
       read(unit, '(A)', iostat=iostat) buffer
       if(iostat.ne.0) exit
       if(trim(buffer).eq.''.or.trim(buffer).eq.'#') cycle
       read(buffer, *) system%energy
       read(unit, '(A)') buffer
       num_species = icount(buffer)
       allocate(system%element_symbols(num_species))
       allocate(system%stoichiometry(num_species))
       read(buffer, *) system%element_symbols
       read(unit, *) system%stoichiometry
       system%num_atoms = sum(system%stoichiometry)
       num_pairs = nint( &
            gamma(real(num_species + 2, real32)) / &
            ( gamma(real(num_species, real32)) * gamma( 3._real32 ) ) &
       )
       allocate(system%df_2body(this%nbins(1),num_pairs))
       do j = 1, this%nbins(1)
          read(unit, *) system%df_2body(j,:)
       end do
       allocate(system%df_3body(this%nbins(2),num_species))
       do j = 1, this%nbins(2)
          read(unit, *) system%df_3body(j,:)
       end do
       allocate(system%df_4body(this%nbins(3),num_species))
       do j = 1, this%nbins(3)
          read(unit, *) system%df_4body(j,:)
       end do

       this%system = [ this%system, system ]
       deallocate(&
            system%element_symbols, system%stoichiometry, &
            system%df_2body, system%df_3body, system%df_4body &
       )
    end do
    close(unit)

  end subroutine read_dfs
!###############################################################################


!###############################################################################
  subroutine write_2body(this, file)
    !! Write the learned 2-body distribution functions to a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to write the 2-body distribution functions to.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: i, j, is, js
    !! Loop indices.
    integer :: num_pairs
    !! Number of pairs.
    integer, allocatable, dimension(:,:) :: idx
    !! Pair indices.


    num_pairs = nint( &
         gamma(real(size(this%element_info) + 2, real32)) / &
         ( gamma(real(size(this%element_info), real32)) * gamma( 3._real32 ) ) &
    )
    allocate(idx(2,num_pairs))
    i = 0
    do is = 1, size(this%element_info)
       do js = is, size(this%element_info), 1
          i = i + 1
          idx(:,i) = [is, js]
       end do
    end do

    open(newunit=unit, file=file)
    do i = 1,  size(this%gdf%df_2body, dim=2)
       write(unit,'("# ",A,2X,A)') &
            this%element_info(idx(1,i))%name, &
            this%element_info(idx(2,i))%name
       do j = 1, size(this%gdf%df_2body, dim=1)
          write(unit,*) &
               this%cutoff_min(1) + this%width(1) * ( j - 1 ), &
               this%gdf%df_2body(j,i)
       end do
       write(unit,*)
    end do
    close(unit)

  end subroutine write_2body
!###############################################################################


!###############################################################################
  subroutine write_3body(this, file)
    !! Write the learned 3-body distribution functions to a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to write the 3-body distribution functions to.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: i, j
    !! Loop indices.


    open(newunit=unit, file=file)
    do i = 1,  size(this%gdf%df_3body, dim=2)
       write(unit,'("# ",A)') this%element_info(i)%name
       do j = 1, size(this%gdf%df_3body, dim=1)
          write(unit,*) &
               this%cutoff_min(2) + this%width(2) * ( j - 1 ), &
               this%gdf%df_3body(j,i)
       end do
       write(unit,*)
    end do
    close(unit)

  end subroutine write_3body
!###############################################################################


!###############################################################################
  subroutine write_4body(this, file)
    !! Write the learned 4-body distribution functions to a file.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    character(*), intent(in) :: file
    !! Filename to write the 4-body distribution functions to.

    ! Local variables
    integer :: unit
    !! File unit.
    integer :: i, j
    !! Loop indices.


    open(newunit=unit, file=file)
    do i = 1,  size(this%gdf%df_4body, dim=2)
       write(unit,'("# ",A)') this%element_info(i)%name
       do j = 1, size(this%gdf%df_4body, dim=1)
          write(unit,*) &
               this%cutoff_min(3) + this%width(3) * ( j - 1 ), &
               this%gdf%df_4body(j,i)
       end do
       write(unit,*)
    end do
    close(unit)

  end subroutine write_4body
!###############################################################################


!###############################################################################
  function get_2body(this) result(output)
    !! Get the 2-body distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(this%nbins(1),size(this%bond_info)) :: output

    output = this%gdf%df_2body

  end function get_2body
!###############################################################################


!###############################################################################
  function get_3body(this) result(output)
    !! Get the 3-body distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(this%nbins(2),size(this%element_info)) :: output

    output = this%gdf%df_3body

  end function get_3body
!###############################################################################


!###############################################################################
  function get_4body(this) result(output)
    !! Get the 4-body distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent. Instance of distribution functions container.
    real(real32), dimension(this%nbins(3),size(this%element_info)) :: output

    output = this%gdf%df_4body

  end function get_4body
!###############################################################################


!###############################################################################
  function generate_fingerprint(this, structure) result(output)
    !! Generate a descriptor for the structure.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    type(basis_type), intent(in) :: structure
    !! Structure to generate the descriptor for.
    type(distribs_type) :: output
    !! Descriptor for the structure.

    call output%calculate( &
         structure, &
         width = this%width, &
         sigma = this%sigma, &
         cutoff_min = this%cutoff_min, &
         cutoff_max = this%cutoff_max, &
         radius_distance_tol = this%radius_distance_tol &
    )

  end function generate_fingerprint
!-------------------------------------------------------------------------------
  subroutine generate_fingerprint_python( &
       this, structure, output_2body, output_3body, output_4body &
  )
    !! Generate a descriptor for the structure.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    type(basis_type), intent(in) :: structure
    !! Structure to generate the descriptor for.
    real(real32), dimension(:,:), intent(out) :: output_2body
    !! 2-body descriptor for the structure.
    real(real32), dimension(:,:), intent(out) :: output_3body
    !! 3-body descriptor for the structure.
    real(real32), dimension(:,:), intent(out) :: output_4body
    !! 4-body descriptor for the structure.

    ! Local variables
    type(distribs_type) :: distrib
    !! Descriptor for the structure.

    distrib = this%generate_fingerprint(structure)
    output_2body = distrib%df_2body
    output_3body = distrib%df_3body
    output_4body = distrib%df_4body

  end subroutine generate_fingerprint_python
!###############################################################################


!###############################################################################
  subroutine add(this, system)
    !! Add a system to the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    class(*), dimension(..), intent(in) :: system
    !! System to add to the container.

    ! Local variables
    integer :: i
    !! Loop index.
    integer :: num_structures_previous
    !! Number of structures in the container before adding the system.
    character(256) :: stop_msg
    !! Error message.

    select rank(rank_ptr => system)
    rank(0)
       select type(type_ptr => rank_ptr)
       type is (distribs_type)
          this%system = [ this%system, type_ptr ]
       class is (basis_type)
#if defined(GFORTRAN)
          call this%add_basis(type_ptr)
#else
          block
            type(basis_type), dimension(1) :: basis

            basis = type_ptr
            call this%add_basis(basis(1))
          end block
#endif
       class default
          write(stop_msg,*) "Invalid type for system" // &
               achar(13) // achar(10) // &
               "Expected type distribs_type or basis_type"
          call stop_program( stop_msg )
          return
       end select
    rank(1)
       num_structures_previous = size(this%system)
       if(.not.allocated(this%system))then
          allocate(this%system(0))
       end if
       select type(type_ptr => rank_ptr)
       type is (distribs_type)
          this%system = [ this%system, type_ptr ]
       class is (basis_type)
          do i = 1, size(type_ptr)
             call this%add_basis(type_ptr(i))
          end do
       class default
          write(stop_msg,*) "Invalid type for system" // &
               achar(13) // achar(10) // &
               "Expected type distribs_type or basis_type"
          call stop_program( stop_msg )
          return
       end select
    rank default
       write(stop_msg,*) "Invalid rank for system" // &
            achar(13) // achar(10) // &
            "Expected rank 0 or 1, got ", rank(rank_ptr)
       call stop_program( stop_msg )
       return
    end select
    call this%update_element_info()
    call this%update_bond_info()

  end subroutine add
!###############################################################################


!###############################################################################
  subroutine add_basis(this, basis)
    !! Add a basis to the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    type(basis_type), intent(in) :: basis
    !! Basis to add to the container.

    ! Local variables
    type(distribs_type) :: system
    !! System to add to the container.

    call system%calculate( &
         basis, &
         width = this%width, &
         sigma = this%sigma, &
         cutoff_min = this%cutoff_min, &
         cutoff_max = this%cutoff_max, &
         radius_distance_tol = this%radius_distance_tol &
    )

    if(.not.allocated(this%system))then
       this%system = [ system ]
    else
       this%system = [ this%system, system ]
    end if
  end subroutine add_basis
!###############################################################################


!###############################################################################
  subroutine set_element_map(this, element_list)
    !! Set the element map for the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(3), dimension(:), intent(in) :: element_list
    !! Element information.

    ! Local variables
    integer :: is
    !! Loop index.
    integer :: idx
    !! Index of the element in the element_info array.
    character(256) :: stop_msg
    !! Error message.

    if(allocated(this%element_map)) deallocate(this%element_map)
    allocate(this%element_map(size(element_list)))
    do is = 1, size(element_list)
       idx = findloc( &
            [ this%element_info(:)%name ], element_list(is), dim=1 &
       )
       if(idx.eq.0)then
          write(stop_msg,*) "Element not found in element_info array" // &
               achar(13) // achar(10) // &
               "Element: ", element_list(is)
          call stop_program( stop_msg )
          return
       end if
       this%element_map(is) = idx
    end do

  end subroutine set_element_map
!###############################################################################


!###############################################################################
  subroutine set_element_info(this)
    !! Set the list of elements for the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: i
    !! Loop index.
    real(real32) :: radius
    !! Element radii.
    character(len=3), dimension(:), allocatable :: element_list
    !! List of elements in the container.


    !---------------------------------------------------------------------------
    ! get list of species in dataset
    !---------------------------------------------------------------------------
    allocate(element_list(0))
    element_list = [ this%system(1)%element_symbols ]
    do i = 2, size(this%system),1
       element_list = [ element_list, this%system(i)%element_symbols ]
    end do
    call set(element_list)
    if(allocated(this%element_info)) deallocate(this%element_info)
    if(.not.allocated(element_database)) allocate(element_database(0))
    allocate(this%element_info(size(element_list)))
    do i = 1, size(element_list)
       if( findloc( &
            [ element_database(:)%name ], element_list(i), dim=1 ) .lt. 1 )then
          call get_element_properties(element_list(i), radius=radius)
          element_database = [ &
               element_database(:), &
               element_type(name = element_list(i), radius = radius) &
          ]
       end if
       call this%element_info(i)%set(element_list(i))
    end do

  end subroutine set_element_info
!###############################################################################


!###############################################################################
  subroutine update_element_info(this)
    !! Update the element information in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: i
    !! Loop index.
    real(real32) :: radius
    !! Element radii.
    character(len=3), dimension(:), allocatable :: element_list
    !! List of elements in the container.


    !---------------------------------------------------------------------------
    ! check if element_info is allocated, if not, set it and return
    !---------------------------------------------------------------------------
    if(.not.allocated(this%element_info))then
       call this%set_element_info()
       return
    elseif(size(this%element_info).eq.0)then
       call this%set_element_info()
       return
    end if


    !---------------------------------------------------------------------------
    ! get list of species in dataset
    !---------------------------------------------------------------------------
    allocate(element_list(0))
    element_list = [ this%system(1)%element_symbols ]
    do i = 2, size(this%system),1
       element_list = [ element_list, this%system(i)%element_symbols ]
    end do
    call set(element_list)


    !---------------------------------------------------------------------------
    ! check if all elements are in the element_info array
    !---------------------------------------------------------------------------
    if(.not.allocated(element_database)) allocate(element_database(0))
    do i = 1, size(element_list)
       if(findloc( &
            [ element_database(:)%name ], &
            element_list(i), dim=1 ) .lt. 1 )then
          call get_element_properties(element_list(i), radius=radius)
          element_database = [ &
               element_database(:), &
               element_type(name = element_list(i), radius = radius) &
          ]
       end if
       if( findloc( &
            [ this%element_info(:)%name ], &
            element_list(i), dim=1 ) .lt. 1 )then
          this%element_info = [ &
               this%element_info(:), &
               element_type(element_list(i)) &
          ]
          call this%element_info(size(this%element_info))%set(element_list(i))
       end if
    end do

  end subroutine update_element_info
!###############################################################################


!###############################################################################
  subroutine add_to_element_info(this, element)
    !! Add an element to the element_info array.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), intent(in) :: element
    !! Element name.


    if(.not.allocated(this%element_info)) allocate(this%element_info(0))
    this%element_info = [ &
         this%element_info(:), &
         element_type(element) &
    ]
    call this%element_info(size(this%element_info))%set(element)

  end subroutine add_to_element_info
!###############################################################################


!###############################################################################
  subroutine set_element_energy(this, element, energy)
    !! Set the energy of an element in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), intent(in) :: element
    !! Element name.
    real(real32), intent(in) :: energy
    !! Energy of the element.

    ! Local variables
    integer :: idx, idx_db
    !! Index of the element in the element_info array.
    real(real32) :: radius
    !! Element radius.
    character(len=3) :: element_
    !! Element name without null characters.
    logical :: in_element_info
    !! Boolean whether the element is in the element_info array.


    !---------------------------------------------------------------------------
    ! remove python formatting
    !---------------------------------------------------------------------------
    element_ = strip_null(element)


    !---------------------------------------------------------------------------
    ! if element_info is allocated, update energy of associated index
    !---------------------------------------------------------------------------
    in_element_info = .false.
    if(allocated(this%element_info))then
       idx = findloc( [ this%element_info(:)%name ], element_, dim=1 )
       if(idx.ge.1)then
          this%element_info(idx)%energy = energy
          in_element_info = .true.
       end if
    end if


    !---------------------------------------------------------------------------
    ! if element_database is allocated, update energy of associated index
    !---------------------------------------------------------------------------
    if(.not.allocated(element_database)) allocate(element_database(0))
    idx_db = findloc( [ element_database(:)%name ], element_, dim=1 )
    if(idx_db.lt.1)then
       call get_element_properties( element_, radius = radius )
       element_database = [ &
            element_database(:), &
            element_type(name = element_, energy = energy, radius = radius) &
       ]
    else
       element_database(idx_db)%energy = energy
    end if


    !---------------------------------------------------------------------------
    ! if element is not in element_info, add it to reserve_element_names
    !---------------------------------------------------------------------------
    if(.not.in_element_info) call this%add_to_element_info(element_)

  end subroutine set_element_energy
!###############################################################################


!###############################################################################
  subroutine set_element_energies(this, elements, energies)
    !! Set the energies of elements in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(:), intent(in) :: elements
    !! Element names.
    real(real32), dimension(:), intent(in) :: energies
    !! Energies of the elements.

    ! Local variables
    integer :: i

    do i = 1, size(elements)
       call this%set_element_energy(elements(i), energies(i))
    end do

  end subroutine set_element_energies
!###############################################################################


!###############################################################################
  subroutine get_element_energies(this, elements, energies)
    !! Return the energies of elements in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(:), allocatable, intent(out) :: elements
    !! Element names.
    real(real32), dimension(:), allocatable, intent(out) :: energies
    !! Energies of the elements.

    ! Local variables
    integer :: i
    !! Loop index.


    allocate(elements(size(this%element_info)))
    allocate(energies(size(this%element_info)))
    do i = 1, size(this%element_info)
       elements(i) = this%element_info(i)%name
       energies(i) = this%element_info(i)%energy
    end do

  end subroutine get_element_energies
!###############################################################################


!###############################################################################
  subroutine get_element_energies_staticmem(this, elements, energies)
    !! Return the energies of elements in the container.
    !!
    !! This subroutine is used when the memory for the output arrays is
    !! allocated outside of the subroutine. Used in Python interface.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(size(this%element_info,1)), intent(out) :: &
         elements
    !! Element names.
    real(real32), dimension(size(this%element_info,1)), intent(out) :: energies
    !! Energies of the elements.

    ! Local variables
    integer :: i
    !! Loop index.


    do i = 1, size(this%element_info,1)
       elements(i) = this%element_info(i)%name
       energies(i) = this%element_info(i)%energy
    end do

  end subroutine get_element_energies_staticmem
!###############################################################################


!###############################################################################
  subroutine set_bond_info(this)
    !! Set the 2-body bond information for the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: i, j
    !! Loop index.
    integer :: num_elements, num_pairs
    !! Number of elements and pairs.
    logical :: success
    !! Success flag.


    !---------------------------------------------------------------------------
    ! allocate the bond information array
    !---------------------------------------------------------------------------
    num_elements = size(this%element_info)
    num_pairs = nint(gamma(real(num_elements + 2, real32)) / &
         ( gamma(real(num_elements, real32)) * gamma( 3._real32 ) ) )
    if(allocated(this%bond_info)) deallocate(this%bond_info)
    allocate(this%bond_info(num_pairs))


    !---------------------------------------------------------------------------
    ! loop over all pairs of elements to set the bond information
    !---------------------------------------------------------------------------
    num_pairs = 0
    pair_loop1: do i = 1, num_elements
       pair_loop2: do j = i, num_elements
          num_pairs = num_pairs + 1
          call this%bond_info(num_pairs)%set( &
               this%element_info(i)%name, &
               this%element_info(j)%name, &
               success &
          )
          if(success) cycle pair_loop2
          call set_bond_radius_to_default( [ &
               this%element_info(i)%name, &
               this%element_info(j)%name &
          ] )
          call this%bond_info(num_pairs)%set( &
               this%element_info(i)%name, &
               this%element_info(j)%name, &
               success &
          )
       end do pair_loop2
    end do pair_loop1

  end subroutine set_bond_info
!###############################################################################


!###############################################################################
  subroutine set_bond_radius_to_default(elements)
    !! Set the bond radius to the default value.
    !!
    !! The default value is the average of the covalent radii of the elements.
    implicit none

    ! Arguments
    character(len=3), dimension(2), intent(in) :: elements
    !! Element symbols.

    ! Local variables
    integer :: idx1, idx2
    !! Index of the elements in the element database.
    real(real32) :: radius, radius1, radius2
    !! Average of covalent radii.
    character(256) :: warn_msg


    write(warn_msg,'("No bond data for element pair ",A," and ",A)') &
         elements(1), elements(2)
    warn_msg = trim(warn_msg) // &
         achar(13) // achar(10) // &
         "Setting bond to average of covalent radii"
    call print_warning(warn_msg)
    if(.not.allocated(element_database)) allocate(element_database(0))
    idx1 = findloc([ element_database(:)%name ], &
         elements(1), dim=1)
    if(idx1.lt.1)then
       call get_element_properties(elements(1), radius=radius1)
       element_database = [ element_database, &
            element_type(name=elements(1), radius=radius1) ]
       idx1 = size(element_database)
    end if
    idx2 = findloc([ element_database(:)%name ], &
         elements(2), dim=1)
    if(idx2.lt.1)then
       call get_element_properties(elements(2), radius=radius2)
       element_database = [ element_database, &
            element_type(name=elements(2), radius=radius2) ]
       idx2 = size(element_database)
    end if
    radius = ( element_database(idx1)%radius + &
         element_database(idx2)%radius ) / 2._real32
    if(.not.allocated(element_bond_database)) &
         allocate(element_bond_database(0))
    element_bond_database = [ element_bond_database, &
         element_bond_type(elements=[ &
              elements(1), &
              elements(2) &
         ], radius=radius) &
    ]
    call sort_str( &
         element_bond_database(size(element_bond_database))%element &
    )

  end subroutine set_bond_radius_to_default
!###############################################################################


!###############################################################################
  subroutine update_bond_info(this)
    !! Update the element information in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: i, j, k, is, js
    !! Loop index.
    real(real32) :: radius, radius1, radius2
    !! Average of covalent radii.
    character(len=3), dimension(:), allocatable :: element_list
    !! List of elements in the container.
    character(len=3), dimension(:,:), allocatable :: pair_list
    !! List of element pairs in the container.


    !---------------------------------------------------------------------------
    ! check if bond_info is allocated, if not, set it and return
    !---------------------------------------------------------------------------
    if(.not.allocated(this%bond_info))then
       call this%set_bond_info()
       return
    elseif(size(this%bond_info).eq.0)then
       call this%set_bond_info()
       return
    end if


    !---------------------------------------------------------------------------
    ! get list of element pairs in dataset
    !---------------------------------------------------------------------------
    allocate(element_list(0))
    element_list = [ this%system(1)%element_symbols ]
    do i = 2, size(this%system),1
       element_list = [ element_list, this%system(i)%element_symbols ]
    end do
    call set(element_list)
    allocate(pair_list(triangular_number(size(element_list)),2))
    k = 0
    do i = 1, size(element_list)
       do j = i, size(element_list)
          k = k + 1
          pair_list(k,:) = [ element_list(i), element_list(j) ]
          call sort_str(pair_list(k,:))
       end do
    end do

    !---------------------------------------------------------------------------
    ! check if all element pairs are in the database
    !---------------------------------------------------------------------------
    if(.not.allocated(element_bond_database)) allocate(element_bond_database(0))
    pair_loop1: do i = 1, size(pair_list,1)
       do j = 1, size(element_bond_database)
          if( ( &
               element_bond_database(j)%element(1) .eq. pair_list(i,1) .and. &
               element_bond_database(j)%element(2) .eq. pair_list(i,2) &
          ) .or. ( &
               element_bond_database(j)%element(1) .eq. pair_list(i,2) .and. &
               element_bond_database(j)%element(2) .eq. pair_list(i,1) &
          ) ) cycle pair_loop1
       end do
       ! if not found, add to the database
       is = findloc([ this%element_info(:)%name ], pair_list(i,1), dim=1)
       js = findloc([ this%element_info(:)%name ], pair_list(i,2), dim=1)
       radius1 = this%element_info(is)%radius
       if(radius1.le.1.E-6) &
            call get_element_properties(pair_list(i,1), radius = radius1)
       radius2 = this%element_info(js)%radius
       if(radius2.le.1.E-6) &
            call get_element_properties(pair_list(i,2), radius = radius2)
       radius = ( radius1 + radius2 ) / 2._real32
       element_bond_database = [ element_bond_database, &
            element_bond_type(elements=[pair_list(i,:)], radius=radius) ]
       call sort_str(element_bond_database(size(element_bond_database))%element)
    end do pair_loop1


    ! --------------------------------------------------------------------------
    ! check if all element pairs are in the bond_info array
    ! --------------------------------------------------------------------------
    pair_loop2: do i = 1, size(pair_list,1)
       info_loop: do j = 1, size(this%bond_info)
          if( ( &
               this%bond_info(j)%element(1) .eq. pair_list(i,1) .and. &
               this%bond_info(j)%element(2) .eq. pair_list(i,2) &
          ) .or. ( &
               this%bond_info(j)%element(1) .eq. pair_list(i,2) .and. &
               this%bond_info(j)%element(2) .eq. pair_list(i,1) &
          ) ) cycle pair_loop2
       end do info_loop
       this%bond_info = [ &
            this%bond_info(:), &
            element_bond_type( [ pair_list(i,1:2) ] ) &
       ]
       call this%bond_info(size(this%bond_info))%set( &
            pair_list(i,1), &
            pair_list(i,2) )
    end do pair_loop2

  end subroutine update_bond_info
!###############################################################################


!###############################################################################
  subroutine set_bond_radius(this, elements, radius)
    !! Set the bond radius for a pair of elements in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(2), intent(in) :: elements
    !! Element name.
    real(real32), intent(in) :: radius
    !! Bond radius.

    ! Local variables
    integer :: idx, i
    !! Index of the bond in the bond_info array.
    character(len=3) :: element_1, element_2
    !! Element names.


    !---------------------------------------------------------------------------
    ! remove python formatting
    !---------------------------------------------------------------------------
    element_1 = strip_null(elements(1))
    element_2 = strip_null(elements(2))


    !---------------------------------------------------------------------------
    ! if bond_info is allocated, update radius of associated index
    !---------------------------------------------------------------------------
    if(allocated(this%bond_info))then
       idx = this%get_pair_index(element_1, element_2)
       if(idx.ge.1) this%bond_info(idx)%radius_covalent = radius
    end if


    !---------------------------------------------------------------------------
    ! if element_bond_database is allocated, update radius of associated index
    !---------------------------------------------------------------------------
    if(.not.allocated(element_bond_database))then
       allocate(element_bond_database(1))
       element_bond_database(1)%element = [ element_1, element_2 ]
       call sort_str(element_bond_database(1)%element)
       element_bond_database(1)%radius_covalent = radius
       return
    end if
    do i = 1, size(element_bond_database)
       if( ( &
            element_bond_database(i)%element(1) .eq. element_1 .and. &
            element_bond_database(i)%element(2) .eq. element_2 &
       ) .or. ( &
            element_bond_database(i)%element(1) .eq. element_2 .and. &
            element_bond_database(i)%element(2) .eq. element_1 &
       ) )then
          element_bond_database(i)%radius_covalent = radius
          return
       end if
    end do
    ! if allocated and not found, add to the database
    element_bond_database = [ element_bond_database, &
         element_bond_type([ element_1, element_2 ], radius) ]
    call sort_str(element_bond_database(size(element_bond_database))%element)

  end subroutine set_bond_radius
!###############################################################################


!###############################################################################
  subroutine set_bond_radii(this, elements, radii)
    !! Set the bond radii for a pair of elements in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(:,:), intent(in) :: elements
    !! Element names.
    real(real32), dimension(:), intent(in) :: radii
    !! Bond radii.

    ! Local variables
    integer :: i
    !! Loop index.


    do i = 1, size(elements,1)
       call this%set_bond_radius(elements(i,:), radii(i))
    end do

  end subroutine set_bond_radii
!###############################################################################


!###############################################################################
  subroutine get_bond_radii(this, elements, radii)
    !! Return the bond radii of elements in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(:,:), allocatable, intent(out) :: elements
    !! Element pair names.
    real(real32), dimension(:), allocatable, intent(out) :: radii
    !! Radii of the bond pairs.

    ! Local variables
    integer :: i
    !! Loop index.


    allocate(elements(size(this%bond_info),2))
    allocate(radii(size(this%bond_info)))
    do i = 1, size(this%bond_info)
       elements(i,:) = this%bond_info(i)%element
       radii(i) = this%bond_info(i)%radius_covalent
    end do

  end subroutine get_bond_radii
!###############################################################################


!###############################################################################
  subroutine get_bond_radii_staticmem(this, elements, radii)
    !! Return the energies of elements in the container.
    !!
    !! This subroutine is used when the memory for the output arrays is
    !! allocated outside of the subroutine. Used in Python interface.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), dimension(size(this%bond_info,1),2), intent(out) :: &
         elements
    !! Element pair names.
    real(real32), dimension(size(this%bond_info,1)), intent(out) :: radii
    !! Radii of the bond pairs.

    ! Local variables
    integer :: i
    !! Loop index.


    do i = 1, size(this%bond_info)
       elements(i,:) = this%bond_info(i)%element
       radii(i) = this%bond_info(i)%radius_covalent
    end do

  end subroutine get_bond_radii_staticmem
!###############################################################################


!###############################################################################
  subroutine set_best_energy(this)
    !! Set the best energy in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: i, j, is, js, idx1, idx2
    !! Loop index.
    real(real32) :: energy, energy_per_species, energy_pair
    !! Energy of the system.
    integer, dimension(:,:), allocatable :: idx_list
    !! Index list for pairs of elements.
    character(len=256) :: warn_msg
    !! Warning message.

    if(.not.allocated(this%best_energy_pair))then
       allocate( &
            this%best_energy_pair(size(this%bond_info,1)), &
            source = 0._real32 &
       )
    elseif(size(this%best_energy_pair).ne.size(this%bond_info))then
       deallocate(this%best_energy_pair)
       allocate( &
            this%best_energy_pair(size(this%bond_info,1)), &
            source = 0._real32 &
       )
    end if

    if(.not.allocated(this%best_energy_per_species))then
       allocate( &
            this%best_energy_per_species(size(this%element_info,1)), &
            source = 0._real32 &
       )
    elseif(size(this%best_energy_per_species).ne.size(this%element_info))then
       deallocate(this%best_energy_per_species)
       allocate( &
            this%best_energy_per_species(size(this%element_info,1)), &
            source = 0._real32 &
       )
    end if

    do i = 1, size(this%system)
       j = 0
       allocate( idx_list( &
            size(this%system(i)%element_symbols), &
            size(this%system(i)%element_symbols) &
       ) )
       do is = 1, size(this%system(i)%element_symbols)
          do js = is, size(this%system(i)%element_symbols), 1
             j = j + 1
             idx_list(is,js) = j
             idx_list(js,is) = j
          end do
       end do

       energy = this%system(i)%energy
       do is = 1, size(this%system(i)%element_symbols)
          idx1 = findloc( &
               [ this%element_info(:)%name ], &
               this%system(i)%element_symbols(is), &
               dim = 1 &
          )
          if(idx1.lt.1)then
             call stop_program( "Species not found in element_info" )
             return
          end if
          energy = energy - &
               this%system(i)%stoichiometry(is) * this%element_info(idx1)%energy
       end do
       energy = energy / this%system(i)%num_atoms

       do is = 1, size(this%system(i)%element_symbols)
          if(this%system(i)%num_per_species(is).eq.0)then
             write(warn_msg, &
                  '("No neighbours found for species ",A," (",I0,") &
                  &in system ",I0)' &
             ) trim(this%system(i)%element_symbols(is)), is, i
             call print_warning(warn_msg)
             cycle
          end if
          idx1 = findloc( &
               [ this%element_info(:)%name ], &
               this%system(i)%element_symbols(is), &
               dim = 1 &
          )
          energy_per_species = &
               energy * this%system(i)%weight_per_species(is) / &
               real( sum( this%system(i)%num_per_species(:) ), real32 )

          if( energy_per_species .lt. this%best_energy_per_species(idx1) )then
             this%best_energy_per_species(idx1) = energy_per_species
          end if
          do js = 1, size(this%system(i)%element_symbols)
             idx2 = findloc( &
                  [ this%element_info(:)%name ], &
                  this%system(i)%element_symbols(js), &
                  dim = 1 &
             )
             j = nint( &
                  ( &
                       size(this%element_info) - &
                       min( idx1, idx2 ) / 2._real32 &
                  ) * ( min( idx1, idx2 ) - 1._real32 ) + max( idx1, idx2 ) &
             )

             energy_pair = &
                  energy * this%system(i)%weight_pair(idx_list(is,js)) / &
                  real( sum( this%system(i)%num_per_species(:) ), real32 )

             if( energy_pair .lt. this%best_energy_pair(j) )then
                this%best_energy_pair(j) = energy_pair
             end if

          end do
       end do
       deallocate(idx_list)
       if( this%best_energy_pair(j) .lt. -1.E1 )then
          write(warn_msg, &
               '("Best energy pair is less than -10 eV, &
               &this is likely to be unphysical. Check the energy values.")' &
          )
          call print_warning(warn_msg)
       end if

    end do

  end subroutine set_best_energy
!###############################################################################


!###############################################################################
  pure function get_pair_index(this, species1, species2) result(idx)
    !! Get the index of a pair of elements in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), intent(in) :: species1, species2
    !! Element names.
    integer :: idx
    !! Index of the pair in the bond_info array.

    ! Local variables
    integer :: is, js
    !! Index of the elements in the element_info array.

    is = findloc([ this%element_info(:)%name ], species1, dim=1)
    js = findloc([ this%element_info(:)%name ], species2, dim=1)
    !! This comes from subtraction of nth triangular numbers
    !! nth triangular number: N_n = n(n+1)/2 = ( n^2 + n ) / 2
    !! idx = N_n - N_{n-is+1} + ( js - is + 1)
    !! idx = ( n - is/2 ) * ( is - 1 ) + js
    !idx = nint( ( size(this%element_info) - min( is, js ) / 2._real32 ) * &
    !      ( is - 1._real32 ) + js )
    idx = nint( ( size(this%element_info) - min( is, js ) / 2._real32 ) * &
         ( min( is, js ) - 1._real32 ) + max( is, js ) )

  end function get_pair_index
!###############################################################################


!###############################################################################
  pure function get_element_index(this, species) result(idx)
    !! Get the index of an element in the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    character(len=3), intent(in) :: species
    !! Element name.
    integer :: idx
    !! Index of the element in the element_info array.

    idx = findloc([ this%element_info(:)%name ], species, dim=1)

  end function get_element_index
!###############################################################################


!###############################################################################
  subroutine set_num_bins(this)
    !! Set the number of bins for the n-body distribution functions.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: i
    !! Loop index.

    do i = 1, 3
       if(this%nbins(i).eq.-1)then
          this%nbins(i) = 1 + &
               nint( &
                    ( this%cutoff_max(i) - this%cutoff_min(i) ) / &
                    this%width(i) &
               )
       end if
       this%width_inv(i) = ( this%nbins(i) - 1 ) / &
            ( this%cutoff_max(i) - this%cutoff_min(i) )
    end do

  end subroutine set_num_bins
!###############################################################################


!###############################################################################
  pure function get_bin(this, value, dim) result(bin)
    !! Get the bin index for a value in a dimension.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    real(real32), intent(in) :: value
    !! Value to get the bin index for.
    integer, intent(in) :: dim
    !! Dimension to get the bin index for.
    integer :: bin
    !! Bin index for the value.

    ! Local variables
    real(real32) :: min_val, width_inv
    !! Temporary variables.

    ! Prefetch frequently accessed values
    min_val = this%cutoff_min(dim)
    width_inv = this%width_inv(dim)

    ! Calculate bin using optimized operations
    bin = nint((value - min_val) * width_inv) + 1

    ! Ensure bin stays within bounds (floating point safety)
    bin = min(max(bin, 1), this%nbins(dim))

  end function get_bin
!###############################################################################


!###############################################################################
  subroutine initialise_gdfs(this)
    !! Initialise the distribution functions for the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.

    ! Local variables
    integer :: num_pairs
    !! Number of pairs.


    num_pairs = nint( gamma(real(size(this%element_info) + 2, real32)) / &
         ( gamma(real(size(this%element_info), real32)) * gamma( 3._real32 ) ) )
    allocate(this%gdf%df_2body(this%nbins(1),num_pairs), &
         source = 0._real32 )
    allocate(this%gdf%df_3body(this%nbins(2),size(this%element_info)), &
         source = 0._real32 )
    allocate(this%gdf%df_4body(this%nbins(3),size(this%element_info)), &
         source = 0._real32 )
    allocate(this%in_dataset_2body(num_pairs), source = .false. )
    allocate(this%in_dataset_3body(size(this%element_info)), source = .false. )
    allocate(this%in_dataset_4body(size(this%element_info)), source = .false. )

  end subroutine initialise_gdfs
!###############################################################################


!###############################################################################
  subroutine set_gdfs_to_default(this, body, index)
    !! Initialise the gdfs for index of body distribution function.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    integer, intent(in) :: body
    !! Body distribution function to initialise.
    integer, intent(in) :: index
    !! Index of the pair in the bond_info array.

    ! Local variables
    real(real32) :: eta, weight, height
    !! Parameters for the distribution functions.
    real(real32), dimension(1) :: bonds


    if( body .eq. 2 )then
       weight = exp( -4._real32 )
       height = 1._real32 / this%nbins(1)
       eta = 1._real32 / ( 2._real32 * ( this%sigma(1) )**2._real32 )
       if(size(this%bond_info).eq.0)then
          call set_bond_radius_to_default( [ &
               this%bond_info(index)%element(1), &
               this%bond_info(index)%element(2) &
          ] )
       end if
       bonds = [ 2._real32 * this%bond_info(index)%radius_covalent ]
       if(abs(bonds(1)).lt.1.E-6)then
          call stop_program( "Bond radius is zero" )
       end if
       this%gdf%df_2body(:,index) = weight * height * get_distrib( &
            bonds , &
            this%nbins(1), eta, this%width(1), &
            this%cutoff_min(1), &
            scale_list = [ 1._real32 ] &
       )
    elseif( body .eq. 3 )then
       this%gdf%df_3body(:,index) = 1._real32/this%nbins(2)
    elseif( body .eq. 4 )then
       this%gdf%df_4body(:,index) = 1._real32/this%nbins(3)
    end if

  end subroutine set_gdfs_to_default
!###############################################################################


!###############################################################################
  subroutine evolve(this, system)
    !! Evolve the generalised distribution functions for the container.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    type(distribs_type), dimension(..), intent(in), optional :: system
    !! Optional. System to add to the container.

    ! Local variables
    integer :: i, j, is, js
    !! Loop index.
    integer :: idx1, idx2
    !! Index of the element in the element_info array.
    integer :: num_evaluated
    !! Number of systems evaluated this iteration.
    real(real32) :: weight, energy
    !! Energy and weight variables for a system.
    real(real32), dimension(:), allocatable :: &
         best_energy_pair_old, &
         best_energy_per_species_old
    !! Old best energies.
    integer, dimension(:,:), allocatable :: idx_list
    !! Index list for the element pairs in a system.
    real(real32), dimension(:,:), allocatable :: tmp_df
    !! Temporary array for the distribution functions.
    logical, dimension(:), allocatable :: tmp_in_dataset

    character(256) :: err_msg
    integer, dimension(:), allocatable :: host_idx_list


    weight = 1._real32

    !---------------------------------------------------------------------------
    ! if present, add the system to the container
    !---------------------------------------------------------------------------
    if(present(system)) call this%add(system)
    call this%set_num_bins()


    !---------------------------------------------------------------------------
    ! initialise the generalised distribution functions and get
    ! best energies from lowest formation energy system
    !---------------------------------------------------------------------------
    if(.not.allocated(this%gdf%df_2body))then
       call this%set_best_energy()
       call this%initialise_gdfs()
    else
       best_energy_pair_old = this%best_energy_pair
       best_energy_per_species_old = this%best_energy_per_species
       call this%set_best_energy()
       do i = 1, size(this%gdf%df_2body,2)
          this%gdf%df_2body(:,i) = this%gdf%df_2body(:,i) * &
               exp( this%best_energy_pair(i) / this%kBT ) / &
               exp( best_energy_pair_old(i) / this%kBT )
       end do
       do i = 1, size(this%gdf%df_3body,2)
          this%gdf%df_3body(:,i) = &
               this%gdf%df_3body(:,i) * exp( &
                    this%best_energy_per_species(i) / this%kBT &
               ) / exp( best_energy_per_species_old(i) / this%kBT )
       end do
       do i = 1, size(this%gdf%df_4body,2)
          this%gdf%df_4body(:,i) = &
               this%gdf%df_4body(:,i) * exp( &
                    this%best_energy_per_species(i) / this%kBT &
               ) / exp( best_energy_per_species_old(i) / this%kBT )
       end do
       if(size(this%gdf%df_2body,2).ne.size(this%bond_info))then
          allocate(tmp_df(this%nbins(1),size(this%bond_info)), &
               source = 0._real32 )
          tmp_df(:,1:size(this%gdf%df_2body,2)) = this%gdf%df_2body
          deallocate(this%gdf%df_2body)
          call move_alloc( tmp_df, this%gdf%df_2body )
          allocate(tmp_in_dataset(size(this%bond_info)), source = .false. )
          tmp_in_dataset(1:size(this%in_dataset_2body)) = this%in_dataset_2body
          deallocate(this%in_dataset_2body)
          call move_alloc( tmp_in_dataset, this%in_dataset_2body )
       end if
       if(size(this%gdf%df_3body,2).ne.size(this%element_info))then
          allocate(tmp_df(this%nbins(2),size(this%element_info)), &
               source = 0._real32 )
          tmp_df(:,1:size(this%gdf%df_3body,2)) = this%gdf%df_3body
          deallocate(this%gdf%df_3body)
          call move_alloc( tmp_df, this%gdf%df_3body )
          allocate(tmp_in_dataset(size(this%element_info)), source = .false. )
          tmp_in_dataset(1:size(this%in_dataset_3body)) = this%in_dataset_3body
          deallocate(this%in_dataset_3body)
          call move_alloc( tmp_in_dataset, this%in_dataset_3body )
       end if
       if(size(this%gdf%df_4body,2).ne.size(this%element_info))then
          allocate(tmp_df(this%nbins(3),size(this%element_info)), &
               source = 0._real32 )
          tmp_df(:,1:size(this%gdf%df_4body,2)) = this%gdf%df_4body
          deallocate(this%gdf%df_4body)
          call move_alloc( tmp_df, this%gdf%df_4body )
          allocate(tmp_in_dataset(size(this%element_info)), source = .false. )
          tmp_in_dataset(1:size(this%in_dataset_4body)) = this%in_dataset_4body
          deallocate(this%in_dataset_4body)
          call move_alloc( tmp_in_dataset, this%in_dataset_4body )
       end if
       do j = 1, size(this%gdf%df_2body,2)
          if(.not.this%in_dataset_2body(j))then
             this%gdf%df_2body(:,j) = 0._real32
          else
             this%gdf%df_2body(:,j) = &
                  this%gdf%df_2body(:,j) * this%norm_2body(j)
          end if
       end do
       do is = 1, size(this%element_info)
          if(.not.this%in_dataset_3body(is))then
             this%gdf%df_3body(:,is) = 0._real32
          else
             this%gdf%df_3body(:,is) = &
                  this%gdf%df_3body(:,is) * this%norm_3body(is)
          end if
          if(.not.this%in_dataset_4body(is))then
             this%gdf%df_4body(:,is) = 0._real32
          else
             this%gdf%df_4body(:,is) = &
                  this%gdf%df_4body(:,is) * this%norm_4body(is)
          end if
       end do
       deallocate(this%norm_2body)
       deallocate(this%norm_3body)
       deallocate(this%norm_4body)
    end if

    if( &
         any(this%system(this%num_evaluated_allocated+1:)%from_host) .and. &
         this%host_system%defined &
    )then
       ! set host_idx_list
       allocate(host_idx_list(size(this%element_info)))
       host_idx_list = 0
       do is = 1, size(this%host_system%element_symbols)
          idx1 = findloc( &
               [ this%element_info(:)%name ], &
               this%host_system%element_symbols(is), &
               dim = 1 &
          )
          if(idx1.lt.1)then
             call stop_program( "Host species not found in species list" )
             return
          end if
          host_idx_list(idx1) = is
       end do
    end if

    !---------------------------------------------------------------------------
    ! loop over all systems to calculate the generalised distribution functions
    !---------------------------------------------------------------------------
    num_evaluated = 0
    do i = this%num_evaluated_allocated + 1, size(this%system), 1
       num_evaluated = num_evaluated + 1
       if(this%weight_by_hull)then
          weight = exp( this%system(i)%energy_above_hull / this%kBT )
          if(weight.lt.1.E-6_real32) cycle
       end if
       !------------------------------------------------------------------------
       ! get the list of 2-body species pairs the system
       !------------------------------------------------------------------------
       j = 0
       allocate( idx_list( &
            size(this%system(i)%element_symbols), &
            size(this%system(i)%element_symbols) &
       ) )
       do is = 1, size(this%system(i)%element_symbols)
          do js = is, size(this%system(i)%element_symbols), 1
             j = j + 1
             idx_list(is,js) = j
             idx_list(js,is) = j
          end do
       end do


       !------------------------------------------------------------------------
       ! calculate the weight for the system
       !------------------------------------------------------------------------
       energy = this%system(i)%energy
       do is = 1, size(this%system(i)%element_symbols)
          idx1 = findloc( &
               [ this%element_info(:)%name ], &
               this%system(i)%element_symbols(is), &
               dim = 1 &
          )
          if(idx1.lt.1)then
             call stop_program( "Species not found in species list" )
             return
          end if
          energy = energy - this%system(i)%stoichiometry(is) * &
               this%element_info(idx1)%energy
       end do
       energy = energy / this%system(i)%num_atoms
       j = 0
       !------------------------------------------------------------------------
       ! loop over all species in the system to add the distributions
       !------------------------------------------------------------------------
       do is = 1, size(this%system(i)%element_symbols)

          if( this%system(i)%num_per_species(is).eq.0 )cycle

          idx1 = findloc( &
               [ this%element_info(:)%name ], &
               this%system(i)%element_symbols(is), &
               dim = 1 &
          )

          if(.not.this%weight_by_hull)then
             weight = exp( &
                  ( &
                       this%best_energy_per_species(is) - &
                       energy * ( &
                            this%system(i)%weight_per_species(is) / &
                            real( &
                                 sum( this%system(i)%num_per_species(:) ), &
                                 real32 &
                            ) &
                       ) &
                  ) / this%kBT &
             )
             if(weight.lt.1.E-6_real32) cycle
          end if

          this%gdf%df_3body(:,idx1) = this%gdf%df_3body(:,idx1) + &
               set_difference( &
                    weight * this%system(i)%df_3body(:,is), &
                    this%gdf%df_3body(:,idx1), &
                    set_min_zero = .true. &
               )

          this%gdf%df_4body(:,idx1) = this%gdf%df_4body(:,idx1) + &
               set_difference( &
                    weight * this%system(i)%df_4body(:,is), &
                    this%gdf%df_4body(:,idx1), &
                    set_min_zero = .true. &
               )

          do js = is, size(this%system(i)%element_symbols), 1
             idx2 = findloc( &
                  [ this%element_info(:)%name ], &
                  this%system(i)%element_symbols(js), &
                  dim = 1 &
             )
             j = nint( ( &
                  size(this%element_info) - min( idx1, idx2 ) / 2._real32 &
             ) * ( min( idx1, idx2 ) - 1._real32 ) + max( idx1, idx2 ) )

             if(.not.this%weight_by_hull)then
                weight = exp( &
                     ( &
                          this%best_energy_pair(j) - &
                          energy * ( &
                               this%system(i)%weight_pair(idx_list(is,js)) / &
                               real( &
                                    sum( this%system(i)%num_per_species(:) ), &
                                    real32 &
                               ) &
                          ) &
                     ) / this%kBT &
                )
                if(weight.lt.1.E-6_real32) cycle
             end if

             this%gdf%df_2body(:,j) = this%gdf%df_2body(:,j) + &
                  set_difference( &
                       weight * this%system(i)%df_2body(:,idx_list(is,js)), &
                       this%gdf%df_2body(:,j), &
                       set_min_zero = .true. &
                  )

          end do
       end do
       deallocate(idx_list)
    end do

    !---------------------------------------------------------------------------
    ! if not in the dataset, set distribution functions to default
    !---------------------------------------------------------------------------
    do j = 1, size(this%gdf%df_2body,2)
       if(all(abs(this%gdf%df_2body(:,j)).lt.1.E-6_real32))then
          call this%set_gdfs_to_default(2, j)
       else
          this%in_dataset_2body(j) = .true.
       end if
    end do
    do is = 1, size(this%element_info)
       if(all(abs(this%gdf%df_3body(:,is)).lt.1.E-6_real32))then
          call this%set_gdfs_to_default(3, is)
       else
          this%in_dataset_3body(is) = .true.
       end if
       if(all(abs(this%gdf%df_4body(:,is)).lt.1.E-6_real32))then
          call this%set_gdfs_to_default(4, is)
       else
          this%in_dataset_4body(is) = .true.
       end if
    end do

    allocate(this%norm_2body(size(this%gdf%df_2body,2)))
    do j = 1, size(this%gdf%df_2body,2)
       this%norm_2body(j) = maxval(this%gdf%df_2body(:,j))
       if(abs(this%norm_2body(j)).lt.1.E-6_real32)then
          call stop_program( "Zero norm for 2-body distribution function" )
          return
       end if
       this%gdf%df_2body(:,j) = &
            this%gdf%df_2body(:,j) / this%norm_2body(j)
       if(any(isnan(this%gdf%df_2body(:,j))))then
          write(err_msg, &
               '("NaN in 2-body distribution function for ",A,"-",A,&
               &" with norm of ",F0.3)' &
          ) &
               this%bond_info(j)%element(1), &
               this%bond_info(j)%element(2), &
               this%norm_2body(j)
          call stop_program( err_msg )
          return
       end if
    end do
    allocate(this%norm_3body(size(this%element_info)))
    allocate(this%norm_4body(size(this%element_info)))
    do is = 1, size(this%element_info)
       this%norm_3body(is) = maxval(this%gdf%df_3body(:,is))
       if(abs(this%norm_3body(is)).lt.1.E-6_real32)then
          call stop_program( "Zero norm for 3-body distribution function" )
          return
       end if
       this%norm_4body(is) = maxval(this%gdf%df_4body(:,is))
       if(abs(this%norm_4body(is)).lt.1.E-6_real32)then
          call stop_program( "Zero norm for 4-body distribution function" )
          return
       end if
       this%gdf%df_3body(:,is) = &
            this%gdf%df_3body(:,is) / this%norm_3body(is)
       this%gdf%df_4body(:,is) = &
            this%gdf%df_4body(:,is) / this%norm_4body(is)

       if(any(isnan(this%gdf%df_3body(:,is))))then
          write(err_msg,'("NaN in 3-body distribution function for ",A,&
               &" with norm of ",F0.3)' &
          ) &
               this%element_info(is)%name, this%norm_3body(is)
          call stop_program( err_msg )
          return
       elseif(any(isnan(this%gdf%df_4body(:,is))))then
          write(err_msg,'("NaN in 4-body distribution function for ",A,&
               &" with norm of ",F0.3)' &
          ) &
               this%element_info(is)%name, this%norm_4body(is)
          call stop_program( err_msg )
          return
       end if
    end do

    this%num_evaluated_allocated = size(this%system)
    this%num_evaluated = this%num_evaluated + num_evaluated

    this%viability_2body_default = sum( this%gdf%df_2body ) / &
         real( size( this%gdf%df_2body ), real32 )
    this%viability_3body_default = sum( this%gdf%df_3body ) / &
         real( size( this%gdf%df_3body ), real32 )
    this%viability_4body_default = sum( this%gdf%df_4body ) / &
         real( size( this%gdf%df_4body ), real32 )

  end subroutine evolve
!###############################################################################


!###############################################################################
  function is_converged(this, threshold) result(converged)
    !! Check if the distribution functions have converged.
    implicit none

    ! Arguments
    class(distribs_container_type), intent(in) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    real(real32), intent(in), optional :: threshold
    !! Threshold for convergence.
    logical :: converged
    !! Convergence flag.

    ! Local variables
    real(real32) :: threshold_
    !! Threshold for convergence.


    threshold_ = 1.E-4_real32
    if(present(threshold)) threshold_ = threshold

    if(any(abs(this%history_deltas-huge(0._real32)).lt.1.E-6_real32))then
       converged = .false.
       return
    end if
    if(all(abs(this%history_deltas - this%history_deltas(1)).lt.threshold))then
       converged = .true.
    else
       converged = .false.
    end if

  end function is_converged
!###############################################################################

end module raffle__distribs_container

module raffle__generator
  !! Module for generating random structures from host structures.
  !!
  !! This module contains the raffle generator type, which is used to generate
  !! random structures from a host structure. The raffle generator uses
  !! distribution functions to determine the placement of atoms in the
  !! provided host structure.
  use raffle__io_utils, only: stop_program, print_warning, suppress_warnings
  use raffle__constants, only: real32
  use raffle__tools_infile, only: assign_val, assign_vec
  use raffle__misc, only: strip_null, set, shuffle, sort1D, sort2D, to_upper
  use raffle__geom_rw, only: basis_type
  use raffle__geom_extd, only: extended_basis_type
  use raffle__distribs_container, only: distribs_container_type
  use raffle__geom_utils, only: basis_merge
  use raffle__place_methods, only: &
       place_method_void, place_method_rand, &
       place_method_growth, place_method_walk, &
       place_method_min
  use raffle__viability, only: &
       get_gridpoints_and_viability, update_gridpoints_and_viability

  implicit none


  private
  public :: raffle_generator_type, stoichiometry_type


  type :: stoichiometry_type
     !! Type for storing the stoichiometry of atoms to be placed in the host
     !! structure.
     character(len=3) :: element
     !! Element symbol.
     integer :: num
     !! Number of atoms.
  end type stoichiometry_type


  type :: raffle_generator_type
     !! Type for instance of raffle generator.
     !!
     !! This type contains the parameters and methods for generating random
     !! structures from a host structure, using the RAFFLE method.
     integer :: num_structures = 0
     !! Number of structures generated. Initialised to zero.

     integer, dimension(:), allocatable :: seed
     !! Seed for random number generator

     type(basis_type) :: host
     !! Host structure.
     integer, dimension(3) :: grid = [0, 0, 0]
     !! Grid to divide the host structure into along each axis.
     real(real32), dimension(3) :: &
          grid_offset = [0.5_real32, 0.5_real32, 0.5_real32]
     !! Offset of the gridpoints.
     real(real32) :: grid_spacing = 0.1_real32
     !! Spacing of the gridpoints.
     real(real32), dimension(2,3) :: bounds = reshape( &
          (/ &
               0.0_real32, 1.0_real32, &
               0.0_real32, 1.0_real32, &
               0.0_real32, 1.0_real32 &
          /), [2,3] &
     )
     !! Bounds for atom placement.
     type(distribs_container_type) :: distributions
     !! Distribution function container for the 2-, 3-, and 4-body interactions.
     integer :: max_attempts = 10000
     !! Limit for the number of attempts to place an atom.
     real(real32) :: &
          walk_step_size_coarse = 1._real32, &
          walk_step_size_fine = 0.1_real32
     !! Step size for the walk and grow methods.
     real(real32), dimension(5) :: method_ratio_default = &
          [0.1_real32, 0.01_real32, 0.25_real32, 0.25_real32, 1.0_real32]
     !! Default ratio of each placement method.
     real(real32), dimension(5) :: method_ratio
     !! Last used ratio of each placement method.
     type(basis_type), dimension(:), allocatable :: structures
     !! Generated structures.
   contains
     procedure, pass(this) :: init_seed
     !! Procedure to set the seed for the random number generator.
     procedure, pass(this) :: set_method_ratio_default
     !! Procedure to set the ratio of each placement method.

     procedure, pass(this) :: set_host
     !! Procedure to set the host structure.
     procedure, pass(this) :: get_host
     !! Procedure to get the host structure.
     procedure, pass(this) :: prepare_host
     !! Procedure to prepare the host structure.
     procedure, pass(this) :: set_grid
     !! Procedure to set the grid for the raffle generator.
     procedure, pass(this) :: reset_grid
     !! Procedure to reset the grid for the raffle generator.
     procedure, pass(this) :: set_bounds
     !! Procedure to set the bounds for the raffle generator.
     procedure, pass(this) :: reset_bounds
     !! Procedure to reset the bounds for the raffle generator.
     procedure, pass(this) :: generate
     !! Procedure to generate random structures.
     procedure, pass(this), private :: generate_structure
     !! Procedure to generate a single random structure.
     procedure, pass(this) :: get_structures
     !! Procedure to return the generated structures.
     procedure, pass(this) :: set_structures
     !! Procedure to set the array of generated structures.
     procedure, pass(this) :: remove_structure
     !! Procedure to remove a structure from the array of generated structures.
     procedure, pass(this) :: evaluate
     !! Procedure to evaluate the viability of a structure.
     procedure, pass(this) :: get_probability_density
     !! Procedure to get the probability density of a structure.

     procedure, pass(this) :: print_settings => print_generator_settings
     !! Procedure to print the raffle generator settings.
     procedure, pass(this) :: read_settings => read_generator_settings
     !! Procedure to read the raffle generator settings.
  end type raffle_generator_type

  interface raffle_generator_type
     !! Constructor for the raffle generator type.
     module function init_raffle_generator( &
          host, &
          width, sigma, cutoff_min, cutoff_max, &
          history_len &
     ) result(generator)
       type(basis_type), intent(in), optional :: host
       real(real32), dimension(3), intent(in), optional :: width
       real(real32), dimension(3), intent(in), optional :: sigma
       real(real32), dimension(3), intent(in), optional :: cutoff_min
       real(real32), dimension(3), intent(in), optional :: cutoff_max
       integer, intent(in), optional :: history_len
       type(raffle_generator_type) :: generator
     end function init_raffle_generator
  end interface raffle_generator_type


contains

!###############################################################################
  module function init_raffle_generator( &
       host, width, sigma, cutoff_min, cutoff_max, &
       history_len &
  ) result(generator)
    !! Initialise an instance of the raffle generator.
    !!
    !! Set up run-independent parameters.
    implicit none

    ! Arguments
    type(basis_type), intent(in), optional :: host
    !! Basis of the host structure.
    real(real32), dimension(3), intent(in), optional :: width
    !! Width of the gaussians used in the 2-, 3-, and 4-body
    !! distribution functions.
    real(real32), dimension(3), intent(in), optional :: sigma
    !! Width of the gaussians used in the 2-, 3-, and 4-body
    !! distribution functions.
    real(real32), dimension(3), intent(in), optional :: cutoff_min
    !! Minimum cutoff for the 2-, 3-, and 4-body distribution functions.
    real(real32), dimension(3), intent(in), optional :: cutoff_max
    !! Maximum cutoff for the 2-, 3-, and 4-body distribution functions.
    integer, intent(in), optional :: history_len
    !! Length of the history for the 2-, 3-, and 4-body distribution functions.

    ! Local variables
    type(raffle_generator_type) :: generator
    !! Instance of the raffle generator.

    ! Handle optional arguments
    ! Set up the host structure
    if(present(host)) call generator%set_host(host)

    ! Set up the distribution function parameters
    if(present(width)) &
         call generator%distributions%set_width(width)
    if(present(sigma)) &
         call generator%distributions%set_sigma(sigma)
    if(present(cutoff_min)) &
         call generator%distributions%set_cutoff_min(cutoff_min)
    if(present(cutoff_max)) &
         call generator%distributions%set_cutoff_max(cutoff_max)

    if(present(history_len)) &
         call generator%distributions%set_history_len(history_len)

  end function init_raffle_generator
!###############################################################################


!###############################################################################
  subroutine init_seed(this, put, get, num_threads)
    !! Set the seed for the random number generator.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    integer, dimension(..), intent(in), optional :: put
    !! Seed for the random number generator.
    integer, dimension(:), intent(out), optional :: get
    !! Seed for the random number generator.
    integer, intent(out), optional :: num_threads
    !! Size of the seed array.

    ! Local variables
    integer :: num_threads_
    !! Number of threads for the random number generator.
    integer, dimension(:), allocatable :: seed_arr
    !! Array of seeds for the random number generator.

    call random_seed( size = num_threads_ )
    allocate(seed_arr(num_threads_))
    if(present(put))then
       select rank(put)
       rank(0)
          seed_arr(1:num_threads_) = put
       rank(1)
          if(size(put).eq.1)then
             seed_arr(1:num_threads_) = put(1)
          elseif(size(put).eq.num_threads_)then
             seed_arr = put
          else
             call stop_program("Invalid seed array size")
             return
          end if
       rank default
          call stop_program("Invalid seed array")
          return
       end select
       call random_seed( put = seed_arr )
    end if

    if(present(get))then
       call random_seed( get = seed_arr )
       get = seed_arr
    end if

    this%seed = seed_arr
    if(present(num_threads)) num_threads = num_threads_

  end subroutine init_seed
!###############################################################################


!###############################################################################
  subroutine set_method_ratio_default(this, method_ratio)
    !! Set the ratio of each placement method.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    real(real32), dimension(5), intent(in) :: method_ratio
    !! Ratio of each placement method.

    this%method_ratio_default = method_ratio

  end subroutine set_method_ratio_default
!###############################################################################


!###############################################################################
  subroutine set_host(this, host)
    !! Set the host structure.
    !!
    !! This procedure sets the host structure for the raffle generator.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    class(basis_type), intent(in) :: host
    !! Basis of the host structure.

    call this%host%copy(host)
    call this%distributions%host_system%set(this%host)

    call this%set_grid()
  end subroutine set_host
!###############################################################################


!###############################################################################
  function get_host(this) result(output)
    !! Get the host structure.
    !!
    !! This procedure returns the host structure from the raffle generator.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(in) :: this
    !! Instance of the raffle generator.

    type(basis_type) :: output
    !! Basis of the host structure.

    call output%copy(this%host)

  end function get_host
!###############################################################################


!###############################################################################
  function prepare_host( &
       this, interface_location, interface_axis, depth, &
       location_as_fractional &
  ) result(stoichiometry)
    !! Prepare the host structure for the raffle generator.
    !!
    !! This procedure prepares the host structure for the raffle generator.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    real(real32), dimension(:), intent(in) :: interface_location
    !! Location of the interface in the host structure.
    integer, intent(in), optional :: interface_axis
    !! Axis of the interface in the host structure.
    real(real32), intent(in), optional :: depth
    !! Depth of the interface.
    logical, intent(in), optional :: location_as_fractional
    !! Boolean whether interface location is given in fractional coordinates.

    type(stoichiometry_type), dimension(:), allocatable :: stoichiometry
    !! Stoichiometry of the atoms removed from the host structure.

    ! Local variables
    integer :: i, is, ia
    !! Loop indices.
    integer :: num_remove
    !! Number of atoms removed from the host structure.
    integer :: axis
    !! Axis of the interface in the host structure.
    real(real32) :: dist, depth_
    !! Distance to the interface and depth of the interface.
    real(real32) :: lattice_const
    !! Lattice constant of the host structure along the interface axis.
    type(basis_type) :: host
    !! Host structure.
    logical :: location_as_fractional_
    !! Boolean whether interface location is given in fractional coordinates.
    real(real32), dimension(size(interface_location)) :: intf_loc_
    integer, dimension(:), allocatable :: species_index_list
    !! List of species indices to remove.
    integer, dimension(:,:), allocatable :: remove_atom_list
    !! List of atoms to be removed from the host structure.


    !---------------------------------------------------------------------------
    ! Handle optional arguments
    !---------------------------------------------------------------------------
    axis = 3
    if(present(interface_axis)) axis = interface_axis
    depth_ = 3._real32
    if(present(depth)) depth_ = depth
    call host%copy(this%host)
    lattice_const = norm2(host%lat(axis,:))
    location_as_fractional_ = .false.
    if(present(location_as_fractional)) &
         location_as_fractional_ = location_as_fractional
    if(location_as_fractional_)then
       intf_loc_ = interface_location
    else
       intf_loc_ = interface_location / lattice_const
    end if


    !---------------------------------------------------------------------------
    ! Identify atoms to be removed from the host structure
    !---------------------------------------------------------------------------
    num_remove = 0
    allocate(remove_atom_list(2,host%natom))
    do is = 1, host%nspec
       atom_loop: do ia = 1, host%spec(is)%num
          do i = 1, size(intf_loc_)
             dist = host%spec(is)%atom(ia,axis) - intf_loc_(i)
             dist = dist - ceiling(dist - 0.5_real32)
             if( abs(dist * lattice_const) .le. depth_ )then
                num_remove = num_remove + 1
                remove_atom_list(:,num_remove) = [ is, ia ]
                cycle atom_loop
             end if
          end do
       end do atom_loop
    end do


    !---------------------------------------------------------------------------
    ! Create the dictionary of atoms to be removed
    !---------------------------------------------------------------------------
    if(num_remove.gt.0)then
       remove_atom_list = remove_atom_list(1:2,1:num_remove)
       call host%remove_atoms(remove_atom_list)
       species_index_list = remove_atom_list(1,:)
       call set(species_index_list)
       call sort2D(remove_atom_list, 1)
       allocate(stoichiometry(size(species_index_list)))
       do i = 1, size(species_index_list)
          stoichiometry(i)%element = host%spec(species_index_list(i))%name
          stoichiometry(i)%num = &
               count(remove_atom_list(1,:).eq.species_index_list(i))
       end do
    end if


    !---------------------------------------------------------------------------
    ! Reset the host structure
    !---------------------------------------------------------------------------
    if(host%natom.eq.0)then
       call stop_program("No atoms remaining in host structure")
       return
    end if
    call this%set_host(host)

  end function prepare_host
!###############################################################################


!###############################################################################
  subroutine set_grid(this, grid, grid_spacing, grid_offset)
    !! Set the grid for the raffle generator.
    !!
    !! This procedure sets the grid for the raffle generator. The grid is used
    !! to divide the host structure into bins along each axis on which
    !! atom placement viability will be evaluated
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    integer, dimension(3), intent(in), optional :: grid
    !! Number of bins to divide the host structure into along each axis.
    real(real32), intent(in), optional :: grid_spacing
    !! Spacing of the bins.
    real(real32), dimension(3), intent(in), optional :: grid_offset
    !! Offset of the gridpoints.

    ! Local variables
    integer :: i
    !! Loop index.


    if(present(grid).and.present(grid_spacing)) then
       call this%reset_grid()
       call stop_program("Cannot set grid and grid spacing simultaneously")
       return
    elseif(present(grid_spacing)) then
       this%grid_spacing = grid_spacing
       this%grid = 0
    elseif(present(grid)) then
       this%grid = grid
    end if

    if(present(grid_offset)) this%grid_offset = grid_offset

    if(all(this%grid.eq.0))then
       if(allocated(this%host%spec))then
          do i = 1, 3
             this%grid(i) = nint( &
                  ( this%bounds(2,i) - this%bounds(1,i) ) * &
                  norm2(this%host%lat(i,:)) / this%grid_spacing &
             )
          end do
       end if
    end if

  end subroutine set_grid
!###############################################################################


!###############################################################################
  subroutine reset_grid(this)
    !! Reset the grid for the raffle generator.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.

    this%grid = 0
  end subroutine reset_grid
!###############################################################################


!###############################################################################
  subroutine set_bounds(this, bounds)
    !! Set the bounds for the raffle generator.
    !!
    !! This procedure sets the bounds for the raffle generator. The bounds are
    !! used to determine the placement of atoms in the host structure.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    real(real32), dimension(2,3), intent(in) :: bounds
    !! Bounds for atom placement.

    ! check if bounds has zero volume, if so, return
    if( any(bounds(2,:) .le. bounds(1,:)) ) then
       call stop_program("Bounds have zero volume")
       return
    end if

    this%bounds = bounds
    call this%set_grid()

  end subroutine set_bounds
!###############################################################################


!###############################################################################
  subroutine reset_bounds(this)
    !! Reset the grid for the raffle generator.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.

    this%bounds(1,:) = 0.0_real32
    this%bounds(2,:) = 1.0_real32
  end subroutine reset_bounds
!###############################################################################


!###############################################################################
  subroutine generate(this, num_structures, &
       stoichiometry, method_ratio, seed, settings_out_file, &
       verbose, exit_code &
  )
    !! Generate random structures.
    !!
    !! This procedure generates random structures from the contained host
    !! structure and the stoichiometry argument. The number of structures to
    !! generate is specified by the num_structures argument.
    !! The ratio of placement methods to be sampled is defined by method_ratio.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    integer, intent(in) :: num_structures
    !! Number of structures to generate.
    type(stoichiometry_type), dimension(:), intent(in) :: stoichiometry
    !! Stoichiometry of the structures to generate.
    real(real32), dimension(5), intent(in), optional :: method_ratio
    !! Ratio of each placement method.
    integer, intent(in), optional :: seed
    !! Seed for the random number generator.
    character(*), intent(in), optional :: settings_out_file
    !! File to print the settings to.
    integer, intent(in), optional :: verbose
    !! Verbosity level.
    integer, intent(out), optional :: exit_code
    !! Exit code.

    ! Local variables
    integer :: i, j, k, istructure, num_structures_old, num_structures_new
    !! Loop counters.
    integer :: exit_code_
    !! Exit code.
    integer :: num_seed
    !! Number of seeds for the random number generator.
    integer :: num_insert_atoms, num_insert_species
    !! Number of atoms and species to insert (from stoichiometry).
    real(real32) :: ratio_norm
    !! Normalisation factor for the method ratios.
    logical :: success
    !! Boolean comparison of element symbols.
    integer :: verbose_
    !! Verbosity level.
    logical :: suppress_warnings_store
    !! Boolean to store the suppress_warnings value.
    type(basis_type) :: basis_template
    !! Basis of the structure to generate (i.e. allocated species and atoms).
    real(real32), dimension(5) :: method_rand_limit
    !! Default ratio of each placement method.

    integer, dimension(:), allocatable :: seed_arr
    !! Array of seeds for the random number generator.
    type(basis_type), dimension(:), allocatable :: tmp_structures
    !! Temporary array of structures (for memory reallocation).

    integer, dimension(:,:), allocatable :: placement_list
    !! List of possible atoms to place in the structure.


    !---------------------------------------------------------------------------
    ! Set the verbosity level
    !---------------------------------------------------------------------------
    exit_code_ = 0
    verbose_ = 0
    if(present(verbose)) verbose_ = verbose
    if(verbose_ .eq. 0)then
       suppress_warnings_store = suppress_warnings
       suppress_warnings = .true.
    end if


    !---------------------------------------------------------------------------
    ! Handle placement method optional argument
    !---------------------------------------------------------------------------
    if(present(method_ratio))then
       method_rand_limit = method_ratio
    else
       method_rand_limit = this%method_ratio_default
    end if
    this%method_ratio = method_rand_limit
    if(verbose_.gt.0) write(*,*) &
         "Method ratio (void, rand, walk, grow, min): ", this%method_ratio


    !---------------------------------------------------------------------------
    ! Print the settings to a file
    !---------------------------------------------------------------------------
    if(present(settings_out_file))then
       if(trim(settings_out_file).ne."")then
          call this%print_settings(settings_out_file)
       end if
    end if


    !---------------------------------------------------------------------------
    ! Set the placement method selection limit numbers
    !---------------------------------------------------------------------------
    if(verbose_.gt.0) write(*,*) "Setting method ratio limits"
    ratio_norm = real(sum(method_rand_limit), real32)
    method_rand_limit = method_rand_limit / ratio_norm
    do i = 2, 5, 1
       method_rand_limit(i) = method_rand_limit(i) + method_rand_limit(i-1)
    end do
    if(verbose_.gt.0) write(*,*) &
         "Method random limits (void, rand, walk, grow, min): ", &
         method_rand_limit


    !---------------------------------------------------------------------------
    ! Set the random seed
    !---------------------------------------------------------------------------
    if(present(seed))then
       call this%init_seed( put = seed )
    elseif(.not.allocated(this%seed))then
       call this%init_seed()
    end if


    !---------------------------------------------------------------------------
    ! allocate memory for structures
    !---------------------------------------------------------------------------
    if(verbose_.gt.0) write(*,*) "Allocating memory for structures"
    if(.not.allocated(this%structures))then
       allocate(this%structures(num_structures))
    else
       allocate(tmp_structures(this%num_structures + num_structures))
       tmp_structures(:this%num_structures) = &
            this%structures(:this%num_structures)
       call move_alloc(tmp_structures, this%structures)
    end if


    !---------------------------------------------------------------------------
    ! set up the template basis for generated structures
    !---------------------------------------------------------------------------
    if(verbose_.gt.0) write(*,*) "Setting up basis store"
    num_insert_species = size(stoichiometry)
    num_insert_atoms = sum(stoichiometry(:)%num)
    allocate(basis_template%spec(num_insert_species))
    do i = 1, size(stoichiometry)
       basis_template%spec(i)%name = strip_null(stoichiometry(i)%element)
    end do
    basis_template%spec(:)%num = stoichiometry(:)%num
    basis_template%natom = num_insert_atoms
    basis_template%nspec = num_insert_species
    basis_template%sysname = "inserts"

    j = 0
    do i = 1, basis_template%nspec
       basis_template%spec(i)%atom_mask = &
            [ ( .false., k = 1, basis_template%spec(i)%num, 1 ) ]
       basis_template%spec(i)%atom_idx = &
            [ ( k, k = j + 1, j + basis_template%spec(i)%num, 1 ) ]
       j = j + basis_template%spec(i)%num
       allocate( &
            basis_template%spec(i)%atom(basis_template%spec(i)%num,3), &
            source = 0._real32 &
       )
    end do
    if(.not.allocated(this%host%spec))then
       call stop_program("Host structure not set")
       return
    end if
    basis_template = basis_merge( &
         this%host, basis_template, &
         mask1 = .true., mask2 = .false. &
    )
    basis_template%lat = this%host%lat


    !---------------------------------------------------------------------------
    ! ensure host element map is set
    !---------------------------------------------------------------------------
    call this%distributions%set_element_map( &
         [ basis_template%spec(:)%name ] &
    )
    call this%distributions%host_system%set_element_map( &
         this%distributions%element_info &
    )


    !---------------------------------------------------------------------------
    ! generate the placement list
    ! placement list is the list of number of atoms of each species that can be
    ! placed in the structure
    ! ... the second dimension is the index of the species and atom in the
    ! ... basis_template
    !---------------------------------------------------------------------------
    if(verbose_.gt.0) write(*,*) "Generating placement list"
    allocate(placement_list(2, num_insert_atoms))
    k = 0
    spec_loop1: do i = 1, basis_template%nspec
       success = .false.
       do j = 1, size(stoichiometry)
          if( &
               trim(basis_template%spec(i)%name) .eq. &
               trim(strip_null(stoichiometry(j)%element)) &
          ) success = .true.
       end do
       if(.not.success) cycle
       if(i.gt.this%host%nspec)then
          do j = 1, basis_template%spec(i)%num
             k = k + 1
             placement_list(1,k) = i
             placement_list(2,k) = j
          end do
       else
          do j = 1, basis_template%spec(i)%num
             if(j.le.this%host%spec(i)%num) cycle
             k = k + 1
             placement_list(1,k) = i
             placement_list(2,k) = j
          end do
       end if
    end do spec_loop1


    !---------------------------------------------------------------------------
    ! generate the structures
    !---------------------------------------------------------------------------
    if(verbose_.gt.0) write(*,*) "Entering structure generation loop"
    num_structures_old = this%num_structures
    num_structures_new = this%num_structures + num_structures
    structure_loop: do istructure = num_structures_old + 1, num_structures_new

       if(verbose_.gt.0) write(*,*) "Generating structure", istructure
       call this%structures(istructure)%copy( basis = &
            this%generate_structure( &
                 basis_template, &
                 placement_list, &
                 method_rand_limit, &
                 verbose_, &
                 exit_code_ &
            ) &
       )
       this%num_structures = istructure

    end do structure_loop
    if(verbose_ .gt. 0 .and. exit_code_ .eq. 0) &
         write(*,*) "Finished generating structures"

    if(verbose_ .eq. 0)then
       suppress_warnings = suppress_warnings_store
    end if

    if(present(exit_code))then
       exit_code = exit_code_
    elseif(exit_code_ .ne. 0)then
       call stop_program("Error generating structures", exit_code_)
    end if

  end subroutine generate
!###############################################################################


!###############################################################################
  function generate_structure( &
       this, &
       basis_initial, &
       placement_list, method_rand_limit, verbose, &
       exit_code &
  ) result(basis)
    !! Generate a single random structure.
    !!
    !! This function generates a single random structure from a host structure
    !! by placing atoms according to the ratio of placement methods.
    !! The input host structure will already have all host and insert species
    !! and atoms allocated. The placement list specifies the atoms in the
    !! host structure to be replaced by insert atoms.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(in) :: this
    !! Instance of the raffle generator.
    type(basis_type), intent(in) :: basis_initial
    !! Initial basis to build upon.
    integer, dimension(:,:), intent(in) :: placement_list
    !! List of possible placements.
    real(real32), dimension(5), intent(in) :: method_rand_limit
    !! Upper limit of the random number to call each placement method.
    type(extended_basis_type) :: basis
    !! Generated basis.
    integer, intent(in) :: verbose
    !! Verbosity level.
    integer, intent(inout) :: exit_code
    !! Exit code.

    ! Local variables
    integer :: iplaced, void_ticker, i
    !! Loop counters.
    integer :: num_insert_atoms
    !! Number of atoms to insert.
    real(real32) :: rtmp1
    !! Random number.
    logical :: skip_min
    !! Boolean for skipping the minimum method.
    logical :: viable
    !! Boolean for viable placement.
    logical :: placement_aborted
    !! Boolean for aborted placement.
    integer, dimension(size(placement_list,1),size(placement_list,2)) :: &
         placement_list_shuffled
    !! Shuffled placement list.
    real(real32), dimension(3) :: point
    !! Coordinate of the atom to place.
    real(real32), dimension(5) :: method_rand_limit_, method_rand_limit_store
    !! Temporary random limit of each placement method.
    !! This is used to update the contribution of the global minimum method if
    !! no viable gridpoints are found.
    integer, dimension(:), allocatable :: species_index_list
    !! List of species indices to add.
    real(real32), dimension(:,:), allocatable :: gridpoint_viability
    !! Viable gridpoints for placing atoms.
    character(len=256) :: stop_msg, warn_msg
    !! Error message.


    !---------------------------------------------------------------------------
    ! initialise the basis
    !---------------------------------------------------------------------------
    call basis%copy(basis_initial)
    call basis%create_images( &
         max_bondlength = this%distributions%cutoff_max(1) &
    )
    num_insert_atoms = basis%natom - this%host%natom


    !---------------------------------------------------------------------------
    ! shuffle the placement list
    !---------------------------------------------------------------------------
    placement_list_shuffled = placement_list
    call shuffle(placement_list_shuffled,2)


    !---------------------------------------------------------------------------
    ! generate species index list to add
    !---------------------------------------------------------------------------
    species_index_list = placement_list_shuffled(1,:)
    call set(species_index_list)


    !---------------------------------------------------------------------------
    ! check for viable gridpoints
    !---------------------------------------------------------------------------
    method_rand_limit_ = method_rand_limit
    gridpoint_viability = get_gridpoints_and_viability( &
         this%distributions, &
         this%grid, &
         this%bounds, &
         basis, &
         species_index_list, &
         [ this%distributions%bond_info(:)%radius_covalent ], &
         this%grid_offset &
    )


    !---------------------------------------------------------------------------
    ! place the atoms according to the method ratios
    !---------------------------------------------------------------------------
    iplaced = 0
    void_ticker = 0
    viable = .false.
    skip_min = .false.
    placement_aborted = .false.
    placement_loop: do while (iplaced.lt.num_insert_atoms)
       !------------------------------------------------------------------------
       ! check if there are any viable gridpoints remaining
       !------------------------------------------------------------------------
       if(viable)then
          if(allocated(gridpoint_viability)) &
               call update_gridpoints_and_viability( &
                    gridpoint_viability, &
                    this%distributions, &
                    basis, &
                    species_index_list, &
                    [ placement_list_shuffled(:,iplaced) ], &
                    [ this%distributions%bond_info(:)%radius_covalent ] &
               )
       end if
       if(.not.allocated(gridpoint_viability))then
          write(warn_msg, '("No more viable gridpoints")')
          warn_msg = trim(warn_msg) // &
               achar(13) // achar(10) // &
               "Stopping atom placement for this structure"
          call print_warning(warn_msg)
          placement_aborted = .true.
          exit placement_loop
       end if
       viable = .false.
       !------------------------------------------------------------------------
       ! Choose a placement method
       ! call a random number and query the method ratios
       !------------------------------------------------------------------------
       call random_number(rtmp1)
       if(rtmp1.le.method_rand_limit_(1)) then
          if(verbose.gt.0) write(*,*) "Add Atom Void"
          point = place_method_void( gridpoint_viability, basis, viable )
       elseif(rtmp1.le.method_rand_limit_(2)) then
          if(verbose.gt.0) write(*,*) "Add Atom Random"
          point = place_method_rand( &
               this%distributions, &
               this%bounds, &
               basis, &
               placement_list_shuffled(1,iplaced+1), &
               [ this%distributions%bond_info(:)%radius_covalent ], &
               this%max_attempts, &
               viable &
          )
       elseif(rtmp1.le.method_rand_limit_(3)) then
          if(verbose.gt.0) write(*,*) "Add Atom Walk"
          point = place_method_walk( &
               this%distributions, &
               this%bounds, &
               basis, &
               placement_list_shuffled(1,iplaced+1), &
               [ this%distributions%bond_info(:)%radius_covalent ], &
               this%max_attempts, &
               this%walk_step_size_coarse, this%walk_step_size_fine, &
               viable &
          )
       elseif(rtmp1.le.method_rand_limit_(4)) then
          if(iplaced.eq.0)then
             if(verbose.gt.0) write(*,*) "Add Atom Random (growth seed)"
             point = place_method_rand( &
                  this%distributions, &
                  this%bounds, &
                  basis, &
                  placement_list_shuffled(1,iplaced+1), &
                  [ this%distributions%bond_info(:)%radius_covalent ], &
                  this%max_attempts, &
                  viable &
             )
          else
             if(verbose.gt.0) write(*,*) "Add Atom Growth"
             point = place_method_growth( &
                  this%distributions, &
                  basis%spec(placement_list_shuffled(1,iplaced))%atom( &
                       placement_list_shuffled(2,iplaced),:3 &
                  ), &
                  placement_list_shuffled(1,iplaced), &
                  this%bounds, &
                  basis, &
                  placement_list_shuffled(1,iplaced+1), &
                  [ this%distributions%bond_info(:)%radius_covalent ], &
                  this%max_attempts, &
                  this%walk_step_size_coarse, this%walk_step_size_fine, &
                  viable &
             )
          end if
       elseif(rtmp1.le.method_rand_limit_(5)) then
          if(verbose.gt.0) write(*,*) "Add Atom Minimum"
          point = place_method_min( gridpoint_viability, &
               placement_list_shuffled(1,iplaced+1), &
               species_index_list, &
               viable &
          )
          if(.not. viable .and. abs(method_rand_limit_(4)).lt.1.E-6)then
             write(warn_msg, &
                  '("Minimum method failed, no other methods available")' &
             )
             warn_msg = trim(warn_msg) // &
                  achar(13) // achar(10) // &
                  "Stopping atom placement for this structure"
             call print_warning(warn_msg)
             placement_aborted = .true.
             exit placement_loop
          elseif(.not.viable)then
             skip_min = .true.
             method_rand_limit_store = method_rand_limit_
             method_rand_limit_ = method_rand_limit_ / method_rand_limit_(4)
             method_rand_limit_(5) = method_rand_limit_(4)
          end if
       end if
       !------------------------------------------------------------------------
       ! check if the placement method returned a viable point
       ! if not, cycle the loop
       !------------------------------------------------------------------------
       if(.not. viable)then
          void_ticker = void_ticker + 1
          if(void_ticker.gt.10.and..not.allocated(gridpoint_viability))then
             write(warn_msg, '("No more viable gridpoints")')
             warn_msg = trim(warn_msg) // &
                  achar(13) // achar(10) // &
                  "Stopping atom placement for this structure"
             call print_warning(warn_msg)
             placement_aborted = .true.
             exit placement_loop
          elseif(void_ticker.gt.10)then
             point = place_method_void( gridpoint_viability, basis, viable )
             void_ticker = 0
          end if
          if(.not.viable) cycle placement_loop
       end if
       !------------------------------------------------------------------------
       ! place the atom and update the image atoms in the basis
       !------------------------------------------------------------------------
       if(skip_min)then
          method_rand_limit_ = method_rand_limit_store
          skip_min = .false.
       end if
       iplaced = iplaced + 1
       basis%spec(placement_list_shuffled(1,iplaced))%atom( &
            placement_list_shuffled(2,iplaced),:3) = point(:3)
       basis%spec(placement_list_shuffled(1,iplaced))%atom_mask( &
            placement_list_shuffled(2,iplaced)) = .true.
       call basis%update_images( &
            max_bondlength = this%distributions%cutoff_max(1), &
            is = placement_list_shuffled(1,iplaced), &
            ia = placement_list_shuffled(2,iplaced) &
       )
       if(verbose.gt.0)then
          write(*,'(A)',ADVANCE='NO') achar(13)
          write(*,'(2X,"placed atom ",I0," [",I0,",",I0,"] at",3(1X,F6.3))') &
               iplaced, placement_list_shuffled(1:2,iplaced), point(:3)
          write(*,*)
       end if

    end do placement_loop

    if(placement_aborted)then
       call stop_program( &
            "Placement routine aborted, not all atoms placed", &
            block_stop = .true. &
       )
       exit_code = 1
       call basis%remove_atoms(placement_list_shuffled(:,iplaced+1:))
    end if

    if(allocated(gridpoint_viability)) deallocate(gridpoint_viability)

  end function generate_structure
!###############################################################################


!###############################################################################
  function get_structures(this) result(structures)
    !! Get the generated structures.
    implicit none
    ! Arguments
    class(raffle_generator_type), intent(in) :: this
    !! Instance of the raffle generator.
    type(basis_type), dimension(:), allocatable :: structures
    !! Generated structures.

    structures = this%structures
  end function get_structures
!###############################################################################


!###############################################################################
  subroutine set_structures(this, structures)
    !! Set the generated structures.
    !!
    !! This procedure overwrites the array of generated structures with the
    !! input array.
    !! This can be useful for removing structures that are not viable from the
    !! array.
    implicit none
    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    type(basis_type), dimension(..), allocatable, intent(in) :: structures
    !! Array of structures to set.

    select rank(structures)
    rank(0)
       this%structures = [ structures ]
    rank(1)
       this%structures = structures
    rank default
       call stop_program("Invalid rank for structures")
    end select
    this%num_structures = size(this%structures)
  end subroutine set_structures
!###############################################################################


!###############################################################################
  subroutine remove_structure(this, index)
    !! Remove structures from the generated structures.
    !!
    !! This procedure removes structures from the array of generated structures
    !! at the specified indices.
    implicit none
    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    integer, dimension(..), intent(in) :: index
    !! Indices of the structures to remove.

    ! Local variables
    integer :: i
    !! Loop index.
    integer, dimension(:), allocatable :: index_
    !! Indices of the structures to keep.

    select rank(index)
    rank(0)
       index_ = [ index ]
    rank(1)
       index_ = index
    rank default
       call stop_program("Invalid rank for index")
    end select

    if(any(index_.lt.1) .or. any(index_.gt.this%num_structures))then
       call stop_program("Invalid index")
       return
    end if

    call sort1D(index_, reverse=.true.)

    do i = 1, size(index_)
       this%structures = [ &
            this%structures(:index_(i)-1:1), &
            this%structures(index_(i)+1:this%num_structures:1) &
       ]
       this%num_structures = this%num_structures - 1
    end do

  end subroutine remove_structure
!###############################################################################


!###############################################################################
  subroutine allocate_structures(this, num_structures)
    !! Allocate memory for the generated structures.
    implicit none
    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    integer, intent(in) :: num_structures
    !! Number of structures to allocate memory for.

    if(allocated(this%structures)) deallocate(this%structures)
    allocate(this%structures(num_structures))
    this%num_structures = num_structures
  end subroutine allocate_structures
!###############################################################################


!###############################################################################
  function evaluate(this, basis) result(viability)
    !! Evaluate the viability of the generated structures.
    use raffle__evaluator, only: evaluate_point
    implicit none
    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    type(basis_type), intent(in) :: basis
    !! Basis of the structure to evaluate.
    real(real32) :: viability
    !! Viability of the generated structures.

    ! Local variables
    integer :: is, ia, idx
    !! Loop indices.
    type(extended_basis_type) :: basis_extd
    !! Extended basis for the structure to evaluate.


    call basis_extd%copy(basis)
    call basis_extd%create_images( &
         max_bondlength = this%distributions%cutoff_max(1) &
    )
    viability = 0.0_real32
    call this%distributions%set_element_map( &
         [ basis_extd%spec(:)%name ] &
    )
    call this%distributions%set_num_bins()
    do is = 1, basis%nspec
       idx = this%distributions%get_element_index( &
            basis_extd%spec(is)%name &
       )
       if(idx.eq.0)then
          call stop_program( &
               "Species "//&
               trim(basis_extd%spec(is)%name)//&
               " not found in distribution functions" &
          )
          return
       end if
       do ia = 1, basis%spec(is)%num
          basis_extd%spec(is)%atom_mask(ia) = .false.
          viability = viability + &
               evaluate_point( this%distributions, &
                    [ basis%spec(is)%atom(ia,1:3) ], &
                    is, basis_extd, &
                    [ this%distributions%bond_info(:)%radius_covalent ] &
               )
          basis_extd%spec(is)%atom_mask(ia) = .true.
       end do
    end do

    viability = viability / real(basis%natom, real32)
  end function evaluate
!###############################################################################


!###############################################################################
  function get_probability_density(this, basis, species_list, &
       grid, grid_offset, grid_spacing, bounds, &
       grid_output &
  ) result(probability)
    !! Get the probability density of the generated structures.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    type(basis_type), intent(in) :: basis
    !! Structure to evaluate.
    character(len=3), dimension(:), intent(in) :: species_list
    !! List of species to evaluate.
    integer, dimension(3), intent(in), optional :: grid
    !! Number of bins to divide the host structure into along each axis.
    real(real32), dimension(3), intent(in), optional :: grid_offset
    !! Offset of the gridpoints.
    real(real32), intent(in), optional :: grid_spacing
    !! Spacing of the bins.
    real(real32), dimension(2,3), intent(in), optional :: bounds
    !! Bounds for atom placement.
    integer, dimension(3), intent(out), optional :: grid_output

    real(real32), dimension(:,:), allocatable :: probability

    ! Local variables
    integer :: i, is, ia, idx
    !! Loop indices.
    real(real32) :: grid_spacing_
    !! Spacing of the bins.
    integer, dimension(3) :: grid_
    !! Number of bins to divide the host structure into along each axis.
    integer, dimension(size(species_list,1)) :: species_idx_list
    real(real32), dimension(3) :: grid_offset_
    !! Offset of the gridpoints.
    real(real32), dimension(2,3) :: bounds_
    !! Bounds for atom placement.
    type(extended_basis_type) :: basis_extd
    !! Extended basis for the structure to evaluate.


    !---------------------------------------------------------------------------
    ! Set the grid and bounds
    !---------------------------------------------------------------------------
    grid_ = -1
    grid_spacing_ = -1._real32
    grid_offset_ = 0._real32
    bounds_(1,:) = 0._real32
    bounds_(2,:) = 1._real32
    if(present(grid)) grid_ = grid
    if(present(grid_offset)) grid_offset_ = grid_offset
    if(present(grid_spacing)) grid_spacing_ = grid_spacing
    if(present(bounds)) bounds_ = bounds

    if(any(grid_.eq.-1))then
       if(grid_spacing_.lt.0._real32)then
          call stop_program("Grid or grid spacing not set. One must be set")
          return
       end if
       do i = 1, 3
          grid_(i) = nint( &
               ( bounds_(2,i) - bounds_(1,i) ) * &
               norm2(basis%lat(i,:)) / grid_spacing_ &
          )
       end do
    end if
    if(present(grid_output)) grid_output = grid_
    call this%distributions%set_num_bins()


    call basis_extd%copy(basis)
    do i = 1, size(species_list)
       call basis_extd%add_atom( &
            species_list(i), &
            position = [0._real32, 0._real32, 0._real32], &
            mask = .false. &
       )
       species_idx_list(i) = &
            findloc(basis_extd%spec(:)%name, strip_null(species_list(i)), dim=1)
    end do
    do is = 1, basis_extd%nspec
       idx = this%distributions%get_element_index( &
            basis_extd%spec(is)%name &
       )
       if(idx.eq.0)then
          call stop_program( &
               "Species "//&
               trim(basis_extd%spec(is)%name)//&
               " not found in distribution functions" &
          )
          return
       end if
    end do
    call basis_extd%create_images( &
         max_bondlength = this%distributions%cutoff_max(1) &
    )


    call this%distributions%set_element_map( &
         [ basis_extd%spec(:)%name ] &
    )
    probability = get_gridpoints_and_viability( &
         this%distributions, &
         grid_, &
         bounds_, &
         basis_extd, &
         species_idx_list, &
         [ this%distributions%bond_info(:)%radius_covalent ], &
         grid_offset = grid_offset_ &
    )

  end function get_probability_density
!###############################################################################


!###############################################################################
  subroutine print_generator_settings(this, file)
    !! Print the raffle generator settings.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(in) :: this
    !! Instance of the raffle generator.
    character(*), intent(in) :: file
    !! Filename to write the settings to.

    ! Local variables
    integer :: i
    !! Loop index.
    integer :: unit
    !! Unit number for the file.

    ! Open the file
    open(newunit=unit, file=file)

    write(unit,'("# RAFFLE Generator Settings")')
    write(unit,'("# GENERATOR SETTINGS")')
    write(unit,'("HOST_LATTICE # not a setting, just for reference")')
    write(unit,'("  ",3(1X,F5.2))') this%host%lat(1,:)
    write(unit,'("  ",3(1X,F5.2))') this%host%lat(2,:)
    write(unit,'("  ",3(1X,F5.2))') this%host%lat(3,:)
    write(unit,'("END HOST_LATTICE")')

    write(unit,'("GRID =",3(1X,I0))') this%grid
    write(unit,'("GRID_OFFSET =",3(1X,F15.9))') this%grid_offset
    write(unit,'("GRID_SPACING = ",F15.9)') this%grid_spacing
    write(unit,'("BOUNDS_LW =",3(1X,F15.9))') this%bounds(1,:)
    write(unit,'("BOUNDS_UP =",3(1X,F15.9))') this%bounds(2,:)

    write(unit,'("MAX_ATTEMPTS =",I0)') this%max_attempts
    write(unit,'("WALK_STEP_SIZE_COARSE = ",F15.9)') this%walk_step_size_coarse
    write(unit,'("WALK_STEP_SIZE_FINE = ",F15.9)') this%walk_step_size_fine
    write(unit,'("METHOD_VOID = ",F15.9)') this%method_ratio(1)
    write(unit,'("METHOD_RANDOM = ",F15.9)') this%method_ratio(2)
    write(unit,'("METHOD_WALK = ",F15.9)') this%method_ratio(3)
    write(unit,'("METHOD_GROW = ",F15.9)') this%method_ratio(4)
    write(unit,'("METHOD_MIN = ",F15.9)') this%method_ratio(5)

    write(unit,'("# DISTRIBUTION SETTINGS")')
    write(unit,'("KBT = ",F5.2)') this%distributions%kbt
    write(unit,'("SIGMA =",3(1X,F15.9))') this%distributions%sigma
    write(unit,'("WIDTH =",3(1X,F15.9))') this%distributions%width
    write(unit,'("CUTOFF_MIN =",3(1X,F15.9))') this%distributions%cutoff_min
    write(unit,'("CUTOFF_MAX =",3(1X,F15.9))') this%distributions%cutoff_max
    write(unit,'("RADIUS_DISTANCE_TOLERANCE =",4(1X,F15.9))') &
         this%distributions%radius_distance_tol
    write(unit,'("ELEMENT_INFO # element : energy")')
    do i = 1, size(this%distributions%element_info)
       write(unit,'("  ",A," : ",F15.9)') &
            this%distributions%element_info(i)%name, &
            this%distributions%element_info(i)%energy
    end do
    write(unit,'("END ELEMENT_INFO")')
    write(unit,'("BOND_INFO # element1 element2 : radius")')
    do i = 1, size(this%distributions%bond_info)
       write(unit,'("  ",A," ",A," : ",F15.9)') &
            this%distributions%bond_info(i)%element(1), &
            this%distributions%bond_info(i)%element(2), &
            this%distributions%bond_info(i)%radius_covalent
    end do
    write(unit,'("END BOND_INFO")')

    close(unit)

  end subroutine print_generator_settings
!###############################################################################


!###############################################################################
  subroutine read_generator_settings(this, file)
    !! Read the raffle generator settings.
    implicit none

    ! Arguments
    class(raffle_generator_type), intent(inout) :: this
    !! Instance of the raffle generator.
    character(*), intent(in) :: file
    !! Filename to read the settings from.

    ! Local variables
    integer :: i
    !! Loop index.
    integer :: itmp1, status
    !! Temporary integer.
    integer :: unit
    !! Unit number for the file.
    logical :: exist
    !! Boolean for file existence.
    character(len=256) :: line, buffer, tag
    !! Line from the file.
    character(3), dimension(2) :: elements
    !! Element symbols.
    real(real32) :: rtmp1
    !! Temporary real number.

    ! Check if the file exists
    inquire(file=file, exist=exist)
    if(.not.exist)then
       call stop_program("File does not exist")
       return
    end if

    ! Open the file
    open(newunit=unit, file=file)

    if(allocated(this%distributions%element_info)) &
         deallocate(this%distributions%element_info)
    if(allocated(this%distributions%bond_info)) &
         deallocate(this%distributions%bond_info)
    itmp1 = 0
    do
       read(unit, '(A)', iostat = status) line
       ! encounter end of line
       if(status.ne.0) exit

       if(index(line,'#').gt.0) line = line(1:index(line,'#')-1)
       line = to_upper(trim(adjustl(line)))
       if(len(trim(line)).eq.0) cycle

       tag=trim(adjustl(line))
       if(scan(line,"=").ne.0) tag=trim(tag(:scan(tag,"=")-1))

       select case(trim(adjustl(tag)))
       case("HOST_LATTICE")
          do i = 1, 4
             read(unit,*)
          end do
       case("GRID")
          call assign_vec(line, this%grid, itmp1)
       case("GRID_OFFSET")
          call assign_vec(line, this%grid_offset, itmp1)
       case("GRID_SPACING")
          call assign_val(line, this%grid_spacing, itmp1)
       case("BOUNDS_LW")
          call assign_vec(line, this%bounds(1,:), itmp1)
       case("BOUNDS_UP")
          call assign_vec(line, this%bounds(2,:), itmp1)
       case("MAX_ATTEMPTS")
          call assign_val(line, this%max_attempts, itmp1)
       case("WALK_STEP_SIZE_COARSE")
          call assign_val(line, this%walk_step_size_coarse, itmp1)
       case("WALK_STEP_SIZE_FINE")
          call assign_val(line, this%walk_step_size_fine, itmp1)
       case("METHOD_VOID")
          call assign_val(line, this%method_ratio(1), itmp1)
       case("METHOD_RANDOM")
          call assign_val(line, this%method_ratio(2), itmp1)
       case("METHOD_WALK")
          call assign_val(line, this%method_ratio(3), itmp1)
       case("METHOD_GROW")
          call assign_val(line, this%method_ratio(4), itmp1)
       case("METHOD_MIN")
          call assign_val(line, this%method_ratio(5), itmp1)
       case("KBT")
          call assign_val(line, this%distributions%kbt, itmp1)
       case("SIGMA")
          call assign_vec(line, this%distributions%sigma, itmp1)
       case("WIDTH")
          call assign_vec(line, this%distributions%width, itmp1)
       case("CUTOFF_MIN")
          call assign_vec(line, this%distributions%cutoff_min, itmp1)
       case("CUTOFF_MAX")
          call assign_vec(line, this%distributions%cutoff_max, itmp1)
       case("RADIUS_DISTANCE_TOLERANCE")
          call assign_vec(line, this%distributions%radius_distance_tol, itmp1)
       case("ELEMENT_INFO")
          do
             read(unit,'(A)') line
             if(index(line,'#').gt.0) line = line(1:index(line,'#')-1)
             line = to_upper(trim(adjustl(line)))
             if(len(trim(line)).eq.0) exit
             if(index(line,'END').gt.0) exit
             read(line(:scan(line,":")-1),*) elements(1)
             read(line(scan(line,":")+1:),*) rtmp1
             call this%distributions%set_element_energy(elements(1), rtmp1)
          end do
       case("BOND_INFO")
          do
             read(unit,'(A)') line
             if(index(line,'#').gt.0) line = line(1:index(line,'#')-1)
             line = to_upper(trim(adjustl(line)))
             if(len(trim(line)).eq.0) exit
             if(index(line,'END').gt.0) exit
             read(line(:scan(line,":")-1),*) elements(1), elements(2)
             read(line(scan(line,":")+1:),*) rtmp1
             call this%distributions%set_bond_radius(elements, rtmp1)
          end do
       end select
    end do

    close(unit)

  end subroutine read_generator_settings
!###############################################################################

end module raffle__generator

module inputs
  !! Module for reading input files and setting global variables.
  !!
  !! This module reads the input file and sets the global variables for the
  !! program. NOTE: this module is not intended to be used in a library, it is
  !! only included in the executable program.
  use raffle__misc, only: file_check,flagmaker, icount, to_lower
  use raffle__generator, only: stoichiometry_type
  use raffle__constants, only: real32, pi
  use raffle__io_utils
  implicit none


  private

  public :: grid, grid_spacing, method_ratio
  public :: seed
  public :: num_structures, task
  public :: stoich
  public :: filename_host
  public :: database_format, database_list
  public :: cutoff_min_list, cutoff_max_list, width_list, sigma_list
  public :: output_dir
  public :: element_symbols, element_energies
  public :: bond_pairs, pair_radii

  public :: set_global_vars
  public :: verbose


  logical :: lseed
  !! Logical for random seed.

  integer :: verbose
  !! Verbose printing.
  integer :: seed
  !! Random seed.
  integer :: num_structures
  !! Number of structures to generate.
  integer :: task
  !! Task to perform (0 = run, 1 = continue).
  type(stoichiometry_type), dimension(:), allocatable :: stoich
  !! Stoichiometry of species to add

  real(real32), dimension(3) :: cutoff_min_list, cutoff_max_list
  !! Cutoff values for distribution functions.
  real(real32), dimension(3) :: width_list, sigma_list
  !! Width and sigma values for distribution functions.

  real(real32), dimension(:), allocatable :: element_energies
  !! Element reference energies.
  real(real32), dimension(:), allocatable :: pair_radii
  !! Element pair radii.
  character(3), dimension(:), allocatable :: element_symbols
  !! Element symbols.
  character(3), dimension(:,:), allocatable :: bond_pairs
  !! Element symbol pairs for pair_radii.

  integer, dimension(3) :: grid = [0, 0, 0]
  !! Grid dimensions.
  real(real32) :: grid_spacing = 0._real32
  !! Grid spacing.
  real(real32), dimension(5) :: method_ratio = &
       [1._real32, 0.1_real32, 0.5_real32, 0.5_real32, 1._real32]
  !! Placement method ratios.

  character(1024), dimension(:), allocatable :: database_list
  !! List of directories containing input database.
  character(1024) :: database_format
  !! Format of input file (POSCAR, XYZ, etc).
  character(1024) :: filename_host
  !! Host structure filename.
  character(1024) :: output_dir
  !! Output directory.


contains

!###############################################################################
  subroutine set_global_vars()
    !! Set global variables for the program.
    !!
    !! This subroutine reads the flags from the command line and sets the global
    !! variables for the program.
    implicit none

    ! Local variables
    integer :: i,j
    !! Loop indices.
    integer :: nseed
    !! Number of random seed values.
    character(1024) :: buffer, flag, input_file
    !! Character variables.
    logical :: skip, empty
    !! Logical variables.
    integer, dimension(:), allocatable :: seed_arr
    !! Random seed array.


    !---------------------------------------------------------------------------
    ! initialises variables
    !---------------------------------------------------------------------------
    input_file = ""
    seed = 1

    !---------------------------------------------------------------------------
    ! read flags and assign to variables
    !---------------------------------------------------------------------------
    flagloop: do i = 0, command_argument_count()
       empty=.false.
       if (skip) then
          skip=.false.
          cycle flagloop
       end if
       call get_command_argument(i,buffer)
       buffer=trim(buffer)
       !------------------------------------------------------------------------
       ! flag options
       !------------------------------------------------------------------------
       if(index(buffer,'-f').eq.1)then
          flag="-f"
          call flagmaker(buffer,flag,i,skip,empty)
          if(.not.empty)then
             read(buffer,'(A)') input_file
          else
             write(0,'("&
                  &ERROR: No input filename supplied, &
                  &but the flag ''-f'' was used&
             &")')
             infilename_do: do j = 1, 3
                write(6,'("Please supply an input filename:")')
                read(5,'(A)') input_file
                if(trim(input_file).ne.'')then
                   write(6,'("Input filename supplied")')
                   exit infilename_do
                else
                   write(0,'(1X,"Not a valid filename")')
                end if
                if(j.eq.3)then
                   call stop_program("No valid input filename supplied")
                   return
                end if
             end do infilename_do
          end if
       elseif(index(buffer,'-v').eq.1)then
          flag="-v"
          call print_build_info()
          stop
       elseif(index(buffer,'--verbose').eq.1)then
          flag="--verbose"
          call flagmaker(buffer,flag,i,skip,empty)
          if(.not.empty) read(buffer,*) verbose
       elseif(index(buffer,'-h').eq.1)then
          write(6,'("Flags:")')
          write(6,'(2X,"-h              : Prints the help for each flag.")')
          write(6,'(2X,"-v              : Verbose printing.")')
          write(6,'("-----------------FILE-NAME-FLAGS-----------------")')
          write(6,'(2X,"-f<STR>         : Input structure file name (&
               &Default = (empty)&
          &).")')
          stop
       end if
    end do flagloop


    !---------------------------------------------------------------------------
    ! check if input file was specified and read if true
    !---------------------------------------------------------------------------
    if(trim(input_file).ne."")then
       call read_input_file(input_file)
    end if


    !---------------------------------------------------------------------------
    ! initialise random seed
    !---------------------------------------------------------------------------
    call random_seed(size=nseed)
    allocate(seed_arr(nseed))
    if(lseed)then
       seed_arr = seed
    else
       call system_clock(count=seed)
       seed_arr = seed + 37 * (/ (i - 1, i = 1, nseed) /)
    end if
    call random_seed(put=seed_arr)
    deallocate(seed_arr)

    return
  end subroutine set_global_vars
!###############################################################################


!###############################################################################
  subroutine read_input_file(file_name)
    !! Read input file to get variables.
    !!
    !! This subroutine reads a namelist input file to get the variables for the
    !! program.
    implicit none

    ! Arguments
    character(*), intent(inout) :: file_name
    !! Input file name.

    ! Local variables
    integer :: i
    !! Loop index.
    integer :: num_species, num_bonds
    !! Number of species and bonds.
    integer :: iostat, unit, l_pos, r_pos
    !! I/O status, unit, left and right positions.
    character(32) :: pair
    !! Pair of elements.
    character(1024) :: stoichiometry, database, buffer, energies, &
         bond_radii
    !! Strings buffers to hold input values (usually derived types).
    real(real32), dimension(3) :: width, sigma
    !! Width and sigma values for distribution functions.
    real(real32) :: void, rand, walk, grow, min
    !! Placement method ratios.
    character(50), dimension(3) :: cutoff_min, cutoff_max
    !! Cutoff values for distribution functions.


    !---------------------------------------------------------------------------
    ! set up namelists for input file
    !---------------------------------------------------------------------------
    namelist /setup/ task, filename_host, seed, grid, &
         grid_spacing, &
         database_format, database, verbose, output_dir
    namelist /placement_method/ void, rand, walk, grow, min
    namelist /structure/    num_structures,stoichiometry
    namelist /distribution/ cutoff_min, cutoff_max, width, sigma
    namelist /element_info/ energies, bond_radii


    !---------------------------------------------------------------------------
    ! check input file exists and open
    !---------------------------------------------------------------------------
    unit=20
    call file_check(unit,file_name)


    !---------------------------------------------------------------------------
    ! initialise variables
    !---------------------------------------------------------------------------
    output_dir = "iteration1"
    cutoff_min = "-1.0"
    cutoff_max = "-1.0"
    width = -1._real32
    sigma = -1._real32
    database_format = "vasprun.xml"
    void = 0._real32; rand = 0._real32
    walk = 0._real32; grow = 0._real32
    min = 0._real32


    !---------------------------------------------------------------------------
    ! read namelists from input file
    !---------------------------------------------------------------------------
    read(unit,NML=setup,iostat=iostat)
    if(iostat.ne.0)then
       write(0,*) "THERE WAS AN ERROR IN READING SETUP"
    end if
    read(unit,NML=placement_method,iostat=iostat)
    if(.not.is_iostat_end(iostat).and.iostat.ne.0)then
       call stop_program( &
            "THERE WAS AN ERROR IN READING PLACEMENT_METHOD SETTINGS" &
       )
       return
    end if
    read(unit,NML=structure,iostat=iostat)
    if(.not.is_iostat_end(iostat).and.iostat.ne.0)then
       call stop_program( &
            "THERE WAS AN ERROR IN READING STRUCTURE SETTINGS" &
       )
       return
    end if
    read(unit,NML=distribution,iostat=iostat)
    if(.not.is_iostat_end(iostat).and.iostat.ne.0)then
       call stop_program( &
            "THERE WAS AN ERROR IN READING DISTRIBUTION SETTINGS" &
       )
       return
    end if
    read(unit,NML=element_info,iostat=iostat)
    if(.not.is_iostat_end(iostat).and.iostat.ne.0)then
       call stop_program( &
            "THERE WAS AN ERROR IN READING ELEMENT_INFO SETTINGS" &
       )
       return
    end if


    !---------------------------------------------------------------------------
    ! handle variables
    !---------------------------------------------------------------------------
    if(trim(database).ne."")then
       allocate(database_list(icount(database)))
       read(database,*) database_list
       l_pos = 0
       do i = 1, size(database_list)
          read(database(l_pos+1:),'(A)') buffer
          r_pos = scan(buffer,",")
          if(r_pos.eq.0) r_pos = len_trim(buffer)
          read(buffer(:r_pos-1),'(A)') database_list(i)
          l_pos = scan(database(l_pos+1:),",") + l_pos
       end do
    end if

    method_ratio = [void, rand, walk, grow, min]
    if(all(abs(method_ratio).lt.1.E-6))then
       method_ratio = &
            [1._real32, 0.1_real32, 0.5_real32, 0.5_real32, 1._real32]
    end if

    if(trim(stoichiometry).ne."")then
       num_species = icount(stoichiometry,",")
       allocate(stoich(num_species))
       l_pos = scan(stoichiometry,"{")
       r_pos = scan(stoichiometry,"}", back=.true.)
       do i = 1, num_species
          read(stoichiometry(l_pos+1:r_pos-1),'(A)') buffer
          read(buffer(:scan(buffer,":")-1),*) stoich(i)%element
          read(buffer(scan(buffer,":")+1:),*) stoich(i)%num
          l_pos = scan(stoichiometry(l_pos+1:),",") + l_pos
       end do
    else
       call stop_program("No stoichiometry specified")
       return
    end if


    if(trim(energies).ne."")then
       num_species = icount(energies,",")
       allocate(element_symbols(num_species))
       allocate(element_energies(num_species))
       l_pos = scan(energies,"{")
       r_pos = scan(energies,"}", back=.true.)
       do i = 1, num_species
          read(energies(l_pos+1:r_pos-1),'(A)') buffer
          read(buffer(:scan(buffer,":")-1),*) element_symbols(i)
          read(buffer(scan(buffer,":")+1:),*) element_energies(i)
          l_pos = scan(energies(l_pos+1:),",") + l_pos
       end do
    else
       call stop_program("No element energies specified")
       return
    end if


    if(trim(bond_radii).ne."")then
       num_bonds = icount(bond_radii,",")
       allocate(bond_pairs(num_bonds,2))
       allocate(pair_radii(num_bonds))
       l_pos = scan(energies,"{")
       r_pos = scan(energies,"}", back=.true.)
       do i = 1, num_bonds
          read(bond_radii(l_pos+1:r_pos-1),'(A)') buffer
          read(buffer(:scan(buffer,":")-1),*) pair
          if(index(pair,"-").ne.0)then
             read(pair(:index(pair,"-")-1),*) bond_pairs(i,1)
             read(pair(index(pair,"-")+1:),*) bond_pairs(i,2)
          else
             read(pair(:),*) bond_pairs(i,1)
             bond_pairs(i,2) = bond_pairs(i,1)
          end if
          read(buffer(scan(buffer,":")+1:),*) pair_radii(i)
          l_pos = scan(energies(l_pos+1:),",") + l_pos
       end do
    end if


    do i = 1, 3
       cutoff_min_list(i) = read_value_from_string(cutoff_min(i))
       cutoff_max_list(i) = read_value_from_string(cutoff_max(i))
       write(*,*) "Cutoff: ",cutoff_min_list(i),cutoff_max_list(i)
    end do

    width_list = width
    sigma_list = sigma

    !---------------------------------------------------------------------------
    ! close input file
    !---------------------------------------------------------------------------
    close(unit)
    write(*,*) "Input file read successfully."

    return
  end subroutine read_input_file
!###############################################################################


!###############################################################################
  function read_value_from_string(string) result(output)
    !! Read a formatted numeric from a string.
    implicit none

    ! Arguments
    character(*), intent(in) :: string
    !! Input string.
    real(real32) :: output
    !! Output value.

    ! Local variables
    integer :: k, pos
    !! Loop index, position.
    real(real32) :: variable, power
    !! Variable and power values.
    character(:), allocatable :: string_
    !! Copy of input string.
    character(12) :: numeric_set = "0123456789.-"
    !! Numeric set.

    pos = 1
    output = 1._real32
    variable = 0._real32
    power = 1._real32
    string_ = trim(to_lower(string))
    loop: do
       !! read until first non-numeric character
       !! read string up to k - 1 to variable (multiply)
       k = verify(string_(pos:len_trim(string_)),numeric_set)
       if (k.eq.0)then
          read(string_(pos:),*) variable
          output = output * variable ** power
          exit loop
       elseif(k.gt.1)then
          read(string_(pos:pos+k-2),*) variable
          output = output * variable ** power
       end if

       pos = pos + k - 1
       !! identify what the next character is (*, /, pi)
       !! if *, then change power factor to 1._real32
       !! if /, then change power factor to -1._real32
       !! if pi, then change power factor to 1._real32 and variable = pi
       !! if blank space, move pos to next non-space character and cycle
       !! if end of string, exit loop

       if (string_(pos:pos).eq."*")then
          power = 1._real32
          pos = pos + 1
       elseif(string_(pos:pos).eq."/")then
          power = -1._real32
          pos = pos + 1
       elseif(string_(pos:pos+1).eq."pi")then
          power = 1._real32
          output = output * pi ** power
          pos = pos + 2
       end if
       if(pos.gt.len_trim(string_)) exit loop
       pos = pos + verify(string_(pos:), " ") - 1
       if(pos.gt.len_trim(string_)) exit loop

    end do loop

  end function read_value_from_string
!###############################################################################

end module inputs

module raffle__io_utils
  !! Module for handling errors and io calls in the program.
  !!
  !! This module provides the expected procedure for stopping a program.
  !! If in testing mode, the stop can be suppressed.
  implicit none
  logical :: test_error_handling = .false.

  logical :: suppress_warnings = .false.
  character(len=*), parameter :: raffle__version__ = "1.1.1"

  private

  public :: raffle__version__
  public :: test_error_handling, suppress_warnings
  public :: stop_program, print_warning
  public :: print_version, print_build_info


contains

!###############################################################################
  subroutine stop_program(message, exit_code, block_stop)
    !! Stop the program and print an error message.
    implicit none
    character(len=*), intent(in) :: message
    integer, intent(in), optional :: exit_code
    logical, intent(in), optional :: block_stop

    integer :: exit_code_
    logical :: block_stop_

    if(present(exit_code)) then
       exit_code_ = exit_code
    else
       exit_code_ = 1
    end if
    if(present(block_stop)) then
       block_stop_ = block_stop
    else
       block_stop_ = .false.
    end if

    write(0,*) 'ERROR: ', trim(message)
    if(.not.block_stop_)then
       if(.not.test_error_handling) then
          stop exit_code_
       end if
    end if
  end subroutine stop_program
!###############################################################################


!###############################################################################
  subroutine print_warning(message)
    !! Print a warning message
    implicit none
    character(len=*), intent(in) :: message

    if(.not.suppress_warnings) then
       write(0,*) 'WARNING: ', trim(message)
    end if
  end subroutine print_warning
!###############################################################################


!###############################################################################
  subroutine print_version()
    !! Print the version number of the program.
    implicit none

    write(*,'("version: ",A)') raffle__version__
  end subroutine print_version
!###############################################################################


!###############################################################################
  subroutine print_build_info()
    !! Print the build information of the program.
    implicit none

    write(*,'("RAFFLE: pseudoRandom Approach For Finding Local Energy minima")')
    call print_version()
    write(*,'(" (build ",A,1X,A,")")') __DATE__, __TIME__

  end subroutine print_build_info
!###############################################################################

end module raffle__io_utils

module raffle__distribs_host
  !! Module for handling the host distribution functions.
  !!
  !! This module contains the type and procedures for handling the host
  !! distribution function. Procedures are also provided to calculate the
  !! interface energy of the host and to set the mapping of host elements to
  !! the element database.
  use raffle__constants, only: real32
  use raffle__io_utils, only: stop_program
  use raffle__geom_rw, only: basis_type
  use raffle__element_utils, only: element_type
  use raffle__distribs, only: distribs_type
  implicit none

  
  private

  public :: distribs_host_type


  type, extends(distribs_type) :: distribs_host_type
     !! Type for host information.
     !!
     !! This type contains the information regarding the host structure that
     !! will be used in the grandparent generator type.
     logical :: defined = .false.
     !! Boolean whether the host structure has been set.
     real(real32) :: interface_energy = 0.0_real32
     !! Energy associated with the formation of the interface in the host.
     type(basis_type) :: basis
     !! Host structure.
     integer, dimension(:,:), allocatable :: pair_index
     !! Index for the 2-body distribution function.
     integer, dimension(:), allocatable :: element_map
     !! Mapping of host elements to distribution function elements.
   contains
     procedure, pass(this) :: calculate_interface_energy
     !! Calculate the interface formation energy of the host.
     procedure, pass(this) :: set => set_host
     !! Set the host structure for the distribution functions.
     procedure, pass(this) :: set_element_map => set_host_element_map
     !! Set the mapping of host elements to distribution function elements.
  end type distribs_host_type


contains

!###############################################################################
  subroutine set_host(this, host)
    !! Set the host structure for the distribution functions.
    !!
    !! distribution function not needed for host
    implicit none

    ! Arguments
    class(distribs_host_type), intent(inout) :: this
    !! Parent. Instance of distribution functions container.
    type(basis_type), intent(in) :: host
    !! Host structure for the distribution functions.

    ! Local variables
    integer :: i, is, js
    !! Loop indices.

    call this%basis%copy(host)
    this%defined = .true.
    if(allocated(this%pair_index)) deallocate(this%pair_index)
    allocate(this%pair_index(this%basis%nspec, this%basis%nspec))
    i = 0
    do is = 1, this%basis%nspec
       do js = is, this%basis%nspec, 1
          i = i + 1
          this%pair_index(js,is) = i
          this%pair_index(is,js) = i
       end do
    end do
    if(allocated(this%df_2body)) deallocate(this%df_2body)
    if(allocated(this%df_3body)) deallocate(this%df_3body)
    if(allocated(this%df_4body)) deallocate(this%df_4body)

    if(allocated(this%stoichiometry)) deallocate(this%stoichiometry)
    if(allocated(this%element_symbols)) deallocate(this%element_symbols)
    if(allocated(this%num_pairs)) deallocate(this%num_pairs)
    if(allocated(this%num_per_species)) deallocate(this%num_per_species)
    if(allocated(this%weight_pair)) deallocate(this%weight_pair)
    if(allocated(this%weight_per_species)) deallocate(this%weight_per_species)

  end subroutine set_host
!###############################################################################


!###############################################################################
  subroutine calculate_interface_energy(this, element_info)
    !! Calculate the interface formation energy of the host.
    implicit none

    ! Arguments
    class(distribs_host_type), intent(inout) :: this
    !! Parent. Instance of host type.
    type(element_type), dimension(:), intent(in) :: element_info
    !! List of elements and properties.

    ! Local variables
    integer :: is, idx1
    !! Loop indices.

    this%interface_energy = this%energy
    do is = 1, size(this%element_symbols)
       idx1 = findloc( &
            [ element_info(:)%name ], &
            this%element_symbols(is), dim=1 &
       )
       if(idx1.lt.1)then
          call stop_program( "Species not found in species list" )
          return
       end if
       this%interface_energy = this%interface_energy - &
            this%stoichiometry(is) * element_info(idx1)%energy
    end do

  end subroutine calculate_interface_energy
!###############################################################################


!###############################################################################
  subroutine set_host_element_map(this, element_info)
    !! Set the host element map for the container.
    implicit none

    ! Arguments
    class(distribs_host_type), intent(inout) :: this
    !! Parent of the procedure. Instance of distribution functions container.
    type(element_type), dimension(:), intent(in) :: element_info
    !! Element information.

    ! Local variables
    integer :: is
    !! Index of the elements in the element_info array.

    if(.not.this%defined)then
       call stop_program( "Host not defined" )
       return
    end if
    if(allocated(this%element_map)) deallocate(this%element_map)
    allocate(this%element_map(this%basis%nspec))
    do is = 1, this%basis%nspec
       this%element_map(is) = findloc(&
            [ element_info(:)%name ], &
            this%basis%spec(is)%name, dim=1 &
       )
    end do

  end subroutine set_host_element_map
!###############################################################################

end module raffle__distribs_host

module raffle__dist_calcs
  !! Module containing distance calculators
  !!
  !! This module contains procedures to calculate the distance between atoms
  !! and other points in the system.
  use raffle__constants, only: pi,real32
  use raffle__geom_rw, only: basis_type
  use raffle__misc_linalg, only: get_angle
  implicit none


  private

  public :: get_min_dist
  public :: get_min_dist_between_point_and_atom
  public :: get_min_dist_between_point_and_species
  public :: get_dist_between_point_and_atom


contains

!###############################################################################
  pure function get_min_dist( &
       basis, loc, lignore_close, axis, labove, lreal, tol &
  ) result(output)
    !! Return the minimum distance between a point and the nearest atom
    !! in a cell.
    !!
    !! This function returns the minimum distance between a point and the
    !! nearest atom in a periodic cell.
    implicit none

    ! Arguments
    logical, intent(in) :: lignore_close
    !! If true, ignore atoms that are really close to the point.
    class(basis_type), intent(in) :: basis
    !! The basis of the cell.
    real(real32), dimension(3), intent(in) :: loc
    !! The location of the point (in crystal coordinates).

    integer, intent(in), optional :: axis
    !! The axis along which to calculate the distance (if undefined, the
    !! distance is calculated in all directions).
    real(real32), intent(in), optional :: tol
    !! The tolerance for the distance.
    logical, intent(in), optional :: labove, lreal
    !! If true, return the real distance, otherwise return the vector.
    real(real32), dimension(3) :: output
    !! The minimum distance between the point and the nearest atom.


    ! Local variables
    integer :: js, ja, i
    !! Loop counters.
    integer :: axis_
    !! Axis along which to calculate the distance.
    real(real32) :: dtmp1
    !! Temporary variables.
    real(real32) :: min_bond
    !! Minimum bond length.
    real(real32) :: tol_
    !! Tolerance for the distance.
    logical :: labove_, lreal_
    !! Booleans for above and real distance arguments
    real(real32), dimension(3) :: vdtmp1, vdtmp2
    !! Vectors for distance calculations.


    ! CORRECT tol TO ACCOUNT FOR LATTICE SIZE
    tol_ = 1.E-5_real32
    labove_ = .false.
    lreal_ = .true.
    axis_ = 0
    if(present(tol)) tol_ = tol

    if(present(labove)) labove_ = labove

    if(present(lreal)) lreal_ = lreal

    if(present(axis)) axis_=axis

    min_bond=huge(0._real32)
    output = 0._real32
    do js = 1, basis%nspec
       atmloop: do ja = 1, basis%spec(js)%num
          if(.not.basis%spec(js)%atom_mask(ja)) cycle atmloop
          vdtmp1 = basis%spec(js)%atom(ja,:3) - loc
          if(lignore_close.and.norm2(vdtmp1).lt.tol_) cycle atmloop
          if(axis_.gt.0)then
             if(abs(vdtmp1(axis_)).lt.tol_) cycle atmloop
             if(labove_)then
                vdtmp1(axis_) = 1._real32 + vdtmp1(axis_)
             else
                vdtmp1(axis_) = vdtmp1(axis_) - 1._real32
             end if
          else
             vdtmp1 = vdtmp1 - ceiling(vdtmp1 - 0.5_real32)
          end if
          vdtmp2 = matmul(vdtmp1,basis%lat)
          dtmp1 = norm2(vdtmp2)
          if(dtmp1.lt.min_bond)then
             min_bond = dtmp1
             if(lreal_)then
                output = vdtmp2
             else
                output = vdtmp1
             end if
          end if
       end do atmloop
    end do

  end function get_min_dist
!###############################################################################


!###############################################################################
  pure function get_min_dist_between_point_and_atom(basis,loc,atom) result(dist)
    !! Return the minimum distance between a point and an atom in a cell.
    !!
    !! This function returns the minimum distance between a point and an atom
    !! in a periodic cell.
    implicit none

    ! Arguments
    class(basis_type), intent(in) :: basis
    !! The basis of the cell.
    integer, dimension(2), intent(in) :: atom
    !! The index of the atom in the cell (species, atom).
    real(real32), dimension(3), intent(in) :: loc
    !! The location of the point (in crystal coordinates).
    real(real32) :: dist
    !! The minimum distance between the point and the atom.

    ! Local variables
    real(real32), dimension(3) :: vec
    !! Vector between the point and the atom.

    vec = loc - basis%spec(atom(1))%atom(atom(2),:3)
    vec = vec - ceiling(vec - 0.5_real32)
    vec = matmul(vec,basis%lat)
    dist = norm2(vec)

  end function get_min_dist_between_point_and_atom
!###############################################################################


!###############################################################################
  pure function get_min_dist_between_point_and_species( &
       basis, loc, species) result(dist)
    !! Return the minimum distance between a point and a species in a cell.
    !!
    !! This function returns the minimum distance between a point and any
    !! instance of the specified species in a periodic cell.
    implicit none

    ! Arguments
    class(basis_type), intent(in) :: basis
    !! The basis of the cell.
    integer, intent(in) :: species
    !! The index of the species in the cell.
    real(real32), dimension(3), intent(in) :: loc
    !! The location of the point (in crystal coordinates).
    real(real32) :: dist
    !! The minimum distance between the point and the species.

    ! Local variables
    integer :: ia, i
    !! Loop indices.
    real(real32) :: rtmp1
    !! Temporary variable.
    real(real32), dimension(3) :: vec
    !! Vector between the point and the atom.


    dist = huge(0._real32)
    atom_loop: do ia = 1,basis%spec(species)%num
       if(.not.basis%spec(species)%atom_mask(ia)) cycle atom_loop
       vec = loc - basis%spec(species)%atom(ia,:3)
       vec = vec - ceiling(vec - 0.5_real32)
       vec = matmul(vec, basis%lat)
       rtmp1 = norm2(vec)
       if( rtmp1 .lt. dist ) dist = rtmp1
    end do atom_loop

  end function get_min_dist_between_point_and_species
!###############################################################################


!###############################################################################
  pure function get_dist_between_point_and_atom(basis,loc,atom) result(dist)
    !! Return the distance between a point and an atom in a cell.
    !!
    !! This function returns the distance between a point and an atom in a cell.
    implicit none

    ! Arguments
    class(basis_type), intent(in) :: basis
    !! The basis of the cell.
    integer, dimension(2), intent(in) :: atom
    !! The index of the atom in the cell (species, atom).
    real(real32), dimension(3), intent(in) :: loc
    !! The location of the point (in crystal coordinates).
    real(real32) :: dist
    !! The minimum distance between the point and the atom.

    ! Local variables
    real(real32), dimension(3) :: vec
    !! Vector between the point and the atom.

    vec = loc - basis%spec(atom(1))%atom(atom(2),:3)
    vec = matmul(vec,basis%lat)
    dist = norm2(vec)

  end function get_dist_between_point_and_atom
!###############################################################################

end module raffle__dist_calcs

program test_geom_utils
  !! Test program for the module edit_geom.
  use raffle__constants, only: real32
  use raffle__geom_rw, only: basis_type
  use raffle__misc_linalg, only: modu
  use raffle__geom_utils, only: basis_merge

  implicit none

  type(basis_type) :: bas, bas2, basis_merged

  logical :: success = .true.


  ! Initialise silicon basis
  bas%sysname = "Silicon"
  bas%nspec = 1
  bas%natom = 2
  allocate(bas%spec(bas%nspec))
  bas%spec(1)%num = 2
  bas%spec(1)%name = 'Si'
  allocate(bas%spec(1)%atom(bas%spec(1)%num, 3))
  bas%spec(1)%atom(1, :) = [0.0, 0.0, 0.0]
  bas%spec(1)%atom(2, :) = [0.25, 0.25, 0.25]

  ! Initialise silicon lattice
  bas%lat(1,:) = [0.0, 2.14, 2.14]
  bas%lat(2,:) = [2.14, 0.0, 2.14]
  bas%lat(3,:) = [2.14, 2.14, 0.0]


  !-----------------------------------------------------------------------------
  ! Test basis_merge
  !-----------------------------------------------------------------------------

  ! Initialise second basis
  bas2%sysname = "SiO2"
  bas2%nspec = 2
  bas2%natom = 3
  allocate(bas2%spec(bas2%nspec))
  bas2%spec(1)%num = 2
  bas2%spec(1)%name = 'Si'
  allocate(bas2%spec(1)%atom(bas2%spec(1)%num, 3))
  bas2%spec(1)%atom(1, :) = [0.5, 0.5, 0.5]
  bas2%spec(1)%atom(2, :) = [0.5, 0.0, 0.0]
  bas2%spec(2)%num = 1
  bas2%spec(2)%name = 'O'
  allocate(bas2%spec(2)%atom(bas2%spec(2)%num, 3))
  bas2%spec(2)%atom(1, :) = [0.0, 0.7, 0.0]

  ! Initialise second lattice
  bas2%lat(1,:) = [0.0, 2.14, 2.14]
  bas2%lat(2,:) = [2.14, 0.0, 2.14]
  bas2%lat(3,:) = [2.14, 2.14, 0.0]


  basis_merged = basis_merge(bas, bas2)

  if ( basis_merged%nspec .ne. 2 ) then
     write(0,*) &
          'basis_merge failed, number of species not equal to 2: ', &
          basis_merged%nspec
     success = .false.
  end if
  if ( basis_merged%natom .ne. 5 ) then
     write(0,*) &
          'basis_merge failed, number of atoms not equal to 5: ', &
          basis_merged%natom
     success = .false.
  end if
  if ( basis_merged%spec(1)%num .ne. 4 ) then
     write(0,*) &
          'basis_merge failed, number of atoms for species 1 not equal to 4: ', &
          basis_merged%spec(1)%num
     success = .false.
  end if
  if ( basis_merged%spec(2)%num .ne. 1 ) then
     write(0,*) &
          'basis_merge failed, number of atoms for species 2 not equal to 1: ', &
          basis_merged%spec(2)%num
     success = .false.
  end if
  if( basis_merged%spec(1)%name .ne. 'Si' ) then
     write(0,*) &
          'basis_merge failed, name of species 1 not equal to Si: ', &
          basis_merged%spec(1)%name
     success = .false.
  end if
  if( basis_merged%spec(2)%name .ne. 'O' ) then
     write(0,*) &
          'basis_merge failed, name of species 2 not equal to O: ', &
          basis_merged%spec(2)%name
     success = .false.
  end if
  if( any(.not.basis_merged%spec(1)%atom_mask) ) then
     write(0,*) &
          'basis_merge failed, atom mask for species 1 not all true'
     success = .false.
  end if
  if( any(.not.basis_merged%spec(2)%atom_mask) ) then
     write(0,*) &
          'basis_merge failed, atom mask for species 2 not all true'
     success = .false.
  end if

  basis_merged = basis_merge(bas, bas2, mask1 = .true., mask2 = .false.)
  if( any(.not.basis_merged%spec(1)%atom_mask(:bas%spec(1)%num)) ) then
     write(0,*) &
          'basis_merge failed, atom mask for basis 1 not all true'
     success = .false.
  end if
  if( any(basis_merged%spec(1)%atom_mask(bas%spec(1)%num+1:)) .or. &
       any(basis_merged%spec(2)%atom_mask) &
  ) then
     write(0,*) &
          'basis_merge failed, atom mask for basis 2 not all false'
     success = .false.
  end if

  basis_merged = basis_merge(bas, bas2, mask1 = .false., mask2 = .true.)
  if( any(basis_merged%spec(1)%atom_mask(:bas%spec(1)%num)) ) then
     write(0,*) &
          'basis_merge failed, atom mask for basis 1 not all false'
     success = .false.
  end if
  if( any(.not.basis_merged%spec(1)%atom_mask(bas%spec(1)%num+1:)) .or. &
       any(.not.basis_merged%spec(2)%atom_mask) &
  ) then
     write(0,*) &
          'basis_merge failed, atom mask for basis 2 not all true'
     success = .false.
  end if

  !-----------------------------------------------------------------------------
  ! check for any failed tests
  !-----------------------------------------------------------------------------
  write(*,*) "----------------------------------------"
  if(success)then
     write(*,*) 'test_geom_utils passed all tests'
  else
     write(0,*) 'test_geom_utils failed one or more tests'
     stop 1
  end if

end program test_geom_utils

module raffle__evaluator
  !! Module to build viability map of a structure
  !!
  !! This module handles the viability map for a structure, which is a map of
  !! the system with each point in the map representing the suitability of
  !! that point for a new atom. The map is built by checking the bond lengths,
  !! bond angles and dihedral angles between the test point and all atoms.
  use raffle__constants, only: real32, tau, pi
  use raffle__misc_linalg, only: modu, get_angle, get_improper_dihedral_angle
  use raffle__geom_extd, only: extended_basis_type
  use raffle__distribs_container, only: distribs_container_type
  implicit none


  private
  public :: evaluate_point


contains

!###############################################################################
  pure function evaluate_point( distribs_container, &
       position, species, basis, &
       radius_list &
  ) result(output)
    !! Return the viability of a point in a basis for a specified species
    !!
    !! This function evaluates the viability of a point in a basis for a
    !! specified species. The viability is determined by the bond lengths,
    !! bond angles and dihedral angles between the test point and all atoms.
    implicit none

    ! Arguments
    integer, intent(in) :: species
    !! Index of the query element.
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    type(extended_basis_type), intent(in) :: basis
    !! Basis of the system.
    real(real32), dimension(3), intent(in) :: position
    !! Position of the test point.
    real(real32), dimension(:), intent(in) :: radius_list
    !! List of radii for each pair of elements.
    real(real32) :: output
    !! Suitability of the test point.

    ! Local variables
    integer :: i, is, js, ia, ja, ia_end, ja_start, is_end
    !! Loop counters.
    integer :: element_idx
    !! Index of the query element.
    integer :: num_2body, num_3body, num_4body
    !! Number of 2-, 3- and 4-body interactions.
    real(real32) :: viability_2body
    !! Viability of the test point for 2-body interactions.
    real(real32) :: viability_3body, viability_4body
    !! Viability of the test point for 3- and 4-body interactions.
    real(real32) :: bondlength, rtmp1, min_distance, min_from_max_cutoff
    !! Temporary variables.
    logical :: has_4body
    !! Boolean whether the system has 4-body interactions.
    real(real32) :: cos_scale1, cos_scale2
    !! Cosine scales for the 3- and 4-body interactions.
    real(real32), dimension(3) :: position_1
    !! Cartesian coordinates of the test point.
    real(real32), dimension(4) :: position_2
    !! Cartesian coordinates of the second atom and its cutoff weighting.
    real(real32), dimension(4) :: tolerances
    !! Tolerance for the distance between atoms for 3- and 4-body.
    integer, dimension(:,:), allocatable :: pair_index
    !! Index of element pairs.
    type(extended_basis_type) :: neighbour_basis
    !! Basis of the neighbouring atoms.


    ! Initialisation
    output = 0._real32
    viability_2body = 0._real32
    min_distance = distribs_container%cutoff_max(1)
    min_from_max_cutoff = 0._real32


    !---------------------------------------------------------------------------
    ! get list of element pair indices
    ! (i.e. the index for bond_info for each element pair)
    !---------------------------------------------------------------------------
    allocate(pair_index(basis%nspec, basis%nspec), source = 0)
    do is = 1, basis%nspec
       do js = 1, basis%nspec
          pair_index(is, js) = distribs_container%get_pair_index( &
               basis%spec(is)%name, basis%spec(js)%name &
          )
       end do
    end do


    !---------------------------------------------------------------------------
    ! loop over all atoms in the system
    !---------------------------------------------------------------------------
    allocate(neighbour_basis%spec(basis%nspec))
    allocate(neighbour_basis%image_spec(basis%nspec))
    neighbour_basis%nspec = basis%nspec
    neighbour_basis%lat = basis%lat
    num_2body = 0
    species_loop: do is = 1, basis%nspec
       allocate(neighbour_basis%spec(is)%atom( &
            basis%spec(is)%num+basis%image_spec(is)%num, 4 &
       ) )
       allocate(neighbour_basis%image_spec(is)%atom( &
            basis%spec(is)%num+basis%image_spec(is)%num, 4 &
       ) )
       neighbour_basis%spec(is)%num = 0
       neighbour_basis%image_spec(is)%num = 0
       tolerances = distribs_container%radius_distance_tol * &
            radius_list(pair_index(species,is))
       tolerances(1) = max( distribs_container%cutoff_min(1), tolerances(1) )
       tolerances(3) = max( distribs_container%cutoff_min(1), tolerances(3) )
       tolerances(2) = min( distribs_container%cutoff_max(1), tolerances(2) )
       tolerances(4) = min( distribs_container%cutoff_max(1), tolerances(4) )
       cos_scale1 = tau / ( tolerances(2) - tolerances(1) )
       cos_scale2 = tau / ( tolerances(4) - tolerances(3) )
       !------------------------------------------------------------------------
       ! 2-body map
       ! check bondlength between test point and all other atoms
       !------------------------------------------------------------------------
       atom_loop: do ia = 1, basis%spec(is)%num
          ! Check if the atom is in the ignore list
          ! If it is, skip the atom.
          if(.not.basis%spec(is)%atom_mask(ia)) cycle atom_loop
          associate( position_store => [ basis%spec(is)%atom(ia,1:3) ] )
             bondlength = norm2( matmul(position - position_store, basis%lat) )
             if( bondlength .gt. distribs_container%cutoff_max(1) ) &
                  cycle atom_loop
             if( bondlength .lt. tolerances(1) )then
                ! If the bond length is less than the minimum allowed bond,
                ! return 0 (i.e. the point is not viable).
                return
             elseif( bondlength .le. tolerances(2) )then
                ! If the bond length is within the tolerance of the covalent
                ! radius of the pair, add the atom to the list of
                ! atoms to consider for 3-body interactions.
                neighbour_basis%spec(is)%num = neighbour_basis%spec(is)%num + 1
                neighbour_basis%spec(is)%atom( &
                     neighbour_basis%spec(is)%num,:3 &
                ) = matmul(position_store, basis%lat)
                neighbour_basis%spec(is)%atom( &
                     neighbour_basis%spec(is)%num,4 &
                ) = 0.5_real32 * abs( 1._real32 - &
                     cos( cos_scale1 * ( bondlength - tolerances(1) ) ) )
             end if

             if( bondlength .ge. tolerances(3) .and. &
                  bondlength .le. tolerances(4) &
             )then
                ! If the bond length is within the min and max allowed size,
                ! add the atom to the list of atoms to consider for 4-body.
                neighbour_basis%image_spec(is)%num = &
                     neighbour_basis%image_spec(is)%num + 1
                neighbour_basis%image_spec(is)%atom( &
                     neighbour_basis%image_spec(is)%num,:3 &
                ) = matmul(position_store, basis%lat)
                neighbour_basis%image_spec(is)%atom( &
                     neighbour_basis%image_spec(is)%num,4 &
                ) = 0.5_real32 * abs( 1._real32 - &
                     cos( cos_scale2 * ( bondlength - tolerances(3) ) ) )
             end if

             !------------------------------------------------------------------
             ! Add the contribution of the bond length to the viability
             !------------------------------------------------------------------
             if(bondlength - tolerances(1) .lt. min_distance)then
                min_distance = bondlength - tolerances(1)
             end if
             if(distribs_container%cutoff_max(1) - bondlength .gt. &
                  min_from_max_cutoff)then
                min_from_max_cutoff = distribs_container%cutoff_max(1) - &
                     bondlength
             end if
             viability_2body = viability_2body + &
                  evaluate_2body_contributions( &
                       distribs_container, bondlength, pair_index(species,is) &
                  )
             num_2body = num_2body + 1
          end associate
       end do atom_loop

       !------------------------------------------------------------------------
       ! Repeat the process for the image atoms.
       ! i.e. atoms that are not in the unit cell but are within the cutoff
       ! distance.
       !------------------------------------------------------------------------
       image_loop: do ia = 1, basis%image_spec(is)%num, 1
          associate( position_store => [ basis%image_spec(is)%atom(ia,1:3) ] )
             bondlength = norm2( matmul(position - position_store, basis%lat) )
             if( bondlength .gt. distribs_container%cutoff_max(1) ) &
                  cycle image_loop
             if( bondlength .lt. tolerances(1) )then
                return
             elseif( bondlength .le. tolerances(2) )then
                neighbour_basis%spec(is)%num = neighbour_basis%spec(is)%num + 1
                neighbour_basis%spec(is)%atom( &
                     neighbour_basis%spec(is)%num,:3 &
                ) = matmul(position_store, basis%lat)
                neighbour_basis%spec(is)%atom( &
                     neighbour_basis%spec(is)%num,4 &
                ) = 0.5_real32 * ( 1._real32 - &
                     cos( cos_scale1 * ( bondlength - tolerances(1) ) ) )
             end if

             if( bondlength .ge. tolerances(3) .and. &
                  bondlength .le. tolerances(4) &
             )then
                neighbour_basis%image_spec(is)%num = &
                     neighbour_basis%image_spec(is)%num + 1
                neighbour_basis%image_spec(is)%atom( &
                     neighbour_basis%image_spec(is)%num,:3 &
                ) = matmul(position_store, basis%lat)
                neighbour_basis%image_spec(is)%atom( &
                     neighbour_basis%image_spec(is)%num,4 &
                ) =  0.5_real32 * abs( 1._real32 - &
                     cos( cos_scale2 * ( bondlength - tolerances(3) ) ) )
             end if

             !------------------------------------------------------------------
             ! Add the contribution of the bond length to the viability
             !------------------------------------------------------------------
             if(bondlength - tolerances(1) .lt. min_distance)then
                min_distance = bondlength - tolerances(1)
             end if
             if(distribs_container%cutoff_max(1) - bondlength .gt. &
                  min_from_max_cutoff)then
                min_from_max_cutoff = distribs_container%cutoff_max(1) - &
                     bondlength
             end if
             viability_2body = viability_2body + &
                  evaluate_2body_contributions( &
                       distribs_container, bondlength, pair_index(species,is) &
                  )
             num_2body = num_2body + 1
          end associate
       end do image_loop
       !------------------------------------------------------------------------
       ! DEVELOPER TOOL: This conditional allows the user to retrieve
       ! results closer to first arXiv paper release.
       ! It is not recommended to use this option for production runs and is
       ! only here for testing purposes.
       !------------------------------------------------------------------------
       if(.not.distribs_container%smooth_viability)then
          neighbour_basis%spec(is)%atom(1:neighbour_basis%spec(is)%num,4) = &
               1._real32
          neighbour_basis%image_spec(is)%atom( &
               1:neighbour_basis%image_spec(is)%num,4 &
          ) = 1._real32
       end if
    end do species_loop
    neighbour_basis%natom = sum(neighbour_basis%spec(:)%num)


    !---------------------------------------------------------------------------
    ! Normalise the bond length viability
    !---------------------------------------------------------------------------
    if(num_2body.eq.0)then
       ! This does not matter as, if there are no 2-body bonds, the point is
       ! not meant to be included in the viability set.
       ! The evaluator cannot comment on the viability of the point.
       viability_2body = distribs_container%viability_2body_default
    else
       viability_2body = viability_2body / real( num_2body, real32 )
       if(min_distance .lt. 0.25_real32 )then
          viability_2body = viability_2body * 0.5_real32 * &
               ( 1._real32 - cos( pi * min_distance / 0.25_real32 ) )
       end if
       if( min_from_max_cutoff .lt. 0.5_real32 )then
          rtmp1 = 0.5_real32 * ( 1._real32 - &
               cos( pi * min_from_max_cutoff / 0.5_real32 ) )
          viability_2body = &
               distribs_container%viability_2body_default * &
               abs( 1._real32 - rtmp1 ) + &
               rtmp1 * viability_2body
       end if
    end if


    ! store 3-body viable atoms in neighbour_basis%spec
    ! store 4-body viable atoms in neighbour_basis%image_spec
    ! for 3-bdoy, just cycle over neighbour_basis%spec
    ! for 4-body, cycle over neighbour_basis%spec for first two atoms,
    ! and neighbour_basis%image_spec for the third atom
    num_3body = 0
    num_4body = 0
    viability_3body = 1._real32
    viability_4body = 1._real32
    position_1 = matmul(position, basis%lat)
    element_idx = distribs_container%element_map(species)
    has_4body = any(neighbour_basis%image_spec(:)%num .gt. 0)
    is_end = 0
    do is = 1, neighbour_basis%nspec, 1
       if(neighbour_basis%spec(is)%num .gt. 0) is_end = is
    end do
    do is = 1, is_end, 1
       ia_end = neighbour_basis%spec(is)%num - merge( 1, 0, is .eq. is_end )
       do ia = 1, ia_end, 1
          position_2 = neighbour_basis%spec(is)%atom(ia,1:4)
          !---------------------------------------------------------------------
          ! 3-body map
          ! check bondangle between test point and all other atoms
          !---------------------------------------------------------------------
          viability_3body = viability_3body * max( &
               0._real32, &
               evaluate_3body_contributions( distribs_container, &
                    position_1, &
                    position_2, &
                    neighbour_basis, element_idx, [is, ia] &
               ) )
          num_3body = num_3body + 1
          if( has_4body )then
             do js = is, neighbour_basis%nspec
                ja_start = merge(ia + 1, 1, js .eq. is)
                do ja = ja_start, neighbour_basis%spec(js)%num, 1
                   !------------------------------------------------------------
                   ! 4-body map
                   ! check improperdihedral angle between test point and all
                   ! other atoms
                   !------------------------------------------------------------
                   rtmp1 = max( &
                        0._real32, &
                        evaluate_4body_contributions( distribs_container, &
                             position_1, &
                             position_2, &
                             [ neighbour_basis%spec(js)%atom(ja,1:4) ], &
                             neighbour_basis, element_idx &
                        ) )
                   viability_4body = viability_4body * rtmp1
                   num_4body = num_4body + 1
                end do
             end do
          end if
       end do
    end do


    !---------------------------------------------------------------------------
    ! Normalise the angular viabilities
    !---------------------------------------------------------------------------
    if(num_3body.gt.0)then
       viability_3body = viability_3body ** ( &
            1._real32 / real(num_3body,real32) &
       )
    else
       viability_3body = distribs_container%viability_3body_default
    end if
    if(num_4body.gt.0)then
       viability_4body = viability_4body ** ( &
            1._real32 / real(num_4body,real32) &
       )
    else
       viability_4body = distribs_container%viability_4body_default
    end if


    !---------------------------------------------------------------------------
    ! Combine the 2-, 3- and 4-body viabilities to get the overall viability
    !---------------------------------------------------------------------------
    output = viability_2body * viability_3body * viability_4body

  end function evaluate_point
!###############################################################################


!###############################################################################
  pure function evaluate_2body_contributions( distribs_container, &
       bondlength, pair_index &
  ) result(output)
    !! Return the contribution to the viability from 2-body interactions
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    real(real32), intent(in) :: bondlength
    !! Bond length.
    integer, intent(in) :: pair_index
    !! Index of the element pair.
    real(real32) :: output
    !! Contribution to the viability.


    output = distribs_container%gdf%df_2body( &
         distribs_container%get_bin(bondlength, dim = 1), &
         pair_index &
    )

  end function evaluate_2body_contributions
!###############################################################################


!###############################################################################
  pure function evaluate_3body_contributions( distribs_container, &
       position_1, position_2, basis, element_idx, current_idx &
  ) result(output)
    !! Return the contribution to the viability from 3-body interactions
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    real(real32), dimension(3), intent(in) :: position_1
    !! Positions of the atom.
    real(real32), dimension(4), intent(in) :: position_2
    !! Positions of the second atom and its cutoff weighting.
    type(extended_basis_type), intent(in) :: basis
    !! Basis of the system.
    integer, intent(in) :: element_idx
    !! Index of the query element.
    integer, dimension(2), intent(in) :: current_idx
    !! Index of the 1st-atom query element.
    real(real32) :: output
    !! Contribution to the viability.

    ! Local variables
    integer :: js, ja
    !! Loop indices.
    integer :: bin
    !! Bin for the distribution function.
    integer :: num_3body_local
    !! Number of 3-body interactions local to the current atom pair.
    real(real32) :: power
    !! Power for the contribution to the viability.
    integer :: start_idx
    !! Start index for the loop over the atoms.
    real(real32) :: rtmp1, weight_2
    !! Temporary variables.


    num_3body_local = sum(basis%spec(current_idx(1):)%num) - current_idx(2)
    output = 1._real32
    power = 1._real32 / real( num_3body_local, real32 )
    weight_2 = sqrt( position_2(4) )
    species_loop: do js = current_idx(1), basis%nspec, 1
       start_idx = merge(current_idx(2) + 1, 1, js .eq. current_idx(1))
       atom_loop: do ja = start_idx, basis%spec(js)%num
          bin = distribs_container%get_bin( &
               get_angle( &
                    position_2(1:3), &
                    position_1, &
                    [ basis%spec(js)%atom(ja,1:3) ] &
               ), dim = 2 &
          )
          rtmp1 = weight_2 * sqrt( basis%spec(js)%atom(ja,4) )
          output = output * ( &
               distribs_container%viability_3body_default * &
               abs( 1._real32 - rtmp1 ) + &
               rtmp1 * distribs_container%gdf%df_3body( bin, element_idx ) &
          ) ** power
       end do atom_loop
    end do species_loop

  end function evaluate_3body_contributions
!###############################################################################


!###############################################################################
  pure function evaluate_4body_contributions( distribs_container, &
       position_1, position_2, position_3, basis, element_idx ) result(output)
    !! Return the contribution to the viability from 4-body interactions
    implicit none

    ! Arguments
    type(distribs_container_type), intent(in) :: distribs_container
    !! Distribution function (gvector) container.
    real(real32), dimension(3), intent(in) :: position_1
    !! Positions of the atoms.
    real(real32), dimension(4), intent(in) :: position_2, position_3
    type(extended_basis_type), intent(in) :: basis
    !! Basis of the system.
    integer, intent(in) :: element_idx
    !! Index of the query element.
    real(real32) :: output
    !! Contribution to the viability.

    ! Local variables
    integer :: ks, ka
    !! Loop indices.
    integer :: bin
    !! Bin for the distribution function.
    integer :: num_4body_local
    !! Number of 4-body interactions local to the current atom triplet.
    real(real32) :: power
    !! Power for the contribution to the viability.
    real(real32) :: rtmp1, third, weight_2_3
    !! Temporary variables.


    num_4body_local = sum(basis%image_spec(:)%num)
    output = 1._real32
    power = 1._real32 / real( num_4body_local, real32 )
    third = 1._real32 / 3._real32
    weight_2_3 = ( position_2(4) * position_3(4) ) ** third
    species_loop: do ks = 1, basis%nspec, 1
       atom_loop: do ka = 1, basis%image_spec(ks)%num
          bin = distribs_container%get_bin( &
               get_improper_dihedral_angle( &
                    position_1, &
                    position_2(1:3), &
                    position_3(1:3), &
                    [ basis%image_spec(ks)%atom(ka,1:3) ] &
               ), dim = 3 &
          )
          rtmp1 = weight_2_3 * ( basis%image_spec(ks)%atom(ka,4) ) ** third
          output = output * ( &
               distribs_container%viability_4body_default * &
               abs( 1._real32 - rtmp1 ) + &
               rtmp1 * distribs_container%gdf%df_4body( bin, element_idx ) &
          ) ** power
       end do atom_loop
    end do species_loop

  end function evaluate_4body_contributions
!###############################################################################

end module raffle__evaluator

# Description

> _Briefly describe the purpose and content of this merge request._
> _E.g. "Add structure generation constraints", or "Fix bug in energy parsing"._

# Checklist

Mark with `x` when complete, or `~` if not applicable.

- [ ] [I have read and followed the **RAFFLE's contribution guidelines.**](https://github.com/ExeQuantCode/RAFFLE/blob/main/CONTRIBUTING.md)
- [ ] **Code is commented** appropriately, and API docstrings follow NumPy or FORD style.
- [ ] **Read*the*Docs** documentation is added/updated (if applicable).
- [ ] **Unit tests** are added/updated (if applicable).
- [ ] **Linked issue** is resolved with a `closes #XXXX` reference (if applicable).

project:
summary: A Fortran library and executable for structure prediction at material interfaces
src_dir: ./src/fortran
    ./app
exclude: **/f90wrap_*.f90
output_dir: docs/html
preprocess: false
predocmark: !!
fpp_extensions: f90
                F90
display: public
         protected
         private
source: true
graph: true
md_extensions: markdown.extensions.toc
coloured_edges: true
sort: permission-alpha
author: RAFFLE developers
github: https://github.com/ExeQuantCode
print_creation_date: true
creation_date: %Y-%m-%d %H:%M %z
project_github: https://github.com/ExeQuantCode/raffle
project_download: https://github.com/ExeQuantCode/raffle/releases
github: https://github.com/ExeQuantCode

{!README.md!}

# Contributing Guidelines

Thank you for considering contributing to the RAFFLE project! We appreciate your time and effort. To ensure a smooth collaboration, please follow the guidelines provided below.

Please first discuss potential changes you wish to make to the project via issue (preferably), or email.

> And if you like the project, but just don't have time to contribute, that's fine. There are other easy ways to support the project and show your appreciation, which we would also be very happy about:
> - Star the project
> - Mention it on social media platforms
> - Refer this project in your project's readme
> - Mention the project at local meetups and tell your friends/colleagues

<!-- omit in toc -->

## Table of Contents
- [Code of Conduct](#code-of-conduct)
- [I Have a Question](#i-have-a-question)
- [I Want to Contribute](#i-want-to-contribute)
- [Reporting Bugs](#reporting-bugs)
- [Suggesting Enhancements](#suggesting-enhancements)
- [Code Style](#code-style)
- [Testing](#testing)
- [Documentation](#documentation)
- [Contact](#contact)
- [License](#license)


## Code of Conduct

This project and everyone participating in it is governed by the
[RAFFLE Code of Conduct](CODE_OF_CONDUCT.md).
By participating, you are expected to uphold this code.
Please report unacceptable behavior to the RAFFLE developers: [Ned Taylor](mailto:n.t.taylor@exeter.ac.uk?subject=RAFFLE%20-%behaviour) or [Steve Hepplestone](mailto:s.p.hepplestone@exeter.ac.uk?subject=RAFFLE%20-%behaviour).

## I Have a Question

> If you want to ask a question, we assume that you have read the available [Documentation](README.md).

Before you ask a question, it is best to search for existing [Issues](https://github.com/ExeQuantCode/RAFFLE/issues) that might help you.
In case you have found a suitable issue and still need clarification, you can write your question in this issue. It is also advisable to search the internet for answers first.

If you then still feel the need to ask a question and need clarification, we recommend the following:

- Open an [Issue](https://github.com/ExeQuantCode/RAFFLE/issues/new).
- Provide as much context as you can about what you're running into.
- Provide project and platform versions (python, fortran, pip), depending on what seems relevant.

We will then take care of the issue as soon as possible.

## I Want To Contribute

> ### Legal Notice <!-- omit in toc -->
> When contributing to this project, you must agree that you have authored 100% of the content, that you have the necessary rights to the content and that the content you contribute may be provided under the project license.

### Reporting Bugs
If you encounter any issues or have suggestions for improvement, please open an [Issue](https://github.com/ExeQuantCode/RAFFLE/issues/new) on the repository's issue tracker.

When reporting, please provide as much context as possible and describe the reproduction steps that someone else can follow to recreate the issue on their own.
This usually includes your code.
For good bug reports you should isolate the problem and create a reduced test case.



### Suggesting Enhancements

This section guides you through submitting an enhancement suggestion for RAFFLE, **including completely new features and minor improvements to existing functionality**.
Following these guidelines will help maintainers and the community to understand your suggestion and find related suggestions.

<!-- omit in toc -->
#### Before Submitting an Enhancement

- Make sure that you are using the latest version.
- Read the compilable documentation carefully and find out if the functionality is already covered.
- Perform a [search](https://github.com/ExeQuantCode/RAFFLE/issues) to see if the enhancement has already been suggested. If it has, add a comment to the existing issue instead of opening a new one.
- Find out whether your idea fits with the scope and aims of the project. It's up to you to make a strong case to convince the project's developers of the merits of this feature. Keep in mind that we want features that will be useful to the majority of our users and not just a small subset. If you're just targeting a minority of users, consider writing an add-on/plugin library.


### Contributing Code

This guide provides the recommended route to contributing to RAFFLE:

1. Fork the repository.
2. Clone the forked repository to your local machine.
3. Create a new branch for your changes.
4. Make your changes and commit them.
5. Push the changes to your forked repository.
6. Open a pull request to the main repository.

When submitting your contributions, please ensure the following:
- Provide a clear and descriptive title for your pull request.
- Include a detailed description of the changes made.
- Reference any related issues or pull requests, if applicable.
- Write unit tests for your contributions
- Ensure all existing tests pass before submitting your changes.
- Update the documentation to reflect your changes, if necessary (i.e. through FORD style commenting for Fortran and NumPy docstrings style for Python).
- Provide examples and usage instructions, if applicable.

Follow the [Code Style](#code-style) when contributing code to this project to ensure compatibility and a uniform format to the project.


### Code Style
- Follow the existing code style and conventions.
- Use meaningful variable and function names.
- Write clear and concise comments. For the Fortran library, use comments compatible with the [FORD Fortran Documenter](https://forddocs.readthedocs.io/en/stable/). For the Python wrapper, use comments compatible with [pandoc](https://pandoc.org), following the [NumPy style guide](https://numpydoc.readthedocs.io/en/latest/format.html).



## Contact
If you have any questions or need further assistance, feel free to contact [Ned Taylor](mailto:n.t.taylor@exeter.ac.uk?subject=RAFFLE%20-%query) or [Steve Hepplestone](mailto:s.p.hepplestone@exeter.ac.uk?subject=RAFFLE%20-%query).

## License
This project is licensed under the [GPL-3.0 License](LICENSE).

<!-- omit in toc -->
## Attribution
This guide is based on the **contributing-gen** and has been copied from the [graphstruc](https://github.com/nedtaylor/graphstruc) repository, with permission from the creator (Ned Taylor).
[Make your own](https://github.com/bttger/contributing-gen)!
